// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
#ifndef __ambchk_h
#define __amgchk_h

#include "ints.h"
#include "vec.h"
#include "c_all_internal.h"

class Grammar;

typedef void (*fnct_statusupdate)(const char *szStatusText);

struct AmbiguitiesOptions
{
    bool m_bMaxDepth;
    int m_iMaxDepth;
    bool m_bMaxPaths;
    uint64_t m_iMaxPaths;
    bool m_bProbabalisticSearch;
    int m_iPercent;
    bool m_bStopAtFirstAmbiguity;
    bool m_bShowBigTree;
    bool m_bShowLilTrees;
    int m_icontinue;

    fnct_statusupdate m_statusupdate;
    outbuf *m_outputstream;
};

void LIBGLR_EXPORT CheckForAmbiguities(Grammar *g, AmbiguitiesOptions *poptions);
void LIBGLR_EXPORT CheckForAmbiguitiesInString(Grammar *g, AmbiguitiesOptions *poptions, const vector<int> &symbols);

#endif
