#ifdef __cplusplus
extern "C" {
#endif
// you may choose to define your own allocation function.
#ifndef vp_realloc
GLR_API void *vp_realloc(void *vp, size_t size) {
  if( ! vp && ! size )
    return 0;
  else if( ! vp )
    vp = malloc(size);
  else if( ! size ) {
    free(vp);
    return 0;
  }
  else
    vp = realloc(vp, size);
  return vp;
}
#endif
GLR_API void vp_memzero(void *dst, size_t size) {
  size_t i = 0;
  if( ! size )
    return;
  for( ; i < size; ++i )
    ((char*)dst)[i] = 0;
}
GLR_API char *nv_strdup(const char *str, size_t *len)
{
    char *sdup = 0;
    size_t slen = strlen(str), i = 0;
    if( len ) *len = slen;
    sdup = (char*)vp_realloc(0, slen+1);
    while( str[i] )
    {
        sdup[i] = str[i];
        ++i;
    }
    sdup[slen] = 0;
    return sdup;
}
#ifdef __cplusplus
} /* extern "C" */
#endif
