#!for-each tokenizer-state
#define $(TOKENSETNAME)_TOKENSET ($(TOKENSETSTATE))
#!end
#!for-each symbol
#define SYMID_$(SYMBOL_FRIENDLY_NAME) ($(SYMBOL_INDEX))
#!end
#!for-each production
#!if copycat
#!else
#define PRID_$(PRODUCTION_FRIENDLY_NAME) ($(PRODUCTION_ID))
#!end
#!end
#define STARTTOK ($(STARTTOK))
#define EOFTOK   ($(EOFTOK))
#define ERRTOK   ($(ERRTOK))
#define ACCEPTSTATE ($(STATECOUNT))

#!for-each ctype
static ttype $(CTYPE_FRIENDLY_NAME)_tt = {"$(CTYPE)",sizeof($(CTYPE)),INIT_T($(CTYPE)),DESTRUCT_T($(CTYPE))};
#!end

static symbol allsymbols[] = {
#!for-each symbol
{"$(SYMBOL_NAME)",\
#!if has-ctype
&$(SYMBOL_TYPE_FRIENDLY_NAME)_tt\
#!else
0\
#!end
},\\
#!end
};
\
#!for-each production
static int  ps$(PRODUCTION_ID)[] = {\
  #!for-each production-symbol
$(SYMBOL_INDEX),\
  #!end
-1\
};
\
  #!if copycat
static int skp$(PRODUCTION_ID)[] = {\
#!for-each skip
$(SKIPINDEX),\
#!end
};
  #!end
#!end
\
static production productions[] = {
#!for-each production
{$(PRODUCTION_ID),$(ORIGINAL_PRODUCTION_ID),$(NT_INDEX),$(SYMBOL_COUNT),ps$(PRODUCTION_ID),\
  #!if copycat
SZ(skp$(PRODUCTION_ID)),skp$(PRODUCTION_ID)\
  #!else
0,0\
  #!end
},
#!end
};
\
#!if no-compressed-lr-table
  #!for-each parse-state
static parse_action pa$(STATE)[] = {\\
    #!for-each parse-action
      #!if shift
{$(TOKEN_ID),SH,$(SHIFT_TO)},\\
      #!else-if reduceaccept
{$(TOKEN_ID),RD,$(REDUCE_BY)},\\
      #!end
    #!end
};
  #!end
\
static parse_state parse_states[] = {\\
  #!for-each parse-state
{SZ(pa$(STATE)),pa$(STATE)},\\
  #!end
};
\
#!else
\
  #!for-each compressed-action-range
static int par_rng_$(RANGE_IDX)[] = {$(RANGE_SIZE),\
    #!for-each action-range-item
$(ACTION_RANGE_MIN),$(ACTION_RANGE_MAX),\
    #!end
};
  #!end
\
  #!for-each parse-state
static parse_action_range par$(STATE)[] = {\
    #!for-each compressed-parse-action
{\
      #!if shift
SH\
      #!else-if reduceaccept
RD\
      #!end
,$(FIRST_ACTION_IDX),$(LAST_ACTION_IDX),par_rng_$(RANGE_IDX)},\
    #!end
};
  #!end
\
static parse_state parse_states[] = {
  #!for-each parse-state
{SZ(par$(STATE)),par$(STATE)},\\
  #!end
};
#!end

#!if no-compressed-scanner
  #!for-each tokenizer-state
    #!for-each lexer-state
      #!if out-transitions
static lxtr ts_$(TOKENSETNAME)_$(FROM_STATE)[] = {
        #!for-each transition-range
{$(RANGE_MIN),$(RANGE_MAX),$(TO_STATE),$(PARTIAL_ACCEPT_TOK)},\
        #!end
};
      #!end
    #!end
  #!end
\
  #!for-each tokenizer-state
static lxstnfo lxinfo_$(TOKENSETNAME)[] = {
    #!for-each lexer-state
      #!if out-transitions
{$(FROM_STATE),SZ(ts_$(TOKENSETNAME)_$(FROM_STATE)),ts_$(TOKENSETNAME)_$(FROM_STATE)},\\
      #!else
{$(FROM_STATE),0,0},\\
      #!end
    #!end
};
  #!end
\
static tsinfo tsinfos[] = {
  #!for-each tokenizer-state
{$(TOKENSETNAME)_TOKENSET,SZ(lxinfo_$(TOKENSETNAME)),lxinfo_$(TOKENSETNAME)},\\
  #!end
};
#!else
  #!for-each tokenizer-state
static int brk_$(TOKENSETNAME)[] = {\\
    #!for-each compressed-break
$(COMPRESSED_BREAK),\\
    #!end
};
static scnitem scn_$(TOKENSETNAME)[] = {\\
    #!for-each compressed-lxitem
{$(COMPRESSED_LXITEM_POS),$(COMPRESSED_LXITEM_OFF),$(COMPRESSED_LXITEM_COUNT),$(COMPRESSED_LXITEM_LEAD),$(COMPRESSED_LXITEM_NEXT)},\\
    #!end
};
static int accepttoks_$(TOKENSETNAME)[] = {\\
    #!for-each lexer-state
$(ACCEPTTOK),\\
    #!end
};
  #!end
static tsinfo tsinfos[] = {\\
  #!for-each tokenizer-state
{SZ(brk_$(TOKENSETNAME)),brk_$(TOKENSETNAME),$(TOKENSETSTATECOUNT),accepttoks_$(TOKENSETNAME),SZ(scn_$(TOKENSETNAME)),scn_$(TOKENSETNAME)},\\
  #!end
};
#!end

static int reduce_action(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr\
#!if global-ctype
, $(GLOBAL_CTYPE) *pextra\
#!else
, void *pextra\
#!end
)
{
#!if global-ctype
  $(GLOBAL_CTYPE) extra = *pextra;
#!end
  switch(pid) {
#!for-each production
  #!if hasaction
  case $(PRODUCTION_ID): {
#!if usepoundline
#line $(SRCLINE) "$(SRCFILE)"
#!end
$(REDUCE_SRC)
#!if usepoundline
#line $(LINE+1) "$(FILE)"
#!end
  } break;
  #!end
#!end
  default: break;
  }
  return 1;
}

#!for-each tokenizer-state
static lxact lxact_$(TOKENSETNAME)[] = {
  #!for-each tokenizer-token
{$(SYMBOL_INDEX),\
    #!if ws
WS_FLAG,$(NEXT_STATE)\
    #!else-if push
PUSH_FLAG,$(NEXT_STATE)\
    #!else-if pop
POP_FLAG,$(NEXT_STATE)\
    #!else-if goto
GOTO_FLAG,$(NEXT_STATE)\
    #!else
0,-1\
    #!end
},\\
  #!end
{-1,0,0}\\
};
#!end
static lxact *lxactions[] = {
#!for-each tokenizer-state
lxact_$(TOKENSETNAME),\
#!end
};

#!! prsstk contains the parser state numbers
#!!   on input, the bottom value of prsstk must contain the $extra parameter
#!!   on output after a successful parse, it will contain the reduced start state
#!! lexstk contains the lexer stack for push/pop/goto actions
#!! instk contains the input queue for semantic actions
#!! tokstk contains the input token numbers
static int Parse_$(NAME)(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc\
#!if global-ctype
, $(GLOBAL_CTYPE) extra\
#!end
)
{
    return parse_any(buf, obuf, trace, err_lc,
                                tsinfos,
                                lxactions,
                                parse_states,
                                productions,
                                $(PRODUCTION_ADJUST_COUNT),
                                $(MAX_PRODUCTION_SYMBOLS),
                                allsymbols,
                                STARTTOK,
                                ERRTOK,
                                EOFTOK,
                                ACCEPTSTATE,
                                $(PARSER_START_STATE),
                                INITIAL_TOKENSET,
                                (reduce_action_fnct)reduce_action,
#!if global-ctype
                                &extra\
#!else
                                0
#!end
);
}
