#line 1 "skfile.gg"
// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
#include "vec.h"
#include "emitC.h"


#line 26 "skfile.cpp"
/*
   generated by glrgen.  
   (Skeleton Code) Copyright (c) 2008-2011 Mighty Heave Software LLC.
   Wormhole license (MIT Style)  http://www.mightyheave.com
*/
/* duplicode management {
   define C_IO_STATIC, or nothing to get a stand alone parser, static functions
     GLR_API -> static
   define C_IO_CPP to implement extern functions
   define C_IO_EXTERN to use extern functions
   define C_IO_HEADER to use extern functions
     GLR_API -> extern
     
   In all modes except C_IO_STATIC, you may provide an alternate GLR_API preprocessor
   definition, which can be handy for importing and exporting dll functions on windows.
} duplicode management */
#if ! defined(C_IO_STATIC) && (defined(C_IO_CPP) || defined(C_IO_EXTERN) || defined(C_IO_HEADER))
#ifndef GLR_API
#define GLR_API extern
#endif
#else
#ifndef C_IO_STATIC
#define C_IO_STATIC
#endif
#undef GLR_API
#define GLR_API static
#endif
#ifndef __c_skeleton_decl
#define __c_skeleton_decl
#ifdef __cplusplus
extern "C" {
#endif
GLR_API void *vp_realloc(void *vp, size_t size);
GLR_API void vp_memzero(void *dst, size_t size);
GLR_API char *nv_strdup(const char *str, size_t *len);
#ifdef __cplusplus
} /* extern "C" */
#endif
#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
typedef HANDLE handle_t;
#define H_STDIN GetStdHandle(STD_INPUT_HANDLE)
#define H_STDOUT GetStdHandle(STD_OUTPUT_HANDLE)
#define H_STDERR GetStdHandle(STD_ERROR_HANDLE)
typedef __int64 foff_t;
#else
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
typedef int handle_t;
#define H_STDIN STDIN_FILENO
#define H_STDOUT STDOUT_FILENO
#define H_STDERR STDERR_FILENO
typedef long long foff_t;
#endif

#define BUF_BLOCK_SIZE (32767)
#define SZ(a) (sizeof(a)/sizeof(a[0]))

#ifdef __cplusplus
extern "C" {
#endif

#define INBUF_SET (0)
#define INBUF_CUR (1)
#define INBUF_END (2)

struct tag_inbuf;
typedef struct tag_inbuf inbuf;
typedef int (*ibf_read)(inbuf*,void*,int);
typedef foff_t (*ibf_seek)(inbuf*,foff_t,int);
typedef void (*ibf_close)(inbuf*);

GLR_API inbuf *new_inbuf(size_t inbufsize, const char *fname, ibf_read readfnct, ibf_seek seekfnct, ibf_close closefnct);
GLR_API void free_inbuf(inbuf *buf);
GLR_API int ib_read(inbuf *buf, void *vp, int count);
GLR_API foff_t ib_seek(inbuf *buf, foff_t to, int whence);
GLR_API foff_t ib_tell(inbuf *buf);

struct tag_inbuf
{
  char *s;
  const char *fname;
  foff_t startpos;
  int count;
  int capacity;
  int pos;
  int eof;
  int line;
  int col;
  int strbuf;
  ibf_read readfnct;
  ibf_seek seekfnct;
  ibf_close closefnct;
#ifdef __cplusplus
  int read(void *vp,int len) { return ib_read(this,vp,len); }
  foff_t seek(foff_t off, int whence) { return ib_seek(this,off,whence); }
  foff_t tell() { return ib_tell(this); }
  void close() { if(!closefnct) return; closefnct(this); }
  void free() { free_inbuf(this); }
#endif
};

struct tag_fpinbuf; typedef struct tag_fpinbuf fpinbuf;
struct tag_fpinbuf {
    inbuf base;
    handle_t h;
};

GLR_API inbuf *h_inbuf(const char *fname, handle_t h, int handoff);
GLR_API inbuf *file_inbuf(const char *fname);
GLR_API inbuf *string_inbuf(const char *s, int staticstr);

struct tag_outbuf;
typedef struct tag_outbuf outbuf;
typedef void (*obf_write)(outbuf *buf, const char *s, size_t len);
typedef void (*obf_flush)(outbuf *buf);
typedef void (*obf_close)(outbuf *buf);

GLR_API outbuf *new_ob(size_t size, obf_write write, obf_flush flush, obf_close close);
GLR_API void free_ob(outbuf *buf);
GLR_API void ob_write(outbuf *buf, const char *s, size_t len);
GLR_API void ob_printf(outbuf *buf, const char *fmt, ...);
GLR_API void ob_vprintf(outbuf *buf, const char *fmt, ...);
GLR_API void ob_flush(outbuf *buf);
GLR_API void ob_putc(outbuf *buf, int c);
GLR_API void ob_puts(outbuf *buf, const char *s);

struct tag_outbuf
{
    char buffer[BUF_BLOCK_SIZE];
    char safetynet[16];
    size_t bufused;
    int enc;
    obf_write writefnct;
    obf_flush flushfnct;
    obf_close closefnct;
    int lineno;
    int colno;
    int autoflush;
#ifdef __cplusplus
    void write(const char *s, size_t len) { ob_write(this,s,len); }
    void printf(const char *fmt, ...)
    {
        va_list args;
        va_start(args,fmt);
        ob_vprintf(this,fmt,args);
        va_end(args);
    }
    void vprintf(const char *fmt, va_list args) { ob_vprintf(this,fmt,args); }
    void flush(outbuf *buf) { ob_flush(this); }
    void putc(int c) { ob_putc(this,c); }
    void puts(const char *s) { ob_puts(this,s); }
    void free() { free_ob(this); }
#endif
};

typedef struct tag_file_outbuf
{
    outbuf base;
    handle_t h;
} file_outbuf;

GLR_API outbuf *new_file_outbuf(const char *fname);
GLR_API outbuf *new_h_outbuf(const char *fname, handle_t h, int handoff, int autoflush);

typedef struct tag_string_outbuf
{
    outbuf base;
    int capacity, count;
    char *buf;
} string_outbuf;

GLR_API outbuf *new_string_outbuf();
GLR_API void obs_clear(outbuf *buf);
GLR_API const char *obs_getstr(outbuf *buf);

#ifdef __cplusplus
} /* extern "C" */
#endif
#define NULL_TYPESTACK {0, 0, 0}
#define NULL_LXSTACK {0, 0, 0}

#define WS_FLAG   (1)
#define PUSH_FLAG (2)
#define POP_FLAG  (3)
#define GOTO_FLAG (4)

#define STKVALUE(stk,t,i) (*((t*)((stk)->nodes[(stk)->tncount+(i)].vp)))
#define SH (0)
#define RD (1)

#ifdef __cplusplus
#include <new>
template<class T> void init_T(void *vp) { new(vp) T; }
template<class T> void destruct_T(void *t) { ((T*)t)->~T(); }
#define INIT_T(T)     init_T<T>
#define DESTRUCT_T(T) destruct_T<T>
#else
#define INIT_T(T)     0
#define DESTRUCT_T(T) 0
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tag_lxstack { int *i, count, capacity; } lxstack;
GLR_API int lxstack_push(lxstack *stk, int i);
GLR_API int lxstack_pop(lxstack *stk);
GLR_API int lxstack_size(lxstack *stk);
GLR_API void lxstack_clear(lxstack *stk);
GLR_API int lxstack_top(lxstack *stk);

typedef struct tag_ttype {
  const char *name;
  size_t size;
  void (*init)(void *vp);
  void (*destroy)(void *vp);
} ttype;

extern ttype ptr_tt;

struct tag_toknode;
typedef struct tag_toknode toknode;
struct tag_toknode {
  int ref;
  int line, col;
  int sym, state;
  void *vp;
  size_t size;
  ttype *tt;
  size_t tokslen; char *tokstr;
  toknode *wstop, *wsbottom;
  size_t sncount, sncapacity; toknode **subnodes;
};

GLR_API toknode *new_toknode(size_t size, ttype *tt, int sym, int state);
GLR_API void toknode_addref(toknode *node);
GLR_API void toknode_destroytt(toknode *node);
GLR_API void toknode_decref(toknode *node);

typedef struct tag_typestack
{
  toknode **nodes;
  size_t tncount, tncapacity;
} typestack;

GLR_API int typestack_bump_capacity(typestack *tstack);
GLR_API void *typestack_alloc(typestack *tstack, ttype *tt, int sym, int state);
GLR_API size_t measure_str(toknode *node, int ws);
GLR_API char *collect_str(toknode *node, char *dst, int ws);
GLR_API char *toknode_str(toknode *node);
GLR_API int typestack_pop(typestack *stk, size_t count);
GLR_API int typestack_moveone(typestack *dststk, typestack *srcstk);
GLR_API void typestack_clear(typestack *stk);
GLR_API size_t typestack_size(typestack *stk);
GLR_API toknode *typestack_top(typestack *stk);

typedef struct tag_symbol { const char *name; ttype *tt; } symbol;
typedef struct tag_production { int id, origid, nt, scount, *symbols, skcount, *skips; } production;
#ifdef NO_COMPRESSED_LR_TABLE
typedef struct tag_parse_action { int token, action, shiftto_or_reduceby; } parse_action;
typedef struct tag_parse_state { int acount; parse_action *actions; } parse_state;
#else
typedef struct tag_parse_action_range { int action, first, last, *range; } parse_action_range;
typedef struct tag_parse_state { int acount; parse_action_range *actions; } parse_state;
#endif
#ifdef NO_COMPRESSED_SCANNER
typedef struct tag_lxtr { int low, high, next, tok; } lxtr;
typedef struct tag_lxstnfo { int from, icount; lxtr *toranges; } lxstnfo;
typedef struct tag_tsinfo { int tokstate, lxcount; lxstnfo *lxinfos; } tsinfo;
#else
typedef struct tag_scnitem { int pos, off, count, lead, next; } scnitem;
typedef struct tag_tsinfo { int brkcount, *brks, statecount, *accepttoks, scncnt; scnitem *scnitems; } tsinfo;
#endif
GLR_API int subnodes_bump_capacity(toknode *node);
GLR_API int subnodes_add(toknode *node, toknode *sub);
GLR_API toknode *makews(toknode *wsdst, toknode *wssrc);
GLR_API void toknode_set_subnodes(toknode *node, toknode **nodes, int sncount);
GLR_API void toknode_unset_subnodes(toknode *node, toknode **nodes, int sncount);
GLR_API void toknode_keep_subnodes(toknode *node);

typedef struct tag_line_col {
  int line, col;
} line_col;

typedef struct lxact_tag { int sym, flags, next; } lxact;

GLR_API void update_buf_line_col(inbuf *buf, int len);

GLR_API int readtok(inbuf *buf, lxstack *lexstk, typestack *instk, outbuf *trace, int *isws, outbuf *oberr, int eof, tsinfo *tsinfos, symbol *allsymbols, lxact **lxactions);

typedef int (*reduce_action_fnct)(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr, void *pextra);

GLR_API int update_parse_state(typestack *prsstk, typestack *instk, toknode **nodes, inbuf *buf, outbuf *trace, line_col *err_lc,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int acceptstate,
                                outbuf *oberr,
                                reduce_action_fnct ra,
                                void *pextra
                                );

GLR_API int parse_any(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc,
                                tsinfo *tsinfos,
                                lxact **lxactions,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                int max_production_symbols,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int eoftok,
                                int acceptstate,
                                int parser_start_state,
                                int initial_tokenset,
                                reduce_action_fnct ra,
                                void *pextra);

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif /* __c_skeleton_decl */
#if defined(C_IO_STATIC) || defined(C_IO_CPP)
#ifdef __cplusplus
extern "C" {
#endif
// you may choose to define your own allocation function.
#ifndef vp_realloc
GLR_API void *vp_realloc(void *vp, size_t size) {
  if( ! vp && ! size )
    return 0;
  else if( ! vp )
    vp = malloc(size);
  else if( ! size ) {
    free(vp);
    return 0;
  }
  else
    vp = realloc(vp, size);
  return vp;
}
#endif
GLR_API void vp_memzero(void *dst, size_t size) {
  size_t i = 0;
  if( ! size )
    return;
  for( ; i < size; ++i )
    ((char*)dst)[i] = 0;
}
GLR_API char *nv_strdup(const char *str, size_t *len)
{
    char *sdup = 0;
    size_t slen = strlen(str), i = 0;
    if( len ) *len = slen;
    sdup = (char*)vp_realloc(0, slen+1);
    while( str[i] )
    {
        sdup[i] = str[i];
        ++i;
    }
    sdup[slen] = 0;
    return sdup;
}
#ifdef __cplusplus
} /* extern "C" */
#endif
#ifdef __cplusplus
extern "C" {
#endif
GLR_API inbuf *new_inbuf(size_t inbufsize, const char *fname, ibf_read readfnct, ibf_seek seekfnct, ibf_close closefnct)
{
  inbuf *buf = (inbuf*)vp_realloc(0, inbufsize);
  vp_memzero(buf, inbufsize);
  buf->readfnct = readfnct;
  buf->seekfnct = seekfnct;
  buf->closefnct = closefnct;
  buf->fname = fname ? fname : "";
  buf->line = buf->col = 1;
  buf->strbuf = 0;
  return buf;
}

GLR_API void free_inbuf(inbuf *buf)
{
    if( buf->closefnct ) buf->closefnct(buf);
    if(!buf->strbuf && buf->s) vp_realloc(buf->s, 0);
    vp_realloc(buf, 0);
}

GLR_API int ib_read(inbuf *buf, void *vp, int count)
{
    int rd = 0, i0, i1, n;
    char *dst = (char*)vp, *tmps = 0;
    if( ! buf->readfnct )
        return 0;
    while( count )
    {
        // Copy from the buffer if we can
        if( buf->pos < buf->count )
        {
            for( i0=0,i1=buf->pos, n=((count<=(buf->count-buf->pos))?count:(buf->count-buf->pos)); i0<n; ++i0,++i1 )
                dst[i0] = buf->s[i1];
            buf->pos += n;
            count -= n;
            rd += n;
            dst += n;
            continue;
        }
        // if we're out of file, stop.
        if( buf->eof )
            break;
        // Out of buffer, let's read large chunks directly into the destination.
        n = (count / BUF_BLOCK_SIZE) * BUF_BLOCK_SIZE;
        if(n)
        {
            buf->readfnct(buf, dst, n);
            buf->startpos += n;
            rd += n;
            dst += n;
            count -= n;
            continue;
        }
        // Out of large chunks, let's read a single chunk to the buffer (fast io, copy on next loop).
        if( buf->capacity < BUF_BLOCK_SIZE ) {
            // make sure we have a single chunk available
            tmps = (char*)vp_realloc(buf->s, BUF_BLOCK_SIZE);
            if( ! tmps ) break;
            buf->s = tmps;
            buf->capacity = BUF_BLOCK_SIZE;
        }
        buf->pos = 0;
        buf->startpos += buf->count;
        buf->count = buf->readfnct(buf, buf->s, BUF_BLOCK_SIZE);
        if( buf->count == 0 )
        {
            buf->eof = 1;
            break;
        }
    }
    return rd;
}

GLR_API foff_t ib_seek(inbuf *buf, foff_t to, int whence)
{
    // Seeks within the current buffer are handled without using seekfnct,
    // so file devices which buffer all of their contents, e.g. strings, require no seek function.
    if( whence == INBUF_SET )
    {
        if( (to>=buf->startpos) && (to<=buf->startpos+buf->count) )
        {
            buf->pos = (int)(to-buf->startpos);
            return to;
        }
    }
    else if( whence == INBUF_CUR )
    {
        if( (buf->pos+to) >= 0 && (buf->pos+to) <= buf->count )
        {
            buf->pos = buf->pos + (int)to;
            return buf->startpos+buf->pos;
        }
    }
    else if( whence == INBUF_END )
    {
        if( buf->eof && (to<=0) && (-to<=buf->count))
        {
            buf->pos = buf->count+(int)to;
            return buf->startpos+buf->pos;
        }
    }
    else
        return -1;
    // Anything with an actual backing store needs a seek funciton.
    if( ! buf->seekfnct )
        return -1;
    to = buf->seekfnct(buf, to, whence);
    if( to == -1 )
        return -1;
    buf->startpos = to;
    buf->pos = 0;
    buf->count = 0;
    return to;
}

GLR_API foff_t ib_tell(inbuf *buf)
{
    return buf->startpos + buf->pos;
}

GLR_API int read_file(fpinbuf *buf, void *dst, int count)
{
#ifdef _WIN32
  DWORD dwRead = 0;
  if( ! ReadFile(buf->h, dst, count, &dwRead, 0) )
    return 0;
  return dwRead;
#else
  ssize_t rdsz = read(buf->h, dst, count);
  if( rdsz == -1 )
      return 0;
  return rdsz;
#endif
}

GLR_API foff_t seek_file(fpinbuf *buf, foff_t to, int whence)
{
#ifdef _WIN32
    LARGE_INTEGER liDistanceToMove, liNewFilePointer;
    liDistanceToMove.QuadPart = to;
    if( ! SetFilePointerEx(buf->h, liDistanceToMove, &liNewFilePointer, whence) )
        return -1;
    return liNewFilePointer.QuadPart;
#else
    return lseek64(buf->h, to, whence);
#endif
}

GLR_API void close_file(fpinbuf *buf)
{
#ifdef _WIN32
    CloseHandle(buf->h);
#else
    close(buf->h);
#endif
}

GLR_API inbuf *h_inbuf(const char *fname, handle_t h, int handoff)
{
  fpinbuf *ret = (fpinbuf*)new_inbuf(sizeof(fpinbuf), fname, (ibf_read)read_file, (ibf_seek)seek_file, handoff ? (ibf_close)close_file : 0);
  ret->h = h;
  return (inbuf*)ret;
}

GLR_API inbuf *file_inbuf(const char *fname)
{
  fpinbuf *ret = 0;
#ifdef _WIN32
  HANDLE h = CreateFileA(fname, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if( h == INVALID_HANDLE_VALUE ) return 0;
#else
    int h = open(fname, O_RDONLY);
    if( h == -1 )
        return 0;
#endif
  return h_inbuf(fname, h, 1);
}

GLR_API int read_str(inbuf *buf, void *dst, int count) { return 0; }
GLR_API void close_str(inbuf *buf) {}

GLR_API inbuf *string_inbuf(const char *s, int staticstr)
{
  inbuf *ret = new_inbuf(sizeof(inbuf), "<string>", read_str, (ibf_seek)0, close_str);
  size_t len = 0;
  ret->strbuf = staticstr;
  if( staticstr )
      ret->eof = 1;
  if( ! staticstr )
    ret->s = nv_strdup(s, &len);
  else
  {
      ret->s = (char*)s;
      while( *s++ ) ++len;
  }
  ret->capacity = ret->count = (int)len;
  return ret;
}

GLR_API outbuf *new_ob(size_t size, obf_write writefnct, obf_flush flushfnct, obf_close closefnct)
{
    outbuf *out = (outbuf*)vp_realloc(0, size);
    vp_memzero(out, size);
    out->bufused = 0;
    out->writefnct = writefnct;
    out->flushfnct = flushfnct;
    out->closefnct = closefnct;
    out->colno = 1;
    out->lineno = 1;
    out->autoflush = 0;
    return out;
}

GLR_API void ob_write(outbuf *buf, const char *s, size_t len)
{
    int do_autoflush = 0;
    size_t a;
    for( a = 0; a < len; ++a )
    {
        if( s[a] == '\n' )
        {
            if( ! do_autoflush && buf->autoflush )
                do_autoflush = 1;
            buf->colno = 1;
            buf->lineno++;
        }
        else
            buf->colno++;
    }
    // fill the remaining buffer and write out if it is filled.
    if( buf->bufused )
    {
        a = SZ(buf->buffer)-buf->bufused;
        if( a )
        {
            if( a > len )
                a = len;
            memcpy(buf->buffer+buf->bufused, s, a);
            buf->bufused += a;
            len -= a;
            s += a;
        }
        if( buf->bufused == SZ(buf->buffer) )
        {
            buf->writefnct(buf, buf->buffer, buf->bufused);
            buf->bufused = 0;
        }
    }
    while( len >= BUF_BLOCK_SIZE )
    {
        buf->writefnct(buf, s, BUF_BLOCK_SIZE);
        len -= BUF_BLOCK_SIZE;
        s += BUF_BLOCK_SIZE;
    }
    if( len )
    {
        memcpy(buf->buffer, s, len);
        buf->bufused = len;
    }
    if( do_autoflush )
        ob_flush(buf);
}

GLR_API void ob_printf(outbuf *buf, const char *fmt, ...)
{
  va_list args;
  va_start(args,fmt);
  ob_vprintf(buf,fmt,args);
  va_end(args);
}

GLR_API void ob_vprintf(outbuf *buf, const char *fmt, va_list args)
{
  char sbuf[1024];
  size_t len = 0;
  if( ! buf )
      return;
  len = vsprintf(sbuf, fmt, args);
  if( len )
    ob_write(buf, sbuf, len);
}

GLR_API void ob_putc(outbuf *buf, int c)
{
    char ch = c;
    ob_write(buf, &ch, 1);
}

GLR_API void ob_puts(outbuf *buf, const char *s)
{
    const char *send = s;
    while( *send ) ++send;
    ob_write(buf, s, send-s);
}

GLR_API void ob_flush(outbuf *buf)
{
    if( buf->bufused )
    {
        buf->writefnct(buf, buf->buffer, buf->bufused);
        buf->bufused = 0;
    }
    if( buf->flushfnct )
        buf->flushfnct(buf);
}

GLR_API void free_ob(outbuf *buf)
{
    if( buf->bufused )
    {
        buf->writefnct(buf, buf->buffer, buf->bufused);
        buf->bufused = 0;
    }
    ob_flush(buf);
    vp_realloc(buf, 0);
}

GLR_API void file_write(file_outbuf *buf, const char *s, size_t len)
{
#ifdef _WIN32
  DWORD dwWrote = 0;
  WriteFile(buf->h, s, (DWORD)len, &dwWrote, 0);
#else
  ssize_t wrote = write(buf->h, s, len);
#endif
}

GLR_API void file_flush(file_outbuf *buf)
{
#ifdef _WIN32
    FlushFileBuffers(buf->h);
#else
    fsync(buf->h);
#endif
}

GLR_API void file_close(file_outbuf *buf)
{
#ifdef _WIN32
    CloseHandle(buf->h);
#else
    close(buf->h);
#endif
}

GLR_API outbuf *new_h_outbuf(const char *fname, handle_t h, int handoff, int autoflush)
{
    file_outbuf *out = (file_outbuf*)new_ob(sizeof(file_outbuf), (obf_write)file_write, (obf_flush)file_flush, handoff ? (obf_close)file_close : 0);
    out->h = h;
    out->base.autoflush = autoflush;
    return (outbuf*)out;
}

GLR_API outbuf *new_file_outbuf(const char *fname)
{
    file_outbuf *out = 0;
#ifdef _WIN32
    HANDLE h = CreateFileA(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    if( h == INVALID_HANDLE_VALUE )
        return 0;
    if( GetLastError() == ERROR_ALREADY_EXISTS )
    {
        SetFilePointer(h, 0, 0, FILE_BEGIN);
        SetEndOfFile(h);
    }
#else
    int h = open(fname, O_WRONLY|O_CREAT|O_TRUNC);
    if( h == -1 )
        return 0;
#endif
    return new_h_outbuf(fname, h, 1, 0);
}

GLR_API void string_write(string_outbuf *buf, const char *s, size_t len)
{
    char *dst = 0;
    if( ! len ) return;
    if( buf->count+(int)len+1 > buf->capacity )
        buf->buf = (char*)vp_realloc(buf->buf, buf->count+len+1);
    dst = buf->buf+buf->count;
    while( len-- )
        *dst++ = *s++;
    *dst = 0;
}

GLR_API void string_close(string_outbuf *buf)
{
    vp_realloc(buf->buf, 0);
}

GLR_API outbuf *new_string_outbuf()
{
    return new_ob(sizeof(string_outbuf), (obf_write)string_write, (obf_flush)0, (obf_close)string_close);
}

GLR_API void obs_clear(outbuf *buf)
{
    string_outbuf *obs = (string_outbuf*)buf;
    obs->base.bufused = 0;
    obs->count = 0;
}

GLR_API const char *obs_getstr(outbuf *buf)
{
    string_outbuf *obs = (string_outbuf*)buf;
    if( obs->base.bufused )
        ob_flush(buf);
    return obs->buf;
}

#ifdef __cplusplus
} /* extern "C" */
#endif
#ifdef __cplusplus
extern "C" {
#endif
ttype ptr_tt = {"*", sizeof(void*), 0, 0};

GLR_API int lxstack_push(lxstack *stk, int i)
{
  int newcapacity = 0;
  int *newi = 0;
  if( stk->count == stk->capacity ) {
    newcapacity = stk->capacity ? (stk->capacity * 2) : 16;
    newi = (int*)vp_realloc(stk->i, newcapacity*sizeof(int));
    if( ! newi ) return 0;
    stk->i = newi;
    stk->capacity = newcapacity;
  }
  stk->i[stk->count++] = i;
  return 1;
}
GLR_API int lxstack_pop(lxstack *stk)
{
  if( stk->count == 0 ) return -1;
  return stk->i[--stk->count];
}
GLR_API int lxstack_size(lxstack *stk) { return stk->count; }
GLR_API void lxstack_clear(lxstack *stk)
{
  if( stk->i ) { vp_realloc(stk->i, 0); stk->i = 0; }
  stk->count = 0;
  stk->capacity = 0;
}
GLR_API int lxstack_top(lxstack *stk)
{
  if( ! stk->count ) return -1;
  return stk->i[stk->count-1];
}
GLR_API toknode *new_toknode(size_t size, ttype *tt, int sym, int state)
{
  toknode *node = (toknode*)vp_realloc(0, sizeof(toknode));
  vp_memzero(node, sizeof(toknode));
  if( size ) {
    node->vp = vp_realloc(0, size);
    vp_memzero(node->vp, size);
    node->size = size;
    node->tt = tt;
    if( tt && tt->init )
        tt->init(node->vp);
  }
  node->ref = 1;
  node->sym = sym;
  node->state = state;
  return node;
}
GLR_API void toknode_addref(toknode *node) { if(node) ++node->ref; }
GLR_API void toknode_destroytt(toknode *node)
{
  if( ! node || ! node->vp )
    return;
  if( node->tt && node->tt->destroy )
    node->tt->destroy(node->vp);
  vp_realloc(node->vp, 0);
  node->size = 0;
  node->vp = 0;
  node->tt = 0;
}
GLR_API void toknode_flatten(toknode *node)
{
    size_t i = 0, j = 0, endj = 0;
    toknode *cursubnode = 0;
    if( node->wstop )
    {
        subnodes_add(node, node->wstop);
        node->wstop = 0;
    }
    if( node->wsbottom )
    {
        subnodes_add(node, node->wsbottom);
        node->wsbottom = 0;
    }
    // notice that node->sncount may grow on each iteration.
    for( i = 0; i < node->sncount; ++i )
    {
        cursubnode = node->subnodes[i];
        if( ! cursubnode || cursubnode->ref > 1 )
            continue;
        if( cursubnode->wstop )
        {
            subnodes_add(node, cursubnode->wstop);
            cursubnode->wstop = 0;
        }
        if( cursubnode->wsbottom )
        {
            subnodes_add(node, cursubnode->wsbottom);
            cursubnode->wsbottom = 0;
        }
        j = 0;
        endj = cursubnode->sncount;
        for( ; j < endj; ++j )
            subnodes_add(node, cursubnode->subnodes[j]);
        cursubnode->sncount = 0;
    }
}
GLR_API void toknode_decref(toknode *node)
{
  size_t i;
  if( ! node )
    return;
  if( --node->ref > 0 )
    return;
  toknode_destroytt(node);
  if(node->tokstr) {
    vp_realloc(node->tokstr, 0);
    node->tokstr = 0;
  }
  /*
  The original code looked like this...

  if(node->wstop) {
    toknode_decref(node->wstop);
    node->wstop = 0;
  }
  if(node->wsbottom) {
    toknode_decref(node->wsbottom);
    node->wsbottom = 0;
  }
  for( i = 0; i < node->sncount; ++i )
    toknode_decref(node->subnodes[i]);

  unfortunately, we would get stack overflow
  when the call tree was very deep.  So instead,
  we'll decref by iteration instead of recursion.
  */
  if( node->wstop || node->wsbottom || node->sncount )
  {
    toknode_flatten(node);
    for( i = 0; i < node->sncount; ++i )
        toknode_decref(node->subnodes[i]);
  }
  node->sncount = node->sncapacity = 0;
  vp_realloc(node->subnodes, 0);
  node->subnodes = 0;
  vp_realloc(node, 0);
}
GLR_API int typestack_bump_capacity(typestack *tstack) {
  size_t newcapacity = 0;
  toknode **nodes = 0;
  if( tstack->tncount == tstack->tncapacity )
  {
    newcapacity = tstack->tncapacity ? (tstack->tncapacity * 2) : 16;
    nodes = (toknode**)vp_realloc(tstack->nodes, newcapacity*sizeof(toknode*));
    if( ! nodes )
      return 0;
    tstack->nodes = nodes;
    tstack->tncapacity = newcapacity;
  }
  return 1;
}
GLR_API void *typestack_alloc(typestack *tstack, ttype *tt, int sym, int state) {
  toknode *node = 0;
  size_t size = tt ? tt->size : 0;
  if( ! typestack_bump_capacity(tstack) )
      return 0;
  node = new_toknode(size, tt, sym, state);
  tstack->nodes[tstack->tncount++] = node;
  return node->vp;
}
GLR_API size_t measure_str(toknode *node, int ws) {
  size_t i, slen = 0;
  if( ! node )
    return 0;
  if( ws && node->wstop )
    slen += measure_str(node->wstop,1);
  if( node->sncount == 0 && node->tokstr )
      slen += node->tokslen;
  else {
    for( i = 0; i < node->sncount; ++i )
      slen += measure_str(node->subnodes[i],1);
  }
  if( ws && node->wsbottom )
    slen += measure_str(node->wsbottom,1);
  return slen;
}
GLR_API char *collect_str(toknode *node, char *dst, int ws) {
  size_t i = 0, n = 0;
  if( ! node )
    return dst;
  if( ws && node->wstop )
    dst = collect_str(node->wstop, dst, 1);
  if( node->sncount == 0 && node->tokstr ) {
    for( i = 0, n = node->tokslen; i < n; ++i )
      dst[i] = node->tokstr[i];
    dst += n;
  } else {
    for( i = 0; i < node->sncount; ++i )
      dst = collect_str(node->subnodes[i], dst, 1);
  }
  if( ws && node->wsbottom )
    dst = collect_str(node->wsbottom, dst, 1);
  return dst;
}
GLR_API char *toknode_str(toknode *node) {
  if( ! node )
    return "";
  if( node->sncount == 0 && node->tokstr )
    return node->tokstr;
  node->tokslen = measure_str(node,0);
  node->tokstr = (char*)vp_realloc(node->tokstr,node->tokslen+1);
  *collect_str(node,node->tokstr,0) = 0;
  return node->tokstr;
}
GLR_API int typestack_pop(typestack *stk, size_t count)
{
  int i = 0, n = 0;
  if( count > stk->tncount )
    return 0;
  for( i = (int)stk->tncount-1, n = (int)(stk->tncount-count); i >= n; --i )
    toknode_decref(stk->nodes[i]);
  stk->tncount -= count;
  return 1;
}
GLR_API int typestack_moveone(typestack *dststk, typestack *srcstk)
{
  if( srcstk->tncount == 0 )
    return 0;
  if( ! typestack_bump_capacity(dststk) )
    return 0;
  dststk->nodes[dststk->tncount++] = srcstk->nodes[--srcstk->tncount];
  return 1;
}
GLR_API void typestack_clear(typestack *stk)
{
  typestack_pop(stk, stk->tncount);
  vp_realloc(stk->nodes, 0);
  stk->nodes = 0;
  stk->tncount = 0;
  stk->tncapacity = 0;
}
GLR_API size_t typestack_size(typestack *stk) { return stk->tncount; }
GLR_API toknode *typestack_top(typestack *stk)
{
  if( ! stk->tncount ) return 0;
  return stk->nodes[stk->tncount-1];
}
GLR_API int subnodes_bump_capacity(toknode *node) {
  size_t newcapacity = 0;
  toknode **subnodes = 0;
  if( node->sncount == node->sncapacity )
  {
    newcapacity = node->sncapacity ? (node->sncapacity * 2) : 16;
    subnodes = (toknode**)vp_realloc(node->subnodes, newcapacity*sizeof(toknode*));
    if( ! subnodes )
      return 0;
    node->subnodes = subnodes;
    node->sncapacity = newcapacity;
  }
  return 1;
}
GLR_API int subnodes_add(toknode *node, toknode *sub) {
  if( ! subnodes_bump_capacity(node) ) return 0;
  node->subnodes[node->sncount++] = sub;
  return 1;
}
GLR_API toknode *makews(toknode *wsdst, toknode *wssrc) {
    toknode *tmp = 0;
    if( ! wsdst ) return wssrc;
    if( ! wssrc ) return wsdst;
    if( wsdst->sncount ) {
      subnodes_add(wsdst, wssrc);
      return wsdst; }
    tmp = new_toknode(0,0,0,0);
    subnodes_add(tmp, wsdst);
    subnodes_add(tmp, wssrc);
    return tmp;
}
GLR_API void toknode_set_subnodes(toknode *node, toknode **nodes, int sncount) {
  int i = 0;
  node->subnodes = (toknode**)vp_realloc(node->subnodes, sizeof(toknode*)*sncount);
  node->sncount = node->sncapacity = sncount;
  for( ; i < sncount; ++i )
    node->subnodes[i] = nodes[i];
  // copy leading and trailing ws to the nonterminal
  for( i = 0; i < sncount && node->subnodes[i] == 0; ++i );
  if( i < sncount && node->subnodes[i]->wstop ) {
    node->wstop = node->subnodes[i]->wstop;
    node->subnodes[i]->wstop = 0;
  }
  for( i = sncount-1; i >= 0 && node->subnodes[i] == 0; --i );
  if( i >= 0 && node->subnodes[i]->wsbottom ) {
    node->wsbottom = node->subnodes[i]->wsbottom;
    node->subnodes[i]->wsbottom = 0;
  }
}
GLR_API void toknode_unset_subnodes(toknode *node, toknode **nodes, int sncount) {
  int i = 0;
  // copy leading and trailing ws back to the terminals
  for( i = 0; i < sncount && node->subnodes[i] == 0; ++i );
  if( i < sncount && node->subnodes[i]->wstop ) {
    node->subnodes[i]->wstop = node->wstop;
    node->wstop = 0;
  }
  for( i = sncount-1; i >= 0 && node->subnodes[i] == 0; --i );
  if( i >= 0 && node->subnodes[i]->wsbottom ) {
    node->subnodes[i]->wsbottom = node->wsbottom;
    node->wsbottom = 0;
  }
  node->sncount = node->sncapacity = 0;
  (toknode**)vp_realloc(node->subnodes, 0);
  node->subnodes = 0;
}
GLR_API void toknode_keep_subnodes(toknode *node) {
  size_t i = 0, sncount = node->sncount;
  for( ; i < sncount; ++i )
    toknode_destroytt(node->subnodes[i]);
}
GLR_API void update_buf_line_col(inbuf *buf, int len)
{
  int i;
  for( i = 0; i < len; ++i ) {
      if( buf->s[buf->pos+i] == '\n' ) { buf->line++; buf->col = 1; } else buf->col++;
  }
}
#ifdef NO_COMPRESSED_SCANNER
GLR_API int next_state(int c, int curs, int lexs, int *plastaccepttok, tsinfo *tsinfos)
{
    lxstnfo *lxinfo = lxinfo = tsinfos[lexs].lxinfos+curs;
    int low = 0, high = lxinfo->icount-1, mid = 0, nexts = -1;
    lxtr *ranges = 0;
    *plastaccepttok = -1;
    while( low <= high ) {
        mid = (low+high)/2; ranges = lxinfo->toranges + mid;
        if( c < ranges->low ) { high = mid-1; continue; }
        if( c > ranges->high ) { low = mid+1; continue; }
        nexts = ranges->next;
        if( ranges->tok != -1 ) *plastaccepttok = ranges->tok;
        break;
    }
    return nexts;
}
#else
GLR_API int next_state(int c, int curs, int lexs, int *plastaccepttok, tsinfo *tsinfos)
{
    tsinfo *tsfo = tsinfos+lexs;
    int brk = -1, high, low, mid, seek, s;
    scnitem *scnit = 0;

    low = 0; high = tsfo->brkcount-2;
    while(low<=high)
    {
        mid = (low+high)/2;
        if( c < tsfo->brks[mid] )
        {
            high = mid-1;
            continue;
        }
        if( c >= tsfo->brks[mid+1] )
        {
            low = mid+1;
            continue;
        }
        break;
    }
    brk = mid;

    high = tsfo->scncnt-1;
    seek = curs*tsfo->brkcount+brk;
    while(1)
    {
        low = 0;
        while( low <= high )
        {
            mid = (low+high)/2;
            scnit = tsfo->scnitems+mid;
            if( seek < scnit->pos )
            {
                high = mid-1;
                continue;
            }
            if( seek > scnit->pos+scnit->count )
            {
                low = mid+1;
                continue;
            }
            break;
        }
        if(low>high)
            return -1;
        if(scnit->pos+scnit->count == seek)
            break;
        high = mid-1;
        seek = scnit->off + ((seek - scnit->pos) % scnit->lead);
    }
    s = scnit->next;
    if(s < 0 || s >= tsfo->statecount)
    {
        s = -1;
        *plastaccepttok = -1;
    }
    else
        *plastaccepttok = tsfo->accepttoks[s];
    return s;
}
#endif
GLR_API int readtok(inbuf *buf, lxstack *lexstk, typestack *instk, outbuf *trace, int *isws, outbuf *oberr, int eof, tsinfo *tsinfos, symbol *allsymbols, lxact **lxactions)
{
  int pos = 0, s = 0, lexs = 0, c = 0, accepttok = -1, lastaccepttok = -1, lastacceptlen = 0, i = 0, n = 0, low = 0, high = 0, mid = 0, rd = 0, nc = 0, fr = 0, mbdec_i = 0, mbdec_n = 0;
  char **ptok = 0, *tok = 0, *tmps = 0;
  toknode *node = 0;
  lxact *tkact = 0;
  lexs = lxstack_top(lexstk);
  pos = buf->pos;
  *isws = 0;
  while( c != -1 && s != -1 ) {
    if( pos == buf->count ) {
      //read more buffer if you can
      if( ! buf->eof ) {
        if( buf->pos >= BUF_BLOCK_SIZE ) {
            //use the space in the existing buffer
            fr = (buf->pos / BUF_BLOCK_SIZE) * BUF_BLOCK_SIZE;
            buf->startpos += fr;
            for( i = 0, n = buf->capacity-fr; i < n; ++i ) buf->s[i] = buf->s[fr+i];
            buf->count -= fr;
            buf->pos -= fr;
            pos -= fr;
        }
        else {
            //make more space in the buffer
            nc = buf->capacity + BUF_BLOCK_SIZE; fr = BUF_BLOCK_SIZE;
            tmps = (char*)vp_realloc(buf->s, nc);
            if( ! tmps ) return 0;
            buf->s = tmps; buf->capacity = nc;
        }
        rd = buf->readfnct(buf, buf->s+buf->count, fr);
        if( rd < fr )
          buf->eof = 1;
        buf->count += rd;
      }
      //we are really out of buffer
      if( pos == buf->count ) {
        //we're out, but we've consumed some buffer, so it's a token, or an error.
        if( pos > buf->pos )
          break;
        //we're out, and haven't consumed any buffer, so it's EOF
        typestack_alloc(instk, 0, eof, -1);
        node = typestack_top(instk);
        node->line = buf->line;
        node->col = buf->col;
        return 1;
      }
    }
    //get the next code point
    if( ! mbdec_n )
    {
        c = ((unsigned char*)buf->s)[pos++];
        if( c > 0x7F )
        {
            // started a multi-byte fetch.
            mbdec_i = 0;
            mbdec_n = 0;
            while( c & 0x0080 )
            {
                c <<= 1;
                mbdec_n++;
            }
            c &= 0x007F;
            c >>= mbdec_n;
        }
    }
    // if we've started or are continuing a multi-byte fetch, proceed.
    while(mbdec_n && pos < buf->count)
    {
        --mbdec_n;
        rd = ((unsigned char*)buf->s)[pos++];
	    if( (rd & 0xC0000000) != 0x80000000 )
        {
            update_buf_line_col(buf, pos-buf->pos);
            ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, bad multibyte encoding byte %d\n", buf->fname, buf->line, buf->col, mbdec_i+2);
		    return 0;
        }
	    if( mbdec_i == 0 && (rd & 0x3FFFFFFF) == 0 )
        {
            update_buf_line_col(buf, pos-buf->pos);
            ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, overlong encoding\n", buf->fname, buf->line, buf->col);
		    return 0;
        }
        c = (c<<6)|(rd&0x7F);
        mbdec_i++;
    }
    if( mbdec_n )
    {
        if( ! buf->eof )
            continue;
        update_buf_line_col(buf, pos-buf->pos);
        ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, eof while doing multi-byte decoding\n", buf->fname, buf->line, buf->col);
	    return 0;        
    }
    //do a binary search for the next state
    s = next_state(c, s, lexs, &accepttok, tsinfos);
    if( accepttok != -1 )
    {
        lastaccepttok = accepttok;
        lastacceptlen = pos-buf->pos;
    }
  }
  if( lastaccepttok == -1 ) {
      ob_printf(oberr, "%s:%d:%d: error: tokenizer stall\n", buf->fname, buf->line, buf->col); return 0; }
  if( trace )
    ob_printf(trace, "read token %s\n", allsymbols[lastaccepttok].name);
  ptok = (char**)typestack_alloc(instk, &ptr_tt, lastaccepttok, -1);
  node = typestack_top(instk);
  node->line = buf->line;
  node->col = buf->col;
  node->tokslen = lastacceptlen;
  node->tokstr = tok = *ptok = (char*)vp_realloc(0, lastacceptlen+1);
  for( i = 0; i < lastacceptlen; ++i ) tok[i] = buf->s[buf->pos+i];
  tok[lastacceptlen] = 0;
  update_buf_line_col(buf, lastacceptlen);
  buf->pos += lastacceptlen;
  tkact = lxactions[lexs];
  while( tkact->sym != -1 && tkact->sym != lastaccepttok )
    ++tkact;
  switch(tkact->flags){
    case PUSH_FLAG: lxstack_push(lexstk, tkact->next); break;
    case POP_FLAG:
      lxstack_pop(lexstk);
      if( lexstk->count == 0 ) {
        ob_printf(oberr, "empty lexer state stack\n"); return 0; }
      break;
    case GOTO_FLAG: lexstk->i[lexstk->count-1] = tkact->next; break;
    case WS_FLAG:
      *isws = 1;
      break;
    default: break;
  }
  return 1;
}

#ifdef NO_COMPRESSED_LR_TABLE
#define ACTION_SYMBOL(a,s) ((a)->shiftto_or_reduceby)
#else
#define FIRST_SYMBOL(a) ((a)->range[1])
#define LAST_SYMBOL(a) ((a)->range[(a)->range[0]*2])
#define ACTION_SYMBOL(a,s) (((a)->first)+(((a)->first==(a)->last)?0:((s)-FIRST_SYMBOL(a))))
#endif

GLR_API int update_parse_state(typestack *prsstk, typestack *instk, toknode **nodes, inbuf *buf, outbuf *trace, line_col *err_lc,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int acceptstate,
                                outbuf *oberr,
                                reduce_action_fnct ra,
                                void *pextra
                                )
{
  int state = -1, tok = -1, low = 0, high = 0, mid = 0, gotlc = 0, stkpos = -1;
  parse_state *ps = 0;
#ifdef NO_COMPRESSED_LR_TABLE
  parse_action *action = 0;
#else
  parse_action_range *action = 0;
#endif
  production *p = 0, *pO = 0; ttype *tt = 0;
#ifndef NO_COMPRESSED_LR_TABLE
  int *srange = 0;
#endif
  int *skips = 0, *endskips = 0;
  toknode **curnode = 0, **dstnode = 0, *ntnode = 0, *errnode = 0;
  
  while( typestack_size(instk) ) {
    tok = typestack_top(instk)->sym;
    state = typestack_top(prsstk)->state;
    if( state < 0 ) break;
    ps = parse_states+state;
    low = 0; high = ps->acount-1;
    while( low <= high ) {
      mid = (low+high)/2;
      action = ps->actions+mid;
#ifdef NO_COMPRESSED_LR_TABLE
      if( tok < action->token ) { high = mid-1; continue; }
      if( tok > action->token ) { low = mid+1; continue; }
#else
      if( tok < FIRST_SYMBOL(action) ) { high = mid-1; continue; }
      if( tok > LAST_SYMBOL(action) ) { low = mid+1; continue; }
#endif
      break;
    }
#ifdef NO_COMPRESSED_LR_TABLE
    if(tok != action->token) {
#else
    if( low <= high ) {
        // we found a candidate action range, now see if it pans out.
        low = 0; high = action->range[0]-1;
        while( low <= high ) {
          mid = (low+high)/2;
          srange = action->range+1+mid*2;
          if( tok < srange[0] ) { high = mid-1; continue; }
          if( tok > srange[1] ) { low = mid+1; continue; }
          break;
        }
    }
    if( low > high ) {
#endif
      // An error!
      if( typestack_top(prsstk)->sym == errtok )
      {
          if(trace)
            ob_printf(trace, "handling parse error: discarding token\n", tok);
          typestack_pop(instk, 1);
          continue;
      }
      // Search for an error handling production
      for(stkpos=(int)typestack_size(prsstk)-1;stkpos>=0;--stkpos)
      {
          tok = prsstk->nodes[stkpos]->sym;
          state = prsstk->nodes[stkpos]->state;
          if(state<0) { stkpos=-1; break; }
          ps = parse_states+state;
          if(!ps->acount) continue;
          mid = 0;
#if NO_COMPRESSED_LR_TABLE
          while(ps->actions[mid].token<errtok) ++mid;
          if( ps->actions[mid].token == errtok && ps->actions[mid].action == SH )
#else
          while( LAST_SYMBOL(ps->actions+mid) < errtok) ++mid;
          if( errtok >= FIRST_SYMBOL(ps->actions+mid) && errtok <= LAST_SYMBOL(ps->actions+mid) && ps->actions[mid].action == SH )
#endif
            break; // found it, stkpos != -1
      }
      if(stkpos==-1)
      {
        // No production we are building handles errors, stop parsing.
        ntnode = typestack_top(instk);
        ob_printf(oberr, "%s:%d:%d: error: parse error\n", buf->fname, ntnode->line, ntnode->col);
        if( err_lc ) {
          err_lc->line = ntnode->line;
          err_lc->col = ntnode->col;
        }
        return 0;
      }
      // This production handles errors, shift the error and carry on.
      action = ps->actions+mid;
      typestack_pop(prsstk, stkpos-typestack_size(prsstk)-1);
      if(trace)
        ob_printf(trace, "parse error: shift to %d\n", ACTION_SYMBOL(action,errtok));
      typestack_alloc(prsstk, 0, errtok, ACTION_SYMBOL(action,errtok));
      errnode = typestack_top(prsstk);
      ntnode = typestack_top(instk);
      errnode->line = ntnode->line;
      errnode->col = ntnode->col;
      continue;
    }
    if( action->action == SH ) {
      if( trace )
        ob_printf(trace, "shift to %d\n", ACTION_SYMBOL(action,tok));
      if( ! typestack_moveone(prsstk, instk) )
        return 0;
      typestack_top(prsstk)->state = ACTION_SYMBOL(action,tok);
      continue;
    }
    for( low = 0, high = ps->acount; low <= high; ++low ) {
      p = productions+ACTION_SYMBOL(action,tok);
      pO = productions+(p->origid-production_adjust_count);
      skips = p->skips; endskips = skips+p->skcount;
      tt = allsymbols[p->nt].tt;
      typestack_alloc(instk, tt, pO->id, -1);
      ntnode = typestack_top(instk);
      dstnode = nodes;
      gotlc = 0;
      *dstnode++ = ntnode;
      curnode = prsstk->nodes+(prsstk->tncount-p->scount);
      for( low = 0, high = pO->scount; low < high; ++low )
        if( skips < endskips && low == *skips )
            *dstnode++ = 0, ++skips;
        else {
            if( ! gotlc ) {
              ntnode->line = (*curnode)->line; ntnode->col = (*curnode)->col; gotlc = 1; }
            *dstnode++ = *curnode++;
        }
      if( ! gotlc ) { ntnode->line = buf->line; ntnode->col = buf->col; }
      toknode_set_subnodes(ntnode, nodes+1, pO->scount);
      if( trace )
        ob_printf(trace, "reduce %d by production %d", p->scount, p->id-production_adjust_count);
      if( ra(nodes, p->origid, buf->fname, ntnode->line, ntnode->col, oberr, pextra) ) {
        if( trace )
          ob_printf(trace, " (ok)\n");
        toknode_keep_subnodes(ntnode);
        prsstk->tncount -= p->scount;
        if( p->nt == starttok ) {
          if( ! typestack_moveone(prsstk, instk) )
            return 0;
          typestack_top(prsstk)->state = acceptstate;
          return 1;
        }
        break;
      }
      if( trace )
        ob_printf(trace, " (failed)\n");
      toknode_unset_subnodes(ntnode, nodes+1, pO->scount);
      typestack_pop(instk, 1);
      ++action;
    }
    if( low > high )
      return 0;
  }
  return 1;
}

GLR_API int parse_any(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc,
                                tsinfo *tsinfos,
                                lxact **lxactions,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                int max_production_symbols,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int eoftok,
                                int acceptstate,
                                int parser_start_state,
                                int initial_tokenset,
                                reduce_action_fnct ra,
                                void *pextra)
{
  size_t i, n;
  lxstack lexstk = NULL_LXSTACK;
  typestack instk = NULL_TYPESTACK;
  typestack prsstk = NULL_TYPESTACK;
  int ret = 1, isws = 0;
  toknode **nodes = (toknode**)vp_realloc(0, (max_production_symbols+1)*sizeof(toknode*));
  if( err_lc ) { err_lc->line = 0; err_lc->col = 0; }
  lxstack_push(&lexstk, initial_tokenset);
  typestack_alloc(&prsstk, &ptr_tt, 0, parser_start_state);
  do {
    if( ! readtok(buf, &lexstk, &instk, trace, &isws, obuf, eoftok, tsinfos, allsymbols, lxactions) ) {
      if( err_lc ) {
        err_lc->line = buf->line;
        err_lc->col = buf->col;
      }
      ret = 0; goto cleanup; }
    if( isws ) {
      //append whitespace to the end of the last token
      prsstk.nodes[prsstk.tncount-1]->wsbottom = makews(prsstk.nodes[prsstk.tncount-1]->wsbottom, instk.nodes[--instk.tncount]);
      continue; }
    //move accumulated whitespace from the end of the last token to the beginning of the next one
    if( prsstk.nodes[prsstk.tncount-1]->wsbottom ) {
      instk.nodes[instk.tncount-1]->wstop = makews(instk.nodes[instk.tncount-1]->wstop, prsstk.nodes[prsstk.tncount-1]->wsbottom);
      prsstk.nodes[prsstk.tncount-1]->wsbottom = 0;
    }
    if( ! update_parse_state(&prsstk, &instk, nodes, buf, trace,
                                        err_lc, parse_states, productions, production_adjust_count,
                                        allsymbols, starttok, errtok, acceptstate, obuf,
                                        ra, pextra) ) {
        ret = 0; goto cleanup; }
    if( trace ) {
      ob_printf(obuf, "state stack:");
      for( i = 0, n = prsstk.tncount; i < n; ++i )
        ob_printf(obuf, " %d", prsstk.nodes[i]->state);
      ob_printf(obuf, "\n");
    }
  } while( typestack_top(&prsstk)->state != acceptstate );
cleanup:
  vp_realloc(nodes, 0);
  typestack_clear(&prsstk); typestack_clear(&instk); lxstack_clear(&lexstk);
  return ret;
}

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif
#define INITIAL_TOKENSET (0)
#define EXPECT_TOKEN_TOKENSET (1)
#define SYMID_LTSTARTGT (0)
#define SYMID_DOL (1)
#define SYMID_LTEGT (2)
#define SYMID_LTERRORGT (3)
#define SYMID_RXIF (4)
#define SYMID_RXELSE_IF (5)
#define SYMID_RXELSE (6)
#define SYMID_RXFOR_EACH (7)
#define SYMID_RXEND (8)
#define SYMID_RXSECTION (9)
#define SYMID_RXFSLLBR0x0BSLTRBRSTPNDEXEXLBRCRTBSLNRBRSTBSLNFSL (10)
#define SYMID_RXFSLBSLBSLBSLRQBSLNFSL (11)
#define SYMID_LITDOLLPRNAMERPR (12)
#define SYMID_LITDOLLPRSTARTTOKRPR (13)
#define SYMID_LITDOLLPREOFTOKRPR (14)
#define SYMID_LITDOLLPRERRTOKRPR (15)
#define SYMID_LITDOLLPRPRODUCTION_ADJUST_COUNTRPR (16)
#define SYMID_LITDOLLPRMAX_PRODUCTION_SYMBOLSRPR (17)
#define SYMID_LITDOLLPRGLOBAL_CTYPERPR (18)
#define SYMID_LITDOLLPRPRODUCTION_IDRPR (19)
#define SYMID_LITDOLLPRORIGINAL_PRODUCTION_IDRPR (20)
#define SYMID_LITDOLLPRNT_INDEXRPR (21)
#define SYMID_LITDOLLPRSYMBOL_COUNTRPR (22)
#define SYMID_LITDOLLPRREDUCE_SRCRPR (23)
#define SYMID_LITDOLLPRSYMBOL_TYPERPR (24)
#define SYMID_LITDOLLPRSYMBOL_TYPE_FRIENDLY_NAMERPR (25)
#define SYMID_LITDOLLPRIN_PRODUCTION_INDEXRPR (26)
#define SYMID_LITDOLLPRCTYPERPR (27)
#define SYMID_LITDOLLPRCTYPE_FRIENDLY_NAMERPR (28)
#define SYMID_LITDOLLPRLINERPR (29)
#define SYMID_LITDOLLPRLINEP1RPR (30)
#define SYMID_LITDOLLPRFILERPR (31)
#define SYMID_LITDOLLPRSRCLINERPR (32)
#define SYMID_LITDOLLPRSRCFILERPR (33)
#define SYMID_LITDOLLPRSRCRPR (34)
#define SYMID_LITDOLLPRSTATERPR (35)
#define SYMID_LITDOLLPRSTATECOUNTRPR (36)
#define SYMID_LITDOLLPRPARSE_ACTION_COUNTRPR (37)
#define SYMID_LITDOLLPRTOKEN_IDRPR (38)
#define SYMID_LITDOLLPRSHIFT_TORPR (39)
#define SYMID_LITDOLLPRREDUCE_BYRPR (40)
#define SYMID_LITDOLLPRTOKENSETNAMERPR (41)
#define SYMID_LITDOLLPRTOKENSETSTATERPR (42)
#define SYMID_LITDOLLPRTOKENSETSTATECOUNTRPR (43)
#define SYMID_LITDOLLPRACCEPTTOKRPR (44)
#define SYMID_LITDOLLPRNEXT_STATERPR (45)
#define SYMID_LITDOLLPRFROM_STATERPR (46)
#define SYMID_LITDOLLPRTO_STATERPR (47)
#define SYMID_LITDOLLPRRANGE_MINRPR (48)
#define SYMID_LITDOLLPRRANGE_MAXRPR (49)
#define SYMID_LITDOLLPRPARTIAL_ACCEPT_TOKRPR (50)
#define SYMID_LITDOLLPRSYMBOL_INDEXRPR (51)
#define SYMID_LITDOLLPRSYMBOL_FRIENDLY_NAMERPR (52)
#define SYMID_LITDOLLPRPRODUCTION_FRIENDLY_NAMERPR (53)
#define SYMID_LITDOLLPRSYMBOL_NAMERPR (54)
#define SYMID_LITDOLLPRINITIAL_LEXERRPR (55)
#define SYMID_LITDOLLPRPARSER_START_STATERPR (56)
#define SYMID_LITDOLLPRSKIPINDEXRPR (57)
#define SYMID_LITDOLLPRFIRST_ACTION_IDXRPR (58)
#define SYMID_LITDOLLPRLAST_ACTION_IDXRPR (59)
#define SYMID_LITDOLLPRRANGE_IDXRPR (60)
#define SYMID_LITDOLLPRRANGE_SIZERPR (61)
#define SYMID_LITDOLLPRACTION_RANGE_MINRPR (62)
#define SYMID_LITDOLLPRACTION_RANGE_MAXRPR (63)
#define SYMID_LITDOLLPRCOMPRESSED_BREAKRPR (64)
#define SYMID_LITDOLLPRCOMPRESSED_LXITEM_POSRPR (65)
#define SYMID_LITDOLLPRCOMPRESSED_LXITEM_OFFRPR (66)
#define SYMID_LITDOLLPRCOMPRESSED_LXITEM_COUNTRPR (67)
#define SYMID_LITDOLLPRCOMPRESSED_LXITEM_LEADRPR (68)
#define SYMID_LITDOLLPRCOMPRESSED_LXITEM_NEXTRPR (69)
#define SYMID_RXCONTENT (70)
#define SYMID_RXFSLLBR0x0BSLTBSLRRBRPFSL (71)
#define SYMID_RXLABEL (72)
#define SYMID_LIT0xK (73)
#define SYMID_STMTS (74)
#define SYMID_ELSEIFS (75)
#define SYMID_STMT (76)
#define SYMID_ELSEIF (77)
#define SYMID_SYM_STMT (78)
#define SYMID_SECTIONS (79)
#define SYMID_SECTION (80)
#define PRID_LTSTARTGT_SECTIONS (81)
#define PRID_SECTIONS_SECTIONS_SECTION (82)
#define PRID_SECTION_RXSECTION_RXLABEL_LIT0xK_STMTS_RXEND (84)
#define PRID_STMTS_STMTS_STMT (88)
#define PRID_STMT_RXIF_RXLABEL_LIT0xK_STMTS_ELSEIFS_RXELSE_STMTS_RXEND (90)
#define PRID_STMT_RXFOR_EACH_RXLABEL_LIT0xK_STMTS_RXEND (102)
#define PRID_STMT_SYM_STMT (104)
#define PRID_STMT_RXCONTENT (105)
#define PRID_SYM_STMT_LITDOLLPRNAMERPR (106)
#define PRID_SYM_STMT_LITDOLLPRSTARTTOKRPR (107)
#define PRID_SYM_STMT_LITDOLLPREOFTOKRPR (108)
#define PRID_SYM_STMT_LITDOLLPRERRTOKRPR (109)
#define PRID_SYM_STMT_LITDOLLPRPRODUCTION_ADJUST_COUNTRPR (110)
#define PRID_SYM_STMT_LITDOLLPRMAX_PRODUCTION_SYMBOLSRPR (111)
#define PRID_SYM_STMT_LITDOLLPRGLOBAL_CTYPERPR (112)
#define PRID_SYM_STMT_LITDOLLPRPRODUCTION_IDRPR (113)
#define PRID_SYM_STMT_LITDOLLPRORIGINAL_PRODUCTION_IDRPR (114)
#define PRID_SYM_STMT_LITDOLLPRNT_INDEXRPR (115)
#define PRID_SYM_STMT_LITDOLLPRSYMBOL_COUNTRPR (116)
#define PRID_SYM_STMT_LITDOLLPRREDUCE_SRCRPR (117)
#define PRID_SYM_STMT_LITDOLLPRSYMBOL_TYPERPR (118)
#define PRID_SYM_STMT_LITDOLLPRSYMBOL_TYPE_FRIENDLY_NAMERPR (119)
#define PRID_SYM_STMT_LITDOLLPRIN_PRODUCTION_INDEXRPR (120)
#define PRID_SYM_STMT_LITDOLLPRCTYPERPR (121)
#define PRID_SYM_STMT_LITDOLLPRCTYPE_FRIENDLY_NAMERPR (122)
#define PRID_SYM_STMT_LITDOLLPRLINERPR (123)
#define PRID_SYM_STMT_LITDOLLPRLINEP1RPR (124)
#define PRID_SYM_STMT_LITDOLLPRFILERPR (125)
#define PRID_SYM_STMT_LITDOLLPRSRCLINERPR (126)
#define PRID_SYM_STMT_LITDOLLPRSRCFILERPR (127)
#define PRID_SYM_STMT_LITDOLLPRSRCRPR (128)
#define PRID_SYM_STMT_LITDOLLPRSTATERPR (129)
#define PRID_SYM_STMT_LITDOLLPRSTATECOUNTRPR (130)
#define PRID_SYM_STMT_LITDOLLPRPARSE_ACTION_COUNTRPR (131)
#define PRID_SYM_STMT_LITDOLLPRTOKEN_IDRPR (132)
#define PRID_SYM_STMT_LITDOLLPRSHIFT_TORPR (133)
#define PRID_SYM_STMT_LITDOLLPRREDUCE_BYRPR (134)
#define PRID_SYM_STMT_LITDOLLPRTOKENSETNAMERPR (135)
#define PRID_SYM_STMT_LITDOLLPRTOKENSETSTATERPR (136)
#define PRID_SYM_STMT_LITDOLLPRTOKENSETSTATECOUNTRPR (137)
#define PRID_SYM_STMT_LITDOLLPRACCEPTTOKRPR (138)
#define PRID_SYM_STMT_LITDOLLPRNEXT_STATERPR (139)
#define PRID_SYM_STMT_LITDOLLPRFROM_STATERPR (140)
#define PRID_SYM_STMT_LITDOLLPRTO_STATERPR (141)
#define PRID_SYM_STMT_LITDOLLPRRANGE_MINRPR (142)
#define PRID_SYM_STMT_LITDOLLPRRANGE_MAXRPR (143)
#define PRID_SYM_STMT_LITDOLLPRPARTIAL_ACCEPT_TOKRPR (144)
#define PRID_SYM_STMT_LITDOLLPRSYMBOL_INDEXRPR (145)
#define PRID_SYM_STMT_LITDOLLPRSYMBOL_FRIENDLY_NAMERPR (146)
#define PRID_SYM_STMT_LITDOLLPRPRODUCTION_FRIENDLY_NAMERPR (147)
#define PRID_SYM_STMT_LITDOLLPRSYMBOL_NAMERPR (148)
#define PRID_SYM_STMT_LITDOLLPRINITIAL_LEXERRPR (149)
#define PRID_SYM_STMT_LITDOLLPRPARSER_START_STATERPR (150)
#define PRID_SYM_STMT_LITDOLLPRSKIPINDEXRPR (151)
#define PRID_SYM_STMT_LITDOLLPRFIRST_ACTION_IDXRPR (152)
#define PRID_SYM_STMT_LITDOLLPRLAST_ACTION_IDXRPR (153)
#define PRID_SYM_STMT_LITDOLLPRRANGE_IDXRPR (154)
#define PRID_SYM_STMT_LITDOLLPRRANGE_SIZERPR (155)
#define PRID_SYM_STMT_LITDOLLPRACTION_RANGE_MINRPR (156)
#define PRID_SYM_STMT_LITDOLLPRACTION_RANGE_MAXRPR (157)
#define PRID_SYM_STMT_LITDOLLPRCOMPRESSED_BREAKRPR (158)
#define PRID_SYM_STMT_LITDOLLPRCOMPRESSED_LXITEM_POSRPR (159)
#define PRID_SYM_STMT_LITDOLLPRCOMPRESSED_LXITEM_OFFRPR (160)
#define PRID_SYM_STMT_LITDOLLPRCOMPRESSED_LXITEM_COUNTRPR (161)
#define PRID_SYM_STMT_LITDOLLPRCOMPRESSED_LXITEM_LEADRPR (162)
#define PRID_SYM_STMT_LITDOLLPRCOMPRESSED_LXITEM_NEXTRPR (163)
#define PRID_ELSEIFS_ELSEIFS_ELSEIF (164)
#define PRID_ELSEIF_RXELSE_IF_RXLABEL_LIT0xK_STMTS (166)
#define STARTTOK (0)
#define EOFTOK   (1)
#define ERRTOK   (3)
#define ACCEPTSTATE (110)

static ttype vector_ltStatement_ptr_gt_ptr_tt = {"vector<Statement*>*",sizeof(vector<Statement*>*),INIT_T(vector<Statement*>*),DESTRUCT_T(vector<Statement*>*)};
static ttype Statement_ptr_tt = {"Statement*",sizeof(Statement*),INIT_T(Statement*),DESTRUCT_T(Statement*)};
static ttype int_tt = {"int",sizeof(int),INIT_T(int),DESTRUCT_T(int)};

static symbol allsymbols[] = {
{"<Start>",0},{"$",0},{"<E>",0},{"<error>",0},{"IF",0},{"ELSE_IF",0},{"ELSE",0},
{"FOR_EACH",0},{"END",0},{"SECTION",0},{"/[ \\t]*#!![^\\n]*\\n/",0},{"/\\\\\\r?\\n/",0},
{"$(NAME)",0},{"$(STARTTOK)",0},{"$(EOFTOK)",0},{"$(ERRTOK)",0},{"$(PRODUCTION_ADJUST_COUNT)",0},
{"$(MAX_PRODUCTION_SYMBOLS)",0},{"$(GLOBAL_CTYPE)",0},{"$(PRODUCTION_ID)",0},{"$(ORIGINAL_PRODUCTION_ID)",0},
{"$(NT_INDEX)",0},{"$(SYMBOL_COUNT)",0},{"$(REDUCE_SRC)",0},{"$(SYMBOL_TYPE)",0},
{"$(SYMBOL_TYPE_FRIENDLY_NAME)",0},{"$(IN_PRODUCTION_INDEX)",0},{"$(CTYPE)",0},{"$(CTYPE_FRIENDLY_NAME)",0},
{"$(LINE)",0},{"$(LINE+1)",0},{"$(FILE)",0},{"$(SRCLINE)",0},{"$(SRCFILE)",0},{"$(SRC)",0},
{"$(STATE)",0},{"$(STATECOUNT)",0},{"$(PARSE_ACTION_COUNT)",0},{"$(TOKEN_ID)",0},
{"$(SHIFT_TO)",0},{"$(REDUCE_BY)",0},{"$(TOKENSETNAME)",0},{"$(TOKENSETSTATE)",0},
{"$(TOKENSETSTATECOUNT)",0},{"$(ACCEPTTOK)",0},{"$(NEXT_STATE)",0},{"$(FROM_STATE)",0},
{"$(TO_STATE)",0},{"$(RANGE_MIN)",0},{"$(RANGE_MAX)",0},{"$(PARTIAL_ACCEPT_TOK)",0},
{"$(SYMBOL_INDEX)",0},{"$(SYMBOL_FRIENDLY_NAME)",0},{"$(PRODUCTION_FRIENDLY_NAME)",0},
{"$(SYMBOL_NAME)",0},{"$(INITIAL_LEXER)",0},{"$(PARSER_START_STATE)",0},{"$(SKIPINDEX)",0},
{"$(FIRST_ACTION_IDX)",0},{"$(LAST_ACTION_IDX)",0},{"$(RANGE_IDX)",0},{"$(RANGE_SIZE)",0},
{"$(ACTION_RANGE_MIN)",0},{"$(ACTION_RANGE_MAX)",0},{"$(COMPRESSED_BREAK)",0},{"$(COMPRESSED_LXITEM_POS)",0},
{"$(COMPRESSED_LXITEM_OFF)",0},{"$(COMPRESSED_LXITEM_COUNT)",0},{"$(COMPRESSED_LXITEM_LEAD)",0},
{"$(COMPRESSED_LXITEM_NEXT)",0},{"CONTENT",0},{"/[ \\t\\r]+/",0},{"LABEL",0},{"\\n",0},
{"stmts",&vector_ltStatement_ptr_gt_ptr_tt},{"elseifs",&vector_ltStatement_ptr_gt_ptr_tt},
{"stmt",&Statement_ptr_tt},{"elseif",&Statement_ptr_tt},{"sym_stmt",&int_tt},{"sections",0},
{"section",0},};
static int  ps81[] = {79,-1};
static int  ps82[] = {79,80,-1};
static int  ps83[] = {80,-1};
static int skp83[] = {0,};
static int  ps84[] = {9,72,73,74,8,-1};
static int  ps85[] = {9,72,73,74,-1};
static int skp85[] = {4,};
static int  ps86[] = {9,72,73,8,-1};
static int skp86[] = {3,};
static int  ps87[] = {9,72,73,-1};
static int skp87[] = {3,4,};
static int  ps88[] = {74,76,-1};
static int  ps89[] = {76,-1};
static int skp89[] = {0,};
static int  ps90[] = {4,72,73,74,75,6,74,8,-1};
static int  ps91[] = {4,72,73,74,75,6,8,-1};
static int skp91[] = {6,};
static int  ps92[] = {4,72,73,74,75,8,-1};
static int skp92[] = {5,6,};
static int  ps93[] = {4,72,73,74,6,74,8,-1};
static int skp93[] = {4,};
static int  ps94[] = {4,72,73,74,6,8,-1};
static int skp94[] = {4,6,};
static int  ps95[] = {4,72,73,74,8,-1};
static int skp95[] = {4,5,6,};
static int  ps96[] = {4,72,73,75,6,74,8,-1};
static int skp96[] = {3,};
static int  ps97[] = {4,72,73,75,6,8,-1};
static int skp97[] = {3,6,};
static int  ps98[] = {4,72,73,75,8,-1};
static int skp98[] = {3,5,6,};
static int  ps99[] = {4,72,73,6,74,8,-1};
static int skp99[] = {3,4,};
static int  ps100[] = {4,72,73,6,8,-1};
static int skp100[] = {3,4,6,};
static int  ps101[] = {4,72,73,8,-1};
static int skp101[] = {3,4,5,6,};
static int  ps102[] = {7,72,73,74,8,-1};
static int  ps103[] = {7,72,73,8,-1};
static int skp103[] = {3,};
static int  ps104[] = {78,-1};
static int  ps105[] = {70,-1};
static int  ps106[] = {12,-1};
static int  ps107[] = {13,-1};
static int  ps108[] = {14,-1};
static int  ps109[] = {15,-1};
static int  ps110[] = {16,-1};
static int  ps111[] = {17,-1};
static int  ps112[] = {18,-1};
static int  ps113[] = {19,-1};
static int  ps114[] = {20,-1};
static int  ps115[] = {21,-1};
static int  ps116[] = {22,-1};
static int  ps117[] = {23,-1};
static int  ps118[] = {24,-1};
static int  ps119[] = {25,-1};
static int  ps120[] = {26,-1};
static int  ps121[] = {27,-1};
static int  ps122[] = {28,-1};
static int  ps123[] = {29,-1};
static int  ps124[] = {30,-1};
static int  ps125[] = {31,-1};
static int  ps126[] = {32,-1};
static int  ps127[] = {33,-1};
static int  ps128[] = {34,-1};
static int  ps129[] = {35,-1};
static int  ps130[] = {36,-1};
static int  ps131[] = {37,-1};
static int  ps132[] = {38,-1};
static int  ps133[] = {39,-1};
static int  ps134[] = {40,-1};
static int  ps135[] = {41,-1};
static int  ps136[] = {42,-1};
static int  ps137[] = {43,-1};
static int  ps138[] = {44,-1};
static int  ps139[] = {45,-1};
static int  ps140[] = {46,-1};
static int  ps141[] = {47,-1};
static int  ps142[] = {48,-1};
static int  ps143[] = {49,-1};
static int  ps144[] = {50,-1};
static int  ps145[] = {51,-1};
static int  ps146[] = {52,-1};
static int  ps147[] = {53,-1};
static int  ps148[] = {54,-1};
static int  ps149[] = {55,-1};
static int  ps150[] = {56,-1};
static int  ps151[] = {57,-1};
static int  ps152[] = {58,-1};
static int  ps153[] = {59,-1};
static int  ps154[] = {60,-1};
static int  ps155[] = {61,-1};
static int  ps156[] = {62,-1};
static int  ps157[] = {63,-1};
static int  ps158[] = {64,-1};
static int  ps159[] = {65,-1};
static int  ps160[] = {66,-1};
static int  ps161[] = {67,-1};
static int  ps162[] = {68,-1};
static int  ps163[] = {69,-1};
static int  ps164[] = {75,77,-1};
static int  ps165[] = {77,-1};
static int skp165[] = {0,};
static int  ps166[] = {5,72,73,74,-1};
static int  ps167[] = {5,72,73,-1};
static int skp167[] = {3,};
static production productions[] = {
{81,81,0,1,ps81,0,0},
{82,82,79,2,ps82,0,0},
{83,82,79,1,ps83,SZ(skp83),skp83},
{84,84,80,5,ps84,0,0},
{85,84,80,4,ps85,SZ(skp85),skp85},
{86,84,80,4,ps86,SZ(skp86),skp86},
{87,84,80,3,ps87,SZ(skp87),skp87},
{88,88,74,2,ps88,0,0},
{89,88,74,1,ps89,SZ(skp89),skp89},
{90,90,76,8,ps90,0,0},
{91,90,76,7,ps91,SZ(skp91),skp91},
{92,90,76,6,ps92,SZ(skp92),skp92},
{93,90,76,7,ps93,SZ(skp93),skp93},
{94,90,76,6,ps94,SZ(skp94),skp94},
{95,90,76,5,ps95,SZ(skp95),skp95},
{96,90,76,7,ps96,SZ(skp96),skp96},
{97,90,76,6,ps97,SZ(skp97),skp97},
{98,90,76,5,ps98,SZ(skp98),skp98},
{99,90,76,6,ps99,SZ(skp99),skp99},
{100,90,76,5,ps100,SZ(skp100),skp100},
{101,90,76,4,ps101,SZ(skp101),skp101},
{102,102,76,5,ps102,0,0},
{103,102,76,4,ps103,SZ(skp103),skp103},
{104,104,76,1,ps104,0,0},
{105,105,76,1,ps105,0,0},
{106,106,78,1,ps106,0,0},
{107,107,78,1,ps107,0,0},
{108,108,78,1,ps108,0,0},
{109,109,78,1,ps109,0,0},
{110,110,78,1,ps110,0,0},
{111,111,78,1,ps111,0,0},
{112,112,78,1,ps112,0,0},
{113,113,78,1,ps113,0,0},
{114,114,78,1,ps114,0,0},
{115,115,78,1,ps115,0,0},
{116,116,78,1,ps116,0,0},
{117,117,78,1,ps117,0,0},
{118,118,78,1,ps118,0,0},
{119,119,78,1,ps119,0,0},
{120,120,78,1,ps120,0,0},
{121,121,78,1,ps121,0,0},
{122,122,78,1,ps122,0,0},
{123,123,78,1,ps123,0,0},
{124,124,78,1,ps124,0,0},
{125,125,78,1,ps125,0,0},
{126,126,78,1,ps126,0,0},
{127,127,78,1,ps127,0,0},
{128,128,78,1,ps128,0,0},
{129,129,78,1,ps129,0,0},
{130,130,78,1,ps130,0,0},
{131,131,78,1,ps131,0,0},
{132,132,78,1,ps132,0,0},
{133,133,78,1,ps133,0,0},
{134,134,78,1,ps134,0,0},
{135,135,78,1,ps135,0,0},
{136,136,78,1,ps136,0,0},
{137,137,78,1,ps137,0,0},
{138,138,78,1,ps138,0,0},
{139,139,78,1,ps139,0,0},
{140,140,78,1,ps140,0,0},
{141,141,78,1,ps141,0,0},
{142,142,78,1,ps142,0,0},
{143,143,78,1,ps143,0,0},
{144,144,78,1,ps144,0,0},
{145,145,78,1,ps145,0,0},
{146,146,78,1,ps146,0,0},
{147,147,78,1,ps147,0,0},
{148,148,78,1,ps148,0,0},
{149,149,78,1,ps149,0,0},
{150,150,78,1,ps150,0,0},
{151,151,78,1,ps151,0,0},
{152,152,78,1,ps152,0,0},
{153,153,78,1,ps153,0,0},
{154,154,78,1,ps154,0,0},
{155,155,78,1,ps155,0,0},
{156,156,78,1,ps156,0,0},
{157,157,78,1,ps157,0,0},
{158,158,78,1,ps158,0,0},
{159,159,78,1,ps159,0,0},
{160,160,78,1,ps160,0,0},
{161,161,78,1,ps161,0,0},
{162,162,78,1,ps162,0,0},
{163,163,78,1,ps163,0,0},
{164,164,75,2,ps164,0,0},
{165,164,75,1,ps165,SZ(skp165),skp165},
{166,166,77,4,ps166,0,0},
{167,166,77,3,ps167,SZ(skp167),skp167},
};
static int par_rng_0[] = {1,9,9,};
static int par_rng_1[] = {1,82,83,};
static int par_rng_2[] = {1,84,87,};
static int par_rng_3[] = {1,72,72,};
static int par_rng_4[] = {1,1,1,};
static int par_rng_5[] = {2,1,1,9,9,};
static int par_rng_6[] = {1,73,73,};
static int par_rng_7[] = {1,4,4,};
static int par_rng_8[] = {1,7,8,};
static int par_rng_9[] = {1,12,70,};
static int par_rng_10[] = {1,88,89,};
static int par_rng_11[] = {1,90,105,};
static int par_rng_12[] = {1,106,163,};
static int par_rng_13[] = {3,1,1,4,9,12,70,};
static int par_rng_14[] = {1,7,7,};
static int par_rng_15[] = {1,8,8,};
static int par_rng_16[] = {1,5,6,};
static int par_rng_17[] = {1,164,165,};
static int par_rng_18[] = {1,166,167,};
static int par_rng_19[] = {1,5,5,};
static int par_rng_20[] = {1,6,6,};
static int par_rng_21[] = {2,5,6,8,8,};
static parse_action_range par0[] = {{SH,1,1,par_rng_0},{SH,2,2,par_rng_1},{SH,3,3,par_rng_2},};
static parse_action_range par1[] = {{SH,4,4,par_rng_3},};
static parse_action_range par2[] = {{RD,0,0,par_rng_4},{SH,1,1,par_rng_0},{SH,5,5,par_rng_2},};
static parse_action_range par3[] = {{RD,2,2,par_rng_5},};
static parse_action_range par4[] = {{SH,6,6,par_rng_6},};
static parse_action_range par5[] = {{RD,1,1,par_rng_5},};
static parse_action_range par6[] = {{RD,6,6,par_rng_4},{SH,7,7,par_rng_7},{SH,8,9,par_rng_8},{RD,6,6,par_rng_0},{SH,10,68,par_rng_9},{SH,69,69,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par7[] = {{SH,72,72,par_rng_3},};
static parse_action_range par8[] = {{SH,73,73,par_rng_3},};
static parse_action_range par9[] = {{RD,5,5,par_rng_5},};
static parse_action_range par10[] = {{RD,25,25,par_rng_13},};
static parse_action_range par11[] = {{RD,26,26,par_rng_13},};
static parse_action_range par12[] = {{RD,27,27,par_rng_13},};
static parse_action_range par13[] = {{RD,28,28,par_rng_13},};
static parse_action_range par14[] = {{RD,29,29,par_rng_13},};
static parse_action_range par15[] = {{RD,30,30,par_rng_13},};
static parse_action_range par16[] = {{RD,31,31,par_rng_13},};
static parse_action_range par17[] = {{RD,32,32,par_rng_13},};
static parse_action_range par18[] = {{RD,33,33,par_rng_13},};
static parse_action_range par19[] = {{RD,34,34,par_rng_13},};
static parse_action_range par20[] = {{RD,35,35,par_rng_13},};
static parse_action_range par21[] = {{RD,36,36,par_rng_13},};
static parse_action_range par22[] = {{RD,37,37,par_rng_13},};
static parse_action_range par23[] = {{RD,38,38,par_rng_13},};
static parse_action_range par24[] = {{RD,39,39,par_rng_13},};
static parse_action_range par25[] = {{RD,40,40,par_rng_13},};
static parse_action_range par26[] = {{RD,41,41,par_rng_13},};
static parse_action_range par27[] = {{RD,42,42,par_rng_13},};
static parse_action_range par28[] = {{RD,43,43,par_rng_13},};
static parse_action_range par29[] = {{RD,44,44,par_rng_13},};
static parse_action_range par30[] = {{RD,45,45,par_rng_13},};
static parse_action_range par31[] = {{RD,46,46,par_rng_13},};
static parse_action_range par32[] = {{RD,47,47,par_rng_13},};
static parse_action_range par33[] = {{RD,48,48,par_rng_13},};
static parse_action_range par34[] = {{RD,49,49,par_rng_13},};
static parse_action_range par35[] = {{RD,50,50,par_rng_13},};
static parse_action_range par36[] = {{RD,51,51,par_rng_13},};
static parse_action_range par37[] = {{RD,52,52,par_rng_13},};
static parse_action_range par38[] = {{RD,53,53,par_rng_13},};
static parse_action_range par39[] = {{RD,54,54,par_rng_13},};
static parse_action_range par40[] = {{RD,55,55,par_rng_13},};
static parse_action_range par41[] = {{RD,56,56,par_rng_13},};
static parse_action_range par42[] = {{RD,57,57,par_rng_13},};
static parse_action_range par43[] = {{RD,58,58,par_rng_13},};
static parse_action_range par44[] = {{RD,59,59,par_rng_13},};
static parse_action_range par45[] = {{RD,60,60,par_rng_13},};
static parse_action_range par46[] = {{RD,61,61,par_rng_13},};
static parse_action_range par47[] = {{RD,62,62,par_rng_13},};
static parse_action_range par48[] = {{RD,63,63,par_rng_13},};
static parse_action_range par49[] = {{RD,64,64,par_rng_13},};
static parse_action_range par50[] = {{RD,65,65,par_rng_13},};
static parse_action_range par51[] = {{RD,66,66,par_rng_13},};
static parse_action_range par52[] = {{RD,67,67,par_rng_13},};
static parse_action_range par53[] = {{RD,68,68,par_rng_13},};
static parse_action_range par54[] = {{RD,69,69,par_rng_13},};
static parse_action_range par55[] = {{RD,70,70,par_rng_13},};
static parse_action_range par56[] = {{RD,71,71,par_rng_13},};
static parse_action_range par57[] = {{RD,72,72,par_rng_13},};
static parse_action_range par58[] = {{RD,73,73,par_rng_13},};
static parse_action_range par59[] = {{RD,74,74,par_rng_13},};
static parse_action_range par60[] = {{RD,75,75,par_rng_13},};
static parse_action_range par61[] = {{RD,76,76,par_rng_13},};
static parse_action_range par62[] = {{RD,77,77,par_rng_13},};
static parse_action_range par63[] = {{RD,78,78,par_rng_13},};
static parse_action_range par64[] = {{RD,79,79,par_rng_13},};
static parse_action_range par65[] = {{RD,80,80,par_rng_13},};
static parse_action_range par66[] = {{RD,81,81,par_rng_13},};
static parse_action_range par67[] = {{RD,82,82,par_rng_13},};
static parse_action_range par68[] = {{RD,24,24,par_rng_13},};
static parse_action_range par69[] = {{RD,4,4,par_rng_4},{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,74,74,par_rng_15},{RD,4,4,par_rng_0},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par70[] = {{RD,8,8,par_rng_13},};
static parse_action_range par71[] = {{RD,23,23,par_rng_13},};
static parse_action_range par72[] = {{SH,76,76,par_rng_6},};
static parse_action_range par73[] = {{SH,77,77,par_rng_6},};
static parse_action_range par74[] = {{RD,3,3,par_rng_5},};
static parse_action_range par75[] = {{RD,7,7,par_rng_13},};
static parse_action_range par76[] = {{SH,7,7,par_rng_7},{SH,78,79,par_rng_16},{SH,8,8,par_rng_14},{SH,80,80,par_rng_15},{SH,10,68,par_rng_9},{SH,81,81,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},{SH,82,82,par_rng_17},{SH,83,83,par_rng_18},};
static parse_action_range par77[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,84,84,par_rng_15},{SH,10,68,par_rng_9},{SH,85,85,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par78[] = {{SH,86,86,par_rng_3},};
static parse_action_range par79[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,87,87,par_rng_15},{SH,10,68,par_rng_9},{SH,88,88,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par80[] = {{RD,20,20,par_rng_13},};
static parse_action_range par81[] = {{SH,7,7,par_rng_7},{SH,78,78,par_rng_19},{SH,89,89,par_rng_20},{SH,8,8,par_rng_14},{SH,90,90,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},{SH,91,91,par_rng_17},{SH,83,83,par_rng_18},};
static parse_action_range par82[] = {{SH,78,78,par_rng_19},{SH,92,92,par_rng_20},{SH,93,93,par_rng_15},{SH,94,94,par_rng_18},};
static parse_action_range par83[] = {{RD,84,84,par_rng_21},};
static parse_action_range par84[] = {{RD,22,22,par_rng_13},};
static parse_action_range par85[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,95,95,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par86[] = {{SH,96,96,par_rng_6},};
static parse_action_range par87[] = {{RD,19,19,par_rng_13},};
static parse_action_range par88[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,97,97,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par89[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,98,98,par_rng_15},{SH,10,68,par_rng_9},{SH,99,99,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par90[] = {{RD,14,14,par_rng_13},};
static parse_action_range par91[] = {{SH,78,78,par_rng_19},{SH,100,100,par_rng_20},{SH,101,101,par_rng_15},{SH,94,94,par_rng_18},};
static parse_action_range par92[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,102,102,par_rng_15},{SH,10,68,par_rng_9},{SH,103,103,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par93[] = {{RD,17,17,par_rng_13},};
static parse_action_range par94[] = {{RD,83,83,par_rng_21},};
static parse_action_range par95[] = {{RD,21,21,par_rng_13},};
static parse_action_range par96[] = {{SH,7,7,par_rng_7},{RD,86,86,par_rng_16},{SH,8,8,par_rng_14},{RD,86,86,par_rng_15},{SH,10,68,par_rng_9},{SH,104,104,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par97[] = {{RD,18,18,par_rng_13},};
static parse_action_range par98[] = {{RD,13,13,par_rng_13},};
static parse_action_range par99[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,105,105,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par100[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,106,106,par_rng_15},{SH,10,68,par_rng_9},{SH,107,107,par_rng_10},{SH,70,70,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par101[] = {{RD,11,11,par_rng_13},};
static parse_action_range par102[] = {{RD,16,16,par_rng_13},};
static parse_action_range par103[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,108,108,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par104[] = {{SH,7,7,par_rng_7},{RD,85,85,par_rng_16},{SH,8,8,par_rng_14},{RD,85,85,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par105[] = {{RD,12,12,par_rng_13},};
static parse_action_range par106[] = {{RD,10,10,par_rng_13},};
static parse_action_range par107[] = {{SH,7,7,par_rng_7},{SH,8,8,par_rng_14},{SH,109,109,par_rng_15},{SH,10,68,par_rng_9},{SH,75,75,par_rng_11},{SH,71,71,par_rng_12},};
static parse_action_range par108[] = {{RD,15,15,par_rng_13},};
static parse_action_range par109[] = {{RD,9,9,par_rng_13},};
static parse_state parse_states[] = {
{SZ(par0),par0},{SZ(par1),par1},{SZ(par2),par2},{SZ(par3),par3},{SZ(par4),par4},
{SZ(par5),par5},{SZ(par6),par6},{SZ(par7),par7},{SZ(par8),par8},{SZ(par9),par9},
{SZ(par10),par10},{SZ(par11),par11},{SZ(par12),par12},{SZ(par13),par13},{SZ(par14),par14},
{SZ(par15),par15},{SZ(par16),par16},{SZ(par17),par17},{SZ(par18),par18},{SZ(par19),par19},
{SZ(par20),par20},{SZ(par21),par21},{SZ(par22),par22},{SZ(par23),par23},{SZ(par24),par24},
{SZ(par25),par25},{SZ(par26),par26},{SZ(par27),par27},{SZ(par28),par28},{SZ(par29),par29},
{SZ(par30),par30},{SZ(par31),par31},{SZ(par32),par32},{SZ(par33),par33},{SZ(par34),par34},
{SZ(par35),par35},{SZ(par36),par36},{SZ(par37),par37},{SZ(par38),par38},{SZ(par39),par39},
{SZ(par40),par40},{SZ(par41),par41},{SZ(par42),par42},{SZ(par43),par43},{SZ(par44),par44},
{SZ(par45),par45},{SZ(par46),par46},{SZ(par47),par47},{SZ(par48),par48},{SZ(par49),par49},
{SZ(par50),par50},{SZ(par51),par51},{SZ(par52),par52},{SZ(par53),par53},{SZ(par54),par54},
{SZ(par55),par55},{SZ(par56),par56},{SZ(par57),par57},{SZ(par58),par58},{SZ(par59),par59},
{SZ(par60),par60},{SZ(par61),par61},{SZ(par62),par62},{SZ(par63),par63},{SZ(par64),par64},
{SZ(par65),par65},{SZ(par66),par66},{SZ(par67),par67},{SZ(par68),par68},{SZ(par69),par69},
{SZ(par70),par70},{SZ(par71),par71},{SZ(par72),par72},{SZ(par73),par73},{SZ(par74),par74},
{SZ(par75),par75},{SZ(par76),par76},{SZ(par77),par77},{SZ(par78),par78},{SZ(par79),par79},
{SZ(par80),par80},{SZ(par81),par81},{SZ(par82),par82},{SZ(par83),par83},{SZ(par84),par84},
{SZ(par85),par85},{SZ(par86),par86},{SZ(par87),par87},{SZ(par88),par88},{SZ(par89),par89},
{SZ(par90),par90},{SZ(par91),par91},{SZ(par92),par92},{SZ(par93),par93},{SZ(par94),par94},
{SZ(par95),par95},{SZ(par96),par96},{SZ(par97),par97},{SZ(par98),par98},{SZ(par99),par99},
{SZ(par100),par100},{SZ(par101),par101},{SZ(par102),par102},{SZ(par103),par103},
{SZ(par104),par104},{SZ(par105),par105},{SZ(par106),par106},{SZ(par107),par107},
{SZ(par108),par108},{SZ(par109),par109},};

static int brk_INITIAL[] = {0,9,10,11,13,14,32,33,34,35,36,37,40,41,42,43,44,45,
46,48,49,50,58,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,
88,89,90,91,92,93,95,96,97,98,99,100,101,102,103,104,105,106,108,109,110,111,112,
114,115,116,117,123,1114112,};
static scnitem scn_INITIAL[] = {{0,0,0,0,6},{1,0,0,0,1},{2,0,0,0,5},{3,0,3,1,1},
{7,3,2,2,2},{10,0,0,0,4},{11,3,38,3,3},{50,11,24,24,10},{75,0,0,0,7},{76,0,0,0,11},
{77,74,3,1,7},{81,77,2,2,8},{84,0,0,0,9},{85,77,63,3,13},{149,148,6,1,12},{156,148,66,7,10},
{223,77,1,1,15},{225,223,1,1,14},{227,85,4,4,16},{232,84,64,64,18},{297,296,11,1,17},
{309,296,61,12,597},{371,370,73,1,10},{445,77,1,1,11},{447,85,6,6,16},{454,232,64,64,10},
{519,75,147,147,18},{667,309,11,11,597},{679,309,61,61,10},{741,445,73,73,597},{815,370,74,74,19},
{890,814,4,4,19},{895,0,0,0,24},{896,814,49,49,21},{946,0,0,0,22},{947,814,2,2,20},
{950,814,7,7,23},{958,815,4,4,10},{963,445,75,74,15},{1039,447,71,71,597},{1111,815,73,73,13},
{1185,148,6,6,597},{1192,156,66,66,597},{1259,815,12,12,40},{1272,950,5,5,39},{1278,1277,2,1,597},
{1281,0,0,0,38},{1282,1277,1,1,34},{1284,1277,1,1,27},{1286,0,0,0,36},{1287,0,0,0,30},
{1288,1282,1,1,33},{1290,1277,2,2,35},{1293,0,0,0,29},{1294,0,0,0,25},{1295,0,0,0,31},
{1296,0,0,0,28},{1297,1278,1,1,32},{1299,0,0,0,26},{1300,0,0,0,37},{1301,1277,5,3,597},
{1307,958,2,2,39},{1310,958,1,1,39},{1312,1301,18,5,597},{1331,958,1,1,10},{1333,741,74,74,19},
{1408,890,9,5,597},{1418,896,45,45,21},{1464,946,16,16,597},{1481,814,57,57,41},
{1539,814,78,75,42},{1618,1272,1,1,43},{1620,370,74,74,44},{1695,1111,64,64,45},
{1760,1111,16,16,46},{1777,1776,1,1,47},{1779,1776,71,2,597},{1851,1259,22,22,48},
{1874,1301,3,3,50},{1878,1312,14,14,49},{1893,1301,31,31,597},{1925,1851,22,22,39},
{1948,1878,6,6,54},{1955,1948,2,2,55},{1958,1311,6,6,53},{1965,1893,1,1,51},{1967,1874,3,3,52},
{1971,1309,2,2,597},{1974,1310,4,2,39},{1979,1312,17,17,597},{1997,1481,14,14,40},
{2012,1272,9,9,39},{2022,1878,13,13,56},{2036,2022,2,2,57},{2039,1947,7,7,597},{2047,2012,2,2,39},
{2050,1974,2,2,39},{2053,1979,42,42,59},{2096,1311,16,16,58},{2113,2039,56,56,60},
{2170,1311,24,19,597},{2195,2047,48,48,39},{2244,2052,10,10,61},{2255,1979,13,13,597},
{2269,2195,59,59,39},{2329,2096,5,5,62},{2335,2039,56,56,64},{2392,2021,3,3,63},
{2396,2170,20,20,597},{2417,958,2,2,39},{2420,958,1,1,39},{2422,1978,56,56,65},{2479,2243,11,11,597},
{2491,2047,48,48,39},{2540,1311,13,13,67},{2554,2479,4,4,66},{2559,1893,54,54,69},
{2614,1947,7,7,68},{2622,2422,16,16,597},{2639,2195,56,56,70},{2696,2539,8,8,71},
{2705,2039,63,56,39},{2769,2705,6,6,72},{2776,2096,10,10,597},{2787,2195,50,50,73},
{2838,2170,22,22,597},{2861,1973,62,62,39},{2924,2776,49,49,597},{2974,1539,203,78,74},
{3178,2974,60,60,75},{3239,2974,85,85,76},{3325,3239,60,60,77},{3386,3239,18,18,46},
{3405,1777,86,86,597},{3492,1110,73,73,40},{3566,3325,5,5,39},{3572,1278,5,3,39},
{3578,2422,9,9,78},{3588,2422,12,12,597},{3601,3386,2,2,39},{3604,3386,1,1,39},{3606,1978,68,57,597},
{3675,3491,2,2,79},{3678,3566,1,1,39},{3680,3606,65,65,80},{3746,1278,3,3,597},{3750,3678,4,2,39},
{3755,2053,42,42,81},{3798,2170,85,84,82},{3884,3588,63,63,83},{3948,2838,79,79,84},
{4028,2622,73,73,85},{4102,4028,70,70,86},{4173,3679,23,22,597},{4197,3605,61,61,87},
{4259,2705,70,70,88},{4330,2776,71,61,39},{4402,2554,4,4,89},{4407,4259,77,70,39},
{4485,0,0,0,90},{4486,3746,53,51,39},{4540,1878,11,11,91},{4552,4330,67,67,92},{4620,4028,68,68,93},
{4689,2838,21,21,597},{4711,2269,61,61,94},{4773,2479,68,68,96},{4842,4028,19,19,95},
{4862,1310,23,22,597},{4886,1925,11,11,40},{4898,4885,5,5,39},{4904,3572,17,15,39},
{4922,2255,8,8,97},{4931,1971,62,62,98},{4994,3588,74,74,99},{5069,4921,11,9,597},
{5081,2269,65,65,39},{5147,0,0,0,100},{5148,5069,6,6,597},{5155,5081,59,59,101},
{5215,4921,5,5,102},{5221,4407,70,70,103},{5292,4330,69,69,104},{5362,2422,14,14,597},
{5377,950,2,2,105},{5380,5376,1,1,39},{5382,3606,45,45,106},{5428,3754,16,16,107},
{5445,1893,44,44,597},{5490,1480,43,43,108},{5534,1481,16,16,110},{5551,0,0,0,109},
{5552,0,0,0,111},{5553,5550,5,2,110},{5559,5550,65,1,597},{5625,1481,16,16,112},
{5642,1539,126,78,113},{5769,1695,16,16,40},{5786,2012,13,13,114},{5800,2396,77,77,115},
{5878,2622,84,73,116},{5963,1893,66,61,39},{6030,3948,4,4,117},{6035,3603,1,1,118},
{6037,5963,55,55,119},{6093,2396,23,20,597},{6117,2195,38,38,122},{6156,2012,14,14,121},
{6171,2396,5,5,120},{6177,2255,67,67,123},{6245,4173,83,83,124},{6329,1311,9,9,597},
{6339,2269,65,65,39},{6405,2049,1,1,125},{6407,5963,73,71,126},{6481,5963,57,57,127},
{6539,4689,88,83,128},{6628,0,0,0,129},{6629,6407,78,73,39},{6708,950,3,3,130},{6712,4196,46,46,131},
{6759,3798,23,23,597},{6783,3601,54,54,132},{6838,3680,22,21,597},{6861,3605,64,64,133},
{6926,3679,4,4,597},{6931,1996,2,2,39},{6934,6783,1,1,39},{6936,3680,49,49,134},
{6986,6838,82,82,135},{7069,6329,77,77,136},{7147,6407,69,69,137},{7217,6329,73,73,138},
{7291,7069,62,62,139},{7354,6935,20,19,597},{7375,6931,54,54,39},{7430,2421,12,12,140},
{7443,7147,58,58,141},{7502,7354,87,87,142},{7590,5148,67,66,143},{7658,4994,65,65,144},
{7724,7502,87,87,145},{7812,5148,59,59,146},{7872,6838,20,18,597},{7893,7375,56,56,147},
{7950,4028,43,43,149},{7994,0,0,0,150},{7995,2046,1,1,149},{7997,7995,3,2,597},{8001,1417,8,8,148},
{8010,815,56,56,110},{8067,5551,73,73,110},{8141,5553,1,1,111},{8143,5558,71,66,597},
{8215,5642,130,126,151},{8346,8214,77,77,152},{8424,8346,25,25,153},{8450,8346,5,5,39},
{8456,4904,29,26,597},{8486,8424,1,1,39},{8488,8486,2,2,39},{8491,1979,55,55,154},
{8547,2479,88,74,155},{8636,8488,58,58,39},{8695,5382,5,5,156},{8701,5963,58,58,157},
{8760,7724,83,83,158},{8844,4552,67,67,159},{8912,2622,73,73,160},{8986,8912,55,55,597},
{9042,3492,95,95,39},{9138,2052,6,6,161},{9145,5963,62,62,162},{9208,5878,79,79,163},
{9288,4330,73,73,164},{9362,4330,79,76,165},{9442,6926,57,57,166},{9500,7502,77,77,167},
{9578,5878,80,80,168},{9659,7291,58,58,169},{9718,3798,81,81,170},{9800,9208,67,67,171},
{9868,3948,75,75,172},{9944,7502,86,86,173},{10031,2705,64,64,174},{10096,9208,69,69,175},
{10166,7724,86,86,176},{10253,2705,46,46,177},{10300,2420,1,1,178},{10302,2416,4,4,39},
{10307,3603,22,21,39},{10330,6926,63,59,39},{10394,5362,17,17,179},{10412,2420,35,35,180},
{10448,2012,23,23,39},{10472,9362,78,78,181},{10551,10329,82,82,182},{10634,2416,1,1,39},
{10636,2422,56,56,183},{10693,8547,79,79,184},{10773,6407,69,69,185},{10843,6329,72,72,186},
{10916,2924,97,97,187},{11014,5625,13,13,149},{11028,7994,15,15,597},{11044,8215,183,130,188},
{11228,5642,86,86,189},{11315,5642,94,94,40},{11410,5786,12,12,190},{11423,4689,88,83,191},
{11512,7590,73,67,39},{11586,0,0,0,192},{11587,6037,44,44,193},{11632,10448,11,11,194},
{11644,4689,22,21,597},{11667,2417,59,59,195},{11727,2255,75,75,196},{11803,8547,71,71,197},
{11875,2255,87,79,597},{11963,2417,2,2,198},{11966,2268,1,1,39},{11968,10636,56,56,199},
{12025,8547,70,70,200},{12096,5362,18,17,597},{12115,2421,54,54,201},{12170,12096,65,65,202},
{12236,11644,88,82,204},{12325,10253,10,10,203},{12336,2050,45,45,205},{12382,12236,24,22,597},
{12407,7375,65,65,206},{12473,4407,67,67,207},{12541,2255,75,75,208},{12617,10693,64,64,209},
{12682,9944,94,86,597},{12777,1408,2,2,210},{12780,12114,55,55,39},{12836,8912,3,3,211},
{12840,4330,59,59,212},{12900,9944,24,20,597},{12925,1973,38,38,213},{12964,10448,37,37,214},
{13002,2420,49,49,215},{13052,9944,59,59,597},{13112,5642,80,80,216},{13193,13112,66,66,40},
{13260,10448,9,9,217},{13270,12900,63,63,597},{13334,13112,73,73,40},{13408,12964,37,37,218},
{13446,2417,1,1,39},{13448,3606,61,61,219},{13510,11512,73,73,221},{13584,7812,9,9,220},
{13594,2050,45,45,222},{13640,13447,24,19,597},{13665,2417,61,61,39},{13727,4620,5,5,223},
{13733,5963,67,67,224},{13801,2923,95,95,225},{13897,371,70,70,226},{13968,5642,83,83,227},
{14052,1481,21,21,40},{14074,6156,13,13,228},{14088,9500,88,77,229},{14177,10551,68,68,230},
{14246,2924,123,123,40},{14370,12964,23,23,231},{14394,9362,84,79,597},{14479,2194,2,2,232},
{14482,12336,45,45,39},{14528,2021,3,3,233},{14532,14088,73,73,234},{14606,14088,88,88,235},
{14695,5963,57,57,236},{14753,13270,21,21,597},{14775,8485,38,38,237},{14814,10448,73,73,238},
{14888,10448,102,102,239},{14991,14177,54,54,240},{15046,12900,63,63,40},{15110,14814,37,37,241},
{15148,11966,56,56,242},{15205,11875,76,76,243},{15282,14394,87,87,244},{15370,8488,45,45,245},
{15416,15046,101,101,246},{15518,8488,53,53,248},{15572,5362,3,3,247},{15576,5362,5,5,249},
{15582,11512,58,58,250},{15641,14753,60,60,40},{15702,15110,20,20,251},{15723,15205,52,52,597},
{15776,13334,88,88,252},{15865,4173,86,85,253},{15952,7590,45,45,254},{15998,13334,85,85,255},
{16084,15416,22,22,597},{16107,6931,48,48,256},{16156,15416,92,92,257},{16249,5963,62,62,258},
{16312,10096,69,69,259},{16382,7724,88,87,260},{16471,10551,73,73,261},{16545,10551,82,82,262},
{16628,15148,36,35,597},{16665,8215,119,119,263},{16785,16665,100,100,40},{16886,14888,31,31,264},
{16918,4486,51,51,265},{16970,15046,83,83,266},{17054,12096,83,73,267},{17138,9442,55,55,268},
{17194,2255,2,2,271},{17197,2255,2,2,270},{17200,15205,4,4,272},{17205,15205,5,5,269},
{17211,2559,44,44,273},{17256,14888,73,73,274},{17330,10448,97,97,275},{17428,10472,63,63,276},
{17492,13052,140,140,597},{17633,15998,66,66,40},{17700,14370,17,17,277},{17718,9208,67,67,278},
{17786,16084,89,71,279},{17876,11512,83,74,280},{17960,13446,48,48,281},{18009,15416,21,21,597},
{18031,7375,50,50,282},{18082,17786,82,82,283},{18165,6177,63,63,285},{18229,14088,16,16,284},
{18246,17876,55,55,287},{18302,6177,7,7,286},{18310,2622,68,68,288},{18379,18009,78,72,289},
{18458,5878,85,84,290},{18544,10330,81,81,291},{18626,5380,47,47,39},{18674,14088,14,14,292},
{18689,4407,74,74,293},{18764,15582,45,45,597},{18810,3492,95,95,39},{18906,12541,6,6,294},
{18913,5963,56,56,295},{18970,17786,71,71,296},{19042,15046,76,76,297},{19119,6539,89,88,298},
{19209,5963,58,58,299},{19268,8760,83,83,300},{19352,4330,76,76,301},{19429,4259,46,46,597},
{19476,15776,73,73,302},{19550,10448,102,102,303},{19653,14991,44,44,304},{19698,17330,96,96,305},
{19795,8547,74,74,306},{19870,14394,82,82,307},{19953,1971,63,63,308},{20017,8547,77,77,309},
{20095,10031,56,56,310},{20152,15046,63,63,597},{20216,11044,147,147,311},{20364,14888,102,102,39},
{20467,7430,2,2,312},{20470,4486,65,65,313},{20536,19870,78,78,314},{20615,10551,73,73,315},
{20689,14177,54,54,316},{20744,15416,93,93,317},{20838,10330,72,72,318},{20911,10329,82,82,319},
{20994,18626,62,62,320},{21057,4407,79,78,321},{21137,19953,63,63,322},{21201,8547,82,82,323},
{21284,20470,67,65,39},{21352,3884,5,5,324},{21358,21284,75,73,325},{21434,15110,3,3,39},
{21438,20994,47,47,326},{21486,17786,82,82,327},{21569,19042,13,13,597},{21583,2491,56,56,328},
{21640,19042,16,16,597},{21657,2490,2,2,39},{21660,20994,49,49,329},{21710,14088,77,77,330},
{21788,21640,84,69,331},{21873,10329,73,73,332},{21947,6629,44,44,333},{21992,20364,96,96,334},
{22089,4540,4,4,335},{22094,15952,45,45,336},{22140,10448,93,93,337},{22234,17786,14,14,597},
{22249,2491,48,48,338},{22298,20152,137,137,40},{22436,12964,13,13,339},{22450,12682,59,59,597},
{22510,18810,102,102,340},{22613,20911,74,74,341},{22688,18544,68,68,342},{22757,7069,61,61,343},
{22819,18082,21,21,597},{22841,2490,2,2,39},{22844,2490,1,1,39},{22846,21486,18,18,597},
{22865,1997,32,32,344},{22898,21788,77,77,345},{22976,3588,51,51,597},{23028,15776,73,73,346},
{23102,17330,96,96,347},{23199,10693,68,68,348},{23268,16084,16,16,597},{23285,21657,48,48,349},
{23334,20744,75,75,350},{23410,21486,73,73,351},{23484,17786,94,89,352},{23579,1971,65,64,353},
{23645,10843,60,60,354},{23706,21486,61,61,355},{23768,17330,73,73,356},{23842,17330,73,73,357},
{23916,19698,73,73,358},{23990,21992,87,87,359},{24078,16084,20,20,597},{24099,13665,67,67,360},
{24167,21873,58,58,361},{24226,21710,73,73,362},{24300,24078,72,72,363},{24373,15641,84,81,364},
{24458,10472,67,67,365},{24526,4028,69,69,366},{24596,22450,143,143,367},{24740,15416,92,92,368},
{24833,5445,88,88,597},{24922,8010,29,29,369},{24952,21992,96,96,370},{25049,20017,50,50,371},
{25100,23916,73,73,372},{25174,23102,96,96,373},{25271,19795,64,64,374},{25336,24078,73,73,375},
{25410,25336,73,73,376},{25484,24226,73,73,377},{25558,22450,168,162,597},{25727,23916,2,2,378},
{25730,13002,49,49,39},{25780,20017,9,9,379},{25790,9362,76,76,380},{25867,4407,58,58,381},
{25926,23484,90,90,382},{26017,21873,69,69,383},{26087,6329,75,75,384},{26163,18689,46,46,385},
{26210,23842,78,73,597},{26289,11044,290,183,386},{26580,20364,91,91,387},{26672,18458,87,85,388},
{26760,21284,64,64,389},{26825,8547,88,88,390},{26914,20994,58,58,391},{26973,10693,74,74,392},
{27048,19352,49,49,393},{27098,24952,95,95,394},{27194,3884,61,61,395},{27256,22298,153,151,396},
{27410,22846,22,21,597},{27433,2421,34,34,597},{27468,11044,147,147,40},{27616,25100,28,28,397},
{27645,10773,44,44,398},{27690,26210,37,37,399},{27728,18626,62,62,39},{27791,12025,4,4,400},
{27796,26760,64,64,401},{27861,4773,50,50,402},{27912,19550,83,83,403},{27996,23199,4,4,405},
{28001,12617,2,2,404},{28004,22898,78,77,406},{28083,10693,79,79,407},{28163,13733,58,58,408},
{28222,24078,77,77,409},{28300,21788,69,69,410},{28370,24078,83,83,411},{28454,2924,197,197,40},
{28652,25100,23,23,412},{28676,9288,63,63,413},{28740,28370,72,72,414},{28813,22819,71,71,415},
{28885,23199,9,9,416},{28895,11875,90,90,417},{28986,26914,58,58,418},{29045,2923,124,124,40},
{29170,25100,13,13,419},{29184,24078,88,88,420},{29273,13733,58,58,421},{29332,28740,59,59,422},
{29392,26210,147,147,40},{29540,26210,14,14,423},{29555,22845,23,22,597},{29579,6861,34,34,424},
{29614,19550,86,86,425},{29701,22819,60,60,597},{29762,22510,86,86,426},{29849,22819,73,73,427},
{29923,22819,87,78,428},{30011,21057,81,79,597},{30093,12964,2,2,429},{30096,27728,67,67,39},
{30164,3746,5,5,430},{30170,8636,60,60,431},{30231,7217,72,72,432},{30304,5292,49,49,433},
{30354,17330,86,86,434},{30441,29923,83,83,435},{30525,20017,77,77,436},{30603,5221,67,67,437},
{30671,11875,79,79,438},{30751,21057,78,78,439},{30830,20470,59,59,440},{30890,26672,90,87,597},
{30981,29392,2,2,441},{30984,28986,35,35,442},{31020,19550,87,87,443},{31108,24078,94,88,597},
{31203,25100,2,2,444},{31206,30984,36,35,597},{31243,29762,72,72,40},{31316,29392,26,26,445},
{31343,19429,120,120,40},{31464,26210,20,20,446},{31485,28895,71,71,447},{31557,22898,15,15,597},
{31573,2047,38,38,448},{31612,19698,91,91,449},{31704,21640,67,67,450},{31772,23484,89,89,451},
{31862,11512,74,74,452},{31937,6629,67,67,453},{32005,29045,149,138,39},{32155,32005,4,4,454},
{32160,10330,81,81,455},{32242,2050,35,35,456},{32278,20364,105,105,39},{32384,0,0,0,457},
{32385,4931,54,54,458},{32440,24078,77,77,459},{32518,22898,68,68,460},{32587,29923,78,78,461},
{32666,8986,129,129,462},{32796,25100,11,11,463},{32808,25926,83,83,464},{32892,4994,69,69,465},
{32962,21788,88,84,466},{33051,23579,66,65,39},{33118,13801,3,3,467},{33122,6926,43,43,597},
{33166,15776,87,87,468},{33254,24078,83,83,469},{33338,20536,78,78,470},{33417,16545,82,82,471},
{33500,2416,1,1,39},{33502,22846,68,51,597},{33571,2416,2,2,472},{33574,21660,47,47,473},
{33622,31772,79,79,474},{33702,8986,164,158,597},{33867,25100,2,2,475},{33870,21660,45,45,476},
{33916,24740,92,92,477},{34009,20911,76,76,478},{34086,30830,54,54,479},{34141,33501,21,19,597},
{34163,21583,40,38,597},{34204,33166,71,71,40},{34276,25100,23,23,480},{34300,12840,59,59,482},
{34360,2244,7,7,481},{34368,22898,69,69,483},{34438,31108,97,97,484},{34536,33500,63,63,485},
{34600,13510,68,68,486},{34669,26825,80,80,487},{34750,20838,53,53,488},{34804,34141,24,21,597},
{34829,6339,67,67,489},{34897,22613,72,72,490},{34970,17876,74,74,491},{35045,6407,67,67,492},
{35113,34669,73,73,493},{35187,10693,70,70,494},{35258,12096,67,67,495},{35326,34438,59,59,496},
{35386,32278,105,105,497},{35492,21358,71,71,498},{35564,22688,66,66,499},{35631,21201,82,82,500},
{35714,35492,64,64,501},{35779,28083,73,73,502},{35853,28083,79,79,503},{35933,6481,57,57,504},
{35991,34141,60,60,40},{36052,23842,22,22,505},{36075,35853,79,79,506},{36155,16471,68,68,507},
{36224,15282,82,82,508},{36307,23579,58,58,509},{36366,28004,68,68,510},{36435,35991,70,70,511},
{36506,34804,63,63,512},{36570,35386,95,95,513},{36666,22976,125,125,514},{36792,35386,96,96,515},
{36889,36075,50,50,516},{36940,23768,73,73,517},{37014,14888,86,86,518},{37101,35991,70,70,519},
{37172,34804,98,92,597},{37271,23842,2,2,520},{37274,11966,56,56,521},{37331,28895,81,81,522},
{37413,21873,58,58,523},{37472,29184,79,79,524},{37552,17054,75,75,525},{37628,3588,75,75,526},
{37704,19352,63,63,527},{37768,29184,81,81,528},{37850,22976,125,125,40},{37976,17256,37,37,529},
{38014,26914,36,35,597},{38051,31243,99,99,39},{38151,2244,1,1,530},{38153,24833,118,118,597},
{38272,13334,94,94,531},{38367,11875,74,74,532},{38442,4994,63,63,533},{38506,34804,22,22,597},
{38529,24099,67,67,39},{38597,2244,3,3,534},{38601,4931,40,40,535},{38642,23842,73,73,536},
{38716,23916,73,73,537},{38790,17330,84,84,538},{38875,34804,23,23,597},{38899,22249,48,48,39},
{38948,21569,12,12,539},{38961,26825,82,82,540},{39044,4486,55,55,541},{39100,28370,71,71,544},
{39172,2244,8,8,545},{39181,3577,1,1,546},{39183,0,0,0,543},{39184,0,0,0,542},{39185,7217,48,48,547},
{39234,32278,106,106,548},{39341,1971,54,54,549},{39396,34438,83,83,550},{39480,15282,87,87,551},
{39568,31206,110,109,597},{39679,11044,146,146,40},{39826,23916,23,23,552},{39850,19870,84,82,597},
{39935,2416,2,2,553},{39938,12780,35,35,554},{39974,23916,73,73,555},{40048,17330,97,97,556},
{40146,36224,64,64,557},{40211,33501,23,22,597},{40235,40211,22,22,597},{40258,14052,11,11,40},
{40270,25100,23,23,558},{40294,9362,63,63,559},{40358,40211,20,19,597},{40379,34829,52,52,560},
{40432,25558,171,171,561},{40604,32242,35,35,562},{40640,35386,103,103,563},{40744,18544,66,66,564},
{40811,40211,11,11,597},{40823,2269,59,59,565},{40883,21569,70,70,566},{40954,21788,55,55,597},
{41010,27468,175,175,567},{41186,13510,60,60,568},{41247,40211,88,82,569},{41336,18544,53,53,570},
{41390,40358,24,20,597},{41415,38529,70,70,571},{41486,35492,64,64,572},{41551,32005,147,147,573},
{41699,40811,60,60,574},{41760,41390,91,91,575},{41852,15582,58,58,576},{41911,41390,21,21,597},
{41933,22249,38,38,577},{41972,23916,73,73,578},{42046,17330,96,96,579},{42143,40811,63,63,580},
{42207,34141,60,60,40},{42268,25100,28,28,581},{42297,9145,54,54,582},{42352,41390,92,92,583},
{42445,20615,66,66,584},{42512,38442,51,51,585},{42564,25100,73,73,586},{42638,26210,221,221,40},
{42860,38642,28,28,587},{42889,10329,44,44,588},{42934,38716,73,73,589},{43008,23102,95,95,590},
{43104,34141,12,12,597},{43117,2194,2,2,39},{43120,34536,35,35,591},{43156,23102,87,87,592},
{43244,40432,133,133,597},{43378,13334,73,73,593},{43452,42638,235,235,594},{43688,25558,133,133,595},
{43822,43452,147,147,596},{43970,43452,208,208,-1},};
static int accepttoks_INITIAL[] = {-1,70,70,70,70,70,70,70,-1,-1,70,70,-1,70,70,
11,-1,-1,70,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,70,4,
-1,-1,-1,-1,-1,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,34,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
6,-1,-1,12,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
29,-1,-1,31,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,35,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,27,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,5,-1,9,-1,-1,-1,-1,
-1,-1,-1,-1,-1,14,15,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,30,-1,-1,-1,-1,
-1,-1,-1,-1,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,32,33,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,21,-1,13,-1,-1,-1,-1,-1,-1,39,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,38,-1,-1,47,-1,-1,-1,
-1,-1,-1,-1,-1,-1,57,-1,-1,-1,-1,-1,-1,-1,-1,40,48,49,60,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,44,-1,45,36,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,23,61,-1,-1,-1,-1,-1,-1,46,
-1,-1,-1,-1,24,-1,-1,-1,54,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,22,-1,51,-1,-1,-1,-1,-1,-1,-1,-1,18,-1,-1,-1,-1,-1,-1,-1,-1,41,-1,-1,-1,-1,-1,
19,-1,-1,-1,-1,-1,-1,-1,55,-1,-1,-1,-1,-1,42,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,59,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,64,-1,58,-1,62,63,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
-1,-1,-1,-1,-1,-1,37,56,50,-1,-1,-1,-1,-1,-1,-1,-1,-1,43,-1,-1,-1,-1,-1,-1,26,28,
-1,-1,-1,-1,-1,-1,52,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,65,66,-1,-1,-1,-1,
-1,-1,17,20,-1,68,69,-1,16,-1,67,-1,53,25,};
static int brk_EXPECT_TOKEN[] = {0,9,10,11,13,14,32,33,45,46,48,58,65,91,95,96,97,
123,};
static scnitem scn_EXPECT_TOKEN[] = {{0,0,0,0,4},{1,0,0,0,1},{2,0,0,0,3},{3,0,5,2,2},
{9,0,1,1,2},{11,9,7,2,4},{19,1,1,1,4},{21,3,6,5,4},{28,20,16,2,2},{45,27,1,1,2},
{47,45,7,2,4},{55,28,17,16,-1},};
static int accepttoks_EXPECT_TOKEN[] = {-1,71,72,73,};
static tsinfo tsinfos[] = {{SZ(brk_INITIAL),brk_INITIAL,597,accepttoks_INITIAL,SZ(scn_INITIAL),scn_INITIAL},
{SZ(brk_EXPECT_TOKEN),brk_EXPECT_TOKEN,4,accepttoks_EXPECT_TOKEN,SZ(scn_EXPECT_TOKEN),scn_EXPECT_TOKEN},
};

static int reduce_action(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr, SkeletonFile* *pextra)
{
  SkeletonFile* extra = *pextra;
  switch(pid) {
  case 84: {
#line 109 "skfile.gg"
 extra->m_sections[(*((char**)nodes[2]->vp))] = (nodes[4]?1:0) ? (*((vector<Statement*>**)nodes[4]->vp)) : 0; 
#line 2372 "skfile.cpp"
  } break;
  case 88: {
#line 110 "skfile.gg"
 if((nodes[1]?1:0)) (*((vector<Statement*>**)nodes[0]->vp)) = (*((vector<Statement*>**)nodes[1]->vp)); else (*((vector<Statement*>**)nodes[0]->vp)) = new vector<Statement*>(); (*((vector<Statement*>**)nodes[0]->vp))->push_back((*((Statement**)nodes[2]->vp))); 
#line 2377 "skfile.cpp"
  } break;
  case 90: {
#line 112 "skfile.gg"
 (*((Statement**)nodes[0]->vp)) = if_stmt((*((char**)nodes[2]->vp)),(nodes[4]?1:0)?(*((vector<Statement*>**)nodes[4]->vp)):0,(nodes[5]?1:0)?(*((vector<Statement*>**)nodes[5]->vp)):0,(nodes[7]?1:0)?(*((vector<Statement*>**)nodes[7]->vp)):0); 
#line 2382 "skfile.cpp"
  } break;
  case 102: {
#line 114 "skfile.gg"
 (*((Statement**)nodes[0]->vp)) = for_each_stmt((*((char**)nodes[2]->vp)),(nodes[4]?1:0)?(*((vector<Statement*>**)nodes[4]->vp)):0); 
#line 2387 "skfile.cpp"
  } break;
  case 104: {
#line 115 "skfile.gg"
 (*((Statement**)nodes[0]->vp)) = subst_stmt((*((int*)nodes[1]->vp))); 
#line 2392 "skfile.cpp"
  } break;
  case 105: {
#line 116 "skfile.gg"
 (*((Statement**)nodes[0]->vp)) = txt_stmt((*((char**)nodes[1]->vp))); 
#line 2397 "skfile.cpp"
  } break;
  case 106: {
#line 119 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2402 "skfile.cpp"
  } break;
  case 107: {
#line 120 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2407 "skfile.cpp"
  } break;
  case 108: {
#line 121 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2412 "skfile.cpp"
  } break;
  case 109: {
#line 122 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2417 "skfile.cpp"
  } break;
  case 110: {
#line 123 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2422 "skfile.cpp"
  } break;
  case 111: {
#line 124 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2427 "skfile.cpp"
  } break;
  case 112: {
#line 125 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2432 "skfile.cpp"
  } break;
  case 113: {
#line 126 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2437 "skfile.cpp"
  } break;
  case 114: {
#line 127 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2442 "skfile.cpp"
  } break;
  case 115: {
#line 128 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2447 "skfile.cpp"
  } break;
  case 116: {
#line 129 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2452 "skfile.cpp"
  } break;
  case 117: {
#line 130 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2457 "skfile.cpp"
  } break;
  case 118: {
#line 131 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2462 "skfile.cpp"
  } break;
  case 119: {
#line 132 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2467 "skfile.cpp"
  } break;
  case 120: {
#line 133 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2472 "skfile.cpp"
  } break;
  case 121: {
#line 134 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2477 "skfile.cpp"
  } break;
  case 122: {
#line 135 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2482 "skfile.cpp"
  } break;
  case 123: {
#line 136 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2487 "skfile.cpp"
  } break;
  case 124: {
#line 137 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2492 "skfile.cpp"
  } break;
  case 125: {
#line 138 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2497 "skfile.cpp"
  } break;
  case 126: {
#line 139 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2502 "skfile.cpp"
  } break;
  case 127: {
#line 140 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2507 "skfile.cpp"
  } break;
  case 128: {
#line 141 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2512 "skfile.cpp"
  } break;
  case 129: {
#line 142 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2517 "skfile.cpp"
  } break;
  case 130: {
#line 143 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2522 "skfile.cpp"
  } break;
  case 131: {
#line 144 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2527 "skfile.cpp"
  } break;
  case 132: {
#line 145 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2532 "skfile.cpp"
  } break;
  case 133: {
#line 146 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2537 "skfile.cpp"
  } break;
  case 134: {
#line 147 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2542 "skfile.cpp"
  } break;
  case 135: {
#line 148 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2547 "skfile.cpp"
  } break;
  case 136: {
#line 149 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2552 "skfile.cpp"
  } break;
  case 137: {
#line 150 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2557 "skfile.cpp"
  } break;
  case 138: {
#line 151 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2562 "skfile.cpp"
  } break;
  case 139: {
#line 152 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2567 "skfile.cpp"
  } break;
  case 140: {
#line 153 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2572 "skfile.cpp"
  } break;
  case 141: {
#line 154 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2577 "skfile.cpp"
  } break;
  case 142: {
#line 155 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2582 "skfile.cpp"
  } break;
  case 143: {
#line 156 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2587 "skfile.cpp"
  } break;
  case 144: {
#line 157 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2592 "skfile.cpp"
  } break;
  case 145: {
#line 158 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2597 "skfile.cpp"
  } break;
  case 146: {
#line 159 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2602 "skfile.cpp"
  } break;
  case 147: {
#line 160 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2607 "skfile.cpp"
  } break;
  case 148: {
#line 161 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2612 "skfile.cpp"
  } break;
  case 149: {
#line 162 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2617 "skfile.cpp"
  } break;
  case 150: {
#line 163 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2622 "skfile.cpp"
  } break;
  case 151: {
#line 164 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2627 "skfile.cpp"
  } break;
  case 152: {
#line 165 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2632 "skfile.cpp"
  } break;
  case 153: {
#line 166 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2637 "skfile.cpp"
  } break;
  case 154: {
#line 167 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2642 "skfile.cpp"
  } break;
  case 155: {
#line 168 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2647 "skfile.cpp"
  } break;
  case 156: {
#line 169 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2652 "skfile.cpp"
  } break;
  case 157: {
#line 170 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2657 "skfile.cpp"
  } break;
  case 158: {
#line 171 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2662 "skfile.cpp"
  } break;
  case 159: {
#line 172 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2667 "skfile.cpp"
  } break;
  case 160: {
#line 173 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2672 "skfile.cpp"
  } break;
  case 161: {
#line 174 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2677 "skfile.cpp"
  } break;
  case 162: {
#line 175 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2682 "skfile.cpp"
  } break;
  case 163: {
#line 176 "skfile.gg"
 (*((int*)nodes[0]->vp)) = (nodes[1])->sym; 
#line 2687 "skfile.cpp"
  } break;
  case 164: {
#line 179 "skfile.gg"
 (*((vector<Statement*>**)nodes[0]->vp)) = (nodes[1]?1:0)?(*((vector<Statement*>**)nodes[1]->vp)):new vector<Statement*>(); (*((vector<Statement*>**)nodes[0]->vp))->push_back((*((Statement**)nodes[2]->vp))); 
#line 2692 "skfile.cpp"
  } break;
  case 166: {
#line 180 "skfile.gg"
 (*((Statement**)nodes[0]->vp)) = if_stmt((*((char**)nodes[2]->vp)),(nodes[4]?1:0)?(*((vector<Statement*>**)nodes[4]->vp)):0,0,0); 
#line 2697 "skfile.cpp"
  } break;
  default: break;
  }
  return 1;
}

static lxact lxact_INITIAL[] = {
{4,PUSH_FLAG,1},{5,PUSH_FLAG,1},{6,0,-1},{7,PUSH_FLAG,1},{8,0,-1},{9,PUSH_FLAG,1},
{10,WS_FLAG,-1},{11,WS_FLAG,-1},{12,0,-1},{13,0,-1},{14,0,-1},{15,0,-1},{16,0,-1},
{17,0,-1},{18,0,-1},{19,0,-1},{20,0,-1},{21,0,-1},{22,0,-1},{23,0,-1},{24,0,-1},
{25,0,-1},{26,0,-1},{27,0,-1},{28,0,-1},{29,0,-1},{30,0,-1},{31,0,-1},{32,0,-1},
{33,0,-1},{34,0,-1},{35,0,-1},{36,0,-1},{37,0,-1},{38,0,-1},{39,0,-1},{40,0,-1},
{41,0,-1},{42,0,-1},{43,0,-1},{44,0,-1},{45,0,-1},{46,0,-1},{47,0,-1},{48,0,-1},
{49,0,-1},{50,0,-1},{51,0,-1},{52,0,-1},{53,0,-1},{54,0,-1},{55,0,-1},{56,0,-1},
{57,0,-1},{58,0,-1},{59,0,-1},{60,0,-1},{61,0,-1},{62,0,-1},{63,0,-1},{64,0,-1},
{65,0,-1},{66,0,-1},{67,0,-1},{68,0,-1},{69,0,-1},{70,0,-1},{-1,0,0}};
static lxact lxact_EXPECT_TOKEN[] = {
{71,WS_FLAG,-1},{72,0,-1},{73,POP_FLAG,-1},{-1,0,0}};
static lxact *lxactions[] = {
lxact_INITIAL,lxact_EXPECT_TOKEN,};

static int Parse_skfile(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc, SkeletonFile* extra)
{
    return parse_any(buf, obuf, trace, err_lc,
                                tsinfos,
                                lxactions,
                                parse_states,
                                productions,
                                81,
                                8,
                                allsymbols,
                                STARTTOK,
                                ERRTOK,
                                EOFTOK,
                                ACCEPTSTATE,
                                0,
                                INITIAL_TOKENSET,
                                (reduce_action_fnct)reduce_action,
                                &extra);
}
#line 183 "skfile.gg"

int Parse_SkeletonFile(inbuf *buf, outbuf *obuf, outbuf *trace, SkeletonFile *skfile)
{
    line_col err_lc;
    return Parse_skfile(buf, obuf, trace, &err_lc, skfile);
}

void ob_puts_fix_backslash(outbuf *obuf, const char *s)
{
    const char *begins = s, *ends = s;
    while( *begins )
    {
        while( *ends && *ends != '\\' )
            ++ends;
        ob_write(obuf,begins,ends-begins);
        if( *ends == '\\' )
        {
            ob_write(obuf,"\\\\",2);
            ends++;
        }
        begins = ends;        
    }        
}

int Statement::eval(EmitGlobals *globals, defines *defs, outbuf *wr, outbuf *err, outbuf *trace)
{
    switch( m_stype )
    {
        case NULL_STMT:
            break;
        case IF_STMT:
            if( defs->is_defined(m_label) )
                return evaluate(m_strue, globals, defs, wr, err, trace);
            if( m_selseifs )
                for( vector<Statement*>::iterator curstmt = m_selseifs->begin(), endstmt = m_selseifs->end(); curstmt != endstmt; ++curstmt )
                    if( defs->is_defined((*curstmt)->m_label) )
                        return evaluate((*curstmt)->m_strue, globals, defs, wr, err, trace);
            return evaluate(m_selse, globals, defs, wr, err, trace);
            break;
        case FOREACH_STMT:
            {
                EmitGlobals scopeglobals = *globals;
                return evalloops(&scopeglobals, defs, wr, err, trace);
            }
            break;
        case SUBST_STMT:
            switch( m_tok )
            {
            case SYMID_LITDOLLPRNAMERPR:
                ob_puts(wr, globals->m_g->m_name.c_str());
                break;
            case SYMID_LITDOLLPRSTARTTOKRPR:
                ob_printf(wr, "%d", globals->m_g->m_startsymbol->GetIndex());
                break;
            case SYMID_LITDOLLPREOFTOKRPR:
                ob_printf(wr, "%d", globals->m_g->m_endmarker->GetIndex());
                break;
            case SYMID_LITDOLLPRERRTOKRPR:
                ob_printf(wr, "%d", globals->m_g->m_errorsymbol->GetIndex());
                break;
            case SYMID_LITDOLLPRPRODUCTION_ADJUST_COUNTRPR:
                ob_printf(wr, "%d", globals->m_g->m_symbols[-1]->GetIndex() + 1);
                break;
            case SYMID_LITDOLLPRMAX_PRODUCTION_SYMBOLSRPR:
                ob_printf(wr, "%d", globals->m_max_production_symbols);
                break;
            case SYMID_LITDOLLPRPRODUCTION_IDRPR:
                if( ! globals->m_p )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_p->GetIndex() + globals->m_g->m_symbols[-1]->GetIndex() + 1);
                break;
            case SYMID_LITDOLLPRORIGINAL_PRODUCTION_IDRPR:
                {
                if( ! globals->m_p )
                    goto do_default;
                Production *p = globals->m_p;
                while( p->m_copyof && p != p->m_copyof )
                    p = p->m_copyof;
                ob_printf(wr, "%d", p->GetIndex() + globals->m_g->m_symbols[-1]->GetIndex() + 1);
                break;
                }
            case SYMID_LITDOLLPRNT_INDEXRPR:
                if( ! globals->m_p )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_p->m_nt->GetIndex());
                break;
            case SYMID_LITDOLLPRSYMBOL_COUNTRPR:
                if( ! globals->m_p )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_p->m_items.size());
                break;
            case SYMID_LITDOLLPRREDUCE_SRCRPR:
                if( ! globals->m_p )
                    goto do_default;
                if( ! Emit_Reduce_Src(globals->m_p->m_ReduceCode.m_code.c_str(), globals, defs, wr, err, trace) )
                    return 0;
                break;
            case SYMID_LITDOLLPRLINERPR:
                ob_printf(wr, "%d", wr->lineno);
                break;
            case SYMID_LITDOLLPRLINEP1RPR:
                ob_printf(wr, "%d", wr->lineno+1);
                break;
            case SYMID_LITDOLLPRFILERPR:
                ob_puts_fix_backslash(wr, globals->m_g->m_outfile.c_str());
                break;
            case SYMID_LITDOLLPRSRCLINERPR:
                if( ! globals->m_snip )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_snip->m_line);
                break;
            case SYMID_LITDOLLPRSRCFILERPR:
                if( ! globals->m_snip )
                    goto do_default;
                ob_puts_fix_backslash(wr, globals->m_snip->m_file.c_str());
                break;
            case SYMID_LITDOLLPRSRCRPR:
                if( ! globals->m_snip )
                    goto do_default;
                if( ! Emit_Src(globals->m_snip->m_code.c_str(), globals, defs, wr, err, trace) )
                    return 0;
                break;
            case SYMID_LITDOLLPRIN_PRODUCTION_INDEXRPR:
                if( globals->m_sindex == -1 )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_sindex);
                break;
            case SYMID_LITDOLLPRSYMBOL_TYPERPR:
                if( ! globals->m_s )
                    goto do_default;
                if( globals->m_s->IsCharSet() )
                    ob_puts(wr, "int");
                else if( globals->m_s->GetSType() == LITERAL_SYMBOL || globals->m_s->GetSType() == REGEX_SYMBOL )
                    ob_puts(wr, "char*");
                else if( globals->m_s->GetSType() == NONTERMINAL_SYMBOL && globals->m_s->m_CType.length() )
                    ob_puts(wr, globals->m_s->m_CType.c_str());
                else
                {
                    ob_printf(err, "error: tried to use a symbol (%s) type with no type %s(%d)\n", globals->m_s->m_Name.c_str(), globals->m_snip ? globals->m_snip->m_file.c_str() : "???", globals->m_snip ? globals->m_snip->m_line : -1);
                    return 0;
                }
                break;
            case SYMID_LITDOLLPRSYMBOL_TYPE_FRIENDLY_NAMERPR:
                if( ! globals->m_s )
                    goto do_default;
                if( globals->m_s->IsCharSet() )
                    ob_puts(wr, "int");
                else if( globals->m_s->GetSType() == LITERAL_SYMBOL || globals->m_s->GetSType() == REGEX_SYMBOL )
                    ob_puts(wr, "char_ptr");
                else if( globals->m_s->GetSType() == NONTERMINAL_SYMBOL && globals->m_s->m_CType.length() )
                    ob_puts(wr, FriendlyCType(globals->m_s->m_CType).c_str());
                else
                {
                    ob_printf(err, "error: tried to use a symbol (%s) type with no type %s(%d)\n", globals->m_s->m_Name.c_str(), globals->m_snip ? globals->m_snip->m_file.c_str() : "???", globals->m_snip ? globals->m_snip->m_line : -1);
                    return 0;
                }
                break;
            case SYMID_LITDOLLPRCTYPERPR:
                if( ! globals->m_ctype.length() )
                    goto do_default;
                ob_puts(wr, globals->m_ctype.c_str());
                break;
            case SYMID_LITDOLLPRCTYPE_FRIENDLY_NAMERPR:
                if( ! globals->m_ctype.length() )
                    goto do_default;
                ob_puts(wr, FriendlyCType(globals->m_ctype).c_str());
                break;
            case SYMID_LITDOLLPRSTATERPR:
                if( ! globals->m_state )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_state->m_number);
                break;
            case SYMID_LITDOLLPRSTATECOUNTRPR:
                ob_printf(wr, "%d", globals->m_g->m_lrstates.size());
                break;
            case SYMID_LITDOLLPRPARSE_ACTION_COUNTRPR:
                if( ! globals->m_state )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_state->m_actions.size());
                break;
            case SYMID_LITDOLLPRTOKEN_IDRPR:
                if( ! globals->m_action )
                    goto do_default;
                if( globals->m_action->m_gtype == GTypeSymbol )
                    ob_printf(wr, "%d", globals->m_action->m_s->GetIndex());
                else if( globals->m_action->m_gtype == GTypeProduction )
                    ob_printf(wr, "%d", globals->m_action->m_p->GetIndex() + globals->m_g->m_symbols[-1]->GetIndex() + 1);
                else
                    goto do_default;
                break;
            case SYMID_LITDOLLPRSHIFT_TORPR:
                if( ! globals->m_action )
                    goto do_default;
                if( ! (globals->m_action->m_atype == ATypeShift) )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_action->m_shiftto->m_number);
                break;
            case SYMID_LITDOLLPRREDUCE_BYRPR:
                if( ! globals->m_action )
                    goto do_default;
                if( ! (globals->m_action->m_atype & (ATypeReduce|ATypeAccept)) )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_action->m_reduceby->GetIndex());
                break;
            case SYMID_LITDOLLPRTOKENSETNAMERPR:
                if( ! globals->m_tokenset )
                    goto do_default;
                ob_puts(wr, globals->m_tokenset->m_Name.toupper().c_str());
                break;
            case SYMID_LITDOLLPRTOKENSETSTATERPR:
                if( ! globals->m_tokenset )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_tokenset->GetIndex());
                break;
            case SYMID_LITDOLLPRTOKENSETSTATECOUNTRPR:
                if( ! globals->m_tokenset )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_tokenset->m_bigdfa->m_statecount);
                break;
            case SYMID_LITDOLLPRACCEPTTOKRPR:
            {
                if( ! globals->m_tokenset || globals->m_lexstate == -1 )
                    goto do_default;
                Symbol *s = globals->m_tokenset->m_accepttokens[globals->m_lexstate];
                ob_printf(wr, "%d", s ? s->GetIndex() : -1);
                break;
            }
            case SYMID_LITDOLLPRNEXT_STATERPR:
                if( ! globals->m_tokensetaction )
                    goto do_default;
                if( globals->m_tokensetaction->m_actionset )
                    ob_printf(wr, "%d", globals->m_tokensetaction->m_actionset->GetIndex());
                else
                    ob_printf(wr, "%d", -1);
                break;
            case SYMID_LITDOLLPRFROM_STATERPR:
                if( globals->m_lexstate == -1 )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_lexstate);
                break;
            case SYMID_LITDOLLPRTO_STATERPR:
                if( ! globals->m_range )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_range->m_to);
                break;
            case SYMID_LITDOLLPRRANGE_MINRPR:
                if( ! globals->m_range )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_range->m_start);
                break;
            case SYMID_LITDOLLPRRANGE_MAXRPR:
                if( ! globals->m_range )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_range->m_stop);
                break;
            case SYMID_LITDOLLPRPARTIAL_ACCEPT_TOKRPR:
                if( ! globals->m_tokenset || ! globals->m_range )
                    goto do_default;
                {
                Symbol *sym = globals->m_tokenset->m_accepttokens[globals->m_range->m_to];
                int symidx = sym ? sym->GetIndex() : -1;
                ob_printf(wr, "%d", symidx);
                }
                break;
            case SYMID_LITDOLLPRSYMBOL_INDEXRPR:
                if( ! globals->m_s )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_s->GetIndex());
                break;
            case SYMID_LITDOLLPRSYMBOL_FRIENDLY_NAMERPR:
                if( ! globals->m_s )
                    goto do_default;
                ob_puts(wr, SymbolFriendlyName(globals->m_s).c_str());
                break;
            case SYMID_LITDOLLPRPRODUCTION_FRIENDLY_NAMERPR:
                if( ! globals->m_p )
                    goto do_default;
                ob_puts(wr, ProductionFriendlyName(globals->m_p).c_str());
                break;
            case SYMID_LITDOLLPRSYMBOL_NAMERPR:
                if( ! globals->m_s )
                    goto do_default;
                {
                String s = globals->m_s->m_Name;
                s = s.replace("\n", "\\n");
                s = s.replace("\\", "\\\\");
                s = s.replace("\"", "\\\"");
                ob_puts(wr, s.c_str());
                }
                break;
            case SYMID_LITDOLLPRGLOBAL_CTYPERPR:
                if( ! globals->m_g->m_globalctype.length() )
                    goto do_default;
                ob_puts(wr, globals->m_g->m_globalctype.c_str());
                break;
            case SYMID_LITDOLLPRINITIAL_LEXERRPR:
            case SYMID_LITDOLLPRPARSER_START_STATERPR:
                ob_puts(wr, "0");
                break;
            case SYMID_LITDOLLPRSKIPINDEXRPR:
                if( globals->m_skipindex == -1 )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_skipindex);
                break;
            case SYMID_LITDOLLPRFIRST_ACTION_IDXRPR:
                if( ! globals->m_actionrange )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_actionrange->m_firstactionidx);
                break;
            case SYMID_LITDOLLPRLAST_ACTION_IDXRPR:
                if( ! globals->m_actionrange )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_actionrange->m_lastactionidx);
                break;
            case SYMID_LITDOLLPRRANGE_IDXRPR:
                if( globals->m_action_range_index == -1 )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_action_range_index);
                break;
            case SYMID_LITDOLLPRRANGE_SIZERPR:
                if( globals->m_action_range_size == -1 )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_action_range_size);
                break;
            case SYMID_LITDOLLPRACTION_RANGE_MINRPR:
                if( ! globals->m_action_range_item )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_action_range_item->m_min);
                break;
            case SYMID_LITDOLLPRACTION_RANGE_MAXRPR:
                if( ! globals->m_action_range_item )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_action_range_item->m_max);
                break;
            case SYMID_LITDOLLPRCOMPRESSED_BREAKRPR:
                if( globals->m_compressed_break == -1 )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_compressed_break);
                break;
            case SYMID_LITDOLLPRCOMPRESSED_LXITEM_POSRPR:
                if( ! globals->m_compressed_lxitem )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_compressed_lxitem->pos);
                break;
            case SYMID_LITDOLLPRCOMPRESSED_LXITEM_OFFRPR:
                if( ! globals->m_compressed_lxitem )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_compressed_lxitem->off);
                break;
            case SYMID_LITDOLLPRCOMPRESSED_LXITEM_COUNTRPR:
                if( ! globals->m_compressed_lxitem )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_compressed_lxitem->count);
                break;
            case SYMID_LITDOLLPRCOMPRESSED_LXITEM_LEADRPR:
                if( ! globals->m_compressed_lxitem )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_compressed_lxitem->lead);
                break;
            case SYMID_LITDOLLPRCOMPRESSED_LXITEM_NEXTRPR:
                if( ! globals->m_compressed_lxitem )
                    goto do_default;
                ob_printf(wr, "%d", globals->m_compressed_lxitem->next);
                break;
            default:
                break;
            }
            break;
        case TXT_STMT:
            {
                const char *txt = m_txt.c_str();
                size_t len = m_txt.length();
                bool autonewline = false;
                if( len && txt[len-1] == '\n' )
                {
                    size_t newlen = len;
                    --newlen;
                    if( newlen && txt[newlen-1] == '\r' )
                        --newlen;
                    if( newlen && txt[newlen-1] == '\\' )
                    {
                        --newlen;
                        if( newlen && txt[newlen-1] == '\\' )
                        {
                            --newlen;
                            autonewline = true;
                        }
                        len = newlen;
                    }
                }
                if( len )
                    ob_write(wr, txt, len);
                if( autonewline && wr->colno > 80 )
                    ob_putc(wr, '\n');
            }
            break;
    }
    
    return 1;
do_default:
    ob_puts(wr, m_txt.c_str());
    return 1;
}

#line 3143 "skfile.cpp"
