// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
#ifndef __sysport_h
#define __sysport_h

#include "ints.h"
#include "glrexport.h"
#include <stddef.h>
typedef ptrdiff_t ptrsize_t;

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _WIN32
typedef unsigned long ptd_t;
typedef long threadid_t;
#define NULL_PTD TLS_OUT_OF_INDEXES
typedef void *file_t;
#define NULL_FILE ((void*)-1)
#define SPIN(splk,i,wait) while( InterlockedCompareExchange(&splk, 1, 0) ) for(i=0;i<wait;++i);
#define UNSPIN(splk) InterlockedExchange(&splk, 0);
#define spin_t volatile LONG
#define NULL_SPINLOCK (0)
#endif

// system (not C library!) memory
void LIBGLR_EXPORT *sys_malloc(ptrsize_t size, ptrsize_t *osize, int iflags);
int LIBGLR_EXPORT sys_free(void *vpdata);

// thread
typedef int (*thread_fnct)(void *vpdata);
threadid_t LIBGLR_EXPORT start_thread(thread_fnct f, void *vpdata);
unsigned int LIBGLR_EXPORT current_threadid();

// per thread data
ptd_t LIBGLR_EXPORT ptd_alloc(void (*release)(void*));
void LIBGLR_EXPORT ptd_free(ptd_t ptd);
void LIBGLR_EXPORT *ptd_get(ptd_t ptd);
void LIBGLR_EXPORT ptd_set(ptd_t ptd, void *vp);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // __sysport_h
