#line 1 "glrgen.gg"
// Copyright (c) 2008-2011 Mighty Heave Software LLC.
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
// glrgen grammar, version 2.0
#include "emitC.h"
#include "rx.h"
#include "chtest.h"
#include <stdarg.h>
#include <stdio.h>
#include <ctype.h>

class Symbols
{
public:
    vector<Symbol*> m_symbols;
    vector<sl_decl> m_decls;
};

class ProductionPart
{
public:
    Symbols m_symbols;
    AllProperties m_props;
    void SetSymbols(Symbols &symbols) { m_symbols = symbols; }
    void SetProps(AllProperties &props) { m_props = props; }
};

static unsigned int otoi(const char *s)
{
    unsigned int ret = 0;
    while( *s )
    {
        ret <<= 3;
        ret |= glr_digitvalue(*s);
        ++s;
    }
    return ret;
}

static unsigned int xtoi(const char *s)
{
    unsigned int ret = 0;
    while( *s )
    {
        ret <<= 4;
        if( isxdigit(*s) )
			ret |= glr_xdigitvalue(*s);
        ++s;
    }
    return ret;
}


#line 72 "glrgen.cpp"
/*
   generated by glrgen.  
   (Skeleton Code) Copyright (c) 2008-2011 Mighty Heave Software LLC.
   Wormhole license (MIT Style)  http://www.mightyheave.com
*/
/* duplicode management {
   define C_IO_STATIC, or nothing to get a stand alone parser, static functions
     GLR_API -> static
   define C_IO_CPP to implement extern functions
   define C_IO_EXTERN to use extern functions
   define C_IO_HEADER to use extern functions
     GLR_API -> extern
     
   In all modes except C_IO_STATIC, you may provide an alternate GLR_API preprocessor
   definition, which can be handy for importing and exporting dll functions on windows.
} duplicode management */
#if ! defined(C_IO_STATIC) && (defined(C_IO_CPP) || defined(C_IO_EXTERN) || defined(C_IO_HEADER))
#ifndef GLR_API
#define GLR_API extern
#endif
#else
#ifndef C_IO_STATIC
#define C_IO_STATIC
#endif
#undef GLR_API
#define GLR_API static
#endif
#ifndef __c_skeleton_decl
#define __c_skeleton_decl
#ifdef __cplusplus
extern "C" {
#endif
GLR_API void *vp_realloc(void *vp, size_t size);
GLR_API void vp_memzero(void *dst, size_t size);
GLR_API char *nv_strdup(const char *str, size_t *len);
#ifdef __cplusplus
} /* extern "C" */
#endif
#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
typedef HANDLE handle_t;
#define H_STDIN GetStdHandle(STD_INPUT_HANDLE)
#define H_STDOUT GetStdHandle(STD_OUTPUT_HANDLE)
#define H_STDERR GetStdHandle(STD_ERROR_HANDLE)
typedef __int64 foff_t;
#else
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
typedef int handle_t;
#define H_STDIN STDIN_FILENO
#define H_STDOUT STDOUT_FILENO
#define H_STDERR STDERR_FILENO
typedef long long foff_t;
#endif

#define BUF_BLOCK_SIZE (32767)
#define SZ(a) (sizeof(a)/sizeof(a[0]))

#ifdef __cplusplus
extern "C" {
#endif

#define INBUF_SET (0)
#define INBUF_CUR (1)
#define INBUF_END (2)

struct tag_inbuf;
typedef struct tag_inbuf inbuf;
typedef int (*ibf_read)(inbuf*,void*,int);
typedef foff_t (*ibf_seek)(inbuf*,foff_t,int);
typedef void (*ibf_close)(inbuf*);

GLR_API inbuf *new_inbuf(size_t inbufsize, const char *fname, ibf_read readfnct, ibf_seek seekfnct, ibf_close closefnct);
GLR_API void free_inbuf(inbuf *buf);
GLR_API int ib_read(inbuf *buf, void *vp, int count);
GLR_API foff_t ib_seek(inbuf *buf, foff_t to, int whence);
GLR_API foff_t ib_tell(inbuf *buf);

struct tag_inbuf
{
  char *s;
  const char *fname;
  foff_t startpos;
  int count;
  int capacity;
  int pos;
  int eof;
  int line;
  int col;
  int strbuf;
  ibf_read readfnct;
  ibf_seek seekfnct;
  ibf_close closefnct;
#ifdef __cplusplus
  int read(void *vp,int len) { return ib_read(this,vp,len); }
  foff_t seek(foff_t off, int whence) { return ib_seek(this,off,whence); }
  foff_t tell() { return ib_tell(this); }
  void close() { if(!closefnct) return; closefnct(this); }
  void free() { free_inbuf(this); }
#endif
};

struct tag_fpinbuf; typedef struct tag_fpinbuf fpinbuf;
struct tag_fpinbuf {
    inbuf base;
    handle_t h;
};

GLR_API inbuf *h_inbuf(const char *fname, handle_t h, int handoff);
GLR_API inbuf *file_inbuf(const char *fname);
GLR_API inbuf *string_inbuf(const char *s, int staticstr);

struct tag_outbuf;
typedef struct tag_outbuf outbuf;
typedef void (*obf_write)(outbuf *buf, const char *s, size_t len);
typedef void (*obf_flush)(outbuf *buf);
typedef void (*obf_close)(outbuf *buf);

GLR_API outbuf *new_ob(size_t size, obf_write write, obf_flush flush, obf_close close);
GLR_API void free_ob(outbuf *buf);
GLR_API void ob_write(outbuf *buf, const char *s, size_t len);
GLR_API void ob_printf(outbuf *buf, const char *fmt, ...);
GLR_API void ob_vprintf(outbuf *buf, const char *fmt, ...);
GLR_API void ob_flush(outbuf *buf);
GLR_API void ob_putc(outbuf *buf, int c);
GLR_API void ob_puts(outbuf *buf, const char *s);

struct tag_outbuf
{
    char buffer[BUF_BLOCK_SIZE];
    char safetynet[16];
    size_t bufused;
    int enc;
    obf_write writefnct;
    obf_flush flushfnct;
    obf_close closefnct;
    int lineno;
    int colno;
    int autoflush;
#ifdef __cplusplus
    void write(const char *s, size_t len) { ob_write(this,s,len); }
    void printf(const char *fmt, ...)
    {
        va_list args;
        va_start(args,fmt);
        ob_vprintf(this,fmt,args);
        va_end(args);
    }
    void vprintf(const char *fmt, va_list args) { ob_vprintf(this,fmt,args); }
    void flush(outbuf *buf) { ob_flush(this); }
    void putc(int c) { ob_putc(this,c); }
    void puts(const char *s) { ob_puts(this,s); }
    void free() { free_ob(this); }
#endif
};

typedef struct tag_file_outbuf
{
    outbuf base;
    handle_t h;
} file_outbuf;

GLR_API outbuf *new_file_outbuf(const char *fname);
GLR_API outbuf *new_h_outbuf(const char *fname, handle_t h, int handoff, int autoflush);

typedef struct tag_string_outbuf
{
    outbuf base;
    int capacity, count;
    char *buf;
} string_outbuf;

GLR_API outbuf *new_string_outbuf();
GLR_API void obs_clear(outbuf *buf);
GLR_API const char *obs_getstr(outbuf *buf);

#ifdef __cplusplus
} /* extern "C" */
#endif
#define NULL_TYPESTACK {0, 0, 0}
#define NULL_LXSTACK {0, 0, 0}

#define WS_FLAG   (1)
#define PUSH_FLAG (2)
#define POP_FLAG  (3)
#define GOTO_FLAG (4)

#define STKVALUE(stk,t,i) (*((t*)((stk)->nodes[(stk)->tncount+(i)].vp)))
#define SH (0)
#define RD (1)

#ifdef __cplusplus
#include <new>
template<class T> void init_T(void *vp) { new(vp) T; }
template<class T> void destruct_T(void *t) { ((T*)t)->~T(); }
#define INIT_T(T)     init_T<T>
#define DESTRUCT_T(T) destruct_T<T>
#else
#define INIT_T(T)     0
#define DESTRUCT_T(T) 0
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tag_lxstack { int *i, count, capacity; } lxstack;
GLR_API int lxstack_push(lxstack *stk, int i);
GLR_API int lxstack_pop(lxstack *stk);
GLR_API int lxstack_size(lxstack *stk);
GLR_API void lxstack_clear(lxstack *stk);
GLR_API int lxstack_top(lxstack *stk);

typedef struct tag_ttype {
  const char *name;
  size_t size;
  void (*init)(void *vp);
  void (*destroy)(void *vp);
} ttype;

extern ttype ptr_tt;

struct tag_toknode;
typedef struct tag_toknode toknode;
struct tag_toknode {
  int ref;
  int line, col;
  int sym, state;
  void *vp;
  size_t size;
  ttype *tt;
  size_t tokslen; char *tokstr;
  toknode *wstop, *wsbottom;
  size_t sncount, sncapacity; toknode **subnodes;
};

GLR_API toknode *new_toknode(size_t size, ttype *tt, int sym, int state);
GLR_API void toknode_addref(toknode *node);
GLR_API void toknode_destroytt(toknode *node);
GLR_API void toknode_decref(toknode *node);

typedef struct tag_typestack
{
  toknode **nodes;
  size_t tncount, tncapacity;
} typestack;

GLR_API int typestack_bump_capacity(typestack *tstack);
GLR_API void *typestack_alloc(typestack *tstack, ttype *tt, int sym, int state);
GLR_API size_t measure_str(toknode *node, int ws);
GLR_API char *collect_str(toknode *node, char *dst, int ws);
GLR_API char *toknode_str(toknode *node);
GLR_API int typestack_pop(typestack *stk, size_t count);
GLR_API int typestack_moveone(typestack *dststk, typestack *srcstk);
GLR_API void typestack_clear(typestack *stk);
GLR_API size_t typestack_size(typestack *stk);
GLR_API toknode *typestack_top(typestack *stk);

typedef struct tag_symbol { const char *name; ttype *tt; } symbol;
typedef struct tag_production { int id, origid, nt, scount, *symbols, skcount, *skips; } production;
#ifdef NO_COMPRESSED_LR_TABLE
typedef struct tag_parse_action { int token, action, shiftto_or_reduceby; } parse_action;
typedef struct tag_parse_state { int acount; parse_action *actions; } parse_state;
#else
typedef struct tag_parse_action_range { int action, first, last, *range; } parse_action_range;
typedef struct tag_parse_state { int acount; parse_action_range *actions; } parse_state;
#endif
#ifdef NO_COMPRESSED_SCANNER
typedef struct tag_lxtr { int low, high, next, tok; } lxtr;
typedef struct tag_lxstnfo { int from, icount; lxtr *toranges; } lxstnfo;
typedef struct tag_tsinfo { int tokstate, lxcount; lxstnfo *lxinfos; } tsinfo;
#else
typedef struct tag_scnitem { int pos, off, count, lead, next; } scnitem;
typedef struct tag_tsinfo { int brkcount, *brks, statecount, *accepttoks, scncnt; scnitem *scnitems; } tsinfo;
#endif
GLR_API int subnodes_bump_capacity(toknode *node);
GLR_API int subnodes_add(toknode *node, toknode *sub);
GLR_API toknode *makews(toknode *wsdst, toknode *wssrc);
GLR_API void toknode_set_subnodes(toknode *node, toknode **nodes, int sncount);
GLR_API void toknode_unset_subnodes(toknode *node, toknode **nodes, int sncount);
GLR_API void toknode_keep_subnodes(toknode *node);

typedef struct tag_line_col {
  int line, col;
} line_col;

typedef struct lxact_tag { int sym, flags, next; } lxact;

GLR_API void update_buf_line_col(inbuf *buf, int len);

GLR_API int readtok(inbuf *buf, lxstack *lexstk, typestack *instk, outbuf *trace, int *isws, outbuf *oberr, int eof, tsinfo *tsinfos, symbol *allsymbols, lxact **lxactions);

typedef int (*reduce_action_fnct)(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr, void *pextra);

GLR_API int update_parse_state(typestack *prsstk, typestack *instk, toknode **nodes, inbuf *buf, outbuf *trace, line_col *err_lc,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int acceptstate,
                                outbuf *oberr,
                                reduce_action_fnct ra,
                                void *pextra
                                );

GLR_API int parse_any(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc,
                                tsinfo *tsinfos,
                                lxact **lxactions,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                int max_production_symbols,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int eoftok,
                                int acceptstate,
                                int parser_start_state,
                                int initial_tokenset,
                                reduce_action_fnct ra,
                                void *pextra);

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif /* __c_skeleton_decl */
#if defined(C_IO_STATIC) || defined(C_IO_CPP)
#ifdef __cplusplus
extern "C" {
#endif
// you may choose to define your own allocation function.
#ifndef vp_realloc
GLR_API void *vp_realloc(void *vp, size_t size) {
  if( ! vp && ! size )
    return 0;
  else if( ! vp )
    vp = malloc(size);
  else if( ! size ) {
    free(vp);
    return 0;
  }
  else
    vp = realloc(vp, size);
  return vp;
}
#endif
GLR_API void vp_memzero(void *dst, size_t size) {
  size_t i = 0;
  if( ! size )
    return;
  for( ; i < size; ++i )
    ((char*)dst)[i] = 0;
}
GLR_API char *nv_strdup(const char *str, size_t *len)
{
    char *sdup = 0;
    size_t slen = strlen(str), i = 0;
    if( len ) *len = slen;
    sdup = (char*)vp_realloc(0, slen+1);
    while( str[i] )
    {
        sdup[i] = str[i];
        ++i;
    }
    sdup[slen] = 0;
    return sdup;
}
#ifdef __cplusplus
} /* extern "C" */
#endif
#ifdef __cplusplus
extern "C" {
#endif
GLR_API inbuf *new_inbuf(size_t inbufsize, const char *fname, ibf_read readfnct, ibf_seek seekfnct, ibf_close closefnct)
{
  inbuf *buf = (inbuf*)vp_realloc(0, inbufsize);
  vp_memzero(buf, inbufsize);
  buf->readfnct = readfnct;
  buf->seekfnct = seekfnct;
  buf->closefnct = closefnct;
  buf->fname = fname ? fname : "";
  buf->line = buf->col = 1;
  buf->strbuf = 0;
  return buf;
}

GLR_API void free_inbuf(inbuf *buf)
{
    if( buf->closefnct ) buf->closefnct(buf);
    if(!buf->strbuf && buf->s) vp_realloc(buf->s, 0);
    vp_realloc(buf, 0);
}

GLR_API int ib_read(inbuf *buf, void *vp, int count)
{
    int rd = 0, i0, i1, n;
    char *dst = (char*)vp, *tmps = 0;
    if( ! buf->readfnct )
        return 0;
    while( count )
    {
        // Copy from the buffer if we can
        if( buf->pos < buf->count )
        {
            for( i0=0,i1=buf->pos, n=((count<=(buf->count-buf->pos))?count:(buf->count-buf->pos)); i0<n; ++i0,++i1 )
                dst[i0] = buf->s[i1];
            buf->pos += n;
            count -= n;
            rd += n;
            dst += n;
            continue;
        }
        // if we're out of file, stop.
        if( buf->eof )
            break;
        // Out of buffer, let's read large chunks directly into the destination.
        n = (count / BUF_BLOCK_SIZE) * BUF_BLOCK_SIZE;
        if(n)
        {
            buf->readfnct(buf, dst, n);
            buf->startpos += n;
            rd += n;
            dst += n;
            count -= n;
            continue;
        }
        // Out of large chunks, let's read a single chunk to the buffer (fast io, copy on next loop).
        if( buf->capacity < BUF_BLOCK_SIZE ) {
            // make sure we have a single chunk available
            tmps = (char*)vp_realloc(buf->s, BUF_BLOCK_SIZE);
            if( ! tmps ) break;
            buf->s = tmps;
            buf->capacity = BUF_BLOCK_SIZE;
        }
        buf->pos = 0;
        buf->startpos += buf->count;
        buf->count = buf->readfnct(buf, buf->s, BUF_BLOCK_SIZE);
        if( buf->count == 0 )
        {
            buf->eof = 1;
            break;
        }
    }
    return rd;
}

GLR_API foff_t ib_seek(inbuf *buf, foff_t to, int whence)
{
    // Seeks within the current buffer are handled without using seekfnct,
    // so file devices which buffer all of their contents, e.g. strings, require no seek function.
    if( whence == INBUF_SET )
    {
        if( (to>=buf->startpos) && (to<=buf->startpos+buf->count) )
        {
            buf->pos = (int)(to-buf->startpos);
            return to;
        }
    }
    else if( whence == INBUF_CUR )
    {
        if( (buf->pos+to) >= 0 && (buf->pos+to) <= buf->count )
        {
            buf->pos = buf->pos + (int)to;
            return buf->startpos+buf->pos;
        }
    }
    else if( whence == INBUF_END )
    {
        if( buf->eof && (to<=0) && (-to<=buf->count))
        {
            buf->pos = buf->count+(int)to;
            return buf->startpos+buf->pos;
        }
    }
    else
        return -1;
    // Anything with an actual backing store needs a seek funciton.
    if( ! buf->seekfnct )
        return -1;
    to = buf->seekfnct(buf, to, whence);
    if( to == -1 )
        return -1;
    buf->startpos = to;
    buf->pos = 0;
    buf->count = 0;
    return to;
}

GLR_API foff_t ib_tell(inbuf *buf)
{
    return buf->startpos + buf->pos;
}

GLR_API int read_file(fpinbuf *buf, void *dst, int count)
{
#ifdef _WIN32
  DWORD dwRead = 0;
  if( ! ReadFile(buf->h, dst, count, &dwRead, 0) )
    return 0;
  return dwRead;
#else
  ssize_t rdsz = read(buf->h, dst, count);
  if( rdsz == -1 )
      return 0;
  return rdsz;
#endif
}

GLR_API foff_t seek_file(fpinbuf *buf, foff_t to, int whence)
{
#ifdef _WIN32
    LARGE_INTEGER liDistanceToMove, liNewFilePointer;
    liDistanceToMove.QuadPart = to;
    if( ! SetFilePointerEx(buf->h, liDistanceToMove, &liNewFilePointer, whence) )
        return -1;
    return liNewFilePointer.QuadPart;
#else
    return lseek64(buf->h, to, whence);
#endif
}

GLR_API void close_file(fpinbuf *buf)
{
#ifdef _WIN32
    CloseHandle(buf->h);
#else
    close(buf->h);
#endif
}

GLR_API inbuf *h_inbuf(const char *fname, handle_t h, int handoff)
{
  fpinbuf *ret = (fpinbuf*)new_inbuf(sizeof(fpinbuf), fname, (ibf_read)read_file, (ibf_seek)seek_file, handoff ? (ibf_close)close_file : 0);
  ret->h = h;
  return (inbuf*)ret;
}

GLR_API inbuf *file_inbuf(const char *fname)
{
  fpinbuf *ret = 0;
#ifdef _WIN32
  HANDLE h = CreateFileA(fname, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if( h == INVALID_HANDLE_VALUE ) return 0;
#else
    int h = open(fname, O_RDONLY);
    if( h == -1 )
        return 0;
#endif
  return h_inbuf(fname, h, 1);
}

GLR_API int read_str(inbuf *buf, void *dst, int count) { return 0; }
GLR_API void close_str(inbuf *buf) {}

GLR_API inbuf *string_inbuf(const char *s, int staticstr)
{
  inbuf *ret = new_inbuf(sizeof(inbuf), "<string>", read_str, (ibf_seek)0, close_str);
  size_t len = 0;
  ret->strbuf = staticstr;
  if( staticstr )
      ret->eof = 1;
  if( ! staticstr )
    ret->s = nv_strdup(s, &len);
  else
  {
      ret->s = (char*)s;
      while( *s++ ) ++len;
  }
  ret->capacity = ret->count = (int)len;
  return ret;
}

GLR_API outbuf *new_ob(size_t size, obf_write writefnct, obf_flush flushfnct, obf_close closefnct)
{
    outbuf *out = (outbuf*)vp_realloc(0, size);
    vp_memzero(out, size);
    out->bufused = 0;
    out->writefnct = writefnct;
    out->flushfnct = flushfnct;
    out->closefnct = closefnct;
    out->colno = 1;
    out->lineno = 1;
    out->autoflush = 0;
    return out;
}

GLR_API void ob_write(outbuf *buf, const char *s, size_t len)
{
    int do_autoflush = 0;
    size_t a;
    for( a = 0; a < len; ++a )
    {
        if( s[a] == '\n' )
        {
            if( ! do_autoflush && buf->autoflush )
                do_autoflush = 1;
            buf->colno = 1;
            buf->lineno++;
        }
        else
            buf->colno++;
    }
    // fill the remaining buffer and write out if it is filled.
    if( buf->bufused )
    {
        a = SZ(buf->buffer)-buf->bufused;
        if( a )
        {
            if( a > len )
                a = len;
            memcpy(buf->buffer+buf->bufused, s, a);
            buf->bufused += a;
            len -= a;
            s += a;
        }
        if( buf->bufused == SZ(buf->buffer) )
        {
            buf->writefnct(buf, buf->buffer, buf->bufused);
            buf->bufused = 0;
        }
    }
    while( len >= BUF_BLOCK_SIZE )
    {
        buf->writefnct(buf, s, BUF_BLOCK_SIZE);
        len -= BUF_BLOCK_SIZE;
        s += BUF_BLOCK_SIZE;
    }
    if( len )
    {
        memcpy(buf->buffer, s, len);
        buf->bufused = len;
    }
    if( do_autoflush )
        ob_flush(buf);
}

GLR_API void ob_printf(outbuf *buf, const char *fmt, ...)
{
  va_list args;
  va_start(args,fmt);
  ob_vprintf(buf,fmt,args);
  va_end(args);
}

GLR_API void ob_vprintf(outbuf *buf, const char *fmt, va_list args)
{
  char sbuf[1024];
  size_t len = 0;
  if( ! buf )
      return;
  len = vsprintf(sbuf, fmt, args);
  if( len )
    ob_write(buf, sbuf, len);
}

GLR_API void ob_putc(outbuf *buf, int c)
{
    char ch = c;
    ob_write(buf, &ch, 1);
}

GLR_API void ob_puts(outbuf *buf, const char *s)
{
    const char *send = s;
    while( *send ) ++send;
    ob_write(buf, s, send-s);
}

GLR_API void ob_flush(outbuf *buf)
{
    if( buf->bufused )
    {
        buf->writefnct(buf, buf->buffer, buf->bufused);
        buf->bufused = 0;
    }
    if( buf->flushfnct )
        buf->flushfnct(buf);
}

GLR_API void free_ob(outbuf *buf)
{
    if( buf->bufused )
    {
        buf->writefnct(buf, buf->buffer, buf->bufused);
        buf->bufused = 0;
    }
    ob_flush(buf);
    vp_realloc(buf, 0);
}

GLR_API void file_write(file_outbuf *buf, const char *s, size_t len)
{
#ifdef _WIN32
  DWORD dwWrote = 0;
  WriteFile(buf->h, s, (DWORD)len, &dwWrote, 0);
#else
  ssize_t wrote = write(buf->h, s, len);
#endif
}

GLR_API void file_flush(file_outbuf *buf)
{
#ifdef _WIN32
    FlushFileBuffers(buf->h);
#else
    fsync(buf->h);
#endif
}

GLR_API void file_close(file_outbuf *buf)
{
#ifdef _WIN32
    CloseHandle(buf->h);
#else
    close(buf->h);
#endif
}

GLR_API outbuf *new_h_outbuf(const char *fname, handle_t h, int handoff, int autoflush)
{
    file_outbuf *out = (file_outbuf*)new_ob(sizeof(file_outbuf), (obf_write)file_write, (obf_flush)file_flush, handoff ? (obf_close)file_close : 0);
    out->h = h;
    out->base.autoflush = autoflush;
    return (outbuf*)out;
}

GLR_API outbuf *new_file_outbuf(const char *fname)
{
    file_outbuf *out = 0;
#ifdef _WIN32
    HANDLE h = CreateFileA(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    if( h == INVALID_HANDLE_VALUE )
        return 0;
    if( GetLastError() == ERROR_ALREADY_EXISTS )
    {
        SetFilePointer(h, 0, 0, FILE_BEGIN);
        SetEndOfFile(h);
    }
#else
    int h = open(fname, O_WRONLY|O_CREAT|O_TRUNC);
    if( h == -1 )
        return 0;
#endif
    return new_h_outbuf(fname, h, 1, 0);
}

GLR_API void string_write(string_outbuf *buf, const char *s, size_t len)
{
    char *dst = 0;
    if( ! len ) return;
    if( buf->count+(int)len+1 > buf->capacity )
        buf->buf = (char*)vp_realloc(buf->buf, buf->count+len+1);
    dst = buf->buf+buf->count;
    while( len-- )
        *dst++ = *s++;
    *dst = 0;
}

GLR_API void string_close(string_outbuf *buf)
{
    vp_realloc(buf->buf, 0);
}

GLR_API outbuf *new_string_outbuf()
{
    return new_ob(sizeof(string_outbuf), (obf_write)string_write, (obf_flush)0, (obf_close)string_close);
}

GLR_API void obs_clear(outbuf *buf)
{
    string_outbuf *obs = (string_outbuf*)buf;
    obs->base.bufused = 0;
    obs->count = 0;
}

GLR_API const char *obs_getstr(outbuf *buf)
{
    string_outbuf *obs = (string_outbuf*)buf;
    if( obs->base.bufused )
        ob_flush(buf);
    return obs->buf;
}

#ifdef __cplusplus
} /* extern "C" */
#endif
#ifdef __cplusplus
extern "C" {
#endif
ttype ptr_tt = {"*", sizeof(void*), 0, 0};

GLR_API int lxstack_push(lxstack *stk, int i)
{
  int newcapacity = 0;
  int *newi = 0;
  if( stk->count == stk->capacity ) {
    newcapacity = stk->capacity ? (stk->capacity * 2) : 16;
    newi = (int*)vp_realloc(stk->i, newcapacity*sizeof(int));
    if( ! newi ) return 0;
    stk->i = newi;
    stk->capacity = newcapacity;
  }
  stk->i[stk->count++] = i;
  return 1;
}
GLR_API int lxstack_pop(lxstack *stk)
{
  if( stk->count == 0 ) return -1;
  return stk->i[--stk->count];
}
GLR_API int lxstack_size(lxstack *stk) { return stk->count; }
GLR_API void lxstack_clear(lxstack *stk)
{
  if( stk->i ) { vp_realloc(stk->i, 0); stk->i = 0; }
  stk->count = 0;
  stk->capacity = 0;
}
GLR_API int lxstack_top(lxstack *stk)
{
  if( ! stk->count ) return -1;
  return stk->i[stk->count-1];
}
GLR_API toknode *new_toknode(size_t size, ttype *tt, int sym, int state)
{
  toknode *node = (toknode*)vp_realloc(0, sizeof(toknode));
  vp_memzero(node, sizeof(toknode));
  if( size ) {
    node->vp = vp_realloc(0, size);
    vp_memzero(node->vp, size);
    node->size = size;
    node->tt = tt;
    if( tt && tt->init )
        tt->init(node->vp);
  }
  node->ref = 1;
  node->sym = sym;
  node->state = state;
  return node;
}
GLR_API void toknode_addref(toknode *node) { if(node) ++node->ref; }
GLR_API void toknode_destroytt(toknode *node)
{
  if( ! node || ! node->vp )
    return;
  if( node->tt && node->tt->destroy )
    node->tt->destroy(node->vp);
  vp_realloc(node->vp, 0);
  node->size = 0;
  node->vp = 0;
  node->tt = 0;
}
GLR_API void toknode_flatten(toknode *node)
{
    size_t i = 0, j = 0, endj = 0;
    toknode *cursubnode = 0;
    if( node->wstop )
    {
        subnodes_add(node, node->wstop);
        node->wstop = 0;
    }
    if( node->wsbottom )
    {
        subnodes_add(node, node->wsbottom);
        node->wsbottom = 0;
    }
    // notice that node->sncount may grow on each iteration.
    for( i = 0; i < node->sncount; ++i )
    {
        cursubnode = node->subnodes[i];
        if( ! cursubnode || cursubnode->ref > 1 )
            continue;
        if( cursubnode->wstop )
        {
            subnodes_add(node, cursubnode->wstop);
            cursubnode->wstop = 0;
        }
        if( cursubnode->wsbottom )
        {
            subnodes_add(node, cursubnode->wsbottom);
            cursubnode->wsbottom = 0;
        }
        j = 0;
        endj = cursubnode->sncount;
        for( ; j < endj; ++j )
            subnodes_add(node, cursubnode->subnodes[j]);
        cursubnode->sncount = 0;
    }
}
GLR_API void toknode_decref(toknode *node)
{
  size_t i;
  if( ! node )
    return;
  if( --node->ref > 0 )
    return;
  toknode_destroytt(node);
  if(node->tokstr) {
    vp_realloc(node->tokstr, 0);
    node->tokstr = 0;
  }
  /*
  The original code looked like this...

  if(node->wstop) {
    toknode_decref(node->wstop);
    node->wstop = 0;
  }
  if(node->wsbottom) {
    toknode_decref(node->wsbottom);
    node->wsbottom = 0;
  }
  for( i = 0; i < node->sncount; ++i )
    toknode_decref(node->subnodes[i]);

  unfortunately, we would get stack overflow
  when the call tree was very deep.  So instead,
  we'll decref by iteration instead of recursion.
  */
  if( node->wstop || node->wsbottom || node->sncount )
  {
    toknode_flatten(node);
    for( i = 0; i < node->sncount; ++i )
        toknode_decref(node->subnodes[i]);
  }
  node->sncount = node->sncapacity = 0;
  vp_realloc(node->subnodes, 0);
  node->subnodes = 0;
  vp_realloc(node, 0);
}
GLR_API int typestack_bump_capacity(typestack *tstack) {
  size_t newcapacity = 0;
  toknode **nodes = 0;
  if( tstack->tncount == tstack->tncapacity )
  {
    newcapacity = tstack->tncapacity ? (tstack->tncapacity * 2) : 16;
    nodes = (toknode**)vp_realloc(tstack->nodes, newcapacity*sizeof(toknode*));
    if( ! nodes )
      return 0;
    tstack->nodes = nodes;
    tstack->tncapacity = newcapacity;
  }
  return 1;
}
GLR_API void *typestack_alloc(typestack *tstack, ttype *tt, int sym, int state) {
  toknode *node = 0;
  size_t size = tt ? tt->size : 0;
  if( ! typestack_bump_capacity(tstack) )
      return 0;
  node = new_toknode(size, tt, sym, state);
  tstack->nodes[tstack->tncount++] = node;
  return node->vp;
}
GLR_API size_t measure_str(toknode *node, int ws) {
  size_t i, slen = 0;
  if( ! node )
    return 0;
  if( ws && node->wstop )
    slen += measure_str(node->wstop,1);
  if( node->sncount == 0 && node->tokstr )
      slen += node->tokslen;
  else {
    for( i = 0; i < node->sncount; ++i )
      slen += measure_str(node->subnodes[i],1);
  }
  if( ws && node->wsbottom )
    slen += measure_str(node->wsbottom,1);
  return slen;
}
GLR_API char *collect_str(toknode *node, char *dst, int ws) {
  size_t i = 0, n = 0;
  if( ! node )
    return dst;
  if( ws && node->wstop )
    dst = collect_str(node->wstop, dst, 1);
  if( node->sncount == 0 && node->tokstr ) {
    for( i = 0, n = node->tokslen; i < n; ++i )
      dst[i] = node->tokstr[i];
    dst += n;
  } else {
    for( i = 0; i < node->sncount; ++i )
      dst = collect_str(node->subnodes[i], dst, 1);
  }
  if( ws && node->wsbottom )
    dst = collect_str(node->wsbottom, dst, 1);
  return dst;
}
GLR_API char *toknode_str(toknode *node) {
  if( ! node )
    return "";
  if( node->sncount == 0 && node->tokstr )
    return node->tokstr;
  node->tokslen = measure_str(node,0);
  node->tokstr = (char*)vp_realloc(node->tokstr,node->tokslen+1);
  *collect_str(node,node->tokstr,0) = 0;
  return node->tokstr;
}
GLR_API int typestack_pop(typestack *stk, size_t count)
{
  int i = 0, n = 0;
  if( count > stk->tncount )
    return 0;
  for( i = (int)stk->tncount-1, n = (int)(stk->tncount-count); i >= n; --i )
    toknode_decref(stk->nodes[i]);
  stk->tncount -= count;
  return 1;
}
GLR_API int typestack_moveone(typestack *dststk, typestack *srcstk)
{
  if( srcstk->tncount == 0 )
    return 0;
  if( ! typestack_bump_capacity(dststk) )
    return 0;
  dststk->nodes[dststk->tncount++] = srcstk->nodes[--srcstk->tncount];
  return 1;
}
GLR_API void typestack_clear(typestack *stk)
{
  typestack_pop(stk, stk->tncount);
  vp_realloc(stk->nodes, 0);
  stk->nodes = 0;
  stk->tncount = 0;
  stk->tncapacity = 0;
}
GLR_API size_t typestack_size(typestack *stk) { return stk->tncount; }
GLR_API toknode *typestack_top(typestack *stk)
{
  if( ! stk->tncount ) return 0;
  return stk->nodes[stk->tncount-1];
}
GLR_API int subnodes_bump_capacity(toknode *node) {
  size_t newcapacity = 0;
  toknode **subnodes = 0;
  if( node->sncount == node->sncapacity )
  {
    newcapacity = node->sncapacity ? (node->sncapacity * 2) : 16;
    subnodes = (toknode**)vp_realloc(node->subnodes, newcapacity*sizeof(toknode*));
    if( ! subnodes )
      return 0;
    node->subnodes = subnodes;
    node->sncapacity = newcapacity;
  }
  return 1;
}
GLR_API int subnodes_add(toknode *node, toknode *sub) {
  if( ! subnodes_bump_capacity(node) ) return 0;
  node->subnodes[node->sncount++] = sub;
  return 1;
}
GLR_API toknode *makews(toknode *wsdst, toknode *wssrc) {
    toknode *tmp = 0;
    if( ! wsdst ) return wssrc;
    if( ! wssrc ) return wsdst;
    if( wsdst->sncount ) {
      subnodes_add(wsdst, wssrc);
      return wsdst; }
    tmp = new_toknode(0,0,0,0);
    subnodes_add(tmp, wsdst);
    subnodes_add(tmp, wssrc);
    return tmp;
}
GLR_API void toknode_set_subnodes(toknode *node, toknode **nodes, int sncount) {
  int i = 0;
  node->subnodes = (toknode**)vp_realloc(node->subnodes, sizeof(toknode*)*sncount);
  node->sncount = node->sncapacity = sncount;
  for( ; i < sncount; ++i )
    node->subnodes[i] = nodes[i];
  // copy leading and trailing ws to the nonterminal
  for( i = 0; i < sncount && node->subnodes[i] == 0; ++i );
  if( i < sncount && node->subnodes[i]->wstop ) {
    node->wstop = node->subnodes[i]->wstop;
    node->subnodes[i]->wstop = 0;
  }
  for( i = sncount-1; i >= 0 && node->subnodes[i] == 0; --i );
  if( i >= 0 && node->subnodes[i]->wsbottom ) {
    node->wsbottom = node->subnodes[i]->wsbottom;
    node->subnodes[i]->wsbottom = 0;
  }
}
GLR_API void toknode_unset_subnodes(toknode *node, toknode **nodes, int sncount) {
  int i = 0;
  // copy leading and trailing ws back to the terminals
  for( i = 0; i < sncount && node->subnodes[i] == 0; ++i );
  if( i < sncount && node->subnodes[i]->wstop ) {
    node->subnodes[i]->wstop = node->wstop;
    node->wstop = 0;
  }
  for( i = sncount-1; i >= 0 && node->subnodes[i] == 0; --i );
  if( i >= 0 && node->subnodes[i]->wsbottom ) {
    node->subnodes[i]->wsbottom = node->wsbottom;
    node->wsbottom = 0;
  }
  node->sncount = node->sncapacity = 0;
  (toknode**)vp_realloc(node->subnodes, 0);
  node->subnodes = 0;
}
GLR_API void toknode_keep_subnodes(toknode *node) {
  size_t i = 0, sncount = node->sncount;
  for( ; i < sncount; ++i )
    toknode_destroytt(node->subnodes[i]);
}
GLR_API void update_buf_line_col(inbuf *buf, int len)
{
  int i;
  for( i = 0; i < len; ++i ) {
      if( buf->s[buf->pos+i] == '\n' ) { buf->line++; buf->col = 1; } else buf->col++;
  }
}
#ifdef NO_COMPRESSED_SCANNER
GLR_API int next_state(int c, int curs, int lexs, int *plastaccepttok, tsinfo *tsinfos)
{
    lxstnfo *lxinfo = lxinfo = tsinfos[lexs].lxinfos+curs;
    int low = 0, high = lxinfo->icount-1, mid = 0, nexts = -1;
    lxtr *ranges = 0;
    *plastaccepttok = -1;
    while( low <= high ) {
        mid = (low+high)/2; ranges = lxinfo->toranges + mid;
        if( c < ranges->low ) { high = mid-1; continue; }
        if( c > ranges->high ) { low = mid+1; continue; }
        nexts = ranges->next;
        if( ranges->tok != -1 ) *plastaccepttok = ranges->tok;
        break;
    }
    return nexts;
}
#else
GLR_API int next_state(int c, int curs, int lexs, int *plastaccepttok, tsinfo *tsinfos)
{
    tsinfo *tsfo = tsinfos+lexs;
    int brk = -1, high, low, mid, seek, s;
    scnitem *scnit = 0;

    low = 0; high = tsfo->brkcount-2;
    while(low<=high)
    {
        mid = (low+high)/2;
        if( c < tsfo->brks[mid] )
        {
            high = mid-1;
            continue;
        }
        if( c >= tsfo->brks[mid+1] )
        {
            low = mid+1;
            continue;
        }
        break;
    }
    brk = mid;

    high = tsfo->scncnt-1;
    seek = curs*tsfo->brkcount+brk;
    while(1)
    {
        low = 0;
        while( low <= high )
        {
            mid = (low+high)/2;
            scnit = tsfo->scnitems+mid;
            if( seek < scnit->pos )
            {
                high = mid-1;
                continue;
            }
            if( seek > scnit->pos+scnit->count )
            {
                low = mid+1;
                continue;
            }
            break;
        }
        if(low>high)
            return -1;
        if(scnit->pos+scnit->count == seek)
            break;
        high = mid-1;
        seek = scnit->off + ((seek - scnit->pos) % scnit->lead);
    }
    s = scnit->next;
    if(s < 0 || s >= tsfo->statecount)
    {
        s = -1;
        *plastaccepttok = -1;
    }
    else
        *plastaccepttok = tsfo->accepttoks[s];
    return s;
}
#endif
GLR_API int readtok(inbuf *buf, lxstack *lexstk, typestack *instk, outbuf *trace, int *isws, outbuf *oberr, int eof, tsinfo *tsinfos, symbol *allsymbols, lxact **lxactions)
{
  int pos = 0, s = 0, lexs = 0, c = 0, accepttok = -1, lastaccepttok = -1, lastacceptlen = 0, i = 0, n = 0, low = 0, high = 0, mid = 0, rd = 0, nc = 0, fr = 0, mbdec_i = 0, mbdec_n = 0;
  char **ptok = 0, *tok = 0, *tmps = 0;
  toknode *node = 0;
  lxact *tkact = 0;
  lexs = lxstack_top(lexstk);
  pos = buf->pos;
  *isws = 0;
  while( c != -1 && s != -1 ) {
    if( pos == buf->count ) {
      //read more buffer if you can
      if( ! buf->eof ) {
        if( buf->pos >= BUF_BLOCK_SIZE ) {
            //use the space in the existing buffer
            fr = (buf->pos / BUF_BLOCK_SIZE) * BUF_BLOCK_SIZE;
            buf->startpos += fr;
            for( i = 0, n = buf->capacity-fr; i < n; ++i ) buf->s[i] = buf->s[fr+i];
            buf->count -= fr;
            buf->pos -= fr;
            pos -= fr;
        }
        else {
            //make more space in the buffer
            nc = buf->capacity + BUF_BLOCK_SIZE; fr = BUF_BLOCK_SIZE;
            tmps = (char*)vp_realloc(buf->s, nc);
            if( ! tmps ) return 0;
            buf->s = tmps; buf->capacity = nc;
        }
        rd = buf->readfnct(buf, buf->s+buf->count, fr);
        if( rd < fr )
          buf->eof = 1;
        buf->count += rd;
      }
      //we are really out of buffer
      if( pos == buf->count ) {
        //we're out, but we've consumed some buffer, so it's a token, or an error.
        if( pos > buf->pos )
          break;
        //we're out, and haven't consumed any buffer, so it's EOF
        typestack_alloc(instk, 0, eof, -1);
        node = typestack_top(instk);
        node->line = buf->line;
        node->col = buf->col;
        return 1;
      }
    }
    //get the next code point
    if( ! mbdec_n )
    {
        c = ((unsigned char*)buf->s)[pos++];
        if( c > 0x7F )
        {
            // started a multi-byte fetch.
            mbdec_i = 0;
            mbdec_n = 0;
            while( c & 0x0080 )
            {
                c <<= 1;
                mbdec_n++;
            }
            c &= 0x007F;
            c >>= mbdec_n;
        }
    }
    // if we've started or are continuing a multi-byte fetch, proceed.
    while(mbdec_n && pos < buf->count)
    {
        --mbdec_n;
        rd = ((unsigned char*)buf->s)[pos++];
	    if( (rd & 0xC0000000) != 0x80000000 )
        {
            update_buf_line_col(buf, pos-buf->pos);
            ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, bad multibyte encoding byte %d\n", buf->fname, buf->line, buf->col, mbdec_i+2);
		    return 0;
        }
	    if( mbdec_i == 0 && (rd & 0x3FFFFFFF) == 0 )
        {
            update_buf_line_col(buf, pos-buf->pos);
            ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, overlong encoding\n", buf->fname, buf->line, buf->col);
		    return 0;
        }
        c = (c<<6)|(rd&0x7F);
        mbdec_i++;
    }
    if( mbdec_n )
    {
        if( ! buf->eof )
            continue;
        update_buf_line_col(buf, pos-buf->pos);
        ob_printf(oberr, "%s:%d:%d: error: tokenizer stall, eof while doing multi-byte decoding\n", buf->fname, buf->line, buf->col);
	    return 0;        
    }
    //do a binary search for the next state
    s = next_state(c, s, lexs, &accepttok, tsinfos);
    if( accepttok != -1 )
    {
        lastaccepttok = accepttok;
        lastacceptlen = pos-buf->pos;
    }
  }
  if( lastaccepttok == -1 ) {
      ob_printf(oberr, "%s:%d:%d: error: tokenizer stall\n", buf->fname, buf->line, buf->col); return 0; }
  if( trace )
    ob_printf(trace, "read token %s\n", allsymbols[lastaccepttok].name);
  ptok = (char**)typestack_alloc(instk, &ptr_tt, lastaccepttok, -1);
  node = typestack_top(instk);
  node->line = buf->line;
  node->col = buf->col;
  node->tokslen = lastacceptlen;
  node->tokstr = tok = *ptok = (char*)vp_realloc(0, lastacceptlen+1);
  for( i = 0; i < lastacceptlen; ++i ) tok[i] = buf->s[buf->pos+i];
  tok[lastacceptlen] = 0;
  update_buf_line_col(buf, lastacceptlen);
  buf->pos += lastacceptlen;
  tkact = lxactions[lexs];
  while( tkact->sym != -1 && tkact->sym != lastaccepttok )
    ++tkact;
  switch(tkact->flags){
    case PUSH_FLAG: lxstack_push(lexstk, tkact->next); break;
    case POP_FLAG:
      lxstack_pop(lexstk);
      if( lexstk->count == 0 ) {
        ob_printf(oberr, "empty lexer state stack\n"); return 0; }
      break;
    case GOTO_FLAG: lexstk->i[lexstk->count-1] = tkact->next; break;
    case WS_FLAG:
      *isws = 1;
      break;
    default: break;
  }
  return 1;
}

#ifdef NO_COMPRESSED_LR_TABLE
#define ACTION_SYMBOL(a,s) ((a)->shiftto_or_reduceby)
#else
#define FIRST_SYMBOL(a) ((a)->range[1])
#define LAST_SYMBOL(a) ((a)->range[(a)->range[0]*2])
#define ACTION_SYMBOL(a,s) (((a)->first)+(((a)->first==(a)->last)?0:((s)-FIRST_SYMBOL(a))))
#endif

GLR_API int update_parse_state(typestack *prsstk, typestack *instk, toknode **nodes, inbuf *buf, outbuf *trace, line_col *err_lc,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int acceptstate,
                                outbuf *oberr,
                                reduce_action_fnct ra,
                                void *pextra
                                )
{
  int state = -1, tok = -1, low = 0, high = 0, mid = 0, gotlc = 0, stkpos = -1;
  parse_state *ps = 0;
#ifdef NO_COMPRESSED_LR_TABLE
  parse_action *action = 0;
#else
  parse_action_range *action = 0;
#endif
  production *p = 0, *pO = 0; ttype *tt = 0;
#ifndef NO_COMPRESSED_LR_TABLE
  int *srange = 0;
#endif
  int *skips = 0, *endskips = 0;
  toknode **curnode = 0, **dstnode = 0, *ntnode = 0, *errnode = 0;
  
  while( typestack_size(instk) ) {
    tok = typestack_top(instk)->sym;
    state = typestack_top(prsstk)->state;
    if( state < 0 ) break;
    ps = parse_states+state;
    low = 0; high = ps->acount-1;
    while( low <= high ) {
      mid = (low+high)/2;
      action = ps->actions+mid;
#ifdef NO_COMPRESSED_LR_TABLE
      if( tok < action->token ) { high = mid-1; continue; }
      if( tok > action->token ) { low = mid+1; continue; }
#else
      if( tok < FIRST_SYMBOL(action) ) { high = mid-1; continue; }
      if( tok > LAST_SYMBOL(action) ) { low = mid+1; continue; }
#endif
      break;
    }
#ifdef NO_COMPRESSED_LR_TABLE
    if(tok != action->token) {
#else
    if( low <= high ) {
        // we found a candidate action range, now see if it pans out.
        low = 0; high = action->range[0]-1;
        while( low <= high ) {
          mid = (low+high)/2;
          srange = action->range+1+mid*2;
          if( tok < srange[0] ) { high = mid-1; continue; }
          if( tok > srange[1] ) { low = mid+1; continue; }
          break;
        }
    }
    if( low > high ) {
#endif
      // An error!
      if( typestack_top(prsstk)->sym == errtok )
      {
          if(trace)
            ob_printf(trace, "handling parse error: discarding token\n", tok);
          typestack_pop(instk, 1);
          continue;
      }
      // Search for an error handling production
      for(stkpos=(int)typestack_size(prsstk)-1;stkpos>=0;--stkpos)
      {
          tok = prsstk->nodes[stkpos]->sym;
          state = prsstk->nodes[stkpos]->state;
          if(state<0) { stkpos=-1; break; }
          ps = parse_states+state;
          if(!ps->acount) continue;
          mid = 0;
#if NO_COMPRESSED_LR_TABLE
          while(ps->actions[mid].token<errtok) ++mid;
          if( ps->actions[mid].token == errtok && ps->actions[mid].action == SH )
#else
          while( LAST_SYMBOL(ps->actions+mid) < errtok) ++mid;
          if( errtok >= FIRST_SYMBOL(ps->actions+mid) && errtok <= LAST_SYMBOL(ps->actions+mid) && ps->actions[mid].action == SH )
#endif
            break; // found it, stkpos != -1
      }
      if(stkpos==-1)
      {
        // No production we are building handles errors, stop parsing.
        ntnode = typestack_top(instk);
        ob_printf(oberr, "%s:%d:%d: error: parse error\n", buf->fname, ntnode->line, ntnode->col);
        if( err_lc ) {
          err_lc->line = ntnode->line;
          err_lc->col = ntnode->col;
        }
        return 0;
      }
      // This production handles errors, shift the error and carry on.
      action = ps->actions+mid;
      typestack_pop(prsstk, stkpos-typestack_size(prsstk)-1);
      if(trace)
        ob_printf(trace, "parse error: shift to %d\n", ACTION_SYMBOL(action,errtok));
      typestack_alloc(prsstk, 0, errtok, ACTION_SYMBOL(action,errtok));
      errnode = typestack_top(prsstk);
      ntnode = typestack_top(instk);
      errnode->line = ntnode->line;
      errnode->col = ntnode->col;
      continue;
    }
    if( action->action == SH ) {
      if( trace )
        ob_printf(trace, "shift to %d\n", ACTION_SYMBOL(action,tok));
      if( ! typestack_moveone(prsstk, instk) )
        return 0;
      typestack_top(prsstk)->state = ACTION_SYMBOL(action,tok);
      continue;
    }
    for( low = 0, high = ps->acount; low <= high; ++low ) {
      p = productions+ACTION_SYMBOL(action,tok);
      pO = productions+(p->origid-production_adjust_count);
      skips = p->skips; endskips = skips+p->skcount;
      tt = allsymbols[p->nt].tt;
      typestack_alloc(instk, tt, pO->id, -1);
      ntnode = typestack_top(instk);
      dstnode = nodes;
      gotlc = 0;
      *dstnode++ = ntnode;
      curnode = prsstk->nodes+(prsstk->tncount-p->scount);
      for( low = 0, high = pO->scount; low < high; ++low )
        if( skips < endskips && low == *skips )
            *dstnode++ = 0, ++skips;
        else {
            if( ! gotlc ) {
              ntnode->line = (*curnode)->line; ntnode->col = (*curnode)->col; gotlc = 1; }
            *dstnode++ = *curnode++;
        }
      if( ! gotlc ) { ntnode->line = buf->line; ntnode->col = buf->col; }
      toknode_set_subnodes(ntnode, nodes+1, pO->scount);
      if( trace )
        ob_printf(trace, "reduce %d by production %d", p->scount, p->id-production_adjust_count);
      if( ra(nodes, p->origid, buf->fname, ntnode->line, ntnode->col, oberr, pextra) ) {
        if( trace )
          ob_printf(trace, " (ok)\n");
        toknode_keep_subnodes(ntnode);
        prsstk->tncount -= p->scount;
        if( p->nt == starttok ) {
          if( ! typestack_moveone(prsstk, instk) )
            return 0;
          typestack_top(prsstk)->state = acceptstate;
          return 1;
        }
        break;
      }
      if( trace )
        ob_printf(trace, " (failed)\n");
      toknode_unset_subnodes(ntnode, nodes+1, pO->scount);
      typestack_pop(instk, 1);
      ++action;
    }
    if( low > high )
      return 0;
  }
  return 1;
}

GLR_API int parse_any(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc,
                                tsinfo *tsinfos,
                                lxact **lxactions,
                                parse_state *parse_states,
                                production *productions,
                                int production_adjust_count,
                                int max_production_symbols,
                                symbol *allsymbols,
                                int starttok,
                                int errtok,
                                int eoftok,
                                int acceptstate,
                                int parser_start_state,
                                int initial_tokenset,
                                reduce_action_fnct ra,
                                void *pextra)
{
  size_t i, n;
  lxstack lexstk = NULL_LXSTACK;
  typestack instk = NULL_TYPESTACK;
  typestack prsstk = NULL_TYPESTACK;
  int ret = 1, isws = 0;
  toknode **nodes = (toknode**)vp_realloc(0, (max_production_symbols+1)*sizeof(toknode*));
  if( err_lc ) { err_lc->line = 0; err_lc->col = 0; }
  lxstack_push(&lexstk, initial_tokenset);
  typestack_alloc(&prsstk, &ptr_tt, 0, parser_start_state);
  do {
    if( ! readtok(buf, &lexstk, &instk, trace, &isws, obuf, eoftok, tsinfos, allsymbols, lxactions) ) {
      if( err_lc ) {
        err_lc->line = buf->line;
        err_lc->col = buf->col;
      }
      ret = 0; goto cleanup; }
    if( isws ) {
      //append whitespace to the end of the last token
      prsstk.nodes[prsstk.tncount-1]->wsbottom = makews(prsstk.nodes[prsstk.tncount-1]->wsbottom, instk.nodes[--instk.tncount]);
      continue; }
    //move accumulated whitespace from the end of the last token to the beginning of the next one
    if( prsstk.nodes[prsstk.tncount-1]->wsbottom ) {
      instk.nodes[instk.tncount-1]->wstop = makews(instk.nodes[instk.tncount-1]->wstop, prsstk.nodes[prsstk.tncount-1]->wsbottom);
      prsstk.nodes[prsstk.tncount-1]->wsbottom = 0;
    }
    if( ! update_parse_state(&prsstk, &instk, nodes, buf, trace,
                                        err_lc, parse_states, productions, production_adjust_count,
                                        allsymbols, starttok, errtok, acceptstate, obuf,
                                        ra, pextra) ) {
        ret = 0; goto cleanup; }
    if( trace ) {
      ob_printf(obuf, "state stack:");
      for( i = 0, n = prsstk.tncount; i < n; ++i )
        ob_printf(obuf, " %d", prsstk.nodes[i]->state);
      ob_printf(obuf, "\n");
    }
  } while( typestack_top(&prsstk)->state != acceptstate );
cleanup:
  vp_realloc(nodes, 0);
  typestack_clear(&prsstk); typestack_clear(&instk); lxstack_clear(&lexstk);
  return ret;
}

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif
#define INITIAL_TOKENSET (0)
#define RULES_TOKENSET (1)
#define OPTION_TOKENSET (2)
#define FINAL_TOKENSET (3)
#define RAWCODE_TOKENSET (4)
#define REGEX_TOKENSET (5)
#define SQUOTED_TOKENSET (6)
#define DQUOTED_TOKENSET (7)
#define CHARELEMENT_TOKENSET (8)
#define REPEAT_TOKENSET (9)
#define SYMID_LTSTARTGT (0)
#define SYMID_DOL (1)
#define SYMID_LTEGT (2)
#define SYMID_LTERRORGT (3)
#define SYMID_RXSEPLINE_RX (4)
#define SYMID_RXRAWLINE_NOOP_RX (5)
#define SYMID_LITPCTOPTION (6)
#define SYMID_RXANY_RX (7)
#define SYMID_RXFSLLBR0x0BSLTBSLRRBRPFSL (8)
#define SYMID_RXOPTION_LABEL_RX (9)
#define SYMID_LITCOM (10)
#define SYMID_RXOPTION_OP_RX (11)
#define SYMID_LIT0xK (12)
#define SYMID_RXWS_RX (13)
#define SYMID_RXCOMMENT_RX (14)
#define SYMID_LITLCBPCT (15)
#define SYMID_LITFSL (16)
#define SYMID_LITIFSL (17)
#define SYMID_LITSQT (18)
#define SYMID_LITISQT (19)
#define SYMID_LITDQT (20)
#define SYMID_LITIDQT (21)
#define SYMID_LITLPR (22)
#define SYMID_LITRPR (23)
#define SYMID_LITLTSTARTGT (24)
#define SYMID_LITLTERRORGT (25)
#define SYMID_RXID_RX (26)
#define SYMID_LITM (27)
#define SYMID_RXNATURAL_RX (28)
#define SYMID_RXWHOLE_RX (29)
#define SYMID_LITMGT (30)
#define SYMID_LITLTM (31)
#define SYMID_LITMFSLM (32)
#define SYMID_LITSCOL (33)
#define SYMID_LITCOL (34)
#define SYMID_LITEQ (35)
#define SYMID_LITGT (36)
#define SYMID_LITLT (37)
#define SYMID_LITPRD (38)
#define SYMID_LITAT (39)
#define SYMID_LITP (40)
#define SYMID_LITVSEP (41)
#define SYMID_LITCOLCOL (42)
#define SYMID_RXREF_RX (43)
#define SYMID_LITPCTAS (44)
#define SYMID_LITPCTPUSH (45)
#define SYMID_LITPCTPOP (46)
#define SYMID_LITPCTGOTO (47)
#define SYMID_LITPCTIGNORE (48)
#define SYMID_LITPCTRANK (49)
#define SYMID_LITPCTREJECT (50)
#define SYMID_LITPCTLABEL (51)
#define SYMID_LITPCTACTION (52)
#define SYMID_LITPCTRESOLVABLE_CONFLICT (53)
#define SYMID_LITPCTGLOBAL (54)
#define SYMID_LITPCTPRIORITIES (55)
#define SYMID_LITPCTASSOC (56)
#define SYMID_LITPCTORDEREDMTOKENS (57)
#define SYMID_LITPCTLEFT (58)
#define SYMID_LITPCTRIGHT (59)
#define SYMID_RXNONASSOC (60)
#define SYMID_LITPCTFORBID (61)
#define SYMID_LITPCTALLOW (62)
#define SYMID_LITPCTTYPE (63)
#define SYMID_LITPCTFROM (64)
#define SYMID_LITPCTSHORT (65)
#define SYMID_LITPCTLONG (66)
#define SYMID_RXTOKFRAG (67)
#define SYMID_LITLBR (68)
#define SYMID_LITRBR (69)
#define SYMID_RXGARBAGE_DECL_RX (70)
#define SYMID_LITPCTRCB (71)
#define SYMID_RXRAWCODE_BLKCOMMENT_RX (72)
#define SYMID_RXRAWCODE_LINECOMMENT_RX (73)
#define SYMID_RXRAWCODE_DQUOTESTR_RX (74)
#define SYMID_RXRAWCODE_SQUOTESTR_RX (75)
#define SYMID_RXRAWCODE_OTHERJUNK_RX (76)
#define SYMID_LITBSLA (77)
#define SYMID_LITBSLB (78)
#define SYMID_LITBSLT (79)
#define SYMID_LITBSLN (80)
#define SYMID_LITBSLV (81)
#define SYMID_LITBSLF (82)
#define SYMID_LITBSLR (83)
#define SYMID_RXOCTESC_RX (84)
#define SYMID_RXHEXESC_RX (85)
#define SYMID_RXUESC_RX (86)
#define SYMID_RXESCANY_RX (87)
#define SYMID_LITST (88)
#define SYMID_LITQ (89)
#define SYMID_LITLBRCRT (90)
#define SYMID_LITLCB (91)
#define SYMID_RXTOKFRAG_ID_RX (92)
#define SYMID_LITRCB (93)
#define SYMID_RXNAMEDCHARSET_RX (94)
#define SYMID_RXRAWLINE_RX (95)
#define SYMID_ID (96)
#define SYMID_CHARS (97)
#define SYMID_PROPS (98)
#define SYMID_PROP (99)
#define SYMID_SYMBOLS (100)
#define SYMID_SYMBOL_BLK (101)
#define SYMID_NTS (102)
#define SYMID_NT (103)
#define SYMID_SYMBOL (104)
#define SYMID_LITERAL (105)
#define SYMID_ILITERAL (106)
#define SYMID_REGEX (107)
#define SYMID_ORDERED_TOKEN_SYMBOL (108)
#define SYMID_TOKFRAG_SYMBOL (109)
#define SYMID_RX (110)
#define SYMID_LABELEXPR (111)
#define SYMID_LABEL (112)
#define SYMID_ASSOC_OP (113)
#define SYMID_TOKENSET (114)
#define SYMID_ORDERED_TOKEN_ITEMS (115)
#define SYMID_ORDERED_TOKEN_ITEM (116)
#define SYMID_TOKACTION (117)
#define SYMID_INTEGER (118)
#define SYMID_NATURAL (119)
#define SYMID_WHOLE (120)
#define SYMID_INTEGER_RANGE (121)
#define SYMID_INTEGER_RANGES (122)
#define SYMID_CHAR (123)
#define SYMID_CHARSET (124)
#define SYMID_CHARELEMENTS (125)
#define SYMID_CHARELEMENT (126)
#define SYMID_RAWCODE (127)
#define SYMID_DOTTED_BOXED_PRODUCTION (128)
#define SYMID_BOXED_PRODUCTION (129)
#define SYMID_FROM_SERIES (130)
#define SYMID_PRODUCTION_PARTS (131)
#define SYMID_PRODUCTION_PART (132)
#define SYMID_SL_DECL (133)
#define SYMID_GGDOC (134)
#define SYMID_RAWOPLINES (135)
#define SYMID_SEPLINE (136)
#define SYMID_RULES (137)
#define SYMID_RAWLINES (138)
#define SYMID_RAWLINEITEM (139)
#define SYMID_OPTIONLINE (140)
#define SYMID_OPTIONLIST (141)
#define SYMID_OPTIONITEM (142)
#define SYMID_RULE (143)
#define SYMID_CTYPE (144)
#define SYMID_CTYPE_LIST (145)
#define SYMID_RAWCODE_FRAGS (146)
#define SYMID_RAWCODE_FRAG (147)
#define PRID_LTSTARTGT_GGDOC (148)
#define PRID_GGDOC_RAWOPLINES_SEPLINE_RULES_SEPLINE_RAWLINES (149)
#define PRID_RAWOPLINES_RAWOPLINES_RAWLINEITEM (155)
#define PRID_RAWOPLINES_RAWLINEITEM (156)
#define PRID_RAWLINEITEM_RXRAWLINE_NOOP_RX (157)
#define PRID_RAWLINEITEM_OPTIONLINE (158)
#define PRID_OPTIONLINE_LITPCTOPTION_OPTIONLIST_LIT0xK (159)
#define PRID_OPTIONLIST_OPTIONLIST_LITCOM_OPTIONITEM (161)
#define PRID_OPTIONLIST_OPTIONITEM (162)
#define PRID_OPTIONITEM_RXOPTION_LABEL_RX_RXOPTION_OP_RX_RXOPTION_LABEL_RX (163)
#define PRID_SEPLINE_RXSEPLINE_RX (165)
#define PRID_RULES_RULES_RULE (166)
#define PRID_RULES_RULE (167)
#define PRID_RAWLINES_RAWLINES_RXRAWLINE_RX (168)
#define PRID_RAWLINES_RXRAWLINE_RX (169)
#define PRID_ID_RXID_RX (170)
#define PRID_CTYPE_RXID_RX (171)
#define PRID_CTYPE_LITCOLCOL_RXID_RX (172)
#define PRID_CTYPE_CTYPE_RXREF_RX (173)
#define PRID_CTYPE_CTYPE_LITCOLCOL_RXID_RX (174)
#define PRID_CTYPE_CTYPE_LITLT_CTYPE_LIST_LITGT (175)
#define PRID_CTYPE_LIST_CTYPE_LIST_LITCOM_CTYPE (176)
#define PRID_CTYPE_LIST_CTYPE (177)
#define PRID_DOTTED_BOXED_PRODUCTION_LITLBR_NT_LITCOL_SYMBOLS_LITRBR (178)
#define PRID_RULE_NT_LITCOL_PRODUCTION_PARTS_LITSCOL (180)
#define PRID_PRODUCTION_PARTS_PRODUCTION_PARTS_LITVSEP_PRODUCTION_PART (181)
#define PRID_PRODUCTION_PARTS_PRODUCTION_PART (182)
#define PRID_BOXED_PRODUCTION_LITLBR_NT_LITCOL_SYMBOLS_LITRBR (183)
#define PRID_PRODUCTION_PART_SYMBOLS_LITP_PROPS (185)
#define PRID_RULE_LITPCTTYPE_CTYPE_LITLTM_NTS_LITSCOL (189)
#define PRID_RULE_LTERRORGT (194)
#define PRID_RULE_LTERRORGT_LITSCOL (195)
#define PRID_RULE_LITPCTGLOBAL_CTYPE_LITSCOL (196)
#define PRID_RULE_LITPCTPRIORITIES_LABELEXPR_LITSCOL (197)
#define PRID_RULE_LITPCTASSOC_LABEL_ASSOC_OP_LABEL_LITSCOL (198)
#define PRID_RULE_LITPCTFORBID_BOXED_PRODUCTION_LITAT_DOTTED_BOXED_PRODUCTION_FROM_SERIES_LITSCOL (199)
#define PRID_RULE_LITPCTFORBID_BOXED_PRODUCTION_LITAT_LITPCTLABEL_LITEQ_LABEL_ASSOC_OP_FROM_SERIES_LITSCOL (201)
#define PRID_RULE_LITPCTFORBID_LITPCTLABEL_LITEQ_LABEL_LITAT_DOTTED_BOXED_PRODUCTION_FROM_SERIES_LITSCOL (205)
#define PRID_RULE_LITPCTFORBID_LITAT_DOTTED_BOXED_PRODUCTION_FROM_SERIES_LITSCOL (209)
#define PRID_RULE_LITPCTALLOW_LITPCTLABEL_LITEQ_LABEL_LITAT_DOTTED_BOXED_PRODUCTION_FROM_SERIES_LITSCOL (211)
#define PRID_RULE_LITPCTALLOW_BOXED_PRODUCTION_LITAT_DOTTED_BOXED_PRODUCTION_FROM_SERIES_LITSCOL (215)
#define PRID_RULE_LITPCTALLOW_LITAT_DOTTED_BOXED_PRODUCTION_FROM_SERIES_LITSCOL (217)
#define PRID_FROM_SERIES_FROM_SERIES_LITPCTFROM_DOTTED_BOXED_PRODUCTION (219)
#define PRID_FROM_SERIES_LITPCTFROM_DOTTED_BOXED_PRODUCTION (220)
#define PRID_RULE_RXTOKFRAG_RXID_RX_LITEQ_TOKFRAG_SYMBOL_LITSCOL (221)
#define PRID_TOKFRAG_SYMBOL_REGEX (223)
#define PRID_TOKFRAG_SYMBOL_LITERAL (224)
#define PRID_TOKFRAG_SYMBOL_ILITERAL (225)
#define PRID_RULE_LITPCTORDEREDMTOKENS_TOKENSET_LITEQ_LITLPR_ORDERED_TOKEN_ITEMS_LITRPR_LITSCOL (226)
#define PRID_RULE_LITPCTORDEREDMTOKENS_TOKENSET_LITEQ_LITLPR_ORDERED_TOKEN_ITEMS_LITRPR_LTERRORGT (228)
#define PRID_RULE_LITPCTORDEREDMTOKENS_TOKENSET_LITEQ_LITLPR_LTERRORGT (230)
#define PRID_SYMBOLS_SYMBOLS_SL_DECL_SYMBOL (232)
#define PRID_SYMBOLS_SYMBOLS_SYMBOL_BLK (234)
#define PRID_SYMBOLS_SL_DECL_SYMBOL (235)
#define PRID_SYMBOLS_SYMBOL_BLK (237)
#define PRID_SL_DECL_LITPCTSHORT (238)
#define PRID_SL_DECL_LITPCTLONG (239)
#define PRID_SYMBOL_BLK_LITLBR_SYMBOLS_LITRBR (240)
#define PRID_SYMBOL_BLK_LITLBR_LTERRORGT (241)
#define PRID_SYMBOL_NT (242)
#define PRID_SYMBOL_LITERAL (243)
#define PRID_SYMBOL_ILITERAL (244)
#define PRID_SYMBOL_REGEX (245)
#define PRID_SYMBOL_LITPRD (246)
#define PRID_ORDERED_TOKEN_ITEMS_ORDERED_TOKEN_ITEMS_LITCOM_ORDERED_TOKEN_ITEM (247)
#define PRID_ORDERED_TOKEN_ITEMS_ORDERED_TOKEN_ITEM (248)
#define PRID_ORDERED_TOKEN_ITEM_ORDERED_TOKEN_SYMBOL_LITPCTAS_RXID_RX_LITCOL_TOKACTION (249)
#define PRID_ORDERED_TOKEN_SYMBOL_LITERAL (255)
#define PRID_ORDERED_TOKEN_SYMBOL_ILITERAL (256)
#define PRID_ORDERED_TOKEN_SYMBOL_REGEX (257)
#define PRID_ORDERED_TOKEN_SYMBOL_NT (258)
#define PRID_TOKACTION_LITPCTPUSH_TOKENSET (259)
#define PRID_TOKACTION_LITPCTPOP (260)
#define PRID_TOKACTION_LITPCTIGNORE (261)
#define PRID_TOKACTION_LITPCTGOTO_TOKENSET (262)
#define PRID_TOKENSET_ID (263)
#define PRID_NTS_NTS_NT (264)
#define PRID_NTS_NT (265)
#define PRID_NT_ID (266)
#define PRID_NT_LITLTSTARTGT (267)
#define PRID_NT_LITLTERRORGT (268)
#define PRID_PROPS_PROPS_LITP_PROP (269)
#define PRID_PROPS_PROP (271)
#define PRID_PROP_LITPCTREJECT (272)
#define PRID_PROP_LITPCTRANK_LITEQ_NATURAL (273)
#define PRID_PROP_ASSOC_OP (275)
#define PRID_PROP_LITPCTLABEL_LITEQ_LABEL (276)
#define PRID_PROP_LITPCTACTION_LITEQ_RAWCODE (278)
#define PRID_PROP_LITPCTRESOLVABLE_CONFLICT (280)
#define PRID_LITERAL_LITSQT_CHARS_LITSQT (281)
#define PRID_LITERAL_LITDQT_CHARS_LITDQT (283)
#define PRID_ILITERAL_LITISQT_CHARS_LITSQT (285)
#define PRID_ILITERAL_LITIDQT_CHARS_LITDQT (287)
#define PRID_CHARS_CHARS_CHAR (289)
#define PRID_CHARS_CHAR (290)
#define PRID_CHAR_LITBSLA (291)
#define PRID_CHAR_LITBSLB (292)
#define PRID_CHAR_LITBSLT (293)
#define PRID_CHAR_LITBSLN (294)
#define PRID_CHAR_LITBSLV (295)
#define PRID_CHAR_LITBSLF (296)
#define PRID_CHAR_LITBSLR (297)
#define PRID_CHAR_RXOCTESC_RX (298)
#define PRID_CHAR_RXHEXESC_RX (299)
#define PRID_CHAR_RXUESC_RX (300)
#define PRID_CHAR_RXESCANY_RX (301)
#define PRID_CHAR_RXANY_RX (302)
#define PRID_REGEX_LITFSL_RX_LITFSL (303)
#define PRID_REGEX_LITFSL_LTERRORGT (304)
#define PRID_REGEX_LITIFSL_RX_LITFSL (305)
#define PRID_REGEX_LITIFSL_LTERRORGT (306)
#define PRID_RX_LITLPR_RX_LITRPR (307)
#define PRID_RX_LITLPR_LTERRORGT (308)
#define PRID_RX_RX_RX (309)
#define PRID_RX_RX_LITVSEP_RX (310)
#define PRID_RX_RX_LITST (311)
#define PRID_RX_RX_LITP (312)
#define PRID_RX_RX_LITQ (313)
#define PRID_RX_RX_LITLCB_NATURAL_LITRCB (314)
#define PRID_RX_RX_LITLCB_NATURAL_LITCOM_LITRCB (315)
#define PRID_RX_RX_LITLCB_LITCOM_NATURAL_LITRCB (316)
#define PRID_RX_RX_LITLCB_NATURAL_LITCOM_NATURAL_LITRCB (317)
#define PRID_RX_RX_LITLCB_LTERRORGT (318)
#define PRID_RX_RXTOKFRAG_ID_RX (319)
#define PRID_RX_LITPRD (320)
#define PRID_RX_CHAR (321)
#define PRID_RX_CHARSET (322)
#define PRID_CHARSET_LITLBR_CHARELEMENTS_LITRBR (323)
#define PRID_CHARSET_LITLBR_LTERRORGT (324)
#define PRID_CHARSET_LITLBRCRT_CHARELEMENTS_LITRBR (325)
#define PRID_CHARSET_LITLBRCRT_LTERRORGT (326)
#define PRID_CHARELEMENTS_CHARELEMENTS_CHARELEMENT (327)
#define PRID_CHARELEMENTS_CHARELEMENT (328)
#define PRID_CHARELEMENT_CHAR (329)
#define PRID_CHARELEMENT_CHAR_LITM_CHAR (330)
#define PRID_CHARELEMENT_RXNAMEDCHARSET_RX (331)
#define PRID_LABELEXPR_LABELEXPR_LITEQ_LABELEXPR (332)
#define PRID_LABELEXPR_ASSOC_OP_LABELEXPR (333)
#define PRID_LABELEXPR_LABELEXPR_LITGT_LABELEXPR (334)
#define PRID_LABELEXPR_LABEL (335)
#define PRID_LABEL_ID (336)
#define PRID_ASSOC_OP_LITPCTLEFT (337)
#define PRID_ASSOC_OP_LITPCTRIGHT (338)
#define PRID_ASSOC_OP_RXNONASSOC (339)
#define PRID_ASSOC_OP_LITPCTFORBID_LITLPR_INTEGER_RANGES_LITRPR (340)
#define PRID_INTEGER_RANGES_INTEGER_RANGES_LITCOM_INTEGER_RANGE (341)
#define PRID_INTEGER_RANGE_INTEGER_LITMGT_INTEGER (343)
#define PRID_INTEGER_NATURAL (344)
#define PRID_INTEGER_WHOLE (345)
#define PRID_INTEGER_LITM_NATURAL (346)
#define PRID_INTEGER_LITM_WHOLE (347)
#define PRID_NATURAL_RXNATURAL_RX (348)
#define PRID_WHOLE_RXWHOLE_RX (349)
#define PRID_RAWCODE_LITLCBPCT_RAWCODE_FRAGS_LITPCTRCB (350)
#define PRID_RAWCODE_FRAGS_RAWCODE_FRAGS_RAWCODE_FRAG (352)
#define PRID_RAWCODE_FRAGS_RAWCODE_FRAG (353)
#define PRID_RAWCODE_FRAG_RXRAWCODE_BLKCOMMENT_RX (354)
#define PRID_RAWCODE_FRAG_RXRAWCODE_LINECOMMENT_RX (355)
#define PRID_RAWCODE_FRAG_RXRAWCODE_DQUOTESTR_RX (356)
#define PRID_RAWCODE_FRAG_RXRAWCODE_SQUOTESTR_RX (357)
#define PRID_RAWCODE_FRAG_RXRAWCODE_OTHERJUNK_RX (358)
#define STARTTOK (0)
#define EOFTOK   (1)
#define ERRTOK   (3)
#define ACCEPTSTATE (373)

static ttype String_tt = {"String",sizeof(String),INIT_T(String),DESTRUCT_T(String)};
static ttype AllProperties_tt = {"AllProperties",sizeof(AllProperties),INIT_T(AllProperties),DESTRUCT_T(AllProperties)};
static ttype Symbols_tt = {"Symbols",sizeof(Symbols),INIT_T(Symbols),DESTRUCT_T(Symbols)};
static ttype vector_ltSymbol_ptr_gt_tt = {"vector<Symbol*>",sizeof(vector<Symbol*>),INIT_T(vector<Symbol*>),DESTRUCT_T(vector<Symbol*>)};
static ttype Symbol_ptr_tt = {"Symbol*",sizeof(Symbol*),INIT_T(Symbol*),DESTRUCT_T(Symbol*)};
static ttype Rx_ptr_tt = {"Rx*",sizeof(Rx*),INIT_T(Rx*),DESTRUCT_T(Rx*)};
static ttype PrioritySet_tt = {"PrioritySet",sizeof(PrioritySet),INIT_T(PrioritySet),DESTRUCT_T(PrioritySet)};
static ttype ProductionLabel_ptr_tt = {"ProductionLabel*",sizeof(ProductionLabel*),INIT_T(ProductionLabel*),DESTRUCT_T(ProductionLabel*)};
static ttype PriorityGroup_tt = {"PriorityGroup",sizeof(PriorityGroup),INIT_T(PriorityGroup),DESTRUCT_T(PriorityGroup)};
static ttype OrderedTokenSet_ptr_tt = {"OrderedTokenSet*",sizeof(OrderedTokenSet*),INIT_T(OrderedTokenSet*),DESTRUCT_T(OrderedTokenSet*)};
static ttype vector_ltTokenSetAction_gt_ptr_tt = {"vector<TokenSetAction>*",sizeof(vector<TokenSetAction>*),INIT_T(vector<TokenSetAction>*),DESTRUCT_T(vector<TokenSetAction>*)};
static ttype TokenSetAction_tt = {"TokenSetAction",sizeof(TokenSetAction),INIT_T(TokenSetAction),DESTRUCT_T(TokenSetAction)};
static ttype int_tt = {"int",sizeof(int),INIT_T(int),DESTRUCT_T(int)};
static ttype IntSetRange_tt = {"IntSetRange",sizeof(IntSetRange),INIT_T(IntSetRange),DESTRUCT_T(IntSetRange)};
static ttype vector_ltIntSetRange_gt_tt = {"vector<IntSetRange>",sizeof(vector<IntSetRange>),INIT_T(vector<IntSetRange>),DESTRUCT_T(vector<IntSetRange>)};
static ttype uint32_t_tt = {"uint32_t",sizeof(uint32_t),INIT_T(uint32_t),DESTRUCT_T(uint32_t)};
static ttype UIntSet_tt = {"UIntSet",sizeof(UIntSet),INIT_T(UIntSet),DESTRUCT_T(UIntSet)};
static ttype CodeSnip_tt = {"CodeSnip",sizeof(CodeSnip),INIT_T(CodeSnip),DESTRUCT_T(CodeSnip)};
static ttype LRItem_tt = {"LRItem",sizeof(LRItem),INIT_T(LRItem),DESTRUCT_T(LRItem)};
static ttype Production_ptr_tt = {"Production*",sizeof(Production*),INIT_T(Production*),DESTRUCT_T(Production*)};
static ttype vector_ltLRItem_gt_tt = {"vector<LRItem>",sizeof(vector<LRItem>),INIT_T(vector<LRItem>),DESTRUCT_T(vector<LRItem>)};
static ttype vector_ltProductionPart_gt_tt = {"vector<ProductionPart>",sizeof(vector<ProductionPart>),INIT_T(vector<ProductionPart>),DESTRUCT_T(vector<ProductionPart>)};
static ttype ProductionPart_tt = {"ProductionPart",sizeof(ProductionPart),INIT_T(ProductionPart),DESTRUCT_T(ProductionPart)};
static ttype sl_decl_tt = {"sl_decl",sizeof(sl_decl),INIT_T(sl_decl),DESTRUCT_T(sl_decl)};

static symbol allsymbols[] = {
{"<Start>",0},{"$",0},{"<E>",0},{"<error>",0},{"sepline_rx",0},{"rawline_noop_rx",0},
{"%option",0},{"any_rx",0},{"/[ \\t\\r]+/",0},{"option_label_rx",0},{",",0},{"option_op_rx",0},
{"\\n",0},{"ws_rx",0},{"comment_rx",0},{"{%",0},{"/",0},{"i/",0},{"'",0},{"i'",0},
{"\"",0},{"i\"",0},{"(",0},{")",0},{"<start>",0},{"<error>",0},{"id_rx",0},{"-",0},
{"natural_rx",0},{"whole_rx",0},{"->",0},{"<-",0},{"-/-",0},{";",0},{":",0},{"=",0},
{">",0},{"<",0},{".",0},{"@",0},{"+",0},{"|",0},{"::",0},{"ref_rx",0},{"%as",0},
{"%push",0},{"%pop",0},{"%goto",0},{"%ignore",0},{"%rank",0},{"%reject",0},{"%label",0},
{"%action",0},{"%resolvable_conflict",0},{"%global",0},{"%priorities",0},{"%assoc",0},
{"%ordered-tokens",0},{"%left",0},{"%right",0},{"nonassoc",0},{"%forbid",0},{"%allow",0},
{"%type",0},{"%from",0},{"%short",0},{"%long",0},{"tokfrag",0},{"[",0},{"]",0},{"garbage_decl_rx",0},
{"%}",0},{"rawcode_blkcomment_rx",0},{"rawcode_linecomment_rx",0},{"rawcode_dquotestr_rx",0},
{"rawcode_squotestr_rx",0},{"rawcode_otherjunk_rx",0},{"\\a",0},{"\\b",0},{"\\t",0},
{"\\n",0},{"\\v",0},{"\\f",0},{"\\r",0},{"octesc_rx",0},{"hexesc_rx",0},{"uesc_rx",0},
{"escany_rx",0},{"*",0},{"?",0},{"[^",0},{"{",0},{"tokfrag_id_rx",0},{"}",0},{"namedcharset_rx",0},
{"rawline_rx",0},{"id",&String_tt},{"chars",&String_tt},{"props",&AllProperties_tt},
{"prop",&AllProperties_tt},{"symbols",&Symbols_tt},{"symbol_blk",&Symbols_tt},{"nts",&vector_ltSymbol_ptr_gt_tt},
{"nt",&Symbol_ptr_tt},{"symbol",&Symbol_ptr_tt},{"literal",&Symbol_ptr_tt},{"iliteral",&Symbol_ptr_tt},
{"regex",&Symbol_ptr_tt},{"ordered_token_symbol",&Symbol_ptr_tt},{"tokfrag_symbol",&Symbol_ptr_tt},
{"rx",&Rx_ptr_tt},{"labelexpr",&PrioritySet_tt},{"label",&ProductionLabel_ptr_tt},
{"assoc_op",&PriorityGroup_tt},{"tokenset",&OrderedTokenSet_ptr_tt},{"ordered_token_items",&vector_ltTokenSetAction_gt_ptr_tt},
{"ordered_token_item",&TokenSetAction_tt},{"tokaction",&TokenSetAction_tt},{"integer",&int_tt},
{"natural",&int_tt},{"whole",&int_tt},{"integer_range",&IntSetRange_tt},{"integer_ranges",&vector_ltIntSetRange_gt_tt},
{"char",&uint32_t_tt},{"charset",&UIntSet_tt},{"charelements",&UIntSet_tt},{"charelement",&UIntSet_tt},
{"rawcode",&CodeSnip_tt},{"dotted_boxed_production",&LRItem_tt},{"boxed_production",&Production_ptr_tt},
{"from_series",&vector_ltLRItem_gt_tt},{"production_parts",&vector_ltProductionPart_gt_tt},
{"production_part",&ProductionPart_tt},{"sl_decl",&sl_decl_tt},{"ggdoc",0},{"rawoplines",0},
{"sepline",0},{"rules",0},{"rawlines",0},{"rawlineitem",0},{"optionline",0},{"optionlist",0},
{"optionitem",0},{"rule",0},{"ctype",0},{"ctype_list",0},{"rawcode_frags",0},{"rawcode_frag",0},
};
static int  ps148[] = {134,-1};
static int  ps149[] = {135,136,137,136,138,-1};
static int  ps150[] = {135,136,137,136,-1};
static int skp150[] = {4,};
static int  ps151[] = {135,136,137,-1};
static int skp151[] = {3,4,};
static int  ps152[] = {136,137,136,138,-1};
static int skp152[] = {0,};
static int  ps153[] = {136,137,136,-1};
static int skp153[] = {0,4,};
static int  ps154[] = {136,137,-1};
static int skp154[] = {0,3,4,};
static int  ps155[] = {135,139,-1};
static int  ps156[] = {139,-1};
static int  ps157[] = {5,-1};
static int  ps158[] = {140,-1};
static int  ps159[] = {6,141,12,-1};
static int  ps160[] = {6,12,-1};
static int skp160[] = {1,};
static int  ps161[] = {141,10,142,-1};
static int  ps162[] = {142,-1};
static int  ps163[] = {9,11,9,-1};
static int  ps164[] = {9,-1};
static int skp164[] = {1,2,};
static int  ps165[] = {4,-1};
static int  ps166[] = {137,143,-1};
static int  ps167[] = {143,-1};
static int  ps168[] = {138,95,-1};
static int  ps169[] = {95,-1};
static int  ps170[] = {26,-1};
static int  ps171[] = {26,-1};
static int  ps172[] = {42,26,-1};
static int  ps173[] = {144,43,-1};
static int  ps174[] = {144,42,26,-1};
static int  ps175[] = {144,37,145,36,-1};
static int  ps176[] = {145,10,144,-1};
static int  ps177[] = {144,-1};
static int  ps178[] = {68,103,34,100,69,-1};
static int  ps179[] = {68,103,34,69,-1};
static int skp179[] = {3,};
static int  ps180[] = {103,34,131,33,-1};
static int  ps181[] = {131,41,132,-1};
static int  ps182[] = {132,-1};
static int  ps183[] = {68,103,34,100,69,-1};
static int  ps184[] = {68,103,34,69,-1};
static int skp184[] = {3,};
static int  ps185[] = {100,40,98,-1};
static int  ps186[] = {100,40,-1};
static int skp186[] = {2,};
static int  ps187[] = {100,98,-1};
static int skp187[] = {1,};
static int  ps188[] = {100,-1};
static int skp188[] = {1,2,};
static int  ps189[] = {63,144,31,102,33,-1};
static int  ps190[] = {40,98,-1};
static int skp190[] = {0,};
static int  ps191[] = {40,-1};
static int skp191[] = {0,2,};
static int  ps192[] = {98,-1};
static int skp192[] = {0,1,};
static int  ps193[] = {-1};
static int skp193[] = {0,1,2,};
static int  ps194[] = {3,-1};
static int  ps195[] = {3,33,-1};
static int  ps196[] = {54,144,33,-1};
static int  ps197[] = {55,111,33,-1};
static int  ps198[] = {56,112,113,112,33,-1};
static int  ps199[] = {61,129,39,128,130,33,-1};
static int  ps200[] = {61,129,39,128,33,-1};
static int skp200[] = {4,};
static int  ps201[] = {61,129,39,51,35,112,113,130,33,-1};
static int  ps202[] = {61,129,39,51,35,112,113,33,-1};
static int skp202[] = {7,};
static int  ps203[] = {61,129,39,51,112,113,130,33,-1};
static int skp203[] = {4,};
static int  ps204[] = {61,129,39,51,112,113,33,-1};
static int skp204[] = {4,7,};
static int  ps205[] = {61,51,35,112,39,128,130,33,-1};
static int  ps206[] = {61,51,35,112,39,128,33,-1};
static int skp206[] = {6,};
static int  ps207[] = {61,51,112,39,128,130,33,-1};
static int skp207[] = {2,};
static int  ps208[] = {61,51,112,39,128,33,-1};
static int skp208[] = {2,6,};
static int  ps209[] = {61,39,128,130,33,-1};
static int  ps210[] = {61,39,128,33,-1};
static int skp210[] = {3,};
static int  ps211[] = {62,51,35,112,39,128,130,33,-1};
static int  ps212[] = {62,51,35,112,39,128,33,-1};
static int skp212[] = {6,};
static int  ps213[] = {62,51,112,39,128,130,33,-1};
static int skp213[] = {2,};
static int  ps214[] = {62,51,112,39,128,33,-1};
static int skp214[] = {2,6,};
static int  ps215[] = {62,129,39,128,130,33,-1};
static int  ps216[] = {62,129,39,128,33,-1};
static int skp216[] = {4,};
static int  ps217[] = {62,39,128,130,33,-1};
static int  ps218[] = {62,39,128,33,-1};
static int skp218[] = {3,};
static int  ps219[] = {130,64,128,-1};
static int  ps220[] = {64,128,-1};
static int  ps221[] = {67,26,35,109,33,-1};
static int  ps222[] = {67,26,109,33,-1};
static int skp222[] = {2,};
static int  ps223[] = {107,-1};
static int  ps224[] = {105,-1};
static int  ps225[] = {106,-1};
static int  ps226[] = {57,114,35,22,115,23,33,-1};
static int  ps227[] = {57,114,22,115,23,33,-1};
static int skp227[] = {2,};
static int  ps228[] = {57,114,35,22,115,23,3,-1};
static int  ps229[] = {57,114,22,115,23,3,-1};
static int skp229[] = {2,};
static int  ps230[] = {57,114,35,22,3,-1};
static int  ps231[] = {57,114,22,3,-1};
static int skp231[] = {2,};
static int  ps232[] = {100,133,104,-1};
static int  ps233[] = {100,104,-1};
static int skp233[] = {1,};
static int  ps234[] = {100,101,-1};
static int  ps235[] = {133,104,-1};
static int  ps236[] = {104,-1};
static int skp236[] = {0,};
static int  ps237[] = {101,-1};
static int  ps238[] = {65,-1};
static int  ps239[] = {66,-1};
static int  ps240[] = {68,100,69,-1};
static int  ps241[] = {68,3,-1};
static int  ps242[] = {103,-1};
static int  ps243[] = {105,-1};
static int  ps244[] = {106,-1};
static int  ps245[] = {107,-1};
static int  ps246[] = {38,-1};
static int  ps247[] = {115,10,116,-1};
static int  ps248[] = {116,-1};
static int  ps249[] = {108,44,26,34,117,-1};
static int  ps250[] = {108,44,26,34,-1};
static int skp250[] = {4,};
static int  ps251[] = {108,44,26,-1};
static int skp251[] = {3,4,};
static int  ps252[] = {108,34,117,-1};
static int skp252[] = {1,2,};
static int  ps253[] = {108,34,-1};
static int skp253[] = {1,2,4,};
static int  ps254[] = {108,-1};
static int skp254[] = {1,2,3,4,};
static int  ps255[] = {105,-1};
static int  ps256[] = {106,-1};
static int  ps257[] = {107,-1};
static int  ps258[] = {103,-1};
static int  ps259[] = {45,114,-1};
static int  ps260[] = {46,-1};
static int  ps261[] = {48,-1};
static int  ps262[] = {47,114,-1};
static int  ps263[] = {96,-1};
static int  ps264[] = {102,103,-1};
static int  ps265[] = {103,-1};
static int  ps266[] = {96,-1};
static int  ps267[] = {24,-1};
static int  ps268[] = {25,-1};
static int  ps269[] = {98,40,99,-1};
static int  ps270[] = {98,99,-1};
static int skp270[] = {1,};
static int  ps271[] = {99,-1};
static int  ps272[] = {50,-1};
static int  ps273[] = {49,35,119,-1};
static int  ps274[] = {49,119,-1};
static int skp274[] = {1,};
static int  ps275[] = {113,-1};
static int  ps276[] = {51,35,112,-1};
static int  ps277[] = {51,112,-1};
static int skp277[] = {1,};
static int  ps278[] = {52,35,127,-1};
static int  ps279[] = {52,127,-1};
static int skp279[] = {1,};
static int  ps280[] = {53,-1};
static int  ps281[] = {18,97,18,-1};
static int  ps282[] = {18,18,-1};
static int skp282[] = {1,};
static int  ps283[] = {20,97,20,-1};
static int  ps284[] = {20,20,-1};
static int skp284[] = {1,};
static int  ps285[] = {19,97,18,-1};
static int  ps286[] = {19,18,-1};
static int skp286[] = {1,};
static int  ps287[] = {21,97,20,-1};
static int  ps288[] = {21,20,-1};
static int skp288[] = {1,};
static int  ps289[] = {97,123,-1};
static int  ps290[] = {123,-1};
static int  ps291[] = {77,-1};
static int  ps292[] = {78,-1};
static int  ps293[] = {79,-1};
static int  ps294[] = {80,-1};
static int  ps295[] = {81,-1};
static int  ps296[] = {82,-1};
static int  ps297[] = {83,-1};
static int  ps298[] = {84,-1};
static int  ps299[] = {85,-1};
static int  ps300[] = {86,-1};
static int  ps301[] = {87,-1};
static int  ps302[] = {7,-1};
static int  ps303[] = {16,110,16,-1};
static int  ps304[] = {16,3,-1};
static int  ps305[] = {17,110,16,-1};
static int  ps306[] = {17,3,-1};
static int  ps307[] = {22,110,23,-1};
static int  ps308[] = {22,3,-1};
static int  ps309[] = {110,110,-1};
static int  ps310[] = {110,41,110,-1};
static int  ps311[] = {110,88,-1};
static int  ps312[] = {110,40,-1};
static int  ps313[] = {110,89,-1};
static int  ps314[] = {110,91,119,93,-1};
static int  ps315[] = {110,91,119,10,93,-1};
static int  ps316[] = {110,91,10,119,93,-1};
static int  ps317[] = {110,91,119,10,119,93,-1};
static int  ps318[] = {110,91,3,-1};
static int  ps319[] = {92,-1};
static int  ps320[] = {38,-1};
static int  ps321[] = {123,-1};
static int  ps322[] = {124,-1};
static int  ps323[] = {68,125,69,-1};
static int  ps324[] = {68,3,-1};
static int  ps325[] = {90,125,69,-1};
static int  ps326[] = {90,3,-1};
static int  ps327[] = {125,126,-1};
static int  ps328[] = {126,-1};
static int  ps329[] = {123,-1};
static int  ps330[] = {123,27,123,-1};
static int  ps331[] = {94,-1};
static int  ps332[] = {111,35,111,-1};
static int  ps333[] = {113,111,-1};
static int  ps334[] = {111,36,111,-1};
static int  ps335[] = {112,-1};
static int  ps336[] = {96,-1};
static int  ps337[] = {58,-1};
static int  ps338[] = {59,-1};
static int  ps339[] = {60,-1};
static int  ps340[] = {61,22,122,23,-1};
static int  ps341[] = {122,10,121,-1};
static int  ps342[] = {121,-1};
static int skp342[] = {0,1,};
static int  ps343[] = {118,30,118,-1};
static int  ps344[] = {119,-1};
static int  ps345[] = {120,-1};
static int  ps346[] = {27,119,-1};
static int  ps347[] = {27,120,-1};
static int  ps348[] = {28,-1};
static int  ps349[] = {29,-1};
static int  ps350[] = {15,146,71,-1};
static int  ps351[] = {15,71,-1};
static int skp351[] = {1,};
static int  ps352[] = {146,147,-1};
static int  ps353[] = {147,-1};
static int  ps354[] = {72,-1};
static int  ps355[] = {73,-1};
static int  ps356[] = {74,-1};
static int  ps357[] = {75,-1};
static int  ps358[] = {76,-1};
static production productions[] = {
{148,148,0,1,ps148,0,0},
{149,149,134,5,ps149,0,0},
{150,149,134,4,ps150,SZ(skp150),skp150},
{151,149,134,3,ps151,SZ(skp151),skp151},
{152,149,134,4,ps152,SZ(skp152),skp152},
{153,149,134,3,ps153,SZ(skp153),skp153},
{154,149,134,2,ps154,SZ(skp154),skp154},
{155,155,135,2,ps155,0,0},
{156,156,135,1,ps156,0,0},
{157,157,139,1,ps157,0,0},
{158,158,139,1,ps158,0,0},
{159,159,140,3,ps159,0,0},
{160,159,140,2,ps160,SZ(skp160),skp160},
{161,161,141,3,ps161,0,0},
{162,162,141,1,ps162,0,0},
{163,163,142,3,ps163,0,0},
{164,163,142,1,ps164,SZ(skp164),skp164},
{165,165,136,1,ps165,0,0},
{166,166,137,2,ps166,0,0},
{167,167,137,1,ps167,0,0},
{168,168,138,2,ps168,0,0},
{169,169,138,1,ps169,0,0},
{170,170,96,1,ps170,0,0},
{171,171,144,1,ps171,0,0},
{172,172,144,2,ps172,0,0},
{173,173,144,2,ps173,0,0},
{174,174,144,3,ps174,0,0},
{175,175,144,4,ps175,0,0},
{176,176,145,3,ps176,0,0},
{177,177,145,1,ps177,0,0},
{178,178,128,5,ps178,0,0},
{179,178,128,4,ps179,SZ(skp179),skp179},
{180,180,143,4,ps180,0,0},
{181,181,131,3,ps181,0,0},
{182,182,131,1,ps182,0,0},
{183,183,129,5,ps183,0,0},
{184,183,129,4,ps184,SZ(skp184),skp184},
{185,185,132,3,ps185,0,0},
{186,185,132,2,ps186,SZ(skp186),skp186},
{187,185,132,2,ps187,SZ(skp187),skp187},
{188,185,132,1,ps188,SZ(skp188),skp188},
{189,189,143,5,ps189,0,0},
{190,185,132,2,ps190,SZ(skp190),skp190},
{191,185,132,1,ps191,SZ(skp191),skp191},
{192,185,132,1,ps192,SZ(skp192),skp192},
{193,185,132,0,ps193,SZ(skp193),skp193},
{194,194,143,1,ps194,0,0},
{195,195,143,2,ps195,0,0},
{196,196,143,3,ps196,0,0},
{197,197,143,3,ps197,0,0},
{198,198,143,5,ps198,0,0},
{199,199,143,6,ps199,0,0},
{200,199,143,5,ps200,SZ(skp200),skp200},
{201,201,143,9,ps201,0,0},
{202,201,143,8,ps202,SZ(skp202),skp202},
{203,201,143,8,ps203,SZ(skp203),skp203},
{204,201,143,7,ps204,SZ(skp204),skp204},
{205,205,143,8,ps205,0,0},
{206,205,143,7,ps206,SZ(skp206),skp206},
{207,205,143,7,ps207,SZ(skp207),skp207},
{208,205,143,6,ps208,SZ(skp208),skp208},
{209,209,143,5,ps209,0,0},
{210,209,143,4,ps210,SZ(skp210),skp210},
{211,211,143,8,ps211,0,0},
{212,211,143,7,ps212,SZ(skp212),skp212},
{213,211,143,7,ps213,SZ(skp213),skp213},
{214,211,143,6,ps214,SZ(skp214),skp214},
{215,215,143,6,ps215,0,0},
{216,215,143,5,ps216,SZ(skp216),skp216},
{217,217,143,5,ps217,0,0},
{218,217,143,4,ps218,SZ(skp218),skp218},
{219,219,130,3,ps219,0,0},
{220,220,130,2,ps220,0,0},
{221,221,143,5,ps221,0,0},
{222,221,143,4,ps222,SZ(skp222),skp222},
{223,223,109,1,ps223,0,0},
{224,224,109,1,ps224,0,0},
{225,225,109,1,ps225,0,0},
{226,226,143,7,ps226,0,0},
{227,226,143,6,ps227,SZ(skp227),skp227},
{228,228,143,7,ps228,0,0},
{229,228,143,6,ps229,SZ(skp229),skp229},
{230,230,143,5,ps230,0,0},
{231,230,143,4,ps231,SZ(skp231),skp231},
{232,232,100,3,ps232,0,0},
{233,232,100,2,ps233,SZ(skp233),skp233},
{234,234,100,2,ps234,0,0},
{235,235,100,2,ps235,0,0},
{236,235,100,1,ps236,SZ(skp236),skp236},
{237,237,100,1,ps237,0,0},
{238,238,133,1,ps238,0,0},
{239,239,133,1,ps239,0,0},
{240,240,101,3,ps240,0,0},
{241,241,101,2,ps241,0,0},
{242,242,104,1,ps242,0,0},
{243,243,104,1,ps243,0,0},
{244,244,104,1,ps244,0,0},
{245,245,104,1,ps245,0,0},
{246,246,104,1,ps246,0,0},
{247,247,115,3,ps247,0,0},
{248,248,115,1,ps248,0,0},
{249,249,116,5,ps249,0,0},
{250,249,116,4,ps250,SZ(skp250),skp250},
{251,249,116,3,ps251,SZ(skp251),skp251},
{252,249,116,3,ps252,SZ(skp252),skp252},
{253,249,116,2,ps253,SZ(skp253),skp253},
{254,249,116,1,ps254,SZ(skp254),skp254},
{255,255,108,1,ps255,0,0},
{256,256,108,1,ps256,0,0},
{257,257,108,1,ps257,0,0},
{258,258,108,1,ps258,0,0},
{259,259,117,2,ps259,0,0},
{260,260,117,1,ps260,0,0},
{261,261,117,1,ps261,0,0},
{262,262,117,2,ps262,0,0},
{263,263,114,1,ps263,0,0},
{264,264,102,2,ps264,0,0},
{265,265,102,1,ps265,0,0},
{266,266,103,1,ps266,0,0},
{267,267,103,1,ps267,0,0},
{268,268,103,1,ps268,0,0},
{269,269,98,3,ps269,0,0},
{270,269,98,2,ps270,SZ(skp270),skp270},
{271,271,98,1,ps271,0,0},
{272,272,99,1,ps272,0,0},
{273,273,99,3,ps273,0,0},
{274,273,99,2,ps274,SZ(skp274),skp274},
{275,275,99,1,ps275,0,0},
{276,276,99,3,ps276,0,0},
{277,276,99,2,ps277,SZ(skp277),skp277},
{278,278,99,3,ps278,0,0},
{279,278,99,2,ps279,SZ(skp279),skp279},
{280,280,99,1,ps280,0,0},
{281,281,105,3,ps281,0,0},
{282,281,105,2,ps282,SZ(skp282),skp282},
{283,283,105,3,ps283,0,0},
{284,283,105,2,ps284,SZ(skp284),skp284},
{285,285,106,3,ps285,0,0},
{286,285,106,2,ps286,SZ(skp286),skp286},
{287,287,106,3,ps287,0,0},
{288,287,106,2,ps288,SZ(skp288),skp288},
{289,289,97,2,ps289,0,0},
{290,290,97,1,ps290,0,0},
{291,291,123,1,ps291,0,0},
{292,292,123,1,ps292,0,0},
{293,293,123,1,ps293,0,0},
{294,294,123,1,ps294,0,0},
{295,295,123,1,ps295,0,0},
{296,296,123,1,ps296,0,0},
{297,297,123,1,ps297,0,0},
{298,298,123,1,ps298,0,0},
{299,299,123,1,ps299,0,0},
{300,300,123,1,ps300,0,0},
{301,301,123,1,ps301,0,0},
{302,302,123,1,ps302,0,0},
{303,303,107,3,ps303,0,0},
{304,304,107,2,ps304,0,0},
{305,305,107,3,ps305,0,0},
{306,306,107,2,ps306,0,0},
{307,307,110,3,ps307,0,0},
{308,308,110,2,ps308,0,0},
{309,309,110,2,ps309,0,0},
{310,310,110,3,ps310,0,0},
{311,311,110,2,ps311,0,0},
{312,312,110,2,ps312,0,0},
{313,313,110,2,ps313,0,0},
{314,314,110,4,ps314,0,0},
{315,315,110,5,ps315,0,0},
{316,316,110,5,ps316,0,0},
{317,317,110,6,ps317,0,0},
{318,318,110,3,ps318,0,0},
{319,319,110,1,ps319,0,0},
{320,320,110,1,ps320,0,0},
{321,321,110,1,ps321,0,0},
{322,322,110,1,ps322,0,0},
{323,323,124,3,ps323,0,0},
{324,324,124,2,ps324,0,0},
{325,325,124,3,ps325,0,0},
{326,326,124,2,ps326,0,0},
{327,327,125,2,ps327,0,0},
{328,328,125,1,ps328,0,0},
{329,329,126,1,ps329,0,0},
{330,330,126,3,ps330,0,0},
{331,331,126,1,ps331,0,0},
{332,332,111,3,ps332,0,0},
{333,333,111,2,ps333,0,0},
{334,334,111,3,ps334,0,0},
{335,335,111,1,ps335,0,0},
{336,336,112,1,ps336,0,0},
{337,337,113,1,ps337,0,0},
{338,338,113,1,ps338,0,0},
{339,339,113,1,ps339,0,0},
{340,340,113,4,ps340,0,0},
{341,341,122,3,ps341,0,0},
{342,341,122,1,ps342,SZ(skp342),skp342},
{343,343,121,3,ps343,0,0},
{344,344,118,1,ps344,0,0},
{345,345,118,1,ps345,0,0},
{346,346,118,2,ps346,0,0},
{347,347,118,2,ps347,0,0},
{348,348,119,1,ps348,0,0},
{349,349,120,1,ps349,0,0},
{350,350,127,3,ps350,0,0},
{351,350,127,2,ps351,SZ(skp351),skp351},
{352,352,146,2,ps352,0,0},
{353,353,146,1,ps353,0,0},
{354,354,147,1,ps354,0,0},
{355,355,147,1,ps355,0,0},
{356,356,147,1,ps356,0,0},
{357,357,147,1,ps357,0,0},
{358,358,147,1,ps358,0,0},
};
static int par_rng_0[] = {1,4,6,};
static int par_rng_1[] = {1,149,154,};
static int par_rng_2[] = {1,155,156,};
static int par_rng_3[] = {1,157,158,};
static int par_rng_4[] = {1,159,160,};
static int par_rng_5[] = {1,165,165,};
static int par_rng_6[] = {7,1,1,3,3,24,26,54,57,61,63,67,67,95,95,};
static int par_rng_7[] = {1,9,9,};
static int par_rng_8[] = {1,12,12,};
static int par_rng_9[] = {1,161,162,};
static int par_rng_10[] = {1,163,164,};
static int par_rng_11[] = {1,1,1,};
static int par_rng_12[] = {1,3,3,};
static int par_rng_13[] = {1,24,26,};
static int par_rng_14[] = {1,54,57,};
static int par_rng_15[] = {1,61,63,};
static int par_rng_16[] = {1,67,67,};
static int par_rng_17[] = {1,166,167,};
static int par_rng_18[] = {1,170,170,};
static int par_rng_19[] = {5,180,180,189,189,194,218,221,222,226,231,};
static int par_rng_20[] = {1,266,268,};
static int par_rng_21[] = {1,10,10,};
static int par_rng_22[] = {1,11,11,};
static int par_rng_23[] = {2,10,10,12,12,};
static int par_rng_24[] = {3,1,1,3,4,24,26,};
static int par_rng_25[] = {1,33,33,};
static int par_rng_26[] = {3,54,57,61,63,67,67,};
static int par_rng_27[] = {11,10,10,16,21,23,26,33,34,38,38,40,41,44,44,49,53,58,61,65,66,68,69,};
static int par_rng_28[] = {9,10,10,16,26,33,36,38,41,44,44,49,53,58,61,65,66,68,69,};
static int par_rng_29[] = {1,26,26,};
static int par_rng_30[] = {1,42,42,};
static int par_rng_31[] = {1,171,172,};
static int par_rng_32[] = {1,173,173,};
static int par_rng_33[] = {1,174,175,};
static int par_rng_34[] = {1,58,61,};
static int par_rng_35[] = {1,332,333,};
static int par_rng_36[] = {1,334,334,};
static int par_rng_37[] = {1,335,335,};
static int par_rng_38[] = {1,336,337,};
static int par_rng_39[] = {1,338,340,};
static int par_rng_40[] = {1,336,336,};
static int par_rng_41[] = {1,263,263,};
static int par_rng_42[] = {1,39,39,};
static int par_rng_43[] = {1,51,51,};
static int par_rng_44[] = {1,68,68,};
static int par_rng_45[] = {1,183,184,};
static int par_rng_46[] = {1,4,4,};
static int par_rng_47[] = {6,1,1,3,4,24,26,54,57,61,63,67,67,};
static int par_rng_48[] = {1,34,34,};
static int par_rng_49[] = {5,10,10,31,31,33,33,36,37,42,43,};
static int par_rng_50[] = {1,37,37,};
static int par_rng_51[] = {1,42,43,};
static int par_rng_52[] = {1,43,43,};
static int par_rng_53[] = {6,26,26,33,33,40,41,49,53,58,61,64,64,};
static int par_rng_54[] = {1,22,22,};
static int par_rng_55[] = {5,33,33,35,36,39,41,49,53,58,61,};
static int par_rng_56[] = {1,35,36,};
static int par_rng_57[] = {1,36,36,};
static int par_rng_58[] = {2,33,33,35,36,};
static int par_rng_59[] = {2,332,332,335,335,};
static int par_rng_60[] = {1,337,340,};
static int par_rng_61[] = {3,10,10,22,23,35,35,};
static int par_rng_62[] = {1,35,35,};
static int par_rng_63[] = {1,178,179,};
static int par_rng_64[] = {1,31,31,};
static int par_rng_65[] = {1,16,21,};
static int par_rng_66[] = {1,223,225,};
static int par_rng_67[] = {1,281,284,};
static int par_rng_68[] = {1,285,288,};
static int par_rng_69[] = {1,303,306,};
static int par_rng_70[] = {1,95,95,};
static int par_rng_71[] = {1,168,169,};
static int par_rng_72[] = {1,38,38,};
static int par_rng_73[] = {1,40,40,};
static int par_rng_74[] = {1,41,41,};
static int par_rng_75[] = {1,49,53,};
static int par_rng_76[] = {1,65,66,};
static int par_rng_77[] = {1,181,182,};
static int par_rng_78[] = {2,185,188,190,193,};
static int par_rng_79[] = {1,232,237,};
static int par_rng_80[] = {1,238,239,};
static int par_rng_81[] = {1,240,241,};
static int par_rng_82[] = {1,242,246,};
static int par_rng_83[] = {1,269,271,};
static int par_rng_84[] = {1,272,280,};
static int par_rng_85[] = {1,176,177,};
static int par_rng_86[] = {5,10,10,31,31,33,33,36,36,43,43,};
static int par_rng_87[] = {1,27,29,};
static int par_rng_88[] = {1,341,342,};
static int par_rng_89[] = {1,343,344,};
static int par_rng_90[] = {1,345,347,};
static int par_rng_91[] = {1,348,349,};
static int par_rng_92[] = {1,247,248,};
static int par_rng_93[] = {1,249,254,};
static int par_rng_94[] = {1,255,258,};
static int par_rng_95[] = {1,64,64,};
static int par_rng_96[] = {1,219,220,};
static int par_rng_97[] = {1,264,265,};
static int par_rng_98[] = {1,7,7,};
static int par_rng_99[] = {1,77,87,};
static int par_rng_100[] = {1,90,90,};
static int par_rng_101[] = {1,92,92,};
static int par_rng_102[] = {1,291,302,};
static int par_rng_103[] = {1,307,308,};
static int par_rng_104[] = {1,309,310,};
static int par_rng_105[] = {1,311,322,};
static int par_rng_106[] = {1,323,326,};
static int par_rng_107[] = {1,18,18,};
static int par_rng_108[] = {1,289,290,};
static int par_rng_109[] = {1,20,20,};
static int par_rng_110[] = {2,1,1,95,95,};
static int par_rng_111[] = {9,16,21,24,26,33,33,38,38,40,41,49,53,58,61,65,66,68,69,};
static int par_rng_112[] = {2,33,33,41,41,};
static int par_rng_113[] = {1,28,28,};
static int par_rng_114[] = {1,348,348,};
static int par_rng_115[] = {4,33,33,40,41,49,53,58,61,};
static int par_rng_116[] = {1,15,15,};
static int par_rng_117[] = {1,350,351,};
static int par_rng_118[] = {3,16,21,24,26,38,38,};
static int par_rng_119[] = {2,10,10,36,36,};
static int par_rng_120[] = {1,28,29,};
static int par_rng_121[] = {8,10,10,23,23,30,30,33,33,40,41,49,53,58,61,93,93,};
static int par_rng_122[] = {3,10,10,23,23,30,30,};
static int par_rng_123[] = {1,23,23,};
static int par_rng_124[] = {2,10,10,23,23,};
static int par_rng_125[] = {1,30,30,};
static int par_rng_126[] = {2,33,33,36,36,};
static int par_rng_127[] = {1,44,44,};
static int par_rng_128[] = {4,10,10,23,23,34,34,44,44,};
static int par_rng_129[] = {1,69,69,};
static int par_rng_130[] = {2,24,26,33,33,};
static int par_rng_131[] = {11,7,7,16,16,18,18,20,20,22,23,27,27,38,38,40,41,68,69,77,92,94,94,};
static int par_rng_132[] = {7,7,7,16,16,22,23,38,38,40,41,68,68,77,92,};
static int par_rng_133[] = {1,94,94,};
static int par_rng_134[] = {1,327,328,};
static int par_rng_135[] = {1,329,331,};
static int par_rng_136[] = {1,16,16,};
static int par_rng_137[] = {1,40,41,};
static int par_rng_138[] = {1,88,89,};
static int par_rng_139[] = {1,91,91,};
static int par_rng_140[] = {2,307,308,311,322,};
static int par_rng_141[] = {4,7,7,18,18,20,20,77,87,};
static int par_rng_142[] = {1,71,76,};
static int par_rng_143[] = {1,352,353,};
static int par_rng_144[] = {1,354,358,};
static int par_rng_145[] = {1,343,343,};
static int par_rng_146[] = {1,344,347,};
static int par_rng_147[] = {1,45,48,};
static int par_rng_148[] = {1,259,262,};
static int par_rng_149[] = {2,33,33,64,64,};
static int par_rng_150[] = {4,7,7,69,69,77,87,94,94,};
static int par_rng_151[] = {1,27,27,};
static int par_rng_152[] = {3,69,69,77,87,94,94,};
static int par_rng_153[] = {1,309,309,};
static int par_rng_154[] = {4,7,7,16,16,22,23,38,38,};
static int par_rng_155[] = {3,41,41,68,68,77,87,};
static int par_rng_156[] = {1,71,71,};
static int par_rng_157[] = {1,72,76,};
static int par_rng_158[] = {1,93,93,};
static parse_action_range par0[] = {{SH,1,3,par_rng_0},{SH,4,4,par_rng_1},{SH,5,5,par_rng_2},{SH,6,6,par_rng_3},{SH,7,7,par_rng_4},{SH,8,8,par_rng_5},};
static parse_action_range par1[] = {{RD,17,17,par_rng_6},};
static parse_action_range par2[] = {{RD,9,9,par_rng_0},};
static parse_action_range par3[] = {{SH,9,9,par_rng_7},{SH,10,10,par_rng_8},{SH,11,11,par_rng_9},{SH,12,12,par_rng_10},};
static parse_action_range par4[] = {{RD,0,0,par_rng_11},};
static parse_action_range par5[] = {{SH,1,3,par_rng_0},{SH,13,13,par_rng_3},{SH,7,7,par_rng_4},{SH,14,14,par_rng_5},};
static parse_action_range par6[] = {{RD,8,8,par_rng_0},};
static parse_action_range par7[] = {{RD,10,10,par_rng_0},};
static parse_action_range par8[] = {{SH,15,15,par_rng_12},{SH,16,18,par_rng_13},{SH,19,22,par_rng_14},{SH,23,25,par_rng_15},{SH,26,26,par_rng_16},{SH,27,27,par_rng_17},{SH,28,28,par_rng_18},{SH,29,29,par_rng_19},{SH,30,30,par_rng_20},};
static parse_action_range par9[] = {{RD,16,16,par_rng_21},{SH,31,31,par_rng_22},{RD,16,16,par_rng_8},};
static parse_action_range par10[] = {{RD,12,12,par_rng_0},};
static parse_action_range par11[] = {{SH,32,32,par_rng_21},{SH,33,33,par_rng_8},};
static parse_action_range par12[] = {{RD,14,14,par_rng_23},};
static parse_action_range par13[] = {{RD,7,7,par_rng_0},};
static parse_action_range par14[] = {{SH,15,15,par_rng_12},{SH,16,18,par_rng_13},{SH,19,22,par_rng_14},{SH,23,25,par_rng_15},{SH,26,26,par_rng_16},{SH,34,34,par_rng_17},{SH,28,28,par_rng_18},{SH,29,29,par_rng_19},{SH,30,30,par_rng_20},};
static parse_action_range par15[] = {{RD,46,46,par_rng_24},{SH,35,35,par_rng_25},{RD,46,46,par_rng_26},};
static parse_action_range par16[] = {{RD,119,119,par_rng_27},};
static parse_action_range par17[] = {{RD,120,120,par_rng_27},};
static parse_action_range par18[] = {{RD,22,22,par_rng_28},};
static parse_action_range par19[] = {{SH,36,36,par_rng_29},{SH,37,37,par_rng_30},{SH,38,38,par_rng_31},{SH,39,39,par_rng_32},{SH,38,38,par_rng_33},};
static parse_action_range par20[] = {{SH,18,18,par_rng_29},{SH,40,43,par_rng_34},{SH,44,44,par_rng_18},{SH,45,46,par_rng_35},{SH,46,46,par_rng_36},{SH,45,45,par_rng_37},{SH,47,48,par_rng_38},{SH,48,48,par_rng_39},};
static parse_action_range par21[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,49,49,par_rng_40},};
static parse_action_range par22[] = {{SH,18,18,par_rng_29},{SH,50,50,par_rng_18},{SH,51,51,par_rng_41},};
static parse_action_range par23[] = {{SH,52,52,par_rng_42},{SH,53,53,par_rng_43},{SH,54,54,par_rng_44},{SH,55,55,par_rng_45},};
static parse_action_range par24[] = {{SH,56,56,par_rng_42},{SH,57,57,par_rng_43},{SH,54,54,par_rng_44},{SH,58,58,par_rng_45},};
static parse_action_range par25[] = {{SH,36,36,par_rng_29},{SH,37,37,par_rng_30},{SH,59,59,par_rng_31},{SH,60,60,par_rng_32},{SH,59,59,par_rng_33},};
static parse_action_range par26[] = {{SH,61,61,par_rng_29},};
static parse_action_range par27[] = {{RD,6,6,par_rng_11},{SH,15,15,par_rng_12},{SH,1,1,par_rng_46},{SH,16,18,par_rng_13},{SH,19,22,par_rng_14},{SH,23,25,par_rng_15},{SH,26,26,par_rng_16},{SH,62,62,par_rng_5},{SH,28,28,par_rng_18},{SH,63,63,par_rng_19},{SH,30,30,par_rng_20},};
static parse_action_range par28[] = {{RD,118,118,par_rng_27},};
static parse_action_range par29[] = {{RD,19,19,par_rng_47},};
static parse_action_range par30[] = {{SH,64,64,par_rng_48},};
static parse_action_range par31[] = {{SH,65,65,par_rng_7},};
static parse_action_range par32[] = {{SH,9,9,par_rng_7},{SH,66,66,par_rng_10},};
static parse_action_range par33[] = {{RD,11,11,par_rng_0},};
static parse_action_range par34[] = {{RD,3,3,par_rng_11},{SH,15,15,par_rng_12},{SH,1,1,par_rng_46},{SH,16,18,par_rng_13},{SH,19,22,par_rng_14},{SH,23,25,par_rng_15},{SH,26,26,par_rng_16},{SH,67,67,par_rng_5},{SH,28,28,par_rng_18},{SH,63,63,par_rng_19},{SH,30,30,par_rng_20},};
static parse_action_range par35[] = {{RD,47,47,par_rng_47},};
static parse_action_range par36[] = {{RD,23,23,par_rng_49},};
static parse_action_range par37[] = {{SH,68,68,par_rng_29},};
static parse_action_range par38[] = {{SH,69,69,par_rng_25},{SH,70,70,par_rng_50},{SH,71,72,par_rng_51},};
static parse_action_range par39[] = {{SH,69,69,par_rng_25},{SH,72,72,par_rng_52},};
static parse_action_range par40[] = {{RD,189,189,par_rng_53},};
static parse_action_range par41[] = {{RD,190,190,par_rng_53},};
static parse_action_range par42[] = {{RD,191,191,par_rng_53},};
static parse_action_range par43[] = {{SH,73,73,par_rng_54},};
static parse_action_range par44[] = {{RD,188,188,par_rng_55},};
static parse_action_range par45[] = {{SH,74,74,par_rng_25},{SH,75,76,par_rng_56},};
static parse_action_range par46[] = {{SH,74,74,par_rng_25},{SH,76,76,par_rng_57},};
static parse_action_range par47[] = {{RD,187,187,par_rng_58},};
static parse_action_range par48[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,77,77,par_rng_59},{SH,47,47,par_rng_40},};
static parse_action_range par49[] = {{SH,40,43,par_rng_34},{SH,78,78,par_rng_60},};
static parse_action_range par50[] = {{RD,115,115,par_rng_61},};
static parse_action_range par51[] = {{SH,79,79,par_rng_54},{SH,80,80,par_rng_62},};
static parse_action_range par52[] = {{SH,81,81,par_rng_44},{SH,82,82,par_rng_63},};
static parse_action_range par53[] = {{SH,18,18,par_rng_29},{SH,83,83,par_rng_62},{SH,44,44,par_rng_18},{SH,84,84,par_rng_40},};
static parse_action_range par54[] = {{SH,16,18,par_rng_13},{SH,28,28,par_rng_18},{SH,85,85,par_rng_20},};
static parse_action_range par55[] = {{SH,86,86,par_rng_42},};
static parse_action_range par56[] = {{SH,81,81,par_rng_44},{SH,87,87,par_rng_63},};
static parse_action_range par57[] = {{SH,18,18,par_rng_29},{SH,88,88,par_rng_62},{SH,44,44,par_rng_18},{SH,89,89,par_rng_40},};
static parse_action_range par58[] = {{SH,90,90,par_rng_42},};
static parse_action_range par59[] = {{SH,91,91,par_rng_64},{SH,70,70,par_rng_50},{SH,71,72,par_rng_51},};
static parse_action_range par60[] = {{SH,91,91,par_rng_64},{SH,72,72,par_rng_52},};
static parse_action_range par61[] = {{SH,92,97,par_rng_65},{SH,98,98,par_rng_62},{SH,99,99,par_rng_66},{SH,100,100,par_rng_67},{SH,101,101,par_rng_68},{SH,102,102,par_rng_69},};
static parse_action_range par62[] = {{RD,5,5,par_rng_11},{SH,103,103,par_rng_70},{SH,104,104,par_rng_71},};
static parse_action_range par63[] = {{RD,18,18,par_rng_47},};
static parse_action_range par64[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{RD,45,45,par_rng_25},{SH,105,105,par_rng_72},{SH,106,106,par_rng_73},{RD,45,45,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,28,28,par_rng_18},{SH,115,115,par_rng_77},{SH,116,116,par_rng_78},{SH,117,117,par_rng_79},{SH,118,118,par_rng_80},{SH,119,119,par_rng_81},{SH,120,120,par_rng_82},{SH,121,121,par_rng_20},{SH,122,122,par_rng_83},{SH,123,123,par_rng_84},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},{SH,127,127,par_rng_60},};
static parse_action_range par65[] = {{RD,15,15,par_rng_23},};
static parse_action_range par66[] = {{RD,13,13,par_rng_23},};
static parse_action_range par67[] = {{RD,2,2,par_rng_11},{SH,103,103,par_rng_70},{SH,128,128,par_rng_71},};
static parse_action_range par68[] = {{RD,24,24,par_rng_49},};
static parse_action_range par69[] = {{RD,48,48,par_rng_47},};
static parse_action_range par70[] = {{SH,36,36,par_rng_29},{SH,37,37,par_rng_30},{SH,129,129,par_rng_31},{SH,130,130,par_rng_32},{SH,129,129,par_rng_33},{SH,131,131,par_rng_85},};
static parse_action_range par71[] = {{SH,132,132,par_rng_29},};
static parse_action_range par72[] = {{RD,25,25,par_rng_86},};
static parse_action_range par73[] = {{SH,133,135,par_rng_87},{SH,136,136,par_rng_88},{SH,137,138,par_rng_89},{SH,138,138,par_rng_90},{SH,139,140,par_rng_91},};
static parse_action_range par74[] = {{RD,49,49,par_rng_47},};
static parse_action_range par75[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,141,141,par_rng_37},{SH,47,47,par_rng_40},};
static parse_action_range par76[] = {{SH,18,18,par_rng_29},{SH,40,43,par_rng_34},{SH,44,44,par_rng_18},{SH,142,143,par_rng_35},{SH,142,142,par_rng_37},{SH,47,48,par_rng_38},{SH,48,48,par_rng_39},};
static parse_action_range par77[] = {{RD,185,185,par_rng_25},{SH,75,75,par_rng_62},{RD,185,185,par_rng_57},};
static parse_action_range par78[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,144,144,par_rng_40},};
static parse_action_range par79[] = {{SH,145,145,par_rng_12},{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,28,28,par_rng_18},{SH,146,146,par_rng_92},{SH,147,147,par_rng_93},{SH,148,148,par_rng_94},{SH,149,149,par_rng_20},{SH,150,150,par_rng_67},{SH,151,151,par_rng_68},{SH,152,152,par_rng_69},};
static parse_action_range par80[] = {{SH,153,153,par_rng_54},};
static parse_action_range par81[] = {{SH,16,18,par_rng_13},{SH,28,28,par_rng_18},{SH,154,154,par_rng_20},};
static parse_action_range par82[] = {{SH,155,155,par_rng_25},{SH,156,156,par_rng_95},{SH,157,157,par_rng_96},};
static parse_action_range par83[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,158,158,par_rng_40},};
static parse_action_range par84[] = {{SH,159,159,par_rng_42},};
static parse_action_range par85[] = {{SH,160,160,par_rng_48},};
static parse_action_range par86[] = {{SH,161,161,par_rng_43},{SH,81,81,par_rng_44},{SH,162,162,par_rng_63},};
static parse_action_range par87[] = {{SH,163,163,par_rng_25},{SH,156,156,par_rng_95},{SH,164,164,par_rng_96},};
static parse_action_range par88[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,165,165,par_rng_40},};
static parse_action_range par89[] = {{SH,166,166,par_rng_42},};
static parse_action_range par90[] = {{SH,81,81,par_rng_44},{SH,167,167,par_rng_63},};
static parse_action_range par91[] = {{SH,16,18,par_rng_13},{SH,28,28,par_rng_18},{SH,168,168,par_rng_97},{SH,169,169,par_rng_20},};
static parse_action_range par92[] = {{SH,170,170,par_rng_12},{SH,171,171,par_rng_98},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,189,189,par_rng_103},{SH,190,191,par_rng_104},{SH,189,189,par_rng_105},{SH,192,192,par_rng_106},};
static parse_action_range par93[] = {{SH,193,193,par_rng_12},{SH,171,171,par_rng_98},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,194,194,par_rng_103},{SH,195,196,par_rng_104},{SH,194,194,par_rng_105},{SH,192,192,par_rng_106},};
static parse_action_range par94[] = {{SH,171,171,par_rng_98},{SH,197,197,par_rng_107},{SH,175,185,par_rng_99},{SH,198,198,par_rng_108},{SH,199,199,par_rng_102},};
static parse_action_range par95[] = {{SH,171,171,par_rng_98},{SH,200,200,par_rng_107},{SH,175,185,par_rng_99},{SH,201,201,par_rng_108},{SH,199,199,par_rng_102},};
static parse_action_range par96[] = {{SH,171,171,par_rng_98},{SH,202,202,par_rng_109},{SH,175,185,par_rng_99},{SH,203,203,par_rng_108},{SH,199,199,par_rng_102},};
static parse_action_range par97[] = {{SH,171,171,par_rng_98},{SH,204,204,par_rng_109},{SH,175,185,par_rng_99},{SH,205,205,par_rng_108},{SH,199,199,par_rng_102},};
static parse_action_range par98[] = {{SH,92,97,par_rng_65},{SH,206,206,par_rng_66},{SH,100,100,par_rng_67},{SH,101,101,par_rng_68},{SH,102,102,par_rng_69},};
static parse_action_range par99[] = {{SH,207,207,par_rng_25},};
static parse_action_range par100[] = {{RD,76,76,par_rng_25},};
static parse_action_range par101[] = {{RD,77,77,par_rng_25},};
static parse_action_range par102[] = {{RD,75,75,par_rng_25},};
static parse_action_range par103[] = {{RD,21,21,par_rng_110},};
static parse_action_range par104[] = {{RD,4,4,par_rng_11},{SH,208,208,par_rng_70},};
static parse_action_range par105[] = {{RD,98,98,par_rng_111},};
static parse_action_range par106[] = {{RD,43,43,par_rng_112},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,209,209,par_rng_83},{SH,123,123,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par107[] = {{SH,134,134,par_rng_113},{SH,210,210,par_rng_62},{SH,211,211,par_rng_114},};
static parse_action_range par108[] = {{RD,124,124,par_rng_115},};
static parse_action_range par109[] = {{SH,18,18,par_rng_29},{SH,212,212,par_rng_62},{SH,44,44,par_rng_18},{SH,213,213,par_rng_40},};
static parse_action_range par110[] = {{SH,214,214,par_rng_116},{SH,215,215,par_rng_62},{SH,216,216,par_rng_117},};
static parse_action_range par111[] = {{RD,132,132,par_rng_115},};
static parse_action_range par112[] = {{RD,90,90,par_rng_118},};
static parse_action_range par113[] = {{RD,91,91,par_rng_118},};
static parse_action_range par114[] = {{SH,217,217,par_rng_12},{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,28,28,par_rng_18},{SH,218,218,par_rng_79},{SH,118,118,par_rng_80},{SH,119,119,par_rng_81},{SH,120,120,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par115[] = {{SH,219,219,par_rng_25},{SH,220,220,par_rng_74},};
static parse_action_range par116[] = {{RD,34,34,par_rng_112},};
static parse_action_range par117[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{RD,40,40,par_rng_25},{SH,105,105,par_rng_72},{SH,221,221,par_rng_73},{RD,40,40,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,28,28,par_rng_18},{SH,222,222,par_rng_80},{SH,223,223,par_rng_81},{SH,224,224,par_rng_82},{SH,121,121,par_rng_20},{SH,225,225,par_rng_83},{SH,123,123,par_rng_84},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},{SH,127,127,par_rng_60},};
static parse_action_range par118[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,28,28,par_rng_18},{SH,226,226,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par119[] = {{RD,89,89,par_rng_111},};
static parse_action_range par120[] = {{RD,88,88,par_rng_111},};
static parse_action_range par121[] = {{RD,94,94,par_rng_111},};
static parse_action_range par122[] = {{RD,44,44,par_rng_25},{SH,227,227,par_rng_73},{RD,44,44,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,228,228,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par123[] = {{RD,123,123,par_rng_115},};
static parse_action_range par124[] = {{RD,95,95,par_rng_111},};
static parse_action_range par125[] = {{RD,96,96,par_rng_111},};
static parse_action_range par126[] = {{RD,97,97,par_rng_111},};
static parse_action_range par127[] = {{RD,127,127,par_rng_115},};
static parse_action_range par128[] = {{RD,1,1,par_rng_11},{SH,208,208,par_rng_70},};
static parse_action_range par129[] = {{RD,29,29,par_rng_119},{SH,70,70,par_rng_50},{SH,71,72,par_rng_51},};
static parse_action_range par130[] = {{RD,29,29,par_rng_119},{SH,72,72,par_rng_52},};
static parse_action_range par131[] = {{SH,229,229,par_rng_21},{SH,230,230,par_rng_57},};
static parse_action_range par132[] = {{RD,26,26,par_rng_49},};
static parse_action_range par133[] = {{SH,134,135,par_rng_120},{SH,231,232,par_rng_91},};
static parse_action_range par134[] = {{RD,200,200,par_rng_121},};
static parse_action_range par135[] = {{RD,201,201,par_rng_122},};
static parse_action_range par136[] = {{SH,233,233,par_rng_21},{SH,234,234,par_rng_123},};
static parse_action_range par137[] = {{RD,194,194,par_rng_124},};
static parse_action_range par138[] = {{SH,235,235,par_rng_125},};
static parse_action_range par139[] = {{RD,196,196,par_rng_122},};
static parse_action_range par140[] = {{RD,197,197,par_rng_122},};
static parse_action_range par141[] = {{RD,184,184,par_rng_58},};
static parse_action_range par142[] = {{RD,186,186,par_rng_25},{SH,75,75,par_rng_62},{RD,186,186,par_rng_57},};
static parse_action_range par143[] = {{RD,186,186,par_rng_126},};
static parse_action_range par144[] = {{SH,236,236,par_rng_25},};
static parse_action_range par145[] = {{RD,83,83,par_rng_47},};
static parse_action_range par146[] = {{SH,237,237,par_rng_21},{SH,238,238,par_rng_123},};
static parse_action_range par147[] = {{RD,100,100,par_rng_124},};
static parse_action_range par148[] = {{RD,106,106,par_rng_124},{SH,239,239,par_rng_48},{SH,240,240,par_rng_127},};
static parse_action_range par149[] = {{RD,110,110,par_rng_128},};
static parse_action_range par150[] = {{RD,107,107,par_rng_128},};
static parse_action_range par151[] = {{RD,108,108,par_rng_128},};
static parse_action_range par152[] = {{RD,109,109,par_rng_128},};
static parse_action_range par153[] = {{SH,241,241,par_rng_12},{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,28,28,par_rng_18},{SH,242,242,par_rng_92},{SH,147,147,par_rng_93},{SH,148,148,par_rng_94},{SH,149,149,par_rng_20},{SH,150,150,par_rng_67},{SH,151,151,par_rng_68},{SH,152,152,par_rng_69},};
static parse_action_range par154[] = {{SH,243,243,par_rng_48},};
static parse_action_range par155[] = {{RD,62,62,par_rng_47},};
static parse_action_range par156[] = {{SH,81,81,par_rng_44},{SH,244,244,par_rng_63},};
static parse_action_range par157[] = {{SH,245,245,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par158[] = {{SH,247,247,par_rng_42},};
static parse_action_range par159[] = {{SH,81,81,par_rng_44},{SH,248,248,par_rng_63},};
static parse_action_range par160[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,249,249,par_rng_129},{SH,28,28,par_rng_18},{SH,250,250,par_rng_79},{SH,118,118,par_rng_80},{SH,119,119,par_rng_81},{SH,120,120,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par161[] = {{SH,18,18,par_rng_29},{SH,251,251,par_rng_62},{SH,44,44,par_rng_18},{SH,252,252,par_rng_40},};
static parse_action_range par162[] = {{SH,253,253,par_rng_25},{SH,156,156,par_rng_95},{SH,254,254,par_rng_96},};
static parse_action_range par163[] = {{RD,70,70,par_rng_47},};
static parse_action_range par164[] = {{SH,255,255,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par165[] = {{SH,256,256,par_rng_42},};
static parse_action_range par166[] = {{SH,81,81,par_rng_44},{SH,257,257,par_rng_63},};
static parse_action_range par167[] = {{SH,258,258,par_rng_25},{SH,156,156,par_rng_95},{SH,259,259,par_rng_96},};
static parse_action_range par168[] = {{SH,16,18,par_rng_13},{SH,260,260,par_rng_25},{SH,28,28,par_rng_18},{SH,261,261,par_rng_20},};
static parse_action_range par169[] = {{RD,117,117,par_rng_130},};
static parse_action_range par170[] = {{RD,156,156,par_rng_27},};
static parse_action_range par171[] = {{RD,154,154,par_rng_131},};
static parse_action_range par172[] = {{SH,262,262,par_rng_12},{SH,171,171,par_rng_98},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,263,263,par_rng_103},{SH,264,265,par_rng_104},{SH,263,263,par_rng_105},{SH,192,192,par_rng_106},};
static parse_action_range par173[] = {{RD,172,172,par_rng_132},};
static parse_action_range par174[] = {{SH,266,266,par_rng_12},{SH,171,171,par_rng_98},{SH,175,185,par_rng_99},{SH,267,267,par_rng_133},{SH,268,268,par_rng_102},{SH,269,269,par_rng_134},{SH,270,270,par_rng_135},};
static parse_action_range par175[] = {{RD,143,143,par_rng_131},};
static parse_action_range par176[] = {{RD,144,144,par_rng_131},};
static parse_action_range par177[] = {{RD,145,145,par_rng_131},};
static parse_action_range par178[] = {{RD,146,146,par_rng_131},};
static parse_action_range par179[] = {{RD,147,147,par_rng_131},};
static parse_action_range par180[] = {{RD,148,148,par_rng_131},};
static parse_action_range par181[] = {{RD,149,149,par_rng_131},};
static parse_action_range par182[] = {{RD,150,150,par_rng_131},};
static parse_action_range par183[] = {{RD,151,151,par_rng_131},};
static parse_action_range par184[] = {{RD,152,152,par_rng_131},};
static parse_action_range par185[] = {{RD,153,153,par_rng_131},};
static parse_action_range par186[] = {{SH,271,271,par_rng_12},{SH,171,171,par_rng_98},{SH,175,185,par_rng_99},{SH,267,267,par_rng_133},{SH,268,268,par_rng_102},{SH,272,272,par_rng_134},{SH,270,270,par_rng_135},};
static parse_action_range par187[] = {{RD,171,171,par_rng_132},};
static parse_action_range par188[] = {{RD,173,173,par_rng_132},};
static parse_action_range par189[] = {{SH,171,171,par_rng_98},{SH,273,273,par_rng_136},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,274,275,par_rng_137},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,276,277,par_rng_138},{SH,186,186,par_rng_100},{SH,278,278,par_rng_139},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par190[] = {{SH,171,171,par_rng_98},{SH,273,273,par_rng_136},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,275,275,par_rng_74},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par191[] = {{SH,273,273,par_rng_136},{SH,275,275,par_rng_74},};
static parse_action_range par192[] = {{RD,174,174,par_rng_132},};
static parse_action_range par193[] = {{RD,158,158,par_rng_27},};
static parse_action_range par194[] = {{SH,171,171,par_rng_98},{SH,280,280,par_rng_136},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,274,275,par_rng_137},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,276,277,par_rng_138},{SH,186,186,par_rng_100},{SH,278,278,par_rng_139},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par195[] = {{SH,171,171,par_rng_98},{SH,280,280,par_rng_136},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,275,275,par_rng_74},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par196[] = {{SH,280,280,par_rng_136},{SH,275,275,par_rng_74},};
static parse_action_range par197[] = {{RD,134,134,par_rng_27},};
static parse_action_range par198[] = {{SH,171,171,par_rng_98},{SH,281,281,par_rng_107},{SH,175,185,par_rng_99},{SH,282,282,par_rng_102},};
static parse_action_range par199[] = {{RD,142,142,par_rng_141},};
static parse_action_range par200[] = {{RD,138,138,par_rng_27},};
static parse_action_range par201[] = {{SH,171,171,par_rng_98},{SH,283,283,par_rng_107},{SH,175,185,par_rng_99},{SH,282,282,par_rng_102},};
static parse_action_range par202[] = {{RD,136,136,par_rng_27},};
static parse_action_range par203[] = {{SH,171,171,par_rng_98},{SH,284,284,par_rng_109},{SH,175,185,par_rng_99},{SH,282,282,par_rng_102},};
static parse_action_range par204[] = {{RD,140,140,par_rng_27},};
static parse_action_range par205[] = {{SH,171,171,par_rng_98},{SH,285,285,par_rng_109},{SH,175,185,par_rng_99},{SH,282,282,par_rng_102},};
static parse_action_range par206[] = {{SH,286,286,par_rng_25},};
static parse_action_range par207[] = {{RD,74,74,par_rng_47},};
static parse_action_range par208[] = {{RD,20,20,par_rng_110},};
static parse_action_range par209[] = {{RD,42,42,par_rng_25},{SH,227,227,par_rng_73},{RD,42,42,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,228,228,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par210[] = {{SH,134,134,par_rng_113},{SH,287,287,par_rng_114},};
static parse_action_range par211[] = {{RD,126,126,par_rng_115},};
static parse_action_range par212[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,288,288,par_rng_40},};
static parse_action_range par213[] = {{RD,129,129,par_rng_115},};
static parse_action_range par214[] = {{SH,289,294,par_rng_142},{SH,295,295,par_rng_143},{SH,296,296,par_rng_144},};
static parse_action_range par215[] = {{SH,214,214,par_rng_116},{SH,297,297,par_rng_117},};
static parse_action_range par216[] = {{RD,131,131,par_rng_115},};
static parse_action_range par217[] = {{RD,93,93,par_rng_111},};
static parse_action_range par218[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,298,298,par_rng_129},{SH,28,28,par_rng_18},{SH,222,222,par_rng_80},{SH,223,223,par_rng_81},{SH,224,224,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par219[] = {{RD,32,32,par_rng_47},};
static parse_action_range par220[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{RD,45,45,par_rng_25},{SH,105,105,par_rng_72},{SH,106,106,par_rng_73},{RD,45,45,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,28,28,par_rng_18},{SH,299,299,par_rng_78},{SH,117,117,par_rng_79},{SH,118,118,par_rng_80},{SH,119,119,par_rng_81},{SH,120,120,par_rng_82},{SH,121,121,par_rng_20},{SH,122,122,par_rng_83},{SH,123,123,par_rng_84},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},{SH,127,127,par_rng_60},};
static parse_action_range par221[] = {{RD,38,38,par_rng_112},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,300,300,par_rng_83},{SH,123,123,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par222[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,28,28,par_rng_18},{SH,301,301,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par223[] = {{RD,86,86,par_rng_111},};
static parse_action_range par224[] = {{RD,85,85,par_rng_111},};
static parse_action_range par225[] = {{RD,39,39,par_rng_25},{SH,227,227,par_rng_73},{RD,39,39,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,228,228,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par226[] = {{RD,87,87,par_rng_111},};
static parse_action_range par227[] = {{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,302,302,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par228[] = {{RD,122,122,par_rng_115},};
static parse_action_range par229[] = {{SH,36,36,par_rng_29},{SH,37,37,par_rng_30},{SH,303,303,par_rng_31},{SH,304,304,par_rng_32},{SH,303,303,par_rng_33},};
static parse_action_range par230[] = {{RD,27,27,par_rng_49},};
static parse_action_range par231[] = {{RD,198,198,par_rng_122},};
static parse_action_range par232[] = {{RD,199,199,par_rng_122},};
static parse_action_range par233[] = {{SH,133,135,par_rng_87},{SH,305,305,par_rng_145},{SH,138,138,par_rng_146},{SH,139,140,par_rng_91},};
static parse_action_range par234[] = {{RD,192,192,par_rng_53},};
static parse_action_range par235[] = {{SH,133,135,par_rng_87},{SH,306,306,par_rng_146},{SH,139,140,par_rng_91},};
static parse_action_range par236[] = {{RD,50,50,par_rng_47},};
static parse_action_range par237[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,28,28,par_rng_18},{SH,307,307,par_rng_93},{SH,148,148,par_rng_94},{SH,149,149,par_rng_20},{SH,150,150,par_rng_67},{SH,151,151,par_rng_68},{SH,152,152,par_rng_69},};
static parse_action_range par238[] = {{SH,308,308,par_rng_12},{SH,309,309,par_rng_25},};
static parse_action_range par239[] = {{RD,105,105,par_rng_124},{SH,310,313,par_rng_147},{SH,314,314,par_rng_148},};
static parse_action_range par240[] = {{SH,315,315,par_rng_29},};
static parse_action_range par241[] = {{RD,82,82,par_rng_47},};
static parse_action_range par242[] = {{SH,237,237,par_rng_21},{SH,316,316,par_rng_123},};
static parse_action_range par243[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,317,317,par_rng_129},{SH,28,28,par_rng_18},{SH,318,318,par_rng_79},{SH,118,118,par_rng_80},{SH,119,119,par_rng_81},{SH,120,120,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par244[] = {{RD,72,72,par_rng_149},};
static parse_action_range par245[] = {{RD,61,61,par_rng_47},};
static parse_action_range par246[] = {{SH,81,81,par_rng_44},{SH,319,319,par_rng_63},};
static parse_action_range par247[] = {{SH,81,81,par_rng_44},{SH,320,320,par_rng_63},};
static parse_action_range par248[] = {{SH,321,321,par_rng_25},{SH,156,156,par_rng_95},{SH,322,322,par_rng_96},};
static parse_action_range par249[] = {{RD,36,36,par_rng_42},};
static parse_action_range par250[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,323,323,par_rng_129},{SH,28,28,par_rng_18},{SH,222,222,par_rng_80},{SH,223,223,par_rng_81},{SH,224,224,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par251[] = {{SH,18,18,par_rng_29},{SH,44,44,par_rng_18},{SH,324,324,par_rng_40},};
static parse_action_range par252[] = {{SH,40,43,par_rng_34},{SH,325,325,par_rng_60},};
static parse_action_range par253[] = {{RD,52,52,par_rng_47},};
static parse_action_range par254[] = {{SH,326,326,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par255[] = {{RD,69,69,par_rng_47},};
static parse_action_range par256[] = {{SH,81,81,par_rng_44},{SH,327,327,par_rng_63},};
static parse_action_range par257[] = {{SH,328,328,par_rng_25},{SH,156,156,par_rng_95},{SH,329,329,par_rng_96},};
static parse_action_range par258[] = {{RD,68,68,par_rng_47},};
static parse_action_range par259[] = {{SH,330,330,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par260[] = {{RD,41,41,par_rng_47},};
static parse_action_range par261[] = {{RD,116,116,par_rng_130},};
static parse_action_range par262[] = {{RD,160,160,par_rng_132},};
static parse_action_range par263[] = {{SH,171,171,par_rng_98},{SH,172,172,par_rng_54},{SH,331,331,par_rng_123},{SH,173,173,par_rng_72},{SH,274,275,par_rng_137},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,276,277,par_rng_138},{SH,186,186,par_rng_100},{SH,278,278,par_rng_139},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par264[] = {{SH,171,171,par_rng_98},{SH,172,172,par_rng_54},{SH,331,331,par_rng_123},{SH,173,173,par_rng_72},{SH,275,275,par_rng_74},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par265[] = {{SH,331,331,par_rng_123},{SH,275,275,par_rng_74},};
static parse_action_range par266[] = {{RD,176,176,par_rng_132},};
static parse_action_range par267[] = {{RD,183,183,par_rng_150},};
static parse_action_range par268[] = {{RD,181,181,par_rng_98},{SH,332,332,par_rng_151},{RD,181,181,par_rng_152},};
static parse_action_range par269[] = {{SH,171,171,par_rng_98},{SH,333,333,par_rng_129},{SH,175,185,par_rng_99},{SH,267,267,par_rng_133},{SH,268,268,par_rng_102},{SH,334,334,par_rng_135},};
static parse_action_range par270[] = {{RD,180,180,par_rng_150},};
static parse_action_range par271[] = {{RD,178,178,par_rng_132},};
static parse_action_range par272[] = {{SH,171,171,par_rng_98},{SH,335,335,par_rng_129},{SH,175,185,par_rng_99},{SH,267,267,par_rng_133},{SH,268,268,par_rng_102},{SH,334,334,par_rng_135},};
static parse_action_range par273[] = {{RD,155,155,par_rng_27},};
static parse_action_range par274[] = {{RD,164,164,par_rng_132},};
static parse_action_range par275[] = {{SH,171,171,par_rng_98},{SH,172,172,par_rng_54},{SH,173,173,par_rng_72},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,336,336,par_rng_103},{SH,337,337,par_rng_153},{SH,336,336,par_rng_105},{SH,192,192,par_rng_106},};
static parse_action_range par276[] = {{RD,163,163,par_rng_132},};
static parse_action_range par277[] = {{RD,165,165,par_rng_132},};
static parse_action_range par278[] = {{SH,338,338,par_rng_12},{SH,339,339,par_rng_21},{SH,134,134,par_rng_113},{SH,340,340,par_rng_114},};
static parse_action_range par279[] = {{RD,161,161,par_rng_154},{SH,274,274,par_rng_73},{RD,161,161,par_rng_155},{SH,276,277,par_rng_138},{RD,161,161,par_rng_100},{SH,278,278,par_rng_139},{RD,161,161,par_rng_101},};
static parse_action_range par280[] = {{RD,157,157,par_rng_27},};
static parse_action_range par281[] = {{RD,133,133,par_rng_27},};
static parse_action_range par282[] = {{RD,141,141,par_rng_141},};
static parse_action_range par283[] = {{RD,137,137,par_rng_27},};
static parse_action_range par284[] = {{RD,135,135,par_rng_27},};
static parse_action_range par285[] = {{RD,139,139,par_rng_27},};
static parse_action_range par286[] = {{RD,73,73,par_rng_47},};
static parse_action_range par287[] = {{RD,125,125,par_rng_115},};
static parse_action_range par288[] = {{RD,128,128,par_rng_115},};
static parse_action_range par289[] = {{RD,203,203,par_rng_115},};
static parse_action_range par290[] = {{RD,206,206,par_rng_142},};
static parse_action_range par291[] = {{RD,207,207,par_rng_142},};
static parse_action_range par292[] = {{RD,208,208,par_rng_142},};
static parse_action_range par293[] = {{RD,209,209,par_rng_142},};
static parse_action_range par294[] = {{RD,210,210,par_rng_142},};
static parse_action_range par295[] = {{SH,341,341,par_rng_156},{SH,290,294,par_rng_157},{SH,342,342,par_rng_144},};
static parse_action_range par296[] = {{RD,205,205,par_rng_142},};
static parse_action_range par297[] = {{RD,130,130,par_rng_115},};
static parse_action_range par298[] = {{RD,92,92,par_rng_111},};
static parse_action_range par299[] = {{RD,33,33,par_rng_112},};
static parse_action_range par300[] = {{RD,37,37,par_rng_25},{SH,227,227,par_rng_73},{RD,37,37,par_rng_74},{SH,107,111,par_rng_75},{SH,40,43,par_rng_34},{SH,228,228,par_rng_84},{SH,127,127,par_rng_60},};
static parse_action_range par301[] = {{RD,84,84,par_rng_111},};
static parse_action_range par302[] = {{RD,121,121,par_rng_115},};
static parse_action_range par303[] = {{RD,28,28,par_rng_119},{SH,70,70,par_rng_50},{SH,71,72,par_rng_51},};
static parse_action_range par304[] = {{RD,28,28,par_rng_119},{SH,72,72,par_rng_52},};
static parse_action_range par305[] = {{RD,193,193,par_rng_124},};
static parse_action_range par306[] = {{RD,195,195,par_rng_124},};
static parse_action_range par307[] = {{RD,99,99,par_rng_124},};
static parse_action_range par308[] = {{RD,81,81,par_rng_47},};
static parse_action_range par309[] = {{RD,79,79,par_rng_47},};
static parse_action_range par310[] = {{SH,18,18,par_rng_29},{SH,50,50,par_rng_18},{SH,343,343,par_rng_41},};
static parse_action_range par311[] = {{RD,112,112,par_rng_124},};
static parse_action_range par312[] = {{SH,18,18,par_rng_29},{SH,50,50,par_rng_18},{SH,344,344,par_rng_41},};
static parse_action_range par313[] = {{RD,113,113,par_rng_124},};
static parse_action_range par314[] = {{RD,104,104,par_rng_124},};
static parse_action_range par315[] = {{RD,103,103,par_rng_124},{SH,345,345,par_rng_48},};
static parse_action_range par316[] = {{SH,346,346,par_rng_12},{SH,347,347,par_rng_25},};
static parse_action_range par317[] = {{RD,31,31,par_rng_149},};
static parse_action_range par318[] = {{SH,92,97,par_rng_65},{SH,16,18,par_rng_13},{SH,105,105,par_rng_72},{SH,112,113,par_rng_76},{SH,114,114,par_rng_44},{SH,348,348,par_rng_129},{SH,28,28,par_rng_18},{SH,222,222,par_rng_80},{SH,223,223,par_rng_81},{SH,224,224,par_rng_82},{SH,121,121,par_rng_20},{SH,124,124,par_rng_67},{SH,125,125,par_rng_68},{SH,126,126,par_rng_69},};
static parse_action_range par319[] = {{RD,71,71,par_rng_149},};
static parse_action_range par320[] = {{SH,349,349,par_rng_25},{SH,156,156,par_rng_95},{SH,350,350,par_rng_96},};
static parse_action_range par321[] = {{RD,60,60,par_rng_47},};
static parse_action_range par322[] = {{SH,351,351,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par323[] = {{RD,35,35,par_rng_42},};
static parse_action_range par324[] = {{SH,40,43,par_rng_34},{SH,352,352,par_rng_60},};
static parse_action_range par325[] = {{SH,353,353,par_rng_25},{SH,156,156,par_rng_95},{SH,354,354,par_rng_96},};
static parse_action_range par326[] = {{RD,51,51,par_rng_47},};
static parse_action_range par327[] = {{SH,355,355,par_rng_25},{SH,156,156,par_rng_95},{SH,356,356,par_rng_96},};
static parse_action_range par328[] = {{RD,66,66,par_rng_47},};
static parse_action_range par329[] = {{SH,357,357,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par330[] = {{RD,67,67,par_rng_47},};
static parse_action_range par331[] = {{RD,159,159,par_rng_132},};
static parse_action_range par332[] = {{SH,171,171,par_rng_98},{SH,175,185,par_rng_99},{SH,358,358,par_rng_102},};
static parse_action_range par333[] = {{RD,175,175,par_rng_132},};
static parse_action_range par334[] = {{RD,179,179,par_rng_150},};
static parse_action_range par335[] = {{RD,177,177,par_rng_132},};
static parse_action_range par336[] = {{SH,171,171,par_rng_98},{RD,162,162,par_rng_136},{SH,172,172,par_rng_54},{RD,162,162,par_rng_123},{SH,173,173,par_rng_72},{SH,274,274,par_rng_73},{RD,162,162,par_rng_74},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,276,277,par_rng_138},{SH,186,186,par_rng_100},{SH,278,278,par_rng_139},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par337[] = {{SH,171,171,par_rng_98},{RD,162,162,par_rng_136},{SH,172,172,par_rng_54},{RD,162,162,par_rng_123},{SH,173,173,par_rng_72},{RD,162,162,par_rng_74},{SH,174,174,par_rng_44},{SH,175,185,par_rng_99},{SH,186,186,par_rng_100},{SH,187,187,par_rng_101},{SH,188,188,par_rng_102},{SH,279,279,par_rng_140},{SH,192,192,par_rng_106},};
static parse_action_range par338[] = {{RD,170,170,par_rng_132},};
static parse_action_range par339[] = {{SH,134,134,par_rng_113},{SH,359,359,par_rng_114},};
static parse_action_range par340[] = {{SH,360,360,par_rng_21},{SH,361,361,par_rng_158},};
static parse_action_range par341[] = {{RD,202,202,par_rng_115},};
static parse_action_range par342[] = {{RD,204,204,par_rng_142},};
static parse_action_range par343[] = {{RD,111,111,par_rng_124},};
static parse_action_range par344[] = {{RD,114,114,par_rng_124},};
static parse_action_range par345[] = {{RD,102,102,par_rng_124},{SH,310,313,par_rng_147},{SH,362,362,par_rng_148},};
static parse_action_range par346[] = {{RD,80,80,par_rng_47},};
static parse_action_range par347[] = {{RD,78,78,par_rng_47},};
static parse_action_range par348[] = {{RD,30,30,par_rng_149},};
static parse_action_range par349[] = {{RD,58,58,par_rng_47},};
static parse_action_range par350[] = {{SH,363,363,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par351[] = {{RD,59,59,par_rng_47},};
static parse_action_range par352[] = {{SH,364,364,par_rng_25},{SH,156,156,par_rng_95},{SH,365,365,par_rng_96},};
static parse_action_range par353[] = {{RD,56,56,par_rng_47},};
static parse_action_range par354[] = {{SH,366,366,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par355[] = {{RD,64,64,par_rng_47},};
static parse_action_range par356[] = {{SH,367,367,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par357[] = {{RD,65,65,par_rng_47},};
static parse_action_range par358[] = {{RD,182,182,par_rng_150},};
static parse_action_range par359[] = {{SH,368,368,par_rng_158},};
static parse_action_range par360[] = {{SH,134,134,par_rng_113},{SH,369,369,par_rng_158},{SH,370,370,par_rng_114},};
static parse_action_range par361[] = {{RD,166,166,par_rng_132},};
static parse_action_range par362[] = {{RD,101,101,par_rng_124},};
static parse_action_range par363[] = {{RD,57,57,par_rng_47},};
static parse_action_range par364[] = {{RD,54,54,par_rng_47},};
static parse_action_range par365[] = {{SH,371,371,par_rng_25},{SH,246,246,par_rng_95},};
static parse_action_range par366[] = {{RD,55,55,par_rng_47},};
static parse_action_range par367[] = {{RD,63,63,par_rng_47},};
static parse_action_range par368[] = {{RD,168,168,par_rng_132},};
static parse_action_range par369[] = {{RD,167,167,par_rng_132},};
static parse_action_range par370[] = {{SH,372,372,par_rng_158},};
static parse_action_range par371[] = {{RD,53,53,par_rng_47},};
static parse_action_range par372[] = {{RD,169,169,par_rng_132},};
static parse_state parse_states[] = {
{SZ(par0),par0},{SZ(par1),par1},{SZ(par2),par2},{SZ(par3),par3},{SZ(par4),par4},
{SZ(par5),par5},{SZ(par6),par6},{SZ(par7),par7},{SZ(par8),par8},{SZ(par9),par9},
{SZ(par10),par10},{SZ(par11),par11},{SZ(par12),par12},{SZ(par13),par13},{SZ(par14),par14},
{SZ(par15),par15},{SZ(par16),par16},{SZ(par17),par17},{SZ(par18),par18},{SZ(par19),par19},
{SZ(par20),par20},{SZ(par21),par21},{SZ(par22),par22},{SZ(par23),par23},{SZ(par24),par24},
{SZ(par25),par25},{SZ(par26),par26},{SZ(par27),par27},{SZ(par28),par28},{SZ(par29),par29},
{SZ(par30),par30},{SZ(par31),par31},{SZ(par32),par32},{SZ(par33),par33},{SZ(par34),par34},
{SZ(par35),par35},{SZ(par36),par36},{SZ(par37),par37},{SZ(par38),par38},{SZ(par39),par39},
{SZ(par40),par40},{SZ(par41),par41},{SZ(par42),par42},{SZ(par43),par43},{SZ(par44),par44},
{SZ(par45),par45},{SZ(par46),par46},{SZ(par47),par47},{SZ(par48),par48},{SZ(par49),par49},
{SZ(par50),par50},{SZ(par51),par51},{SZ(par52),par52},{SZ(par53),par53},{SZ(par54),par54},
{SZ(par55),par55},{SZ(par56),par56},{SZ(par57),par57},{SZ(par58),par58},{SZ(par59),par59},
{SZ(par60),par60},{SZ(par61),par61},{SZ(par62),par62},{SZ(par63),par63},{SZ(par64),par64},
{SZ(par65),par65},{SZ(par66),par66},{SZ(par67),par67},{SZ(par68),par68},{SZ(par69),par69},
{SZ(par70),par70},{SZ(par71),par71},{SZ(par72),par72},{SZ(par73),par73},{SZ(par74),par74},
{SZ(par75),par75},{SZ(par76),par76},{SZ(par77),par77},{SZ(par78),par78},{SZ(par79),par79},
{SZ(par80),par80},{SZ(par81),par81},{SZ(par82),par82},{SZ(par83),par83},{SZ(par84),par84},
{SZ(par85),par85},{SZ(par86),par86},{SZ(par87),par87},{SZ(par88),par88},{SZ(par89),par89},
{SZ(par90),par90},{SZ(par91),par91},{SZ(par92),par92},{SZ(par93),par93},{SZ(par94),par94},
{SZ(par95),par95},{SZ(par96),par96},{SZ(par97),par97},{SZ(par98),par98},{SZ(par99),par99},
{SZ(par100),par100},{SZ(par101),par101},{SZ(par102),par102},{SZ(par103),par103},
{SZ(par104),par104},{SZ(par105),par105},{SZ(par106),par106},{SZ(par107),par107},
{SZ(par108),par108},{SZ(par109),par109},{SZ(par110),par110},{SZ(par111),par111},
{SZ(par112),par112},{SZ(par113),par113},{SZ(par114),par114},{SZ(par115),par115},
{SZ(par116),par116},{SZ(par117),par117},{SZ(par118),par118},{SZ(par119),par119},
{SZ(par120),par120},{SZ(par121),par121},{SZ(par122),par122},{SZ(par123),par123},
{SZ(par124),par124},{SZ(par125),par125},{SZ(par126),par126},{SZ(par127),par127},
{SZ(par128),par128},{SZ(par129),par129},{SZ(par130),par130},{SZ(par131),par131},
{SZ(par132),par132},{SZ(par133),par133},{SZ(par134),par134},{SZ(par135),par135},
{SZ(par136),par136},{SZ(par137),par137},{SZ(par138),par138},{SZ(par139),par139},
{SZ(par140),par140},{SZ(par141),par141},{SZ(par142),par142},{SZ(par143),par143},
{SZ(par144),par144},{SZ(par145),par145},{SZ(par146),par146},{SZ(par147),par147},
{SZ(par148),par148},{SZ(par149),par149},{SZ(par150),par150},{SZ(par151),par151},
{SZ(par152),par152},{SZ(par153),par153},{SZ(par154),par154},{SZ(par155),par155},
{SZ(par156),par156},{SZ(par157),par157},{SZ(par158),par158},{SZ(par159),par159},
{SZ(par160),par160},{SZ(par161),par161},{SZ(par162),par162},{SZ(par163),par163},
{SZ(par164),par164},{SZ(par165),par165},{SZ(par166),par166},{SZ(par167),par167},
{SZ(par168),par168},{SZ(par169),par169},{SZ(par170),par170},{SZ(par171),par171},
{SZ(par172),par172},{SZ(par173),par173},{SZ(par174),par174},{SZ(par175),par175},
{SZ(par176),par176},{SZ(par177),par177},{SZ(par178),par178},{SZ(par179),par179},
{SZ(par180),par180},{SZ(par181),par181},{SZ(par182),par182},{SZ(par183),par183},
{SZ(par184),par184},{SZ(par185),par185},{SZ(par186),par186},{SZ(par187),par187},
{SZ(par188),par188},{SZ(par189),par189},{SZ(par190),par190},{SZ(par191),par191},
{SZ(par192),par192},{SZ(par193),par193},{SZ(par194),par194},{SZ(par195),par195},
{SZ(par196),par196},{SZ(par197),par197},{SZ(par198),par198},{SZ(par199),par199},
{SZ(par200),par200},{SZ(par201),par201},{SZ(par202),par202},{SZ(par203),par203},
{SZ(par204),par204},{SZ(par205),par205},{SZ(par206),par206},{SZ(par207),par207},
{SZ(par208),par208},{SZ(par209),par209},{SZ(par210),par210},{SZ(par211),par211},
{SZ(par212),par212},{SZ(par213),par213},{SZ(par214),par214},{SZ(par215),par215},
{SZ(par216),par216},{SZ(par217),par217},{SZ(par218),par218},{SZ(par219),par219},
{SZ(par220),par220},{SZ(par221),par221},{SZ(par222),par222},{SZ(par223),par223},
{SZ(par224),par224},{SZ(par225),par225},{SZ(par226),par226},{SZ(par227),par227},
{SZ(par228),par228},{SZ(par229),par229},{SZ(par230),par230},{SZ(par231),par231},
{SZ(par232),par232},{SZ(par233),par233},{SZ(par234),par234},{SZ(par235),par235},
{SZ(par236),par236},{SZ(par237),par237},{SZ(par238),par238},{SZ(par239),par239},
{SZ(par240),par240},{SZ(par241),par241},{SZ(par242),par242},{SZ(par243),par243},
{SZ(par244),par244},{SZ(par245),par245},{SZ(par246),par246},{SZ(par247),par247},
{SZ(par248),par248},{SZ(par249),par249},{SZ(par250),par250},{SZ(par251),par251},
{SZ(par252),par252},{SZ(par253),par253},{SZ(par254),par254},{SZ(par255),par255},
{SZ(par256),par256},{SZ(par257),par257},{SZ(par258),par258},{SZ(par259),par259},
{SZ(par260),par260},{SZ(par261),par261},{SZ(par262),par262},{SZ(par263),par263},
{SZ(par264),par264},{SZ(par265),par265},{SZ(par266),par266},{SZ(par267),par267},
{SZ(par268),par268},{SZ(par269),par269},{SZ(par270),par270},{SZ(par271),par271},
{SZ(par272),par272},{SZ(par273),par273},{SZ(par274),par274},{SZ(par275),par275},
{SZ(par276),par276},{SZ(par277),par277},{SZ(par278),par278},{SZ(par279),par279},
{SZ(par280),par280},{SZ(par281),par281},{SZ(par282),par282},{SZ(par283),par283},
{SZ(par284),par284},{SZ(par285),par285},{SZ(par286),par286},{SZ(par287),par287},
{SZ(par288),par288},{SZ(par289),par289},{SZ(par290),par290},{SZ(par291),par291},
{SZ(par292),par292},{SZ(par293),par293},{SZ(par294),par294},{SZ(par295),par295},
{SZ(par296),par296},{SZ(par297),par297},{SZ(par298),par298},{SZ(par299),par299},
{SZ(par300),par300},{SZ(par301),par301},{SZ(par302),par302},{SZ(par303),par303},
{SZ(par304),par304},{SZ(par305),par305},{SZ(par306),par306},{SZ(par307),par307},
{SZ(par308),par308},{SZ(par309),par309},{SZ(par310),par310},{SZ(par311),par311},
{SZ(par312),par312},{SZ(par313),par313},{SZ(par314),par314},{SZ(par315),par315},
{SZ(par316),par316},{SZ(par317),par317},{SZ(par318),par318},{SZ(par319),par319},
{SZ(par320),par320},{SZ(par321),par321},{SZ(par322),par322},{SZ(par323),par323},
{SZ(par324),par324},{SZ(par325),par325},{SZ(par326),par326},{SZ(par327),par327},
{SZ(par328),par328},{SZ(par329),par329},{SZ(par330),par330},{SZ(par331),par331},
{SZ(par332),par332},{SZ(par333),par333},{SZ(par334),par334},{SZ(par335),par335},
{SZ(par336),par336},{SZ(par337),par337},{SZ(par338),par338},{SZ(par339),par339},
{SZ(par340),par340},{SZ(par341),par341},{SZ(par342),par342},{SZ(par343),par343},
{SZ(par344),par344},{SZ(par345),par345},{SZ(par346),par346},{SZ(par347),par347},
{SZ(par348),par348},{SZ(par349),par349},{SZ(par350),par350},{SZ(par351),par351},
{SZ(par352),par352},{SZ(par353),par353},{SZ(par354),par354},{SZ(par355),par355},
{SZ(par356),par356},{SZ(par357),par357},{SZ(par358),par358},{SZ(par359),par359},
{SZ(par360),par360},{SZ(par361),par361},{SZ(par362),par362},{SZ(par363),par363},
{SZ(par364),par364},{SZ(par365),par365},{SZ(par366),par366},{SZ(par367),par367},
{SZ(par368),par368},{SZ(par369),par369},{SZ(par370),par370},{SZ(par371),par371},
{SZ(par372),par372},};

static int brk_INITIAL[] = {0,10,11,37,38,105,106,110,111,112,113,116,117,1114112,
};
static scnitem scn_INITIAL[] = {{0,0,0,0,2},{1,0,2,1,1},{4,0,10,3,14},{15,14,2,1,3},
{18,14,4,3,4},{23,18,5,4,5},{29,0,0,0,6},{30,28,12,1,7},{43,0,0,0,8},{44,42,12,1,14},
{57,23,8,5,9},{66,56,4,4,5},{71,29,13,13,14},{85,57,13,8,7},{99,43,22,22,14},{122,84,15,14,10},
{138,56,7,7,11},{146,122,16,15,12},{163,84,12,12,13},{176,146,20,16,-1},};
static int accepttoks_INITIAL[] = {-1,7,7,-1,-1,-1,5,-1,4,-1,-1,-1,-1,6,};
static int brk_RULES[] = {0,9,10,11,13,14,32,33,34,35,36,37,38,39,40,41,42,43,44,
45,46,47,48,49,58,59,60,61,62,63,64,65,66,69,70,79,80,82,83,84,85,91,92,93,94,95,
96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,
117,118,119,120,121,122,123,124,125,170,171,181,182,186,187,192,215,216,247,248,
706,710,722,736,741,748,749,750,751,880,885,886,888,890,894,902,903,904,907,908,
909,910,930,931,1014,1015,1154,1162,1316,1329,1367,1369,1370,1377,1416,1488,1515,
1520,1523,1569,1611,1632,1642,1646,1648,1649,1748,1749,1750,1765,1767,1774,1776,
1786,1789,1791,1792,1808,1809,1810,1840,1869,1958,1969,1970,1984,1994,2027,2036,
2038,2042,2043,2308,2362,2365,2366,2384,2385,2392,2402,2406,2416,2417,2419,2427,
2432,2437,2445,2447,2449,2451,2473,2474,2481,2482,2483,2486,2490,2493,2494,2510,
2511,2524,2526,2527,2530,2534,2544,2546,2565,2571,2575,2577,2579,2601,2602,2609,
2610,2612,2613,2615,2616,2618,2649,2653,2654,2655,2662,2672,2674,2677,2693,2702,
2703,2706,2707,2729,2730,2737,2738,2740,2741,2746,2749,2750,2768,2769,2784,2786,
2790,2800,2821,2829,2831,2833,2835,2857,2858,2865,2866,2868,2869,2874,2877,2878,
2908,2910,2911,2914,2918,2928,2929,2930,2947,2948,2949,2955,2958,2961,2962,2966,
2969,2971,2972,2973,2974,2976,2979,2981,2984,2987,2990,3002,3024,3025,3046,3056,
3077,3085,3086,3089,3090,3113,3114,3124,3125,3130,3133,3134,3160,3162,3168,3170,
3174,3184,3205,3213,3214,3217,3218,3241,3242,3252,3253,3258,3261,3262,3294,3295,
3296,3298,3302,3312,3333,3341,3342,3345,3346,3369,3370,3386,3389,3390,3424,3426,
3430,3440,3450,3456,3461,3479,3482,3506,3507,3516,3517,3518,3520,3527,3585,3633,
3634,3636,3648,3655,3664,3674,3713,3715,3716,3717,3719,3721,3722,3723,3725,3726,
3732,3736,3737,3744,3745,3748,3749,3750,3751,3752,3754,3756,3757,3761,3762,3764,
3773,3774,3776,3781,3782,3783,3792,3802,3804,3806,3840,3841,3872,3882,3904,3912,
3913,3949,3976,3980,4096,4139,4159,4160,4170,4176,4182,4186,4190,4193,4194,4197,
4199,4206,4209,4213,4226,4238,4239,4240,4250,4256,4294,4304,4347,4348,4349,4352,
4442,4447,4515,4520,4602,4608,4681,4682,4686,4688,4695,4696,4697,4698,4702,4704,
4745,4746,4750,4752,4785,4786,4790,4792,4799,4800,4801,4802,4806,4808,4823,4824,
4881,4882,4886,4888,4955,4992,5008,5024,5109,5121,5741,5743,5751,5761,5787,5792,
5867,5870,5873,5888,5901,5902,5906,5920,5938,5952,5970,5984,5997,5998,6001,6016,
6068,6103,6104,6108,6109,6112,6122,6160,6170,6176,6264,6272,6313,6314,6315,6400,
6429,6470,6480,6510,6512,6517,6528,6570,6593,6600,6608,6618,6656,6679,6917,6964,
6981,6988,6992,7002,7043,7073,7086,7088,7098,7168,7204,7232,7242,7245,7248,7258,
7294,7424,7616,7680,7958,7960,7966,7968,8006,8008,8014,8016,8024,8025,8026,8027,
8028,8029,8030,8031,8062,8064,8117,8118,8125,8126,8127,8130,8133,8134,8141,8144,
8148,8150,8156,8160,8173,8178,8181,8182,8189,8305,8306,8319,8320,8336,8341,8450,
8451,8455,8456,8458,8468,8469,8470,8473,8478,8484,8485,8486,8487,8488,8489,8490,
8494,8495,8506,8508,8512,8517,8522,8526,8527,8544,8579,8581,8585,11264,11311,11312,
11359,11360,11376,11377,11390,11392,11493,11520,11558,11568,11622,11631,11632,11648,
11671,11680,11687,11688,11695,11696,11703,11704,11711,11712,11719,11720,11727,11728,
11735,11736,11743,11823,11824,12293,12295,12296,12321,12330,12337,12342,12344,12347,
12349,12353,12439,12445,12448,12449,12539,12540,12544,12549,12590,12593,12687,12704,
12728,12784,12800,13312,19894,19968,40900,40960,42125,42240,42509,42512,42528,42538,
42540,42560,42592,42594,42607,42623,42648,42775,42784,42786,42889,42891,42893,43003,
43010,43011,43014,43015,43019,43020,43043,43072,43124,43138,43188,43216,43226,43264,
43274,43302,43312,43335,43520,43561,43584,43587,43588,43596,43600,43610,44032,55204,
63744,64046,64048,64107,64112,64218,64256,64263,64275,64280,64285,64286,64287,64297,
64298,64311,64312,64317,64318,64319,64320,64322,64323,64325,64326,64434,64467,64830,
64848,64912,64914,64968,65008,65020,65136,65141,65142,65277,65296,65306,65313,65339,
65345,65371,65382,65471,65474,65480,65482,65488,65490,65496,65498,65501,65536,65548,
65549,65575,65576,65595,65596,65598,65599,65614,65616,65630,65664,65787,65856,65909,
66176,66205,66208,66257,66304,66335,66352,66369,66370,66378,66379,66432,66462,66464,
66500,66504,66512,66513,66518,66560,66718,66720,66730,67584,67590,67592,67593,67594,
67638,67639,67641,67644,67645,67647,67648,67840,67862,67872,67898,68096,68097,68112,
68116,68117,68120,68121,68148,73728,74607,74752,74851,119808,119893,119894,119965,
119966,119968,119970,119971,119973,119975,119977,119981,119982,119994,119995,119996,
119997,120004,120005,120070,120071,120075,120077,120085,120086,120093,120094,120122,
120123,120127,120128,120133,120134,120135,120138,120145,120146,120486,120488,120513,
120514,120539,120540,120571,120572,120597,120598,120629,120630,120655,120656,120687,
120688,120713,120714,120745,120746,120771,120772,120780,120782,120832,131072,173783,
194560,195102,1114112,};
static scnitem scn_RULES[] = {{0,0,0,0,29},{1,0,0,0,1},{2,1,1,1,29},{4,2,4,2,9},
{9,0,0,0,3},{10,3,1,1,4},{12,0,0,0,26},{13,0,0,0,8},{14,0,0,0,10},{15,0,0,0,11},
{16,12,1,1,24},{18,0,0,0,19},{19,0,0,0,14},{20,0,0,0,22},{21,0,0,0,6},{22,0,0,0,16},
{23,0,0,0,15},{24,0,0,0,18},{25,0,0,0,17},{26,0,0,0,12},{27,0,0,0,20},{28,0,0,0,21},
{29,0,1,1,23},{31,0,0,0,13},{32,31,9,1,27},{42,0,0,0,2},{43,0,0,0,28},{44,0,1,1,13},
{46,44,2,2,13},{49,31,6,6,7},{56,31,17,10,5},{74,0,0,0,25},{75,44,53,4,29},{129,75,38,23,29},
{168,75,46,25,29},{215,129,22,21,29},{238,45,3,3,29},{242,238,14,4,29},{257,168,43,26,29},
{301,129,18,17,29},{320,238,12,12,29},{333,168,20,19,29},{354,238,32,18,29},{387,257,6,5,29},
{394,320,10,10,29},{405,242,54,40,13},{460,75,38,37,29},{499,128,11,10,13},{511,168,8,7,29},
{520,394,6,6,29},{527,387,6,6,13},{534,498,11,11,13},{546,460,37,37,13},{584,546,30,30,13},
{615,545,46,39,13},{662,546,54,53,29},{717,393,23,12,13},{741,353,30,29,29},{772,661,38,37,13},
{811,320,44,32,13},{856,546,58,57,29},{915,772,4,4,29},{920,0,0,0,212},{921,0,0,0,30},
{922,921,1,1,212},{924,922,4,2,212},{929,920,33,1,31},{963,928,879,34,33},{1843,920,1,1,32},
{1845,963,915,879,34},{2761,2760,1,1,35},{2763,2760,917,2,212},{3681,929,10,10,36},
{3692,3680,10,10,48},{3703,3702,1,1,212},{3705,3680,6,6,48},{3712,3702,9,2,212},
{3722,3692,3,3,48},{3726,3692,1,1,37},{3728,3702,4,2,45},{3733,0,0,0,39},{3734,3712,1,1,40},
{3736,3712,2,2,42},{3739,3712,1,1,44},{3741,0,0,0,43},{3742,0,0,0,38},{3743,3711,1,1,41},
{3745,0,0,0,47},{3746,0,0,0,46},{3747,3711,6,6,212},{3754,3681,2,2,48},{3757,3681,1,1,48},
{3759,3757,60,2,48},{3820,3758,26,13,212},{3847,3758,54,27,212},{3902,3756,63,63,212},
{3966,3902,117,64,48},{4084,3846,73,28,212},{4158,3757,32,32,48},{4191,3759,20,20,48},
{4212,3759,6,6,48},{4219,4083,77,75,212},{4297,3966,38,38,212},{4336,3705,2,2,48},
{4339,4336,4,3,48},{4344,3757,24,24,48},{4369,4297,58,29,212},{4428,3758,52,52,212},
{4481,3757,18,11,212},{4500,3901,32,31,212},{4533,3902,66,66,212},{4600,929,11,11,49},
{4612,1845,1836,915,52},{6449,3704,4,4,51},{6454,3704,7,7,50},{6462,0,0,0,53},{6463,6462,1,1,212},
{6465,3692,6,6,53},{6472,6462,9,2,212},{6482,3753,3,3,53},{6486,3726,1,1,53},{6488,6471,25,10,212},
{6514,3681,2,2,53},{6517,6486,62,2,53},{6580,6516,26,13,212},{6607,6516,54,27,212},
{6662,6516,63,63,212},{6726,6662,117,64,53},{6844,6517,73,62,212},{6918,6517,32,32,53},
{6951,6517,20,20,53},{6972,6517,6,6,53},{6979,6843,77,75,212},{7057,6662,38,38,212},
{7096,6514,5,4,53},{7102,6517,26,26,53},{7129,6726,58,29,212},{7188,6726,52,52,212},
{7241,6517,18,11,212},{7260,6517,32,31,212},{7293,6662,66,66,212},{7360,4612,3699,1836,56},
{11060,963,13,13,55},{11074,6464,4,4,54},{11079,928,12,12,55},{11092,928,13,13,54},
{11106,1845,876,876,53},{11983,6463,918,918,58},{12902,3680,6,6,57},{12909,1845,913,913,59},
{13823,13822,1,1,212},{13825,4612,917,917,60},{14743,14742,1,1,212},{14745,7360,1839,1839,61},
{16585,7359,7347,3700,62},{23933,6513,3,3,62},{23937,7360,3664,3664,30},{27602,922,1838,1838,212},
{29441,7292,1,1,63},{29443,14744,918,918,30},{30362,922,918,918,34},{31281,2761,930,930,212},
{32212,13825,908,908,64},{33121,33120,1,1,65},{33123,33120,917,2,212},{34041,13825,21,21,48},
{34063,3703,25,24,48},{34089,0,0,0,67},{34090,3712,8,8,68},{34099,34090,6,6,66},
{34106,34099,7,6,212},{34114,3754,859,857,212},{34974,34041,8,8,48},{34983,34063,27,26,48},
{35011,34106,10,7,70},{35022,4368,2,2,71},{35025,3819,2,2,69},{35028,35010,5,5,212},
{35034,34114,904,904,73},{35939,4368,2,2,72},{35942,35011,11,10,212},{35954,34114,899,899,74},
{36854,35942,19,11,212},{36874,35034,893,893,75},{37768,3728,3,3,76},{37772,36854,3,3,77},
{37776,36854,17,17,212},{37794,35954,893,893,78},{38688,35011,3,3,79},{38692,37776,9,9,80},
{38702,35942,922,911,81},{39625,36854,8,8,212},{39634,34114,907,907,82},{40542,38702,919,919,83},
{41462,34982,2,2,84},{41465,39625,916,916,86},{42382,40542,9,9,85},{42392,34063,6,4,48},
{42399,4532,60,60,48},{42460,3820,791,791,212},{43252,3692,35,35,48},{43288,35010,6,6,87},
{43295,36854,18,18,212},{43314,34114,907,907,48},{44222,38702,880,880,212},{45103,7360,3679,3679,53},
{48783,6463,936,936,88},{49720,1845,26,26,88},{49747,12909,890,890,89},{50638,12909,26,26,89},
{50665,45103,2714,2714,90},{53380,14744,922,922,59},{54303,13823,2749,2749,62},{57053,23933,908,908,30},
{57962,922,918,918,64},{58881,33121,941,941,212},{59823,50665,919,919,48},{60743,34983,39,38,48},
{60783,41465,2,2,91},{60786,34106,920,915,92},{61707,43287,6,6,212},{61714,39634,904,904,93},
{62619,43295,14,14,212},{62634,43314,911,911,94},{63546,60786,916,916,95},{64463,35010,10,10,212},
{64474,62634,901,901,96},{65376,37776,928,911,48},{66305,34106,1,1,97},{66307,61707,914,911,98},
{67222,40542,918,918,99},{68141,44221,883,881,212},{69025,3705,22,22,48},{69048,37776,12,12,100},
{69061,68141,915,915,101},{69977,67222,8,8,102},{69986,63546,907,907,103},{70894,36854,914,913,104},
{71809,70894,24,19,212},{71834,62634,898,898,105},{72733,70894,20,19,212},{72754,34114,906,906,106},
{73661,68141,909,909,107},{74571,71809,22,22,212},{74594,34114,906,906,108},{75501,68141,923,919,109},
{76425,39625,916,916,110},{77342,38702,920,920,111},{78263,64463,914,912,112},{79178,37776,15,15,212},
{79194,34114,907,907,113},{80102,44222,889,889,114},{80992,29443,15,15,114},{81008,29443,909,909,115},
{81918,29443,26,26,115},{81945,14744,1797,1797,48},{83743,34983,38,38,116},{83782,77342,913,913,117},
{84696,65376,925,925,118},{85622,77342,912,912,119},{86535,43295,1809,1807,212},
{88345,69025,35,35,48},{88381,0,0,0,120},{88382,40542,919,919,121},{89302,88382,906,906,122},
{90209,71809,932,923,123},{91142,88382,915,915,124},{92058,79178,913,913,125},{92972,90209,21,21,212},
{92994,39634,907,907,126},{93902,67222,912,912,127},{94815,86535,916,916,128},{95732,92972,934,929,129},
{96667,66307,906,906,130},{97574,70894,917,914,131},{98492,92972,915,915,132},{99408,71809,25,24,212},
{99434,34114,894,894,133},{100329,90209,930,930,134},{101260,92972,13,13,212},{101274,39634,897,897,135},
{102172,98492,887,887,137},{103060,39634,3,3,48},{103064,69024,27,27,136},{103092,0,0,0,138},
{103093,102172,20,20,212},{103114,79194,907,907,48},{104022,102172,2,2,139},{104025,104021,8,3,212},
{104034,79194,870,868,212},{104905,11092,12,12,140},{104918,1845,26,26,140},{104945,1845,890,890,141},
{105836,1845,25,25,141},{105862,1845,880,880,48},{106743,83743,26,26,142},{106770,69047,23,13,212},
{106794,43314,907,907,143},{107702,38702,927,922,144},{108630,69047,3,3,212},{108634,43314,1788,1788,48},
{110423,60743,41,41,145},{110465,41465,924,916,48},{111390,108630,897,897,146},{112288,99408,936,920,147},
{113225,110465,1824,1822,148},{115050,112288,23,23,212},{115074,74594,904,904,149},
{115979,62619,927,926,150},{116907,66307,911,911,151},{117819,115979,934,927,212},
{118754,108634,1830,1830,152},{120585,110465,920,920,153},{121506,60786,909,909,154},
{122416,65376,937,930,212},{123354,108634,1826,1826,155},{125181,44221,911,911,156},
{126093,12909,889,889,48},{126983,110423,41,41,157},{127025,113225,921,921,158},
{127947,61707,875,875,212},{128823,81008,16,16,159},{128840,81008,26,26,159},{128867,81008,890,890,160},
{129758,81008,26,26,160},{129785,81008,877,877,48},{130663,60743,43,42,48},{130707,66307,913,913,161},
{131621,75501,932,923,212},{132554,115074,901,901,162},{133456,84696,922,922,163},
{134379,117819,912,912,164},{135292,95732,934,934,165},{136227,66307,920,914,48},
{137148,0,0,0,166},{137149,74571,4,4,212},{137154,118754,1830,1830,48},{138985,120585,906,906,167},
{139892,95732,933,933,168},{140826,69986,904,904,169},{141731,135292,22,21,212},
{141754,35034,865,865,137},{142620,35034,3,3,48},{142624,69024,28,28,138},{142653,103093,889,889,212},
{143543,32211,41,41,170},{143585,129785,902,902,171},{144488,92972,25,21,212},{144514,43314,1794,1794,172},
{146309,81945,919,919,173},{147229,81945,913,913,48},{148143,130663,958,957,48},
{149102,139892,4,4,174},{149107,136227,926,921,212},{150034,137154,2733,2733,175},
{152768,98492,25,21,212},{152794,103114,896,896,176},{153691,152768,22,22,212},{153714,103114,907,907,177},
{154622,107702,931,927,212},{155554,103114,870,868,212},{156425,105836,22,22,178},
{156448,81008,894,894,48},{157343,60743,30,30,179},{157374,97574,888,888,212},{158263,23937,1839,1839,48},
{160103,110423,32,32,180},{160136,84696,912,912,181},{161049,142653,24,20,212},{161074,153714,865,865,182},
{161940,103060,31,31,48},{161972,95732,917,917,183},{162890,144488,23,23,212},{162914,155554,895,893,212},
{163810,7095,3,3,184},{163814,147229,888,888,48},{164703,83743,36,36,185},{164740,101260,911,911,186},
{165652,161971,21,21,212},{165674,103114,904,904,187},{166579,117819,883,883,212},
{167463,147229,43,43,188},{167507,147229,875,875,48},{168383,148143,919,919,212},
{169303,147229,36,36,189},{169340,81008,882,882,48},{170223,160103,28,28,190},{170252,161971,21,21,212},
{170274,103114,910,910,48},{171185,0,0,0,191},{171186,34106,905,905,192},{172092,165652,890,890,212},
{172983,81008,38,38,193},{173022,81008,909,909,194},{173932,173022,890,890,48},{174823,148143,37,37,195},
{174861,131621,1824,1824,196},{176686,4191,2,2,48},{176689,152768,24,24,212},{176714,162914,901,899,212},
{177616,4336,1,1,197},{177618,4612,922,922,198},{178541,173022,881,881,48},{179423,148143,43,43,199},
{179467,61707,902,902,200},{180370,172092,23,21,212},{180394,176714,897,897,201},
{181292,81945,934,934,202},{182227,167507,1795,1795,48},{184023,110423,38,38,203},
{184062,44222,918,918,204},{184981,50665,1801,1801,48},{186783,110423,37,37,205},
{186821,44221,924,924,206},{187746,12909,876,876,48},{188623,126983,29,29,207},{188653,176688,20,20,212},
{188674,176714,905,903,212},{189580,169340,911,911,48},{190492,86535,6,6,208},{190499,115979,916,916,209},
{191416,65376,913,913,210},{192330,161971,23,22,212},{192354,170274,911,911,48},
{193266,0,0,0,211},{193267,3747,864,864,212},{194132,143542,10,10,48},{194143,168383,897,897,-1},
};
static int accepttoks_RULES[] = {-1,13,7,7,7,7,16,26,18,20,22,23,37,26,27,28,29,
33,34,10,35,36,38,39,40,41,43,68,69,7,13,-1,-1,13,-1,14,-1,70,70,70,70,70,70,70,
70,70,70,70,70,15,17,19,21,26,-1,-1,31,30,-1,28,29,42,43,13,-1,4,44,70,70,70,70,
70,70,70,70,70,70,70,70,70,70,70,70,70,70,70,70,70,-1,-1,32,70,70,70,70,46,70,70,
70,70,70,70,70,70,70,70,70,70,60,70,70,70,70,70,-1,-1,70,70,70,45,70,47,70,70,49,
70,70,70,70,58,66,70,70,70,64,63,70,-1,70,70,-1,-1,56,70,62,70,70,70,70,70,59,51,
70,70,70,70,-1,70,65,-1,-1,52,70,54,48,50,70,70,70,61,-1,70,24,25,70,70,70,70,-1,
67,70,70,-1,60,67,70,70,70,-1,-1,70,55,70,-1,-1,70,70,-1,-1,67,70,-1,67,70,-1,70,
57,70,70,70,70,53,};
static int brk_OPTION[] = {0,9,10,11,13,14,32,33,44,45,46,47,48,58,61,62,65,91,95,
96,97,123,170,171,181,182,186,187,192,215,216,247,248,706,710,722,736,741,748,749,
750,751,880,885,886,888,890,894,902,903,904,907,908,909,910,930,931,1014,1015,1154,
1162,1316,1329,1367,1369,1370,1377,1416,1488,1515,1520,1523,1569,1611,1632,1642,
1646,1648,1649,1748,1749,1750,1765,1767,1774,1776,1786,1789,1791,1792,1808,1809,
1810,1840,1869,1958,1969,1970,1984,1994,2027,2036,2038,2042,2043,2308,2362,2365,
2366,2384,2385,2392,2402,2406,2416,2417,2419,2427,2432,2437,2445,2447,2449,2451,
2473,2474,2481,2482,2483,2486,2490,2493,2494,2510,2511,2524,2526,2527,2530,2534,
2544,2546,2565,2571,2575,2577,2579,2601,2602,2609,2610,2612,2613,2615,2616,2618,
2649,2653,2654,2655,2662,2672,2674,2677,2693,2702,2703,2706,2707,2729,2730,2737,
2738,2740,2741,2746,2749,2750,2768,2769,2784,2786,2790,2800,2821,2829,2831,2833,
2835,2857,2858,2865,2866,2868,2869,2874,2877,2878,2908,2910,2911,2914,2918,2928,
2929,2930,2947,2948,2949,2955,2958,2961,2962,2966,2969,2971,2972,2973,2974,2976,
2979,2981,2984,2987,2990,3002,3024,3025,3046,3056,3077,3085,3086,3089,3090,3113,
3114,3124,3125,3130,3133,3134,3160,3162,3168,3170,3174,3184,3205,3213,3214,3217,
3218,3241,3242,3252,3253,3258,3261,3262,3294,3295,3296,3298,3302,3312,3333,3341,
3342,3345,3346,3369,3370,3386,3389,3390,3424,3426,3430,3440,3450,3456,3461,3479,
3482,3506,3507,3516,3517,3518,3520,3527,3585,3633,3634,3636,3648,3655,3664,3674,
3713,3715,3716,3717,3719,3721,3722,3723,3725,3726,3732,3736,3737,3744,3745,3748,
3749,3750,3751,3752,3754,3756,3757,3761,3762,3764,3773,3774,3776,3781,3782,3783,
3792,3802,3804,3806,3840,3841,3872,3882,3904,3912,3913,3949,3976,3980,4096,4139,
4159,4160,4170,4176,4182,4186,4190,4193,4194,4197,4199,4206,4209,4213,4226,4238,
4239,4240,4250,4256,4294,4304,4347,4348,4349,4352,4442,4447,4515,4520,4602,4608,
4681,4682,4686,4688,4695,4696,4697,4698,4702,4704,4745,4746,4750,4752,4785,4786,
4790,4792,4799,4800,4801,4802,4806,4808,4823,4824,4881,4882,4886,4888,4955,4992,
5008,5024,5109,5121,5741,5743,5751,5761,5787,5792,5867,5870,5873,5888,5901,5902,
5906,5920,5938,5952,5970,5984,5997,5998,6001,6016,6068,6103,6104,6108,6109,6112,
6122,6160,6170,6176,6264,6272,6313,6314,6315,6400,6429,6470,6480,6510,6512,6517,
6528,6570,6593,6600,6608,6618,6656,6679,6917,6964,6981,6988,6992,7002,7043,7073,
7086,7088,7098,7168,7204,7232,7242,7245,7248,7258,7294,7424,7616,7680,7958,7960,
7966,7968,8006,8008,8014,8016,8024,8025,8026,8027,8028,8029,8030,8031,8062,8064,
8117,8118,8125,8126,8127,8130,8133,8134,8141,8144,8148,8150,8156,8160,8173,8178,
8181,8182,8189,8305,8306,8319,8320,8336,8341,8450,8451,8455,8456,8458,8468,8469,
8470,8473,8478,8484,8485,8486,8487,8488,8489,8490,8494,8495,8506,8508,8512,8517,
8522,8526,8527,8544,8579,8581,8585,11264,11311,11312,11359,11360,11376,11377,11390,
11392,11493,11520,11558,11568,11622,11631,11632,11648,11671,11680,11687,11688,11695,
11696,11703,11704,11711,11712,11719,11720,11727,11728,11735,11736,11743,11823,11824,
12293,12295,12296,12321,12330,12337,12342,12344,12347,12349,12353,12439,12445,12448,
12449,12539,12540,12544,12549,12590,12593,12687,12704,12728,12784,12800,13312,19894,
19968,40900,40960,42125,42240,42509,42512,42528,42538,42540,42560,42592,42594,42607,
42623,42648,42775,42784,42786,42889,42891,42893,43003,43010,43011,43014,43015,43019,
43020,43043,43072,43124,43138,43188,43216,43226,43264,43274,43302,43312,43335,43520,
43561,43584,43587,43588,43596,43600,43610,44032,55204,63744,64046,64048,64107,64112,
64218,64256,64263,64275,64280,64285,64286,64287,64297,64298,64311,64312,64317,64318,
64319,64320,64322,64323,64325,64326,64434,64467,64830,64848,64912,64914,64968,65008,
65020,65136,65141,65142,65277,65296,65306,65313,65339,65345,65371,65382,65471,65474,
65480,65482,65488,65490,65496,65498,65501,65536,65548,65549,65575,65576,65595,65596,
65598,65599,65614,65616,65630,65664,65787,65856,65909,66176,66205,66208,66257,66304,
66335,66352,66369,66370,66378,66379,66432,66462,66464,66500,66504,66512,66513,66518,
66560,66718,66720,66730,67584,67590,67592,67593,67594,67638,67639,67641,67644,67645,
67647,67648,67840,67862,67872,67898,68096,68097,68112,68116,68117,68120,68121,68148,
73728,74607,74752,74851,119808,119893,119894,119965,119966,119968,119970,119971,
119973,119975,119977,119981,119982,119994,119995,119996,119997,120004,120005,120070,
120071,120075,120077,120085,120086,120093,120094,120122,120123,120127,120128,120133,
120134,120135,120138,120145,120146,120486,120488,120513,120514,120539,120540,120571,
120572,120597,120598,120629,120630,120655,120656,120687,120688,120713,120714,120745,
120746,120771,120772,120780,120782,120832,131072,173783,194560,195102,};
static scnitem scn_OPTION[] = {{0,0,0,0,9},{1,0,0,0,1},{2,0,0,0,6},{3,0,5,2,3},{9,0,2,1,4},
{12,9,2,2,5},{15,3,1,1,2},{17,15,57,2,9},{75,15,38,23,9},{114,15,46,25,9},{161,75,22,21,9},
{184,16,18,18,9},{203,114,43,26,9},{247,17,18,17,9},{266,184,12,12,9},{279,183,45,45,2},
{325,114,8,7,9},{334,184,4,4,9},{339,203,22,11,2},{362,203,4,3,9},{367,184,76,18,9},
{444,278,3,2,2},{448,325,8,8,2},{457,325,13,13,2},{471,444,8,7,2},{480,444,11,11,2},
{492,203,25,25,2},{518,114,25,25,2},{544,17,16,16,2},{561,491,46,39,2},{608,366,54,53,9},
{663,339,23,12,2},{687,15,30,29,9},{718,367,38,37,2},{757,266,44,32,2},{802,17,64,63,1},
{867,246,2,2,1},{870,3,4,3,9},{875,443,864,4,7},{1740,246,2,2,7},{1743,480,3,3,7},
{1747,492,1,1,7},{1749,1747,66,2,7},{1816,1748,26,13,9},{1843,1748,54,27,9},{1898,1746,69,69,9},
{1968,1898,111,70,7},{2080,1897,74,73,9},{2155,1746,52,31,7},{2208,1749,6,6,7},{2215,2079,77,75,9},
{2293,1746,38,38,9},{2332,1740,5,5,7},{2338,1749,26,26,7},{2365,1746,58,29,9},{2424,1746,52,52,9},
{2477,1749,18,11,9},{2496,1967,32,31,9},{2529,1898,66,66,9},{2596,874,873,865,8},
{3470,443,4,4,5},{3475,2596,2589,873,7},{6065,1740,864,864,8},{6930,3470,855,855,-1},
};
static int accepttoks_OPTION[] = {-1,8,9,10,-1,11,12,9,-1,};
static int brk_FINAL[] = {0,10,11,1114112,};
static scnitem scn_FINAL[] = {{0,0,0,0,1},{1,0,0,0,2},{2,0,2,1,3},{5,0,0,0,4},{6,4,2,1,5},
{9,8,3,1,3},{13,5,7,7,-1},};
static int accepttoks_FINAL[] = {-1,7,95,-1,95,};
static int brk_RAWCODE[] = {0,10,11,34,35,37,38,39,40,42,43,47,48,92,93,125,126,
1114112,};
static scnitem scn_RAWCODE[] = {{0,0,0,0,5},{1,0,2,1,3},{4,1,1,1,1},{6,4,1,1,4},
{8,0,3,3,2},{12,8,6,3,7},{19,18,14,1,6},{34,19,2,2,10},{37,36,8,1,8},{46,37,1,1,9},
{48,37,6,6,11},{55,54,2,1,13},{58,54,9,3,12},{68,58,4,4,14},{73,72,6,1,16},{80,73,5,5,15},
{86,73,4,4,17},{91,90,2,1,28},{94,90,1,1,19},{96,90,1,1,28},{98,90,3,3,18},{102,98,6,3,28},
{109,108,17,1,17},{127,91,17,17,20},{145,144,8,1,21},{154,144,3,3,28},{158,144,4,4,22},
{163,0,0,0,23},{164,162,16,1,17},{181,127,17,17,11},{199,55,17,17,24},{217,216,17,1,28},
{235,109,17,17,14},{253,73,17,17,25},{271,270,17,1,28},{289,109,35,35,10},{325,37,8,8,28},
{334,46,1,1,28},{336,48,6,6,7},{343,18,14,14,28},{358,18,2,2,20},{361,145,17,17,26},
{379,378,8,1,21},{388,379,1,1,27},{390,379,6,6,22},{397,163,17,17,28},{415,289,17,17,11},
{433,55,35,35,20},{469,361,17,17,28},{487,288,17,17,-1},};
static int accepttoks_RAWCODE[] = {-1,7,7,7,7,76,71,76,-1,-1,76,-1,-1,74,-1,-1,75,
76,-1,-1,-1,-1,-1,73,-1,-1,-1,72,};
static int brk_REGEX[] = {0,40,41,42,43,44,46,47,48,56,58,63,64,65,71,85,86,88,89,
91,92,93,94,95,96,97,98,99,102,103,110,111,114,115,116,117,118,119,120,121,123,124,
125,126,170,171,181,182,186,187,192,215,216,247,248,706,710,722,736,741,748,749,
750,751,880,885,886,888,890,894,902,903,904,907,908,909,910,930,931,1014,1015,1154,
1162,1316,1329,1367,1369,1370,1377,1416,1488,1515,1520,1523,1569,1611,1632,1642,
1646,1648,1649,1748,1749,1750,1765,1767,1774,1776,1786,1789,1791,1792,1808,1809,
1810,1840,1869,1958,1969,1970,1984,1994,2027,2036,2038,2042,2043,2308,2362,2365,
2366,2384,2385,2392,2402,2406,2416,2417,2419,2427,2432,2437,2445,2447,2449,2451,
2473,2474,2481,2482,2483,2486,2490,2493,2494,2510,2511,2524,2526,2527,2530,2534,
2544,2546,2565,2571,2575,2577,2579,2601,2602,2609,2610,2612,2613,2615,2616,2618,
2649,2653,2654,2655,2662,2672,2674,2677,2693,2702,2703,2706,2707,2729,2730,2737,
2738,2740,2741,2746,2749,2750,2768,2769,2784,2786,2790,2800,2821,2829,2831,2833,
2835,2857,2858,2865,2866,2868,2869,2874,2877,2878,2908,2910,2911,2914,2918,2928,
2929,2930,2947,2948,2949,2955,2958,2961,2962,2966,2969,2971,2972,2973,2974,2976,
2979,2981,2984,2987,2990,3002,3024,3025,3046,3056,3077,3085,3086,3089,3090,3113,
3114,3124,3125,3130,3133,3134,3160,3162,3168,3170,3174,3184,3205,3213,3214,3217,
3218,3241,3242,3252,3253,3258,3261,3262,3294,3295,3296,3298,3302,3312,3333,3341,
3342,3345,3346,3369,3370,3386,3389,3390,3424,3426,3430,3440,3450,3456,3461,3479,
3482,3506,3507,3516,3517,3518,3520,3527,3585,3633,3634,3636,3648,3655,3664,3674,
3713,3715,3716,3717,3719,3721,3722,3723,3725,3726,3732,3736,3737,3744,3745,3748,
3749,3750,3751,3752,3754,3756,3757,3761,3762,3764,3773,3774,3776,3781,3782,3783,
3792,3802,3804,3806,3840,3841,3872,3882,3904,3912,3913,3949,3976,3980,4096,4139,
4159,4160,4170,4176,4182,4186,4190,4193,4194,4197,4199,4206,4209,4213,4226,4238,
4239,4240,4250,4256,4294,4304,4347,4348,4349,4352,4442,4447,4515,4520,4602,4608,
4681,4682,4686,4688,4695,4696,4697,4698,4702,4704,4745,4746,4750,4752,4785,4786,
4790,4792,4799,4800,4801,4802,4806,4808,4823,4824,4881,4882,4886,4888,4955,4992,
5008,5024,5109,5121,5741,5743,5751,5761,5787,5792,5867,5870,5873,5888,5901,5902,
5906,5920,5938,5952,5970,5984,5997,5998,6001,6016,6068,6103,6104,6108,6109,6112,
6122,6160,6170,6176,6264,6272,6313,6314,6315,6400,6429,6470,6480,6510,6512,6517,
6528,6570,6593,6600,6608,6618,6656,6679,6917,6964,6981,6988,6992,7002,7043,7073,
7086,7088,7098,7168,7204,7232,7242,7245,7248,7258,7294,7424,7616,7680,7958,7960,
7966,7968,8006,8008,8014,8016,8024,8025,8026,8027,8028,8029,8030,8031,8062,8064,
8117,8118,8125,8126,8127,8130,8133,8134,8141,8144,8148,8150,8156,8160,8173,8178,
8181,8182,8189,8305,8306,8319,8320,8336,8341,8450,8451,8455,8456,8458,8468,8469,
8470,8473,8478,8484,8485,8486,8487,8488,8489,8490,8494,8495,8506,8508,8512,8517,
8522,8526,8527,8544,8579,8581,8585,11264,11311,11312,11359,11360,11376,11377,11390,
11392,11493,11520,11558,11568,11622,11631,11632,11648,11671,11680,11687,11688,11695,
11696,11703,11704,11711,11712,11719,11720,11727,11728,11735,11736,11743,11823,11824,
12293,12295,12296,12321,12330,12337,12342,12344,12347,12349,12353,12439,12445,12448,
12449,12539,12540,12544,12549,12590,12593,12687,12704,12728,12784,12800,13312,19894,
19968,40900,40960,42125,42240,42509,42512,42528,42538,42540,42560,42592,42594,42607,
42623,42648,42775,42784,42786,42889,42891,42893,43003,43010,43011,43014,43015,43019,
43020,43043,43072,43124,43138,43188,43216,43226,43264,43274,43302,43312,43335,43520,
43561,43584,43587,43588,43596,43600,43610,44032,55204,63744,64046,64048,64107,64112,
64218,64256,64263,64275,64280,64285,64286,64287,64297,64298,64311,64312,64317,64318,
64319,64320,64322,64323,64325,64326,64434,64467,64830,64848,64912,64914,64968,65008,
65020,65136,65141,65142,65277,65296,65306,65313,65319,65339,65345,65351,65371,65382,
65471,65474,65480,65482,65488,65490,65496,65498,65501,65536,65548,65549,65575,65576,
65595,65596,65598,65599,65614,65616,65630,65664,65787,65856,65909,66176,66205,66208,
66257,66304,66335,66352,66369,66370,66378,66379,66432,66462,66464,66500,66504,66512,
66513,66518,66560,66718,66720,66730,67584,67590,67592,67593,67594,67638,67639,67641,
67644,67645,67647,67648,67840,67862,67872,67898,68096,68097,68112,68116,68117,68120,
68121,68148,73728,74607,74752,74851,119808,119893,119894,119965,119966,119968,119970,
119971,119973,119975,119977,119981,119982,119994,119995,119996,119997,120004,120005,
120070,120071,120075,120077,120085,120086,120093,120094,120122,120123,120127,120128,
120133,120134,120135,120138,120145,120146,120486,120488,120513,120514,120539,120540,
120571,120572,120597,120598,120629,120630,120655,120656,120687,120688,120713,120714,
120745,120746,120771,120772,120780,120782,120832,131072,173783,194560,195102,1114112,
};
static scnitem scn_REGEX[] = {{0,0,0,0,12},{1,0,0,0,4},{2,0,0,0,5},{3,0,0,0,7},{4,0,0,0,8},
{5,0,1,1,3},{7,0,0,0,1},{8,5,3,1,9},{12,8,7,3,10},{20,0,0,0,2},{21,12,19,7,11},{41,0,0,0,6},
{42,21,848,19,40},{891,890,889,1,23},{1781,1780,7,1,20},{1789,1780,6,6,22},{1796,1781,1,1,21},
{1798,1781,7,7,13},{1806,0,0,0,14},{1807,1781,1,1,18},{1809,1807,1,1,16},{1811,1809,1,1,19},
{1813,1807,1,1,15},{1815,1795,1,1,17},{1817,1796,10,9,23},{1828,1780,842,8,40},{2671,890,6251,890,24},
{8923,2670,880,880,25},{9804,9803,5,1,40},{9810,2671,3,3,25},{9814,9810,1,1,25},
{9816,9803,14,6,40},{9831,9810,7,6,25},{9839,9810,1,1,25},{9841,9839,45,2,40},{9887,9839,38,23,40},
{9926,9839,46,25,40},{9973,9926,22,21,40},{9996,9840,18,18,40},{10015,9841,26,25,40},
{10042,9996,16,16,40},{10059,9887,18,17,40},{10078,9838,12,12,40},{10091,9995,45,45,25},
{10137,10041,8,7,40},{10146,10042,4,4,40},{10151,10015,22,11,25},{10174,10145,4,3,40},
{10179,9838,76,48,40},{10256,9831,12,11,25},{10269,9925,1,1,25},{10271,10145,14,13,40},
{10286,10146,7,5,40},{10294,10269,7,7,25},{10302,10294,70,8,25},{10373,9840,46,39,25},
{10420,10302,54,53,40},{10475,10151,23,12,25},{10499,10420,30,29,40},{10530,10372,5,4,40},
{10536,9840,34,33,25},{10571,10078,44,32,25},{10616,10294,58,57,40},{10675,10173,6,6,40},
{10682,2671,7126,6251,26},{17809,2670,889,889,27},{18699,18698,1,1,40},{18701,8923,2,2,27},
{18704,8923,11,11,27},{18716,18698,3,2,40},{18720,2670,708,708,27},{19429,10077,1,1,27},
{19431,18701,16,14,40},{19448,18719,140,140,28},{19589,19588,1,1,40},{19591,19431,2,2,28},
{19594,18719,11,11,28},{19606,19588,3,2,40},{19610,18720,708,708,28},{20319,9925,1,1,28},
{20321,19591,16,14,40},{20338,2670,1920,1920,29},{22259,22258,1,1,40},{22261,9886,2,2,29},
{22264,22258,5,2,40},{22270,9831,3,3,29},{22274,9972,1,1,29},{22276,22263,14,6,40},
{22291,9972,1,1,30},{22293,22274,64,2,29},{22358,22273,3,3,40},{22362,22358,9,4,29},
{22372,22274,40,2,29},{22413,22274,208,2,29},{22622,22274,73,2,40},{22696,22361,32,10,29},
{22729,22696,20,20,29},{22750,22413,6,6,29},{22757,22621,77,75,40},{22835,22621,38,38,40},
{22874,22261,7,3,29},{22882,22293,24,24,29},{22907,22757,58,29,40},{22966,22881,26,26,40},
{22993,22756,27,27,40},{23021,22882,18,11,40},{23040,22372,32,31,40},{23073,22412,66,66,40},
{23140,19610,8,8,31},{23149,20337,889,889,32},{24039,24038,1,1,40},{24041,9810,2,2,32},
{24044,19610,11,11,32},{24056,24038,3,2,40},{24060,19610,708,708,32},{24769,22413,1,1,32},
{24771,24041,16,14,40},{24788,24060,140,140,33},{24929,24928,1,1,40},{24931,9886,2,2,33},
{24934,24060,11,11,33},{24946,24928,3,2,40},{24950,24060,708,708,33},{25659,9972,1,1,33},
{25661,24931,16,14,40},{25678,24950,140,140,29},{25819,22259,889,889,40},{26709,10682,2669,2669,34},
{29379,29378,1,1,40},{29381,10150,2,2,34},{29384,19609,11,11,34},{29396,29378,3,2,40},
{29400,19609,708,708,34},{30109,9830,1,1,34},{30111,9830,2,2,34},{30114,18719,154,154,35},
{30269,30268,1,1,40},{30271,19594,2,2,35},{30274,19594,11,11,35},{30286,30268,3,2,40},
{30290,19609,708,708,35},{30999,9926,1,1,35},{31001,30271,16,14,40},{31018,19609,140,140,36},
{31159,31158,1,1,40},{31161,29384,2,2,36},{31164,29384,11,11,36},{31176,31158,3,2,40},
{31180,19609,708,708,36},{31889,10475,1,1,36},{31891,31161,16,14,40},{31908,19609,140,140,37},
{32049,32048,1,1,40},{32051,19448,2,2,37},{32054,19448,11,11,37},{32066,32048,3,2,40},
{32070,19609,708,708,37},{32779,23040,1,1,37},{32781,32051,16,14,40},{32798,25678,140,140,38},
{32939,32938,1,1,40},{32941,24788,2,2,38},{32944,24788,11,11,38},{32956,32938,3,2,40},
{32960,19609,708,708,38},{33669,31889,1,1,38},{33671,32941,16,14,40},{33688,31018,140,140,39},
{33829,33828,1,1,40},{33831,18701,2,2,39},{33834,31908,11,11,39},{33846,33828,3,2,40},
{33850,19609,708,708,39},{34559,33849,1,1,39},{34561,33849,2,2,39},{34564,2670,1036,1036,-1},
};
static int accepttoks_REGEX[] = {-1,16,7,38,22,23,41,88,40,89,68,91,7,77,78,79,80,
81,82,83,84,87,87,87,90,-1,84,85,86,-1,92,84,85,86,86,86,86,86,86,86,};
static int brk_SQUOTED[] = {0,39,40,48,56,58,65,71,85,86,88,89,92,93,97,98,99,102,
103,110,111,114,115,116,117,118,119,120,121,65296,65306,65313,65319,65345,65351,
1114112,};
static scnitem scn_SQUOTED[] = {{0,0,0,0,3},{1,0,0,0,1},{2,0,10,1,2},{13,2,23,10,27},
{37,36,35,1,14},{73,72,2,1,11},{76,72,4,3,13},{81,72,1,1,12},{83,72,3,3,4},{87,0,0,0,5},
{88,83,1,1,9},{90,83,1,1,7},{92,73,1,1,10},{94,73,1,1,6},{96,80,1,1,8},{98,81,6,5,14},
{105,72,3,3,27},{109,36,290,36,15},{400,108,35,35,16},{436,435,1,1,27},{438,436,2,2,27},
{441,400,5,5,16},{447,435,3,2,27},{451,108,10,10,16},{462,437,3,3,16},{466,451,5,5,17},
{472,471,1,1,27},{474,472,2,2,27},{477,466,7,7,17},{485,474,8,8,27},{494,477,3,3,17},
{498,477,1,1,17},{500,498,3,2,27},{504,109,39,39,18},{544,504,35,35,19},{580,579,1,1,27},
{582,580,2,2,27},{585,477,5,5,19},{591,579,3,2,27},{595,503,10,10,19},{606,581,3,3,19},
{610,476,5,5,20},{616,615,1,1,27},{618,616,2,2,27},{621,476,5,5,20},{627,615,3,2,27},
{631,504,10,10,20},{642,462,1,1,20},{644,617,10,9,27},{655,108,68,68,21},{724,723,1,1,27},
{726,724,2,2,27},{729,631,5,5,21},{735,723,3,2,27},{739,595,10,10,21},{750,725,3,3,21},
{754,631,5,5,22},{760,759,1,1,27},{762,760,2,2,27},{765,754,7,7,22},{773,762,8,8,27},
{782,585,3,3,22},{786,761,3,3,22},{790,466,5,5,23},{796,795,1,1,27},{798,796,2,2,27},
{801,790,7,7,23},{809,798,8,8,27},{818,466,3,3,23},{822,797,3,3,23},{826,440,5,5,24},
{832,831,1,1,27},{834,832,2,2,27},{837,826,7,7,24},{845,834,8,8,27},{854,466,3,3,24},
{858,833,3,3,24},{862,837,5,5,25},{868,867,1,1,27},{870,868,2,2,27},{873,862,7,7,25},
{881,870,8,8,27},{890,854,3,3,25},{894,869,3,3,25},{898,837,5,5,26},{904,903,1,1,27},
{906,904,2,2,27},{909,898,7,7,26},{917,906,8,8,27},{926,890,3,3,26},{930,905,3,3,26},
{934,655,38,38,-1},};
static int accepttoks_SQUOTED[] = {-1,18,7,7,77,78,79,80,81,82,83,84,87,87,87,84,
85,86,84,85,86,86,86,86,86,86,86,};
static int brk_DQUOTED[] = {0,34,35,48,56,58,65,71,85,86,88,89,92,93,97,98,99,102,
103,110,111,114,115,116,117,118,119,120,121,65296,65306,65313,65319,65345,65351,
1114112,};
static scnitem scn_DQUOTED[] = {{0,0,0,0,3},{1,0,0,0,1},{2,0,10,1,2},{13,2,23,10,27},
{37,36,35,1,14},{73,72,2,1,11},{76,72,4,3,13},{81,72,1,1,12},{83,72,3,3,4},{87,0,0,0,5},
{88,83,1,1,9},{90,83,1,1,7},{92,73,1,1,10},{94,73,1,1,6},{96,80,1,1,8},{98,81,6,5,14},
{105,72,3,3,27},{109,36,290,36,15},{400,108,35,35,16},{436,435,1,1,27},{438,436,2,2,27},
{441,400,5,5,16},{447,435,3,2,27},{451,108,10,10,16},{462,437,3,3,16},{466,451,5,5,17},
{472,471,1,1,27},{474,472,2,2,27},{477,466,7,7,17},{485,474,8,8,27},{494,477,3,3,17},
{498,477,1,1,17},{500,498,3,2,27},{504,109,39,39,18},{544,504,35,35,19},{580,579,1,1,27},
{582,580,2,2,27},{585,477,5,5,19},{591,579,3,2,27},{595,503,10,10,19},{606,581,3,3,19},
{610,476,5,5,20},{616,615,1,1,27},{618,616,2,2,27},{621,476,5,5,20},{627,615,3,2,27},
{631,504,10,10,20},{642,462,1,1,20},{644,617,10,9,27},{655,108,68,68,21},{724,723,1,1,27},
{726,724,2,2,27},{729,631,5,5,21},{735,723,3,2,27},{739,595,10,10,21},{750,725,3,3,21},
{754,631,5,5,22},{760,759,1,1,27},{762,760,2,2,27},{765,754,7,7,22},{773,762,8,8,27},
{782,585,3,3,22},{786,761,3,3,22},{790,466,5,5,23},{796,795,1,1,27},{798,796,2,2,27},
{801,790,7,7,23},{809,798,8,8,27},{818,466,3,3,23},{822,797,3,3,23},{826,440,5,5,24},
{832,831,1,1,27},{834,832,2,2,27},{837,826,7,7,24},{845,834,8,8,27},{854,466,3,3,24},
{858,833,3,3,24},{862,837,5,5,25},{868,867,1,1,27},{870,868,2,2,27},{873,862,7,7,25},
{881,870,8,8,27},{890,854,3,3,25},{894,869,3,3,25},{898,837,5,5,26},{904,903,1,1,27},
{906,904,2,2,27},{909,898,7,7,26},{917,906,8,8,27},{926,890,3,3,26},{930,905,3,3,26},
{934,655,38,38,-1},};
static int accepttoks_DQUOTED[] = {-1,20,7,7,77,78,79,80,81,82,83,84,87,87,87,84,
85,86,84,85,86,86,86,86,86,86,86,};
static int brk_CHARELEMENT[] = {0,45,46,48,56,58,59,65,71,85,86,88,89,91,92,93,94,
97,98,99,102,103,110,111,114,115,116,117,118,119,120,121,123,170,171,181,182,186,
187,223,247,248,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,
272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,
292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,
313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,330,331,332,333,
334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,
354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,
374,375,376,378,379,380,381,382,385,387,388,389,390,392,393,396,398,402,403,405,
406,409,412,414,415,417,418,419,420,421,422,424,425,426,428,429,430,432,433,436,
437,438,439,441,443,445,448,454,455,457,458,460,461,462,463,464,465,466,467,468,
469,470,471,472,473,474,475,476,478,479,480,481,482,483,484,485,486,487,488,489,
490,491,492,493,494,495,497,499,500,501,502,505,506,507,508,509,510,511,512,513,
514,515,516,517,518,519,520,521,522,523,524,525,526,527,528,529,530,531,532,533,
534,535,536,537,538,539,540,541,542,543,544,545,546,547,548,549,550,551,552,553,
554,555,556,557,558,559,560,561,562,563,570,572,573,575,577,578,579,583,584,585,
586,587,588,589,590,591,660,661,688,881,882,883,884,887,888,891,894,912,913,940,
975,976,978,981,984,985,986,987,988,989,990,991,992,993,994,995,996,997,998,999,
1000,1001,1002,1003,1004,1005,1006,1007,1012,1013,1014,1016,1017,1019,1021,1072,
1120,1121,1122,1123,1124,1125,1126,1127,1128,1129,1130,1131,1132,1133,1134,1135,
1136,1137,1138,1139,1140,1141,1142,1143,1144,1145,1146,1147,1148,1149,1150,1151,
1152,1153,1154,1163,1164,1165,1166,1167,1168,1169,1170,1171,1172,1173,1174,1175,
1176,1177,1178,1179,1180,1181,1182,1183,1184,1185,1186,1187,1188,1189,1190,1191,
1192,1193,1194,1195,1196,1197,1198,1199,1200,1201,1202,1203,1204,1205,1206,1207,
1208,1209,1210,1211,1212,1213,1214,1215,1216,1218,1219,1220,1221,1222,1223,1224,
1225,1226,1227,1228,1229,1230,1232,1233,1234,1235,1236,1237,1238,1239,1240,1241,
1242,1243,1244,1245,1246,1247,1248,1249,1250,1251,1252,1253,1254,1255,1256,1257,
1258,1259,1260,1261,1262,1263,1264,1265,1266,1267,1268,1269,1270,1271,1272,1273,
1274,1275,1276,1277,1278,1279,1280,1281,1282,1283,1284,1285,1286,1287,1288,1289,
1290,1291,1292,1293,1294,1295,1296,1297,1298,1299,1300,1301,1302,1303,1304,1305,
1306,1307,1308,1309,1310,1311,1312,1313,1314,1315,1316,1377,1416,7424,7468,7522,
7544,7545,7579,7681,7682,7683,7684,7685,7686,7687,7688,7689,7690,7691,7692,7693,
7694,7695,7696,7697,7698,7699,7700,7701,7702,7703,7704,7705,7706,7707,7708,7709,
7710,7711,7712,7713,7714,7715,7716,7717,7718,7719,7720,7721,7722,7723,7724,7725,
7726,7727,7728,7729,7730,7731,7732,7733,7734,7735,7736,7737,7738,7739,7740,7741,
7742,7743,7744,7745,7746,7747,7748,7749,7750,7751,7752,7753,7754,7755,7756,7757,
7758,7759,7760,7761,7762,7763,7764,7765,7766,7767,7768,7769,7770,7771,7772,7773,
7774,7775,7776,7777,7778,7779,7780,7781,7782,7783,7784,7785,7786,7787,7788,7789,
7790,7791,7792,7793,7794,7795,7796,7797,7798,7799,7800,7801,7802,7803,7804,7805,
7806,7807,7808,7809,7810,7811,7812,7813,7814,7815,7816,7817,7818,7819,7820,7821,
7822,7823,7824,7825,7826,7827,7828,7829,7838,7839,7840,7841,7842,7843,7844,7845,
7846,7847,7848,7849,7850,7851,7852,7853,7854,7855,7856,7857,7858,7859,7860,7861,
7862,7863,7864,7865,7866,7867,7868,7869,7870,7871,7872,7873,7874,7875,7876,7877,
7878,7879,7880,7881,7882,7883,7884,7885,7886,7887,7888,7889,7890,7891,7892,7893,
7894,7895,7896,7897,7898,7899,7900,7901,7902,7903,7904,7905,7906,7907,7908,7909,
7910,7911,7912,7913,7914,7915,7916,7917,7918,7919,7920,7921,7922,7923,7924,7925,
7926,7927,7928,7929,7930,7931,7932,7933,7934,7935,7944,7952,7958,7968,7976,7984,
7992,8000,8006,8016,8024,8032,8040,8048,8062,8064,8072,8080,8088,8096,8104,8112,
8117,8118,8120,8126,8127,8130,8133,8134,8136,8144,8148,8150,8152,8160,8168,8178,
8181,8182,8184,8305,8306,8319,8320,8458,8459,8462,8464,8467,8468,8495,8496,8500,
8501,8505,8506,8508,8510,8518,8522,8526,8527,8580,8581,11312,11359,11361,11362,11365,
11367,11368,11369,11370,11371,11372,11373,11377,11378,11379,11381,11382,11389,11393,
11394,11395,11396,11397,11398,11399,11400,11401,11402,11403,11404,11405,11406,11407,
11408,11409,11410,11411,11412,11413,11414,11415,11416,11417,11418,11419,11420,11421,
11422,11423,11424,11425,11426,11427,11428,11429,11430,11431,11432,11433,11434,11435,
11436,11437,11438,11439,11440,11441,11442,11443,11444,11445,11446,11447,11448,11449,
11450,11451,11452,11453,11454,11455,11456,11457,11458,11459,11460,11461,11462,11463,
11464,11465,11466,11467,11468,11469,11470,11471,11472,11473,11474,11475,11476,11477,
11478,11479,11480,11481,11482,11483,11484,11485,11486,11487,11488,11489,11490,11491,
11493,11520,11558,42561,42562,42563,42564,42565,42566,42567,42568,42569,42570,42571,
42572,42573,42574,42575,42576,42577,42578,42579,42580,42581,42582,42583,42584,42585,
42586,42587,42588,42589,42590,42591,42592,42595,42596,42597,42598,42599,42600,42601,
42602,42603,42604,42605,42606,42625,42626,42627,42628,42629,42630,42631,42632,42633,
42634,42635,42636,42637,42638,42639,42640,42641,42642,42643,42644,42645,42646,42647,
42648,42787,42788,42789,42790,42791,42792,42793,42794,42795,42796,42797,42798,42799,
42802,42803,42804,42805,42806,42807,42808,42809,42810,42811,42812,42813,42814,42815,
42816,42817,42818,42819,42820,42821,42822,42823,42824,42825,42826,42827,42828,42829,
42830,42831,42832,42833,42834,42835,42836,42837,42838,42839,42840,42841,42842,42843,
42844,42845,42846,42847,42848,42849,42850,42851,42852,42853,42854,42855,42856,42857,
42858,42859,42860,42861,42862,42863,42864,42865,42873,42874,42875,42876,42877,42879,
42880,42881,42882,42883,42884,42885,42886,42887,42888,42892,42893,64256,64263,64275,
64280,65296,65306,65313,65319,65345,65351,65371,66600,66640,119834,119860,119886,
119893,119894,119912,119938,119964,119990,119994,119995,119996,119997,120004,120005,
120016,120042,120068,120094,120120,120146,120172,120198,120224,120250,120276,120302,
120328,120354,120380,120406,120432,120458,120486,120514,120539,120540,120546,120572,
120597,120598,120604,120630,120655,120656,120662,120688,120713,120714,120720,120746,
120771,120772,120778,120779,120780,1114112,};
static scnitem scn_CHARELEMENT[] = {{0,0,0,0,5},{1,0,0,0,3},{2,0,11,1,2},{14,0,0,0,4},
{15,0,0,0,1},{16,2,1217,11,33},{1234,1233,1237,1,6},{2472,1233,2460,1238,17},{4933,4932,2,1,14},
{4936,4932,5,3,16},{4942,4932,1,1,15},{4944,4936,5,5,7},{4950,0,0,0,8},{4951,4932,1,1,12},
{4953,4932,1,1,10},{4955,4933,1,1,13},{4957,4933,1,1,9},{4959,4941,1,1,11},{4961,4942,8,7,17},
{4970,4944,1195,5,33},{6166,2472,1249,1249,18},{7416,7415,14,1,33},{7431,7415,1,1,33},
{7433,7431,1132,2,33},{8566,6166,3,3,18},{8570,7431,60,60,33},{8631,2472,8634,2460,19},
{17266,6166,1232,1232,20},{18499,18498,1,1,33},{18501,1234,1,1,20},{18503,1234,9,9,20},
{18513,18498,3,2,33},{18517,17266,1145,1145,20},{19663,18516,1,1,20},{19665,19663,3,2,33},
{19669,18517,62,62,21},{19732,19731,1,1,33},{19734,19665,1,1,21},{19736,18517,9,9,21},
{19746,19731,3,2,33},{19750,18517,1145,1145,21},{20896,18517,1,1,21},{20898,20896,3,2,33},
{20902,2472,1297,1297,22},{22200,18516,11,11,18},{22212,7416,1218,1218,23},{23431,6166,1232,1232,24},
{24664,24663,1,1,33},{24666,18517,1,1,24},{24668,18517,9,9,24},{24678,24663,3,2,33},
{24682,1233,1145,1145,24},{25828,18517,1,1,24},{25830,18517,1,1,24},{25832,18517,64,64,25},
{25897,25896,1,1,33},{25899,18517,1,1,25},{25901,18517,9,9,25},{25911,25896,3,2,33},
{25915,1234,1145,1145,25},{27061,18517,1,1,25},{27063,18517,1,1,25},{27065,18517,76,76,26},
{27142,8631,3686,3686,27},{30829,30828,1,1,33},{30831,18517,1,1,27},{30833,18517,9,9,27},
{30843,30828,3,2,33},{30847,18517,1145,1145,27},{31993,18517,1,1,27},{31995,30831,12,11,33},
{32008,20902,1286,1286,28},{33295,33294,1,1,33},{33297,18517,1,1,28},{33299,18517,9,9,28},
{33309,33294,3,2,33},{33313,18517,1145,1145,28},{34459,33297,3,3,28},{34463,18517,64,64,29},
{34528,34527,1,1,33},{34530,18517,1,1,29},{34532,18517,9,9,29},{34542,34527,3,2,33},
{34546,23431,1145,1145,29},{35692,18517,1,1,29},{35694,18517,1,1,29},{35696,18517,64,64,30},
{35761,35760,1,1,33},{35763,18517,1,1,30},{35765,18517,9,9,30},{35775,35760,3,2,33},
{35779,17266,1145,1145,30},{36925,18517,1,1,30},{36927,18517,1,1,30},{36929,18517,64,64,31},
{36994,36993,1,1,33},{36996,18517,1,1,31},{36998,18517,9,9,31},{37008,36993,3,2,33},
{37012,35779,1145,1145,31},{38158,18517,1,1,31},{38160,18517,1,1,31},{38162,18517,64,64,32},
{38227,38226,1,1,33},{38229,18517,1,1,32},{38231,18517,9,9,32},{38241,38226,3,2,33},
{38245,35779,1145,1145,32},{39391,18517,1,1,32},{39393,18517,1,1,32},{39395,2472,1294,1294,-1},
};
static int accepttoks_CHARELEMENT[] = {-1,69,7,27,7,7,-1,77,78,79,80,81,82,83,84,
87,87,87,-1,84,85,86,-1,84,85,86,94,86,86,86,86,86,86,};
static int brk_REPEAT[] = {0,44,45,48,49,58,125,126,1114112,};
static scnitem scn_REPEAT[] = {{0,0,0,0,4},{1,0,0,0,3},{2,0,2,1,2},{5,0,1,1,1},{7,2,2,2,6},
{10,9,11,1,5},{22,21,1,1,6},{24,9,24,12,5},{49,22,5,5,-1},};
static int accepttoks_REPEAT[] = {-1,93,28,10,7,28,};
static tsinfo tsinfos[] = {{SZ(brk_INITIAL),brk_INITIAL,14,accepttoks_INITIAL,SZ(scn_INITIAL),scn_INITIAL},
{SZ(brk_RULES),brk_RULES,212,accepttoks_RULES,SZ(scn_RULES),scn_RULES},{SZ(brk_OPTION),brk_OPTION,9,accepttoks_OPTION,SZ(scn_OPTION),scn_OPTION},
{SZ(brk_FINAL),brk_FINAL,5,accepttoks_FINAL,SZ(scn_FINAL),scn_FINAL},{SZ(brk_RAWCODE),brk_RAWCODE,28,accepttoks_RAWCODE,SZ(scn_RAWCODE),scn_RAWCODE},
{SZ(brk_REGEX),brk_REGEX,40,accepttoks_REGEX,SZ(scn_REGEX),scn_REGEX},{SZ(brk_SQUOTED),brk_SQUOTED,27,accepttoks_SQUOTED,SZ(scn_SQUOTED),scn_SQUOTED},
{SZ(brk_DQUOTED),brk_DQUOTED,27,accepttoks_DQUOTED,SZ(scn_DQUOTED),scn_DQUOTED},
{SZ(brk_CHARELEMENT),brk_CHARELEMENT,33,accepttoks_CHARELEMENT,SZ(scn_CHARELEMENT),scn_CHARELEMENT},
{SZ(brk_REPEAT),brk_REPEAT,6,accepttoks_REPEAT,SZ(scn_REPEAT),scn_REPEAT},};

static int reduce_action(toknode **nodes, int pid, const char *fname, int line, int col, outbuf *oberr, Grammar* *pextra)
{
  Grammar* extra = *pextra;
  switch(pid) {
  case 148: {
#line 251 "glrgen.gg"
 /* Do nothing */ 
#line 3667 "glrgen.cpp"
  } break;
  case 149: {
#line 255 "glrgen.gg"

    if( (nodes[1]) )
        extra->m_StartBlock = CodeSnip(fname, (nodes[1])->line, toknode_str(nodes[1]));
    if( (nodes[5]) )
        extra->m_EndBlock = CodeSnip(fname, (nodes[5])->line, toknode_str(nodes[5]));

#line 3677 "glrgen.cpp"
  } break;
  case 163: {
#line 272 "glrgen.gg"
 extra->SetOption((*((char**)nodes[1]->vp)),(nodes[2]?1:0)?(*((char**)nodes[2]->vp)):0,(nodes[3]?1:0)?(*((char**)nodes[3]->vp)):0); 
#line 3682 "glrgen.cpp"
  } break;
  case 170: {
#line 282 "glrgen.gg"
 (*((String*)nodes[0]->vp)) = (*((char**)nodes[1]->vp)); 
#line 3687 "glrgen.cpp"
  } break;
  case 178: {
#line 299 "glrgen.gg"

    Symbols tmp;
    Symbols *ptr = &tmp;
    if( (nodes[4]?1:0) )
        ptr = &(*((Symbols*)nodes[4]->vp));
    int pos = -1;
    vector<Symbol*>::iterator cur = ptr->m_symbols.find(Symbol::DOT());
    if( cur != ptr->m_symbols.end() )
        pos = (int)(cur - ptr->m_symbols.begin());
    bool bNew = false;
    Production *p = extra->FindOrAddProduction((*((Symbol**)nodes[2]->vp)), ptr->m_symbols, ptr->m_decls, bNew);
    (*((LRItem*)nodes[0]->vp)) = LRItem(0, p, pos);

#line 3704 "glrgen.cpp"
  } break;
  case 180: {
#line 314 "glrgen.gg"

    for( vector<ProductionPart>::iterator cur = (*((vector<ProductionPart>*)nodes[3]->vp)).begin(); cur != (*((vector<ProductionPart>*)nodes[3]->vp)).end(); ++cur )
    {
        bool bNew = false;
        Production *p = extra->FindOrAddProduction((*((Symbol**)nodes[1]->vp)), cur->m_symbols.m_symbols, cur->m_symbols.m_decls, bNew);
        p->SetProps(&cur->m_props);
    }

#line 3716 "glrgen.cpp"
  } break;
  case 181: {
#line 322 "glrgen.gg"
 (*((vector<ProductionPart>*)nodes[0]->vp)) = (*((vector<ProductionPart>*)nodes[1]->vp)); (*((vector<ProductionPart>*)nodes[0]->vp)).push_back((*((ProductionPart*)nodes[3]->vp))); 
#line 3721 "glrgen.cpp"
  } break;
  case 182: {
#line 323 "glrgen.gg"
 (*((vector<ProductionPart>*)nodes[0]->vp)).push_back((*((ProductionPart*)nodes[1]->vp))); 
#line 3726 "glrgen.cpp"
  } break;
  case 183: {
#line 327 "glrgen.gg"

    Symbols tmp;
    Symbols *ptr = &tmp;
    if( (nodes[4]?1:0) )
        ptr = &(*((Symbols*)nodes[4]->vp));
    bool bNew = false;
    (*((Production**)nodes[0]->vp)) = extra->FindOrAddProduction((*((Symbol**)nodes[2]->vp)), ptr->m_symbols, ptr->m_decls, bNew);

#line 3738 "glrgen.cpp"
  } break;
  case 185: {
#line 340 "glrgen.gg"

    if( (nodes[1]?1:0) )
        (*((ProductionPart*)nodes[0]->vp)).SetSymbols((*((Symbols*)nodes[1]->vp)));
    if( (nodes[3]?1:0) )
        (*((ProductionPart*)nodes[0]->vp)).SetProps((*((AllProperties*)nodes[3]->vp)));

#line 3748 "glrgen.cpp"
  } break;
  case 189: {
#line 351 "glrgen.gg"

for( vector<Symbol*>::iterator cur = (*((vector<Symbol*>*)nodes[4]->vp)).begin(), endsym = (*((vector<Symbol*>*)nodes[4]->vp)).end(); cur != endsym; ++cur )
{
    if( (*cur)->IsTerminal() )
    {
        extra->m_errcount++;
        ob_printf(oberr, "error %s:%d:%d: Attempted to assign %%type %s to terminal %s.\n", fname, line, col, toknode_str(nodes[2]), (*cur)->m_Name.c_str());
    }
    (*cur)->m_CType = toknode_str(nodes[2]);
}

#line 3763 "glrgen.cpp"
  } break;
  case 194: {
#line 364 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget a ';'?\n", fname, (nodes[1])->line, (nodes[1])->col);
    return 0;

#line 3772 "glrgen.cpp"
  } break;
  case 195: {
#line 370 "glrgen.gg"

    ob_printf(oberr, "error %s:%d:%d: bad rule\n", fname, (nodes[1])->line, (nodes[1])->col);
    return 0;

#line 3780 "glrgen.cpp"
  } break;
  case 196: {
#line 374 "glrgen.gg"
 extra->m_globalctype = toknode_str(nodes[2]); 
#line 3785 "glrgen.cpp"
  } break;
  case 197: {
#line 375 "glrgen.gg"
 extra->AddPriorities((*((PrioritySet*)nodes[2]->vp))); 
#line 3790 "glrgen.cpp"
  } break;
  case 198: {
#line 376 "glrgen.gg"
 extra->AddAssociationsByLabel((*((ProductionLabel**)nodes[4]->vp)), (*((ProductionLabel**)nodes[2]->vp)), Assoc::Forbid, (*((PriorityGroup*)nodes[3]->vp)).m_assoc, (*((PriorityGroup*)nodes[3]->vp)).m_assoc_pos, vector<LRItem>(), fname, line); 
#line 3795 "glrgen.cpp"
  } break;
  case 199: {
#line 379 "glrgen.gg"

    vector<IntSetRange> assoc_pos;
    vector<LRItem> from_series;
    if( (*((Production**)nodes[2]->vp))->m_nt != (*((LRItem*)nodes[4]->vp)).GetSymbolAtPosition() )
    {
        extra->m_errcount++;
        ob_printf(oberr, "error %s:%d:%d: Used forbid in an impossible place.\n", fname, line, col);
    }
    int pos = (*((LRItem*)nodes[4]->vp)).m_p->PositionToAssocPosition((*((LRItem*)nodes[4]->vp)).m_pos);
    assoc_pos.push_back( IntSetRange(pos,pos) );
    if( (nodes[5]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[5]->vp));
    
    (*((LRItem*)nodes[4]->vp)).m_p->AddAssociation((*((Production**)nodes[2]->vp)), Assoc::Forbid, Assoc::ByPosition, assoc_pos, from_series, fname, line);

#line 3814 "glrgen.cpp"
  } break;
  case 201: {
#line 396 "glrgen.gg"

    vector<LRItem> from_series;
    if( (nodes[8]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[8]->vp));
    
    extra->AddAssociationsByLabel((*((ProductionLabel**)nodes[6]->vp)), (*((Production**)nodes[2]->vp)), Assoc::Forbid, (*((PriorityGroup*)nodes[7]->vp)).m_assoc, (*((PriorityGroup*)nodes[7]->vp)).m_assoc_pos, from_series, fname, line);

#line 3825 "glrgen.cpp"
  } break;
  case 205: {
#line 405 "glrgen.gg"

    vector<IntSetRange> assoc_pos;
    vector<LRItem> from_series;
    int pos = (*((LRItem*)nodes[6]->vp)).m_p->PositionToAssocPosition((*((LRItem*)nodes[6]->vp)).m_pos);
    assoc_pos.push_back( IntSetRange(pos,pos) );
    if( (nodes[7]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[7]->vp));
    
    (*((LRItem*)nodes[6]->vp)).m_p->AddAssociationByLabel((*((ProductionLabel**)nodes[4]->vp)), Assoc::Forbid, Assoc::ByPosition, assoc_pos, from_series, fname, line);

#line 3839 "glrgen.cpp"
  } break;
  case 209: {
#line 417 "glrgen.gg"

    vector<IntSetRange> assoc_pos;
    int pos = (*((LRItem*)nodes[3]->vp)).m_p->PositionToAssocPosition((*((LRItem*)nodes[3]->vp)).m_pos);
    assoc_pos.push_back( IntSetRange(pos,pos) );
    vector<LRItem> from_series;
    if( (nodes[4]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[4]->vp));
    (*((LRItem*)nodes[3]->vp)).m_p->AddAssociation(0, Assoc::ForbidAny, Assoc::ByPosition, assoc_pos, from_series, fname, line);

#line 3852 "glrgen.cpp"
  } break;
  case 211: {
#line 428 "glrgen.gg"

    vector<IntSetRange> assoc_pos;
    vector<LRItem> from_series;
    int pos = (*((LRItem*)nodes[6]->vp)).m_p->PositionToAssocPosition((*((LRItem*)nodes[6]->vp)).m_pos);
    assoc_pos.push_back( IntSetRange(pos,pos) );
    if( (nodes[7]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[7]->vp));
    
    (*((LRItem*)nodes[6]->vp)).m_p->AddAssociationByLabel((*((ProductionLabel**)nodes[4]->vp)), Assoc::Allow, Assoc::ByPosition, assoc_pos, from_series, fname, line);

#line 3866 "glrgen.cpp"
  } break;
  case 215: {
#line 440 "glrgen.gg"

    vector<IntSetRange> assoc_pos;
    vector<LRItem> from_series;
    if( (*((Production**)nodes[2]->vp))->m_nt != (*((LRItem*)nodes[4]->vp)).GetSymbolAtPosition() )
    {
        extra->m_errcount++;
        ob_printf(oberr, "error %s:%d:%d: Used allow in an impossible place.\n", fname, line, col);
    }
    int pos = (*((LRItem*)nodes[4]->vp)).m_p->PositionToAssocPosition((*((LRItem*)nodes[4]->vp)).m_pos);
    assoc_pos.push_back( IntSetRange(pos,pos) );
    if( (nodes[5]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[5]->vp));
    
    (*((LRItem*)nodes[4]->vp)).m_p->AddAssociation((*((Production**)nodes[2]->vp)), Assoc::Allow, Assoc::ByPosition, assoc_pos, from_series, fname, line);

#line 3885 "glrgen.cpp"
  } break;
  case 217: {
#line 457 "glrgen.gg"

    vector<IntSetRange> assoc_pos;
    int pos = (*((LRItem*)nodes[3]->vp)).m_p->PositionToAssocPosition((*((LRItem*)nodes[3]->vp)).m_pos);
    assoc_pos.push_back( IntSetRange(pos,pos) );
    vector<LRItem> from_series;
    if( (nodes[4]?1:0) )
        from_series = (*((vector<LRItem>*)nodes[4]->vp));
    (*((LRItem*)nodes[3]->vp)).m_p->AddAssociation(0, Assoc::AllowAny, Assoc::ByPosition, assoc_pos, from_series, fname, line);

#line 3898 "glrgen.cpp"
  } break;
  case 219: {
#line 466 "glrgen.gg"
 (*((vector<LRItem>*)nodes[0]->vp)) = (*((vector<LRItem>*)nodes[1]->vp)); (*((vector<LRItem>*)nodes[0]->vp)).append((*((LRItem*)nodes[3]->vp))); 
#line 3903 "glrgen.cpp"
  } break;
  case 220: {
#line 467 "glrgen.gg"
 (*((vector<LRItem>*)nodes[0]->vp)).push_back((*((LRItem*)nodes[2]->vp))); 
#line 3908 "glrgen.cpp"
  } break;
  case 221: {
#line 470 "glrgen.gg"

    Rx *rx = (*((Symbol**)nodes[4]->vp))->RxFromSymbol();
    if( ! rx )
    {
        ob_printf(oberr, "error %s:%d:%d: Declared empty token-fragment %s.\n", fname, line, col, (*((char**)nodes[2]->vp)));
        return 0;
    }
    if( ! extra->DeclareTokFrag((*((char**)nodes[2]->vp)),rx) )
    {
        delete rx;
        ob_printf(oberr, "error %s:%d:%d: Redeclaration of token-fragment %s.\n", fname, line, col, (*((char**)nodes[2]->vp)));
        return 0;
    }

#line 3926 "glrgen.cpp"
  } break;
  case 223: {
#line 484 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 3931 "glrgen.cpp"
  } break;
  case 224: {
#line 485 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 3936 "glrgen.cpp"
  } break;
  case 225: {
#line 486 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 3941 "glrgen.cpp"
  } break;
  case 226: {
#line 490 "glrgen.gg"

    (*((OrderedTokenSet**)nodes[2]->vp))->AddTokensAndRules(*(*((vector<TokenSetAction>**)nodes[5]->vp)));
    delete (*((vector<TokenSetAction>**)nodes[5]->vp));

#line 3949 "glrgen.cpp"
  } break;
  case 228: {
#line 496 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the ';'?\n", fname, (nodes[7])->line, (nodes[7])->col);
    return 0;

#line 3958 "glrgen.cpp"
  } break;
  case 230: {
#line 503 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing ')'?\n", fname, (nodes[5])->line, (nodes[5])->col);
    return 0;

#line 3967 "glrgen.cpp"
  } break;
  case 232: {
#line 511 "glrgen.gg"

                                                    (*((Symbols*)nodes[0]->vp)) = (*((Symbols*)nodes[1]->vp));
                                                    sl_decl esl = sl_neutral;
                                                    if( (nodes[2]?1:0) )
                                                        esl = (*((sl_decl*)nodes[2]->vp));
                                                    (*((Symbols*)nodes[0]->vp)).m_symbols.push_back((*((Symbol**)nodes[3]->vp)));
                                                    (*((Symbols*)nodes[0]->vp)).m_decls.push_back(esl);
                                                
#line 3979 "glrgen.cpp"
  } break;
  case 234: {
#line 519 "glrgen.gg"
 (*((Symbols*)nodes[0]->vp)) = (*((Symbols*)nodes[1]->vp)); (*((Symbols*)nodes[0]->vp)).m_symbols.append((*((Symbols*)nodes[2]->vp)).m_symbols); (*((Symbols*)nodes[0]->vp)).m_decls.append((*((Symbols*)nodes[2]->vp)).m_decls); 
#line 3984 "glrgen.cpp"
  } break;
  case 235: {
#line 520 "glrgen.gg"
 
                                                    sl_decl esl = sl_neutral;
                                                    if( (nodes[1]?1:0) )
                                                        esl = (*((sl_decl*)nodes[1]->vp));
                                                    (*((Symbols*)nodes[0]->vp)).m_symbols.push_back((*((Symbol**)nodes[2]->vp)));
                                                    (*((Symbols*)nodes[0]->vp)).m_decls.push_back(esl);
                                                
#line 3995 "glrgen.cpp"
  } break;
  case 237: {
#line 527 "glrgen.gg"
 (*((Symbols*)nodes[0]->vp)) = (*((Symbols*)nodes[1]->vp)); 
#line 4000 "glrgen.cpp"
  } break;
  case 238: {
#line 528 "glrgen.gg"
 (*((sl_decl*)nodes[0]->vp)) = sl_short; 
#line 4005 "glrgen.cpp"
  } break;
  case 239: {
#line 529 "glrgen.gg"
 (*((sl_decl*)nodes[0]->vp)) = sl_long; 
#line 4010 "glrgen.cpp"
  } break;
  case 240: {
#line 533 "glrgen.gg"

    (*((Symbols*)nodes[0]->vp)).m_symbols.reserve((*((Symbols*)nodes[2]->vp)).m_symbols.size()+2);
    (*((Symbols*)nodes[0]->vp)).m_decls.reserve((*((Symbols*)nodes[2]->vp)).m_decls.size()+2);
    (*((Symbols*)nodes[0]->vp)).m_symbols.push_back(Symbol::LB());
    (*((Symbols*)nodes[0]->vp)).m_decls.push_back(sl_neutral);
    (*((Symbols*)nodes[0]->vp)).m_symbols.append((*((Symbols*)nodes[2]->vp)).m_symbols);
    (*((Symbols*)nodes[0]->vp)).m_decls.append((*((Symbols*)nodes[2]->vp)).m_decls);
    (*((Symbols*)nodes[0]->vp)).m_symbols.push_back(Symbol::RB());
    (*((Symbols*)nodes[0]->vp)).m_decls.push_back(sl_neutral);

#line 4024 "glrgen.cpp"
  } break;
  case 241: {
#line 545 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing ']'?\n", fname, (nodes[2])->line, (nodes[2])->col);
    return 0;

#line 4033 "glrgen.cpp"
  } break;
  case 242: {
#line 550 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4038 "glrgen.cpp"
  } break;
  case 243: {
#line 551 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4043 "glrgen.cpp"
  } break;
  case 244: {
#line 552 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4048 "glrgen.cpp"
  } break;
  case 245: {
#line 553 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4053 "glrgen.cpp"
  } break;
  case 246: {
#line 554 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = Symbol::DOT(); 
#line 4058 "glrgen.cpp"
  } break;
  case 247: {
#line 559 "glrgen.gg"
 (*((vector<TokenSetAction>**)nodes[0]->vp)) = (*((vector<TokenSetAction>**)nodes[1]->vp)); (*((vector<TokenSetAction>**)nodes[0]->vp))->push_back((*((TokenSetAction*)nodes[3]->vp))); 
#line 4063 "glrgen.cpp"
  } break;
  case 248: {
#line 562 "glrgen.gg"

(*((vector<TokenSetAction>**)nodes[0]->vp)) = new vector<TokenSetAction>();
(*((vector<TokenSetAction>**)nodes[0]->vp))->push_back((*((TokenSetAction*)nodes[1]->vp)));

#line 4071 "glrgen.cpp"
  } break;
  case 249: {
#line 568 "glrgen.gg"

if( ! (*((Symbol**)nodes[1]->vp))->IsTerminal() )
{
    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: Attempted to add NonTerminal %s to token set.\n", fname, line, col, (*((Symbol**)nodes[1]->vp))->m_Name.c_str());
    return 0;
}
if( (nodes[3]?1:0) )
{
    Symbol *sym = extra->FindOrAddRx((*((char**)nodes[3]->vp)), 0, false, 0, false);
    if( sym && sym != (*((Symbol**)nodes[1]->vp)) )
    {
        ob_printf(oberr, "error %s:%d:%d: Different redeclaration of regex %s.\n", fname, line, col, (*((char**)nodes[3]->vp)));
        return 0;
    }
    sym = extra->FindOrAddNonterminal((*((char**)nodes[3]->vp)), 0, false);
    if( sym )
    {
        ob_printf(oberr, "error %s:%d:%d: Redeclaration of regex %s previously declared as nonterminal.\n", fname, line, col, (*((char**)nodes[3]->vp)));
        return 0;
    }
    if( ! (*((Symbol**)nodes[1]->vp))->SetFriendlyName((*((char**)nodes[3]->vp))) )
    {
        extra->m_errcount++;
        ob_printf(oberr, "error %s:%d:%d: Attempted to set friendly name to \"%s\" on regex already aliased as \"%s\".\n", fname, line, col, (*((char**)nodes[3]->vp)), (*((Symbol**)nodes[1]->vp))->m_Name.c_str());
        return 0;
    }
}
if( (nodes[5]?1:0) )
{
   (*((TokenSetAction*)nodes[0]->vp)) = (*((TokenSetAction*)nodes[5]->vp));
   (*((TokenSetAction*)nodes[0]->vp)).m_file = fname;
   (*((TokenSetAction*)nodes[0]->vp)).m_lineno = line;
   (*((TokenSetAction*)nodes[0]->vp)).m_sym = (*((Symbol**)nodes[1]->vp));
}
else
   (*((TokenSetAction*)nodes[0]->vp)) = TokenSetAction(fname, line, (*((Symbol**)nodes[1]->vp)), TokenSetAction::NOACTION, 0);

#line 4113 "glrgen.cpp"
  } break;
  case 255: {
#line 606 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4118 "glrgen.cpp"
  } break;
  case 256: {
#line 607 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4123 "glrgen.cpp"
  } break;
  case 257: {
#line 608 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4128 "glrgen.cpp"
  } break;
  case 258: {
#line 609 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = (*((Symbol**)nodes[1]->vp)); 
#line 4133 "glrgen.cpp"
  } break;
  case 259: {
#line 610 "glrgen.gg"
 (*((TokenSetAction*)nodes[0]->vp)) = TokenSetAction(__FILE__, __LINE__, 0, TokenSetAction::PUSH, (*((OrderedTokenSet**)nodes[2]->vp))); 
#line 4138 "glrgen.cpp"
  } break;
  case 260: {
#line 611 "glrgen.gg"
 (*((TokenSetAction*)nodes[0]->vp)) = TokenSetAction(__FILE__, __LINE__, 0, TokenSetAction::POP, 0); 
#line 4143 "glrgen.cpp"
  } break;
  case 261: {
#line 612 "glrgen.gg"
 (*((TokenSetAction*)nodes[0]->vp)) = TokenSetAction(__FILE__, __LINE__, 0, TokenSetAction::IGNOREWS, 0); 
#line 4148 "glrgen.cpp"
  } break;
  case 262: {
#line 613 "glrgen.gg"
 (*((TokenSetAction*)nodes[0]->vp)) = TokenSetAction(__FILE__, __LINE__, 0, TokenSetAction::GOTO, (*((OrderedTokenSet**)nodes[2]->vp))); 
#line 4153 "glrgen.cpp"
  } break;
  case 263: {
#line 614 "glrgen.gg"
 (*((OrderedTokenSet**)nodes[0]->vp)) = extra->FindOrAddTokenSet((*((String*)nodes[1]->vp))); 
#line 4158 "glrgen.cpp"
  } break;
  case 264: {
#line 620 "glrgen.gg"

(*((vector<Symbol*>*)nodes[0]->vp)) = (*((vector<Symbol*>*)nodes[1]->vp));
(*((vector<Symbol*>*)nodes[0]->vp)).push_back((*((Symbol**)nodes[2]->vp)));

#line 4166 "glrgen.cpp"
  } break;
  case 265: {
#line 624 "glrgen.gg"
 (*((vector<Symbol*>*)nodes[0]->vp)).push_back((*((Symbol**)nodes[1]->vp))); 
#line 4171 "glrgen.cpp"
  } break;
  case 266: {
#line 627 "glrgen.gg"

(*((Symbol**)nodes[0]->vp)) = extra->FindOrAddRx((*((String*)nodes[1]->vp)), 0, false, 0, false);
if( ! (*((Symbol**)nodes[0]->vp)) )
    (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddNonterminal((*((String*)nodes[1]->vp)));

#line 4180 "glrgen.cpp"
  } break;
  case 267: {
#line 632 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->m_startsymbol; 
#line 4185 "glrgen.cpp"
  } break;
  case 268: {
#line 633 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->m_errorsymbol; 
#line 4190 "glrgen.cpp"
  } break;
  case 269: {
#line 637 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)) = (*((AllProperties*)nodes[1]->vp)); (*((AllProperties*)nodes[0]->vp)) |= (*((AllProperties*)nodes[3]->vp)); 
#line 4195 "glrgen.cpp"
  } break;
  case 271: {
#line 638 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)) = (*((AllProperties*)nodes[1]->vp)); 
#line 4200 "glrgen.cpp"
  } break;
  case 272: {
#line 640 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)).m_flags |= PROP_FLAGS_REJECT; 
#line 4205 "glrgen.cpp"
  } break;
  case 273: {
#line 641 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)).m_flags |= PROP_FLAGS_RANK; (*((AllProperties*)nodes[0]->vp)).m_rank = (*((int*)nodes[3]->vp)); 
#line 4210 "glrgen.cpp"
  } break;
  case 275: {
#line 644 "glrgen.gg"
 
(*((AllProperties*)nodes[0]->vp)).m_flags |= PROP_FLAGS_ASSOC;
(*((AllProperties*)nodes[0]->vp)).m_assoc = (*((PriorityGroup*)nodes[1]->vp)).m_assoc;
(*((AllProperties*)nodes[0]->vp)).m_assoc_pos = (*((PriorityGroup*)nodes[1]->vp)).m_assoc_pos;

#line 4219 "glrgen.cpp"
  } break;
  case 276: {
#line 649 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)).m_flags |= PROP_FLAGS_LABEL; (*((AllProperties*)nodes[0]->vp)).m_label = (*((ProductionLabel**)nodes[3]->vp)); 
#line 4224 "glrgen.cpp"
  } break;
  case 278: {
#line 650 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)).m_flags |= PROP_FLAGS_ACTION; (*((AllProperties*)nodes[0]->vp)).m_ReduceCode = (*((CodeSnip*)nodes[3]->vp)); 
#line 4229 "glrgen.cpp"
  } break;
  case 280: {
#line 651 "glrgen.gg"
 (*((AllProperties*)nodes[0]->vp)).m_flags |= PROP_FLAGS_RUNTIME_RESOLVABLE; 
#line 4234 "glrgen.cpp"
  } break;
  case 281: {
#line 656 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddLiteral((nodes[2]?1:0)?(*((String*)nodes[2]->vp)):"", false); 
#line 4239 "glrgen.cpp"
  } break;
  case 283: {
#line 657 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddLiteral((nodes[2]?1:0)?(*((String*)nodes[2]->vp)):"", false); 
#line 4244 "glrgen.cpp"
  } break;
  case 285: {
#line 658 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddLiteral((nodes[2]?1:0)?(*((String*)nodes[2]->vp)):"", true); 
#line 4249 "glrgen.cpp"
  } break;
  case 287: {
#line 659 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddLiteral((nodes[2]?1:0)?(*((String*)nodes[2]->vp)):"", true); 
#line 4254 "glrgen.cpp"
  } break;
  case 289: {
#line 660 "glrgen.gg"
 (*((String*)nodes[0]->vp)) = (*((String*)nodes[1]->vp)); (*((String*)nodes[0]->vp)) += (*((uint32_t*)nodes[2]->vp)); 
#line 4259 "glrgen.cpp"
  } break;
  case 290: {
#line 661 "glrgen.gg"
 (*((String*)nodes[0]->vp)) += (*((uint32_t*)nodes[1]->vp)); 
#line 4264 "glrgen.cpp"
  } break;
  case 291: {
#line 665 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\a'; 
#line 4269 "glrgen.cpp"
  } break;
  case 292: {
#line 666 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\b'; 
#line 4274 "glrgen.cpp"
  } break;
  case 293: {
#line 667 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\t'; 
#line 4279 "glrgen.cpp"
  } break;
  case 294: {
#line 668 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\n'; 
#line 4284 "glrgen.cpp"
  } break;
  case 295: {
#line 669 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\v'; 
#line 4289 "glrgen.cpp"
  } break;
  case 296: {
#line 670 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\f'; 
#line 4294 "glrgen.cpp"
  } break;
  case 297: {
#line 671 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = '\r'; 
#line 4299 "glrgen.cpp"
  } break;
  case 298: {
#line 672 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = otoi((*((char**)nodes[1]->vp))+1); 
#line 4304 "glrgen.cpp"
  } break;
  case 299: {
#line 673 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = xtoi((*((char**)nodes[1]->vp))+1); 
#line 4309 "glrgen.cpp"
  } break;
  case 300: {
#line 674 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = xtoi((*((char**)nodes[1]->vp))+1); 
#line 4314 "glrgen.cpp"
  } break;
  case 301: {
#line 675 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = (*((char**)nodes[1]->vp))[1]; 
#line 4319 "glrgen.cpp"
  } break;
  case 302: {
#line 676 "glrgen.gg"
 (*((uint32_t*)nodes[0]->vp)) = (*((char**)nodes[1]->vp))[0]; 
#line 4324 "glrgen.cpp"
  } break;
  case 303: {
#line 683 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddRx(toknode_str(nodes[0]), (*((Rx**)nodes[2]->vp)), false); 
#line 4329 "glrgen.cpp"
  } break;
  case 304: {
#line 686 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing '/'?\n", fname, (nodes[2])->line, (nodes[2])->col);
    return 0;

#line 4338 "glrgen.cpp"
  } break;
  case 305: {
#line 691 "glrgen.gg"
 (*((Symbol**)nodes[0]->vp)) = extra->FindOrAddRx(toknode_str(nodes[0]), (*((Rx**)nodes[2]->vp)), true); 
#line 4343 "glrgen.cpp"
  } break;
  case 306: {
#line 694 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing '/'?\n", fname, (nodes[2])->line, (nodes[2])->col);
    return 0;

#line 4352 "glrgen.cpp"
  } break;
  case 307: {
#line 699 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = (*((Rx**)nodes[2]->vp)); 
#line 4357 "glrgen.cpp"
  } break;
  case 308: {
#line 702 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing ')'?\n", fname, (nodes[2])->line, (nodes[2])->col);
    return 0;

#line 4366 "glrgen.cpp"
  } break;
  case 309: {
#line 707 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxConcat((*((Rx**)nodes[1]->vp)), (*((Rx**)nodes[2]->vp))); 
#line 4371 "glrgen.cpp"
  } break;
  case 310: {
#line 708 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxUnion((*((Rx**)nodes[1]->vp)), (*((Rx**)nodes[3]->vp))); 
#line 4376 "glrgen.cpp"
  } break;
  case 311: {
#line 709 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxStar((*((Rx**)nodes[1]->vp))); 
#line 4381 "glrgen.cpp"
  } break;
  case 312: {
#line 710 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxPlus((*((Rx**)nodes[1]->vp))); 
#line 4386 "glrgen.cpp"
  } break;
  case 313: {
#line 711 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxOpt((*((Rx**)nodes[1]->vp))); 
#line 4391 "glrgen.cpp"
  } break;
  case 314: {
#line 712 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxMany((*((Rx**)nodes[1]->vp)), (*((int*)nodes[3]->vp)), (*((int*)nodes[3]->vp))); 
#line 4396 "glrgen.cpp"
  } break;
  case 315: {
#line 714 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxMany((*((Rx**)nodes[1]->vp)), (*((int*)nodes[3]->vp)), -1); 
#line 4401 "glrgen.cpp"
  } break;
  case 316: {
#line 716 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxMany((*((Rx**)nodes[1]->vp)), -1, (*((int*)nodes[4]->vp))); 
#line 4406 "glrgen.cpp"
  } break;
  case 317: {
#line 718 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxMany((*((Rx**)nodes[1]->vp)), (*((int*)nodes[3]->vp)), (*((int*)nodes[5]->vp))); 
#line 4411 "glrgen.cpp"
  } break;
  case 318: {
#line 720 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing '}'?\n", fname, (nodes[3])->line, (nodes[3])->col);
    return 0;

#line 4420 "glrgen.cpp"
  } break;
  case 319: {
#line 725 "glrgen.gg"
  Rx *rx = extra->LookupTokFrag((*((char**)nodes[1]->vp)));
                                        if( ! rx )
                                        {
                                            extra->m_errcount++;
                                            ob_printf(oberr, "error %s:%d:%d: Unknown token fragment %s.\n", fname, line, col, (*((char**)nodes[1]->vp)));
                                            return 0;
                                        }
                                        (*((Rx**)nodes[0]->vp)) = rx->Copy();
                                    
#line 4433 "glrgen.cpp"
  } break;
  case 320: {
#line 734 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxChars(~UIntSet()); 
#line 4438 "glrgen.cpp"
  } break;
  case 321: {
#line 735 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxChars(UIntSet()%UIntSetRange((*((uint32_t*)nodes[1]->vp)),(*((uint32_t*)nodes[1]->vp)))); 
#line 4443 "glrgen.cpp"
  } break;
  case 322: {
#line 736 "glrgen.gg"
 (*((Rx**)nodes[0]->vp)) = new RxChars((*((UIntSet*)nodes[1]->vp))); 
#line 4448 "glrgen.cpp"
  } break;
  case 323: {
#line 740 "glrgen.gg"
 (*((UIntSet*)nodes[0]->vp)) = (*((UIntSet*)nodes[2]->vp)); 
#line 4453 "glrgen.cpp"
  } break;
  case 324: {
#line 742 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing ']'?\n", fname, (nodes[2])->line, (nodes[2])->col);
    return 0;

#line 4462 "glrgen.cpp"
  } break;
  case 325: {
#line 747 "glrgen.gg"
 (*((UIntSet*)nodes[0]->vp)) = ~(*((UIntSet*)nodes[2]->vp)); 
#line 4467 "glrgen.cpp"
  } break;
  case 326: {
#line 749 "glrgen.gg"

    extra->m_errcount++;
    ob_printf(oberr, "error %s:%d:%d: did you forget the closing ']'?\n", fname, (nodes[2])->line, (nodes[2])->col);
    return 0;

#line 4476 "glrgen.cpp"
  } break;
  case 327: {
#line 754 "glrgen.gg"
 (*((UIntSet*)nodes[0]->vp)) = (*((UIntSet*)nodes[1]->vp)); (*((UIntSet*)nodes[0]->vp)) += (*((UIntSet*)nodes[2]->vp)); 
#line 4481 "glrgen.cpp"
  } break;
  case 328: {
#line 755 "glrgen.gg"
 (*((UIntSet*)nodes[0]->vp)) = UIntSet(); (*((UIntSet*)nodes[0]->vp)) += (*((UIntSet*)nodes[1]->vp)); 
#line 4486 "glrgen.cpp"
  } break;
  case 329: {
#line 756 "glrgen.gg"
 (*((UIntSet*)nodes[0]->vp)) = UIntSet()%UIntSetRange((*((uint32_t*)nodes[1]->vp)), (*((uint32_t*)nodes[1]->vp))); 
#line 4491 "glrgen.cpp"
  } break;
  case 330: {
#line 757 "glrgen.gg"
 (*((UIntSet*)nodes[0]->vp)) = UIntSet()%UIntSetRange((*((uint32_t*)nodes[1]->vp)), (*((uint32_t*)nodes[3]->vp))); 
#line 4496 "glrgen.cpp"
  } break;
  case 331: {
#line 759 "glrgen.gg"

bool bFound = false;
(*((UIntSet*)nodes[0]->vp)) = extra->LookupNamedCharSet((*((char**)nodes[1]->vp)), &bFound);
if( ! bFound ) {
    extra->m_errcount++;
    ob_printf(oberr, "Unknown named character set '%s'.\n", (*((char**)nodes[1]->vp)));
}

#line 4508 "glrgen.cpp"
  } break;
  case 332: {
#line 773 "glrgen.gg"
 (*((PrioritySet*)nodes[0]->vp)) = (*((PrioritySet*)nodes[1]->vp));  (*((PrioritySet*)nodes[0]->vp)).m_groups[0].m_labels.append((*((PrioritySet*)nodes[3]->vp)).m_groups[0].m_labels); 
#line 4513 "glrgen.cpp"
  } break;
  case 333: {
#line 774 "glrgen.gg"
 (*((PrioritySet*)nodes[0]->vp)) = (*((PrioritySet*)nodes[2]->vp)); (*((PrioritySet*)nodes[0]->vp)).m_groups[0].m_assoc = (*((PriorityGroup*)nodes[1]->vp)).m_assoc; (*((PrioritySet*)nodes[0]->vp)).m_groups[0].m_assoc_pos = (*((PriorityGroup*)nodes[1]->vp)).m_assoc_pos; 
#line 4518 "glrgen.cpp"
  } break;
  case 334: {
#line 775 "glrgen.gg"
 (*((PrioritySet*)nodes[0]->vp)) = (*((PrioritySet*)nodes[1]->vp));  (*((PrioritySet*)nodes[0]->vp)).m_groups.append((*((PrioritySet*)nodes[3]->vp)).m_groups); 
#line 4523 "glrgen.cpp"
  } break;
  case 335: {
#line 776 "glrgen.gg"
 (*((PrioritySet*)nodes[0]->vp)).m_groups.resize(1); (*((PrioritySet*)nodes[0]->vp)).m_groups[0].m_labels.append((*((ProductionLabel**)nodes[1]->vp))); 
#line 4528 "glrgen.cpp"
  } break;
  case 336: {
#line 777 "glrgen.gg"
 (*((ProductionLabel**)nodes[0]->vp)) = extra->FindOrAddLabel((*((String*)nodes[1]->vp))); 
#line 4533 "glrgen.cpp"
  } break;
  case 337: {
#line 781 "glrgen.gg"
 (*((PriorityGroup*)nodes[0]->vp)).m_assoc = Assoc::Left; 
#line 4538 "glrgen.cpp"
  } break;
  case 338: {
#line 782 "glrgen.gg"
 (*((PriorityGroup*)nodes[0]->vp)).m_assoc = Assoc::Right; 
#line 4543 "glrgen.cpp"
  } break;
  case 339: {
#line 783 "glrgen.gg"
 (*((PriorityGroup*)nodes[0]->vp)).m_assoc = Assoc::Non; 
#line 4548 "glrgen.cpp"
  } break;
  case 340: {
#line 786 "glrgen.gg"

(*((PriorityGroup*)nodes[0]->vp)).m_assoc = Assoc::ByPosition;
(*((PriorityGroup*)nodes[0]->vp)).m_assoc_pos = (*((vector<IntSetRange>*)nodes[3]->vp));

#line 4556 "glrgen.cpp"
  } break;
  case 341: {
#line 792 "glrgen.gg"

if( (nodes[1]?1:0) )
    (*((vector<IntSetRange>*)nodes[0]->vp)) = (*((vector<IntSetRange>*)nodes[1]->vp));
(*((vector<IntSetRange>*)nodes[0]->vp)).push_back((*((IntSetRange*)nodes[3]->vp)));

#line 4565 "glrgen.cpp"
  } break;
  case 343: {
#line 800 "glrgen.gg"

(*((IntSetRange*)nodes[0]->vp)).m_min = (*((int*)nodes[1]->vp));
(*((IntSetRange*)nodes[0]->vp)).m_max = (*((int*)nodes[3]->vp));

#line 4573 "glrgen.cpp"
  } break;
  case 344: {
#line 807 "glrgen.gg"
 (*((int*)nodes[0]->vp)) = (*((int*)nodes[1]->vp)); 
#line 4578 "glrgen.cpp"
  } break;
  case 345: {
#line 808 "glrgen.gg"
 (*((int*)nodes[0]->vp)) = (*((int*)nodes[1]->vp)); 
#line 4583 "glrgen.cpp"
  } break;
  case 346: {
#line 809 "glrgen.gg"
 (*((int*)nodes[0]->vp)) = -(*((int*)nodes[2]->vp)); 
#line 4588 "glrgen.cpp"
  } break;
  case 347: {
#line 810 "glrgen.gg"
 (*((int*)nodes[0]->vp)) = -(*((int*)nodes[2]->vp)); 
#line 4593 "glrgen.cpp"
  } break;
  case 348: {
#line 811 "glrgen.gg"
 (*((int*)nodes[0]->vp)) = glr_atoi((*((char**)nodes[1]->vp)), 0, 0); 
#line 4598 "glrgen.cpp"
  } break;
  case 349: {
#line 812 "glrgen.gg"
 (*((int*)nodes[0]->vp)) = glr_atoi((*((char**)nodes[1]->vp)), 0, 0); 
#line 4603 "glrgen.cpp"
  } break;
  case 350: {
#line 816 "glrgen.gg"
 (*((CodeSnip*)nodes[0]->vp)) = CodeSnip(fname, line, toknode_str(nodes[2])); 
#line 4608 "glrgen.cpp"
  } break;
  case 352: {
#line 817 "glrgen.gg"
 /* Do nothing. */ 
#line 4613 "glrgen.cpp"
  } break;
  case 353: {
#line 818 "glrgen.gg"
 /* Do nothing. */ 
#line 4618 "glrgen.cpp"
  } break;
  case 354: {
#line 819 "glrgen.gg"
 /* Do nothing. */ 
#line 4623 "glrgen.cpp"
  } break;
  case 355: {
#line 820 "glrgen.gg"
 /* Do nothing. */ 
#line 4628 "glrgen.cpp"
  } break;
  case 356: {
#line 821 "glrgen.gg"
 /* Do nothing. */ 
#line 4633 "glrgen.cpp"
  } break;
  case 357: {
#line 822 "glrgen.gg"
 /* Do nothing. */ 
#line 4638 "glrgen.cpp"
  } break;
  case 358: {
#line 823 "glrgen.gg"
 /* Do nothing. */ 
#line 4643 "glrgen.cpp"
  } break;
  default: break;
  }
  return 1;
}

static lxact lxact_INITIAL[] = {
{4,GOTO_FLAG,1},{5,0,-1},{6,PUSH_FLAG,2},{7,0,-1},{-1,0,0}};
static lxact lxact_RULES[] = {
{13,WS_FLAG,-1},{14,WS_FLAG,-1},{4,GOTO_FLAG,3},{15,PUSH_FLAG,4},{16,PUSH_FLAG,5},
{17,PUSH_FLAG,5},{18,PUSH_FLAG,6},{19,PUSH_FLAG,6},{20,PUSH_FLAG,7},{21,PUSH_FLAG,7},
{22,0,-1},{23,0,-1},{24,0,-1},{25,0,-1},{26,0,-1},{27,0,-1},{28,0,-1},{29,0,-1},
{30,0,-1},{31,0,-1},{32,0,-1},{33,0,-1},{34,0,-1},{10,0,-1},{35,0,-1},{36,0,-1},
{37,0,-1},{38,0,-1},{39,0,-1},{40,0,-1},{41,0,-1},{42,0,-1},{43,0,-1},{44,0,-1},
{45,0,-1},{46,0,-1},{47,0,-1},{48,0,-1},{49,0,-1},{50,0,-1},{51,0,-1},{52,0,-1},
{53,0,-1},{54,0,-1},{55,0,-1},{56,0,-1},{57,0,-1},{58,0,-1},{59,0,-1},{60,0,-1},
{61,0,-1},{62,0,-1},{63,0,-1},{64,0,-1},{65,0,-1},{66,0,-1},{67,0,-1},{68,0,-1},
{69,0,-1},{70,0,-1},{7,0,-1},{-1,0,0}};
static lxact lxact_OPTION[] = {
{8,WS_FLAG,-1},{9,0,-1},{10,0,-1},{11,0,-1},{12,POP_FLAG,-1},{-1,0,0}};
static lxact lxact_FINAL[] = {
{95,0,-1},{7,0,-1},{-1,0,0}};
static lxact lxact_RAWCODE[] = {
{71,POP_FLAG,-1},{72,0,-1},{73,0,-1},{74,0,-1},{75,0,-1},{76,0,-1},{7,0,-1},{-1,0,0}
};
static lxact lxact_REGEX[] = {
{16,POP_FLAG,-1},{77,0,-1},{78,0,-1},{79,0,-1},{80,0,-1},{81,0,-1},{82,0,-1},{83,0,-1},
{84,0,-1},{85,0,-1},{86,0,-1},{87,0,-1},{38,0,-1},{22,0,-1},{23,0,-1},{41,0,-1},
{88,0,-1},{40,0,-1},{89,0,-1},{68,PUSH_FLAG,8},{90,PUSH_FLAG,8},{91,PUSH_FLAG,9},
{92,0,-1},{7,0,-1},{-1,0,0}};
static lxact lxact_SQUOTED[] = {
{18,POP_FLAG,-1},{77,0,-1},{78,0,-1},{79,0,-1},{80,0,-1},{81,0,-1},{82,0,-1},{83,0,-1},
{84,0,-1},{85,0,-1},{86,0,-1},{87,0,-1},{7,0,-1},{-1,0,0}};
static lxact lxact_DQUOTED[] = {
{20,POP_FLAG,-1},{77,0,-1},{78,0,-1},{79,0,-1},{80,0,-1},{81,0,-1},{82,0,-1},{83,0,-1},
{84,0,-1},{85,0,-1},{86,0,-1},{87,0,-1},{7,0,-1},{-1,0,0}};
static lxact lxact_CHARELEMENT[] = {
{69,POP_FLAG,-1},{94,0,-1},{27,0,-1},{77,0,-1},{78,0,-1},{79,0,-1},{80,0,-1},{81,0,-1},
{82,0,-1},{83,0,-1},{84,0,-1},{85,0,-1},{86,0,-1},{87,0,-1},{7,0,-1},{-1,0,0}};
static lxact lxact_REPEAT[] = {
{93,POP_FLAG,-1},{28,0,-1},{10,0,-1},{7,0,-1},{-1,0,0}};
static lxact *lxactions[] = {
lxact_INITIAL,lxact_RULES,lxact_OPTION,lxact_FINAL,lxact_RAWCODE,lxact_REGEX,lxact_SQUOTED,lxact_DQUOTED,lxact_CHARELEMENT,lxact_REPEAT,};

static int Parse_glrgen(inbuf *buf, outbuf *obuf, outbuf *trace, line_col *err_lc, Grammar* extra)
{
    return parse_any(buf, obuf, trace, err_lc,
                                tsinfos,
                                lxactions,
                                parse_states,
                                productions,
                                148,
                                9,
                                allsymbols,
                                STARTTOK,
                                ERRTOK,
                                EOFTOK,
                                ACCEPTSTATE,
                                0,
                                INITIAL_TOKENSET,
                                (reduce_action_fnct)reduce_action,
                                &extra);
}
#line 827 "glrgen.gg"

int Grammar::Parse(const char *fname)
{
    inbuf *buf = 0;
    if( fname && *fname )
      buf = file_inbuf(fname);
    else
      buf = h_inbuf("stdin",H_STDIN,0); 
    int ret = 0;
    if( ! buf ) return 0;
    ret = Parse_glrgen(buf, m_err, m_verbose, 0, this);
    free_inbuf(buf);
    return ret;
}

#line 4719 "glrgen.cpp"
